/**
 * Created by Administrator on 2017/4/6 0006.
 * 图表公共
 */
var comm_chart = {};
var line = null;//折线
var bar;//柱状
var pie;//
/**
 * 折线图
 */
comm_chart.getLine = function(data_x,data_y,obj){
    var chartOption = {
        calculable : false,//是否拖拽重计算
        animation : true,//是否开启动画
        tooltip: {
           trigger: 'axis',
           formatter: "销售业绩 <br/>{b} : {c}"
       },
        grid:{
            borderWidth:0,//边框宽度
            x: 30,
            x2: 30,
            y: 25,
            y2: 25,
       },
        xAxis : [{
                axisLine:{
                    show:false
                },
                axisTick:{
                    show:false
                },
                axisLabel:{
                    textStyle:{
                        fontSize:'14',
                        color:'#FFF'
                    }
                },
                splitLine:{
                    show:false
                },
                type : 'category',
                boundaryGap : false,
                data : data_x
            }],
        yAxis : [{
                axisLine:{
                    show:false,
                },
                axisTick:{
                    show:false
                },
                splitLine:{
                    lineStyle:{
                        color:"rgba(255,255,255,0.1)"
                    }
                },
                type : 'value',
                axisLabel : {
                    textStyle:{
                        fontSize:'14',
                        color:'rgba(255,255,255,0)'
                    }
                }
            }],
        series : [{
                type:'line',
                smooth: true,
                itemStyle:{
                    normal:{
                        color:'#FFF',
                    }
                },
                data:data_y
            }]
    };
    if(!!line && typeof line.dispose == 'function'){//如果存在实例，就是之前的清除掉
        line.dispose();
    }
    line = echarts.init(obj);
    line.setOption(chartOption);
    line.on('tap', function(param){

    });
    return true;
}

/**
 * 柱状
 * @data {name:{data_x,[colour]}}
 * 个别页面需要调整柱状与标签的距离:margin
 */

comm_chart.getBar = function(data_y,data,grid_x,obj,callback,grid_titles,margin){
    var series = [];
    var max = 0;//最大值
    var data_arr = [];
    var show_title=true;//默认显示图表标题
    for(var i in data){
        data_arr.push(data[i]['data_x']);
        if(!!data[i]['colour']){
            var item_style_color = function(params){
                return data[i]['colour'][params.dataIndex] || data[i]['colour'][data[i]['colour'].length-1];
            }
        }else{
            var item_style_color = function(params){
                var colorList = getColorArr(data[i]['data_x']);
                return colorList[params.dataIndex];
            }
        }
        if(!grid_titles){
        	show_title=false;
        }

        series.push({
            name:i,
            type:'bar',
            stack: '总量',
            itemStyle : {
                normal: {
                    color: item_style_color,
                    //柱状上字体样式
                    label : {
                        show: true,
                        position: 'insideRight',
                        textStyle:{
                            color:"#fff"
                        }
                    }
                },
                emphasis:{
                    label : {
                        show: true,
                        textStyle:{
                            color:"rgba(0,0,0,0)"
                        }
                    }
                }
            },
            data:data[i]['data_x']
        });
    }
    if(data_arr.length == 1){
        max = Math.max.apply(null,data_arr[0]);
    }
    var option = {
	    title: {
	        text:grid_titles,
	        show:true,
	        textStyle:{
	        	fontSize:'14'
	        }
	    },
        tooltip : {
            show:true,
            trigger: 'axis',
            axisPointer : {            // 坐标轴指示器，坐标轴触发有效
                type : 'shadow'        // 默认为直线，可选为：'line' | 'shadow'
            }
        },
        xAxis : [{
            type : 'value',
            show:false,
            max: max || null
        }],
        yAxis : [{
            axisLine:{
                show:false
            },
            axisTick:{
                show:false
            },
            splitLine:{
                show:false
            },
            type : 'category',
            nameLocation:'start',
            axisLabel: {
            	showMinLabel:true,
                formatter:function(value){
                    value = value+"";
                 	return value.length >6? value.substring(0,3)+".." : value;
//                  return value.length >6? value.substring(0,6)+".." : value;
                }
            },
            data : data_y
        }],
        grid:{
        	left:50,
            borderWidth:0,
            x:grid_x || 55,
            x2:'5%',
            y:20,
            y2:20,
            top:'0'
        },
        series : series
    };
    obj.style.height = ((data_y.length *  25)+120)+"px";
    if(!!bar && typeof bar.dispose == 'function'){//如果存在实例，则删除之前的实例
        bar.dispose();
    }
    bar = echarts.init(obj);
    bar.setOption(option)
    bar.on('tap', function(param){
        if(typeof callback == 'function'){
            callback(param);
        }
    });
}

/**
 * 圆饼图
 */
comm_chart.getPie = function(data,obj,callback){
    var option = {
        title:{
            show:true,
            text:data['title_text'],
            x:'center',
            y:'center',
            textStyle:{
                fontSize: 15,
                color: '#333'
            }
        },
        tooltip : {
            trigger: 'item',
            formatter: "{a} <br/>{b} : {c} ({d}%)"
        },
        series : [
            {
                name:data['title_text'],
                type:'pie',
                radius : ['40%', '65%'],
                itemStyle : {
                    normal : {
                        color: function(params){
                            var colorList = getColorArr(data['data'] || []);
                            return colorList[params.dataIndex];
                        },
                        label : {
                            show : true,
                            formatter: "{b}\n{c}",
                            textStyle:{
                                align:'center',
                                baseline:'center'
                            }
                        },
                        labelLine : {
                            show : true
                        }
                    }
                },
                data:data['data'] || []
            }
        ]
    };
    if(!!pie && typeof pie.dispose == 'function'){//如果存在实例，则删除之前的实例
        pie.dispose();
    }
    pie = echarts.init(obj);
    pie.setOption(option);
    pie.on('click', function(param){//不监听会报错
        return;
    });
    var div = [];
    div.push('<div class = "hidden_panel"></div>');
    $(obj).append(div.join(""));
    var width = $(obj).width();
    var height = $(obj).height();
    if(width > height){//如果宽度大于高度
        $(".hidden_panel").width(height*0.26);
        $(".hidden_panel").height(height*0.26);
    }else{
        $(".hidden_panel").width(width*0.26);
        $(".hidden_panel").height(width*0.26);
    }
    $('.hidden_panel').on('tap',function(){
        if(typeof callback == 'function'){
            callback();
        }
    })
}

/**
 * 根据数据量，循环获取颜色数组
 */
function getColorArr(data){
    var color_arr  = [];
    var j = 0;
    for(var i=0;i<data.length;i++){
        j = j >= user_color.length ? 0 : j;
        color_arr.push(user_color[j]);
        j++;
    }
    return color_arr;
}
