        // 水波纹
        var wave = {
        init: function () {
            // 组件配置
            // var colors = ['rgba(33, 150, 243, 0.3)', 'rgba(33, 150, 243, 0.5)', 'rgba(33, 150, 243, 0.7)']
            var colors = ['rgba(255, 255, 255,0.3)', 'rgba(255, 255, 255, 0.5)', 'rgba(255, 255, 255, 1)']
            var componentWidth = '100%' // 组件宽度，int or 100%(相当于父元素的宽度)
            var componentHeight = '100%' // 组件高度，int or 100%
            // 波浪配置
            var width = 250 // 宽度
            var height = 70 // 高度
            var deepth = 200 // 深度
            var speed = 2 // 速度
            var speedOffset = 1
            var focus = 0.5 // 波峰集中程度 [-1, 1]
            var offset = -width * 0.8 // 不同波浪的差
            var waveCount = 0 // 波浪数
            var x = [0, offset, offset * 2]
            var cacheData = ['', '', '']
            var svgWave = document.querySelector('#svg-area')
            var paths = svgWave.querySelectorAll('path')
            var path1 = paths[0]
            var path2 = paths[1]
            var path3 = paths[2]
//          if(Common.Browser.IsMobile()&& Common.Screen.IsXS()){
//              width=width/2;
//          }

            // 配置
            config()
            var oldFunc = window.onresize
            window.onresize = function () {
                oldFunc && oldFunc()
                config(true)
            }
            // 启动
            requestAnimationFrame(wave)

            function config(resize) {
                cacheData = ['', '', '']
                svgWave.setAttribute('width', componentWidth)
                svgWave.setAttribute('height', componentHeight)
                var pxWidth = componentWidth === '100%' ? svgWave.parentNode.clientWidth : componentWidth
                waveCount = Math.ceil(pxWidth / width / 2) + 3 // + 1是考虑到第二个波浪向左移，需要预留宽度
                if (resize === true) return
                path1.setAttribute('fill', colors[0])
                path2.setAttribute('fill', colors[1])
                path3.setAttribute('fill', colors[2])
            }

            function wave() {
                path1.setAttribute('d', generateData(0))
                path2.setAttribute('d', generateData(1))
                path3.setAttribute('d', generateData(2))
                x[0] -= speed / 2
                x[1] -= (speed + speedOffset) / 2
                x[2] -= (speed + speedOffset * 2) / 2
                requestAnimationFrame(wave)
            }

            // 动态生成path.d
            function generateData(index) {
                // 起点
                // 重置起点形成循环
                if ((x[index]) % (width * 2) === 0) {
                    x[index] = 0
                }
                var startX = x[index]
                var startY = height
                var start = [startX, startY].join(',')
                if (cacheData[index] === '') {
                    // 波浪 = 贝塞尔曲线组合（正 + 倒）
                    var C_X1 = width / 4 * (focus + 1)
                    var C_Y1 = -height / 2
                    var C_Y2 = -height / 2
                    var C_X2 = width - C_X1
                    var C_X = width
                    var C_Y = 0
                    var CURVETOUP = [C_X1, C_Y1, C_X2, C_Y2, C_X, C_Y].join(' ')
                    C_Y1 = C_Y2 = height / 2
                    var curvetoDown = [C_X1, C_Y1, C_X2, C_Y2, C_X, C_Y].join(' ')
                    var curvetoData = ''
                    for (var i = 0; i < waveCount; i++) {
                        curvetoData = curvetoData + 'c' + CURVETOUP + 'c' + curvetoDown
                    }
                    // 闭合
                    var end = 'l0,' + deepth + ' l-' + waveCount * width * 2 + ',0Z'
                    cacheData[index] = [curvetoData, end].join('')
                }
                return ['M', start, cacheData[index]].join('')
            }
        }
    }
    wave.init();
