var html_name = page_arr.account;//页面名称
var temps, page_list = [], ztj_data = [];
var search_data = {};
var title = '';

$('#header').header({
    back: true,
    title: '账户',
    add: Auth.check('zh', 'edit'),
    filter: true,
    foot_input: {
        show: true,
        plader: '搜索账户',
        yuyin_icon: false,
    },
});

var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    fun.load_DATA_LIST(['md']);

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    fun.orderListHeight({dom:'#banks'});
    //【账户-显示存款】没有开启
    if(!Auth.check('zh_xsck','view')) {
        $('.debt-info').hide();
    }
    getList();

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];

        switch (temp['status']) {
            case 'search':
                search_data['md_id'] = temp['data']['md']['id'] || '';
                search_data['md_mc'] = temp['data']['md']['text'] || '';
                search_data['is_stop'] = temp['data']['is_stop'] || '';
                fun.setItem(html_name + '_isStop', temp['data']['is_stop']);
                fun.setItem(html_name + 'sideslip', true);
                $('#banks').empty();
                getList();
                break;
            case 'refresh':
                $('#banks').empty();
                getList();
                break;
        }

    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('banks', '.bank');
        }
    });
};

function getList() {
    page_list = [];
    temps = $.extend(true, {
        "keyword": "",
        "keyword_key": ['name','number','simple'],
        "md_id": 0,
        "md_mc": '',
        "is_stop": fun.getItem(html_name + '_isStop') || ''
    }, search_data);

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBankList,
        data: temps,
        success: function (res) {
            if (res['status'] == 0) {
                if ($.nui.isEmpty(res['data']) || !res['data'].length) {
                    page_list = [];
                    $('#tj_ck').text(0);
                    // $('#banks').css({'height': '100%', 'position': 'fixed'});
                    // return $('#banks').html('<p class="empty_text topss">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#banks',btnText:'新增账户',auth:'zh',style:'top:0rem;',sameAsTj:false,isDa:true});
                } else {
                    $('#banks').html('');
                    // $('#banks').css({'height': 'auto', 'position': 'unset'});
                }

                ztj_data = res['info'];
                page_list = res['data'];
                showList(fun.PagingData(page_list));
            } else {
                return fun.alert({msg: '网络异常！'});
            }
        }
    });
    fun.load_DATA_LIST(['zh']);
}

function showList(data) {
    $('#tj_ck').text(ztj_data['balance'] || 0);
    var list_html = [];
    //红，黄，蓝，绿，水蓝
    var bg_color = [['#FF9277', '#FE5567'], ['#FFD077', '#FF9055'], ['#64CEFF', '#248CFF'], ['#29D986', '#19A965'], ['#00D6BC', '#0190BA']];
    var bank_icon = [
        ['beijing', 'gonghang', 'guangfa', 'guangzhou', 'huaxia', 'huifeng', 'zhaoshang', 'zhonghang', 'zhoangxin'],
        ['guangda', 'ningbo', 'pingan', 'qita', 'xianjin', 'zheshang'],
        ['jianhang', 'jiangsu', 'jiaohang', 'minsheng', 'pufa', 'shanghai', 'shenfa', 'xingye', 'zhifubao'],
        ['weixin', 'youchu'],
        ['nonghang', 'wangshang']
    ];

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        var zc = getIndexs(bank_icon, fun.is_value(val['icon'])) || 0;
        list_html.push('<div class="bank" data-list=\'' + fun.formatString(JSON.stringify(val)) + '\' data-is-has="' + val['is_has'] + '" data-id="' + val['id'] + '" style="background:linear-gradient(to right,' + (bg_color[zc][0] || '') + ', ' + (bg_color[zc][1] || '') + ');">');
        list_html.push('<div class="bankImg">');
        list_html.push('<img src="../img/bank/' + val['icon'] + '" alt="">');
        list_html.push('</div>');
        list_html.push('<div class="bankCon">');
        list_html.push('<span class="bank-title">' + (val['name'] || "") + '</span>');
        //【账户-显示存款】有开启
        if(Auth.check('zh_xsck','view')) {
            list_html.push('<span class="save-money">存款<em>' + (val['balance'] || '') + '</em></span>');
        }
        list_html.push('<p class="bank-number">');
        list_html.push('<span>' + fun.redFont( fun.dealCard(fun.is_value(val['number'])),search_data['keyword'],'card')+ '</span>');
        list_html.push('</p>');
        list_html.push('<img src="../img/bank2/' + val['icon'] + '" alt="">');
        list_html.push('</div>');
        list_html.push('</div>');
    }
    $("#banks").append(list_html.join(''));
    //【账户-显示存款】没有开启
    if(!Auth.check('zh_xsck','view')) {
        $('.bank-title').css('top','20%');
    }
}

//判断数据是否存在于数组中，并返回对应的颜色
function getIndexs(arr1, value) {
    if (!value && value === undefined) return true;
    if (value && !!value.indexOf('.')) value = value.substr(0, value.indexOf('.'));
    value = value;
    for (var i = 0; i < arr1.length; i++) {
        if (arr1[i].indexOf(value) !== -1) {
            return i;
        }
    }
}

//点击键盘搜索
$('body').bind('search', "#foot_search", function (e) {
    search_data['keyword'] = $('#foot_search').val().trim();
    // if (e.keyCode === 13) {
        // $(this).select();
        $('#banks').empty();
        getList();
    // }
});

$('body').on('tap', '#add_btn', function (e) {
    fun.showPageFull({
        page_url: page_arr.account_add,
        pageParam: {
            return_page: html_name,
            status: 'add'
        }
    });
});

$('body').on('tap', '.bank', function () {
    fun.showPageFull({
        page_url: page_arr.account_add,
        pageParam: {
            id: $(this).data('id'),
            return_page: html_name,
            status: 'edit'
        }
    });
});
fun.setItem(html_name+'sideslip',true);
//打开搜索框
$('body').on('tap', '#filter_btn', function (e) {
    var sideslip=fun.getItem(html_name+'sideslip');
    var options = {
        "choose_merchants": [
            {
                key: "md",
                "text": "门店",
                "value": (temps && temps['md_mc'] ? temps['md_mc'] : ""),
                "id": (temps && temps['md_id'] ? temps['md_id'] : 0),
                // disabled: disabled
            },
        ],
        "switch": [
            {
                "text": "显示停用",
                "max_width": true,
                "key": "is_stop",
                "value": (temps && fun.getItem(html_name + '_isStop') ? fun.getItem(html_name + '_isStop') : '')
            },
        ],
    };
    if(sideslip){
        fun.setItem(html_name+'sideslip',false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

//处理卡号
// function dealCard(value){
//     var vstr=value.replace(/\s/g,'');
// 		var str='';
// 		if(vstr.length>19){
// 			vstr=vstr.replace(/\s/g,'').substr(0,19);
// 		}
// 		for(var i=0;i<vstr.length;i++){
// 			if((i) % 4 == 0 && i!==0){
//         str=str + '\xa0\xa0\xa0\xa0\xa0';
// 			}
// 			str=str+vstr[i];
// 		}
//     return str;
// }
