var html_name = page_arr.account_service;
var allData = [];
var back_status;
var screenArr = [];  //存储已有的账号信息
page_init = function () {
    //头部
    $('#header').header({
        back: true,
        title: '账号搜索',
        foot_input: {      //头部下面文本框
            show: true,
            scan_icon: false,
            fork_icon: false,
            plader: '搜索',
        }
    });

    //头部兼容
    $('.content').css({
        marginTop: api.safeArea.top + $('#header').height()
    })
    getList();
}

// 获取数据
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getUserList,
        data: {
            "is_all": 1,
            "account_id": (fun.getItem('account_info')['account_id'] || 0)
        },
        success: function (res) {
            if (res['status'] === 0) {
                if (res['data'].length != 0) {
                    if (page_data['status'] === 'ywy_shop') {
                        if (page_data['request'].length === 0) {
                            screenArr = res['data'];
                        } else {
                            for (var i = 0; i < res['data'].length; i++) {  //遍历列表除去已开通的账号
                                var item = res['data'][i];
                                var mark = false;
                                mark = page_data['request'].every(function (result, idx) {
                                    return item.account_id !== result.account_id;
                                })
                                if (mark) {
                                    screenArr.push(item);
                                }
                            }
                        }
                    } else {
                        for (var i = 0; i < res['data'].length; i++) {
                            if (res['data'][i]['account_id'] !== page_data['id']) {
                                screenArr.push(res['data'][i])
                            }
                        }
                    }
                    showList(screenArr)
                } else {
                    fun.createDataEmptyTips({ dom: 'ul', btnShow: false });
                }
            }
        }
    })
}

// 渲染列表
function showList(data) {
    var html = [];
    $(data).each(function (idx, item) {
        var colour = order_color[idx % order_color.length];
        html.push('<li class="center-list lower-border-line" data-id=\'' + item.account_id + '\' data-userId=\'' + item.id + '\'>');
        html.push('  <div class="le">');
        html.push('    <div class="eidt">');
        html.push('      <div class="name-radius" style="background-color:' + colour + '">')
        if (!!item['imgs']) {
            html.push('      <img src="' + fun.getImgPath(item.imgs, true, { url: UPLOAD_IMG_PATH }) + '">');
        } else {
            html.push(fun.getLastName(item['name'] || ""));
        }
        html.push('      </div>');
        html.push('      <div class="account-info">');
        html.push('        <div class="account-name">' + fun.is_value(item['name']) + '</div>');
        html.push('        <div class="account-mobile">' + fun.is_value(item['account']) + '</div>');
        html.push('      </div>');
        html.push('    </div>');
        html.push('  </div>');
        html.push('</li>');
    })
    $('#account_list').html(html.join(''));
}

// 搜索
$('body').on('search', '#foot_search', function () {
    if (screenArr.length === 0) return;
    var keywords = '';
    keywords = $('#foot_search').val().trim();
    var search_Arr = [];
    $(screenArr).each(function (i, obj) {
        if ((obj['name'] || "").indexOf(keywords) > -1 || obj['account'].indexOf(keywords) > -1) {
            search_Arr.push(obj);
        }
    })

    //判断搜索后是否有数据
    if (search_Arr.length === 0) {
        fun.createDataEmptyTips({ dom: 'ul', btnShow: false });
    } else {
        showList(search_Arr)
    }

});

//选中
$('body').on('tap', '.center-list', function () {
    var _this = $(this);
    var save_data = {};
    switch (page_data['status']) {
        case 'AIshop':
            save_data.is_default_aishop_customer_service = 1;
            break;
        case 'mall':
            save_data.is_default_mall_customer_service = 1;
            break;
        case 'ywy_shop':
            save_data.had_small_shop = 1;
            break;
    }
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            status: page_data['status'] || 'zh',
            img: _this.find('img').length === 0 ? '' : _this.find('img').attr('src'),
            name: _this.find('.account-name').text()
        }
    })
    save_data.user_id = _this.data('userid');
    $.ajax({
        type: "PUT",
        url: AJAX_URL.Accounts + '/' + _this.data('id') + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        data: save_data,
        success: function (res) {
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    status: page_data['name'] || 'zh',
                    img: _this.find('img').length === 0 ? '' : _this.find('img').attr('src'),
                    name: _this.find('.account-name').text(),
                    background: _this.find('.name-radius').attr('style')
                }
            })
        },
        error: function (err) {
            fun.toast('设置失败')
        },
        complete: function () {
            setTimeout(function () {
                api.closeWin();
            }, 100);
        }
    })
})