var html_name = page_arr.apply;
var $swiper_wrap = $('.swiper-wrapper'), // 滑动容器
    nowIdx = 0, // 上一次点击的序号
    mySwiper = null,
    flag = true, // swiper-wrapper内容滑动过程中，子项是否可以点击跳转
    hasClick = true, // swiper-wrapper内容滑动过程中，顶部导航栏是否可以切换
    nav_has_slide = true, // 子项点击时，顶部导航是否可以点击切换
    timer = null, // 定时器id
    visibleNavItem = null,
    SYS_CONFIG = fun.getItem('sys_config') || {},
    applyHide = $.nui.isTrue(SYS_CONFIG['ycwktgn']),
    photoBrowser;

// 获取视图列表高度
function getViewListHeight() {
    var viewListHeight = $(window).height() - $('.ui-header').outerHeight() - fun.computedHtmlFontSize()
    return viewListHeight;
}

// 获取滑动swiper的高
function getSwiperHeight(idx) {
    return $('.swiper-slide:visible').eq(idx).outerHeight();
}

// 限制swiper滑动高度
function restrictSwiperHeight(idx) {
    console.log('-----')
    console.log(idx)
    console.log(getSwiperHeight(idx))
    console.log(getViewListHeight())

    if (getSwiperHeight(idx) < getViewListHeight()) {
        $('.swiper-wrapper').css({
            height: getViewListHeight()
        })
    }
}

page_init = function () {
    photoBrowser = api.require('photoBrowser');

    showAppHtml(); // 加载html代码

    if (AuthVersionCheck.checkHide('ycsx')) {
        $('[data-type="label_sx"]').hide();
    }else{
        // $('[data-type="label_sx"]').show().css('visibility', 'visible');
    }

    if (AuthVersionCheck.checkHide('scdp')) {
        $('[data-type="dp"]').hide();
    }

    var showNavItem = $('.ui-nav-item:visible');
    var item_len = 100 / (showNavItem.length); // 设置头部切换宽度
    $('.ui-nav-item').css('width', item_len + '%');
    $('.swiper-wrapper').css('width', showNavItem.length * 100 + '%');

    var navLength = $('.ui-nav-item:visible').length;
    // $('.ui-nav-item:visible').eq(0).children('span').addClass('checked');
    $('.ui-nav-item').css('width', 'calc(100% / ' + navLength + ')');
    $('.ui-nav-item').not(':hidden').each(function (idx, item) {
    });

    $('.ui-nav-item span').removeClass('checked');
    $('.ui-nav-item:visible').eq(0).find('span').addClass('checked');

    $('.swiper-wrapper').css({
        height: $('.swiper-slide:visible').outerHeight()
    })

    restrictSwiperHeight(0);

    $('.swiper-container').css({
        paddingTop: $('.ui-header').outerHeight()
    })

    mySwiper = new Swiper('.swiper-container', {
        on: {
            touchStart: function () { // 滑动过程中底部选项不可点击
                api.sendEvent({
                    name: 'hasClick',
                    extra: {
                        hasClick: false
                    }
                });
            },
            touchEnd: function () { // 滑动结束恢复点击状态
                api.sendEvent({
                    name: 'hasClick',
                    extra: {
                        hasClick: true
                    }
                });
            },
            slideChangeTransitionStart: function () {
                visibleNavItem = $('.ui-nav-item:visible');
                nowIdx = this.activeIndex;
                visibleNavItem.eq(nowIdx).siblings().find('span').removeClass('checked');
                visibleNavItem.eq(nowIdx).find('span').addClass('checked');

                $swiper_wrap.css({
                    height: $('.swiper-slide:visible').eq(nowIdx).outerHeight()
                })
                restrictSwiperHeight(nowIdx);
            },
            transitionStart: function () { // 滑动过子项无法跳转
                flag = false;
            },
            transitionEnd: function () {
                setTimeout(function () {
                    flag = true;
                }, 300);
            }
        }
    });

    api.addEventListener({ // 内容滑动过程中是否可以切换滑动
        name: 'hasClick'
    }, function (ret, err) {
        hasClick = ret['value']['hasClick']
    });

    api.addEventListener({ // 子项点击过程头部是否可以切换
        name: 'nav_has_slide'
    }, function (ret, err) {
        nav_has_slide = ret['value']['nav_has_slide'];
    });

    var load_list = ['khh', 'md', 'zh', 'ck', 'sys_config'];
    if (Auth.check('wl', 'view')) load_list.push('wldw_wl');
    if (Auth.check('gys', 'view')) load_list.push('wldw_gys');

    fun.load_DATA_LIST(load_list, function () {
        var SYS_CONFIG = fun.getItem('sys_config') || {};
        if (SYS_CONFIG['dy_ls']) fun.setPrintConfig('mx_col', SYS_CONFIG['dy_ls']);
        if (SYS_CONFIG['dy_mx']) fun.setPrintConfig('group', JSON.parse(fun.formatParseJson(SYS_CONFIG['dy_mx'])));
    }, { showLoad: false });
    fun.load_printer_cloud(null, { not_alert: true, showLoad: false });
}

// 顶部导航触屏事件
$('body').on('tap', '.ui-nav-item:visible', fun.debounce(function () {
    nowIdx = $(this).index('.ui-nav-item:not(:hidden)'); // 拿到当前序号
    visibleNavItem = $('.ui-nav-item:visible');
    if (!hasClick) { // 滑动过程点击无效
        return;
    }

    if (!nav_has_slide) { // 滑动过程顶部导航点击无效
        return;
    }

    visibleNavItem.eq(nowIdx).siblings().find('span').removeClass('checked');
    visibleNavItem.eq(nowIdx).find('span').addClass('checked');

    $swiper_wrap.css({
        height: $('.swiper-slide:visible').eq(nowIdx).outerHeight()  // 获取内容高度
    })
    restrictSwiperHeight(nowIdx);
    mySwiper.slideTo(nowIdx);
}, 200))

// 加载html代码
function showAppHtml() {
    // var appAuch = fun.getItem('appAuch') ? fun.getItem('appAuch') : '';
    // if (appAuch) { // 本地缓存有数据
    //     $swiper_wrap.append(fun.getItem('appAuch'));
    // } else { // 缓存没数据
    $swiper_wrap.append(fun.createAppHtml());
    // }
    
    if (applyHide) {
        checkShow();    
    } else {
        $('.ui-nav-item').show().css('visibility', 'visible');
        
    }
}

// 判断权限
function checkShow() {
    var xs_obj = {
        cg: true,
        xs: true,
        kc: true,
        jg: true,
        ysyf: true,
        srfy: true,
        bb: true,
        zl: true,
        ry: true,
        cw: true,
        sxcg: true,
        sxxs: true,
        sxkc: true,
        sxjg: true,
        sxxz: true,
        dpzl: true,
        sjfx: true
    };

    if (!Auth.checkArr(['bp_cgdd', 'bp_cglhjs', 'bp_cgthjs', 'bp_cglhd', 'bp_cgthd', 'bp_cgbj'], 'view', 'in')) {
        applyHide && $('.module-cg').hide();
        xs_obj['cg'] = false;
    }

    if (!Auth.checkArr(['sx_cgdd', 'sx_cglhjs', 'sx_cgthjs', 'sx_cglhd', 'sx_cgthd', 'sx_cgbj'], 'view', 'in')) {
        applyHide && $('.module-sxcg').hide();
        xs_obj['sxcg'] = false;
    }

    if (!Auth.checkArr(['bp_xsdd', 'bp_xsfhjs', 'bp_xsthjs', 'bp_xsfhd', 'bp_xsthd', 'bp_xsdjcx', 'bp_xsbj', 'bp_xsnyfx'], 'view', 'in')) {
        applyHide && $('.module-xs').hide();
        xs_obj['xs'] = false;
    }

    if (!Auth.checkArr(['sx_xsdd', 'sx_xsfhjs', 'sx_xsthjs', 'sx_xsfhd', 'sx_xsthd', 'sx_xsbj'], 'view', 'in')) {
        applyHide && $('.module-sxxs').hide();
        xs_obj['sxxs'] = false;
    }

    if (!Auth.checkArr(['bp_kc', 'bp_ckc', 'bp_kcyj', 'bp_hdb', 'kc_tmcx', 'kc_bppyd', 'kc_bpmxpkd', 'kc_bptbd', 'kc_bpzspd'], 'view', 'in')) {
        applyHide && $('.module-kc').hide();
        xs_obj['kc'] = false;
    }

    if (!Auth.checkArr(['sx_kc', 'sx_ckc', 'sx_kcyj', 'sx_hdb', 'kc_sxpyd', 'kc_sxtbd', 'kc_sxpd'], 'view', 'in')) {
        applyHide && $('.module-sxkc').hide();
        xs_obj['sxkc'] = false;
    }

    if (!Auth.checkArr(['bp_wwjg', 'bp_jglhjs', 'bp_jgthjs', 'bp_jglhd', 'bp_jgthd', 'bp_jgbj'], 'view', 'in')) {
        applyHide && $('.module-jg').hide();
        xs_obj['jg'] = false;
    }

    if (!Auth.checkArr(['sx_wwjg', 'sx_jglhjs', 'sx_jgthjs', 'sx_jglhd', 'sx_jgthd', 'sx_jgbj'], 'view', 'in')) {
        applyHide && $('.module-sxjg').hide();
        xs_obj['sxjg'] = false;
    }

    if (!Auth.checkArr(['sx_xzd', 'sx_xzlhjs', 'sx_xzlhd', 'sx_xzbj', 'sx_tsd', 'sx_lsd'], 'view', 'in')) {
        applyHide && $('.module-sxxz').hide();
        xs_obj['sxxz'] = false;
    }

    if (!Auth.checkArr(['fs'], 'view', 'in')) {//'khgl', 
        applyHide && $('.module-dpzl').hide();
        xs_obj['dpzl'] = false;
    }

    //AI重构 2020-05-11 打包时注释（其他情况要打开）
    // if (!Auth.checkArr(['dpdt', 'fkfx', 'xsqk', 'nyjl', 'nyfx', 'xqfx'], 'view', 'in')) {
        applyHide && $('.module-sjfx').hide();
        xs_obj['sjfx'] = false;
    // }

    if (!Auth.checkArr(['cw_skd', 'cw_fkd', 'cw_ywtz', 'cw_dzb_kh', 'cw_dzb_gys', 'cw_dzb_jgs', 'cw_dzb_wl'], 'view', 'in')) {
        applyHide && $('.module-ysyf').hide();
        xs_obj['ysyf'] = false;
    }

    if (!Auth.checkArr(['cw_fyd', 'cw_srd', 'cw_nbzz', 'cw_xjyhdzb'], 'view', 'in')) {
        applyHide && $('.module-srfy').hide();
        xs_obj['srfy'] = false;
    }

    if (!Auth.checkArr(['cw_rbb', 'cw_ybb', 'cw_mlb', 'cw_sxmlb', 'cw_cbhs'], 'view', 'in')) {
        applyHide && $('.module-bb').hide();
        xs_obj['bb'] = false;
    }

    if (!Auth.checkArr(['cp', 'ck', 'sx', 'cplb'], 'view', 'in')) {//, 'gsxx'
        applyHide && $('.module-zl').hide();
        xs_obj['zl'] = false;
    }

    if (!Auth.checkArr(['kh', 'gys', 'jgs', 'wl', 'yg'], 'view', 'in')) {
        applyHide && $('.module-ry').hide();
        xs_obj['ry'] = false;
    }

    if (!Auth.checkArr(['zh', 'fylx', 'srlx'], 'view', 'in')) {
        applyHide && $('.module-cw').hide();
        xs_obj['cw'] = false;
    }

    console.log(xs_obj)

    if (!xs_obj['cg'] && !xs_obj['xs'] && !xs_obj['kc'] && !xs_obj['jg']) {
        $('[data-type="bp"]').hide();
    } else {
        $('[data-type="bp"]').show().css('visibility', 'visible');
    }

    if (!xs_obj['sxcg'] && !xs_obj['sxxs'] && !xs_obj['sxjg'] && !xs_obj['sxxz'] && !xs_obj['sxkc']) {
        $('[data-type="label_sx"]').hide();

    } else {
        $('[data-type="label_sx"]').show().css('visibility', 'visible');
    }

    if (!xs_obj['ysyf'] && !xs_obj['srfy'] && !xs_obj['bb']) {
        $('[data-type="cw"]').hide();
    } else {
        $('[data-type="cw"]').show().css('visibility', 'visible');
    }

    if (!xs_obj['zl'] && !xs_obj['ry'] && !xs_obj['cw']) {
        $('[data-type="zl"]').hide();
    } else {
        $('[data-type="zl"]').show().css('visibility', 'visible');
    }

    if (!xs_obj['sjfx'] && !xs_obj['dpzl']) {
        $('[data-type="dp"]').hide();
    } else {
        $('[data-type="dp"]').show().css('visibility', 'visible');
    }

    $('.ui-nav-item span').removeClass('checked');
    $('.ui-nav-item:visible').eq(0).find('span').addClass('checked');
}

// 对应跳转链接参数
var param = {
    // (布匹界面)
    //店铺
    shop_fans: { // 粉丝
        page_url: page_arr['shop_fans']
    },
    zffx: { // 增粉分析
        page_url: page_arr['powder_addition']
    },
    shop_kh_gl: { // 客户管理
        page_url: page_arr['shop_kh_gl']
    },
    shop_xwfx: { // 行为分析
        page_url: page_arr['Behavior_analysis']
    },

    /*数据分析*/
    shop_dp_dt: { // 店铺动态
        page_url: page_arr['shop_dp_dt']
    },
    shop_dp_fkfx: { // 访客分析
        page_url: page_arr['shop_dp_fkfx']
    },
    shop_bp_xsqk: { // 销售情况
        page_url: page_arr['shop_bp_xsqk']
    },
    bp_xsnyjl: { // 拿样记录
        page_url: page_arr['shop_dp_nyjl']
    },
    bp_cpfw: { // 产品访问情况
        page_url: page_arr['product_access']
    },
    // xs_xsfx: { //销售分析
    //     page_url: page_arr['xs_xsfx']
    // },
    shop_xq_fx: { // 兴趣分析
        page_url: page_arr['shop_xq_fx']
    },
    // 采购
    bp_cgdd: { // 采购订单
        text: '采购订单',
        page_url: page_arr['cg_cgdd_tj'],
        pageParam: {}
    },


    'bp_cglhjs,bp_cgthjs': { // 来/退结算
        text: '来/退结算',
        page_url: page_arr['cg_lthjs_tj']
    },
    bp_cglhjs: { // 采购来结算
        text: '来/退结算',
        page_url: page_arr['cg_lthjs_tj']
    },
    bp_cgthjs: { // 采购退结算
        text: '来/退结算',
        page_url: page_arr['cg_lthjs_tj']
    },
    'bp_cglhd,bp_cgthd': { // 来/退货
        text: '来/退货',
        page_url: page_arr['cg_lthtj']
    },
    bp_cgbj: { // 采购报价
        text: '采购报价',
        page_url: page_arr['cg_cgbj_cx']
    },

    // 销售
    bp_xsdd: { // 客户订单
        text: '客户订单',
        page_url: page_arr['xs_khdd_tj']
    },


    'bp_xsfhjs,bp_xsthjs': { // 发/退结算
        text: '发/退结算',
        page_url: page_arr['xs_fthjs_tj']
    },

    'bp_xsfhjs': { // 发结算
        text: '发/退结算',
        page_url: page_arr['xs_fthjs_tj']
    },
    'bp_xsthjs': { // 退结算
        text: '发/退结算',
        page_url: page_arr['xs_fthjs_tj']
    },
    'bp_xsfhd,bp_xsthd': { // 发/退货
        text: '发/退货',
        page_url: page_arr['xs_fth_tj']
    },
    bp_xsdjcx: { // 订金查询
        text: '订金查询',
        page_url: page_arr['xs_djcx']
    },
    bp_xsbj: { // 销售报价
        text: '销售报价',
        page_url: page_arr['xs_xsbj_cx']
    },
    bp_xscpfx: { // 产品分析
        text: '产品分析',
        page_url: page_arr['xs_cpfx']
    },
    bp_xskhfx: {
        text: '客户分析',
        page_url: page_arr['xs_khfx']
    },
    bp_xsnyfx: { // 拿样分析
        text: '拿样分析',
        page_url: page_arr['xs_nyfx']
    },
    // 库存
    bp_kc: { // 布匹库存
        text: '布匹库存',
        page_url: page_arr['kc_ck'],
        pageParam: {
            obj: 'cloth',
        }
    },
    bp_ckc: { // 查库存
        text: '查库存',
        page_url: page_arr['kc_ckc'],
        pageParam: {
            obj: 'cloth',
            title: '产品库存',
            plader: '产品编号、产品名称',
        }
    },
    kc_kcyj: { // 库存预警
        text: '库存预警',
        page_url: page_arr['kc_kcyj'],
    },
    bp_hdb: { // 活动表
        text: '活动表',
        page_url: page_arr['select_list'],
        pageParam: {
            page_type: "hdb_ck",
            // showAllCk: true
        }
    },
    kc_tmcx: { // 条码查询
        text: '条码查询',
        page_url: page_arr['kc_tmcx']
    },
    kc_bppyd: { // 盘盈单
        text: '盘盈单',
        page_url: page_arr['kc_pyd']
    },
    kc_bpmxpkd: { // 明细盘亏
        text: '明细盘亏',
        page_url: page_arr['kc_mxpk']
    },
    kc_bptbd: { // 调拨单
        text: '调拨单',
        page_url: page_arr['kc_dbd']
    },
    kc_bpzspd: { // 总数盘点
        text: '总数盘点',
        page_url: page_arr['kc_zspd']
    },

    // 加工
    bp_wwjg: { // 布匹加工
        text: '布匹加工',
        page_url: page_arr['jg_wwjg_tj']
    },
    'bp_jglhjs,bp_jgthjs': { // 来/退结算
        text: '来/退结算',
        page_url: page_arr['jg_lthjs_tj']
    },
    'bp_jglhd,bp_jgthd': { // 来/退货
        text: '来/退货',
        page_url: page_arr['jg_lthd_tj']
    },
    bp_jgbj: { // 加工报价
        text: '加工报价',
        page_url: page_arr['jg_jgbj']
    },

    // (财务)
    // 应收应付
    cw_skd: { // 收款单
        page_url: page_arr['cw_sfkd_tj'],
        pageParam: {
            title: '收款单',
            obj: 'skd',
        }
    },
    cw_fkd: { // 付款单
        page_url: page_arr['cw_sfkd_tj'],
        pageParam: {
            title: '付款单',
            obj: 'fkd',
        }
    },
    cw_ywtz: { // 业务调账
        page_url: page_arr['cw_ywtz']
    },
    cw_dzb_kh: { // 客户对账
        page_url: page_arr['cw_dz'],
        pageParam: {
            title: '客户对账表',
            page_type: 'kh',
        }
    },
    cw_dzb_gys: { // 供应商对账
        page_url: page_arr['cw_dz'],
        pageParam: {
            title: '供应商对账表',
            page_type: 'gys',
        }
    },
    cw_dzb_jgs: { // 加工商对账
        page_url: page_arr['cw_dz'],
        pageParam: {
            title: '加工商对账表',
            page_type: 'jgs',
        }
    },
    cw_dzb_wl: { // 物流对账
        page_url: page_arr['cw_dz'],
        pageParam: {
            title: '物流对账表',
            page_type: 'wl',
        }
    },

    // 收入费用
    cw_fyd: { // 费用单
        page_url: page_arr['cw_fyd_tj']
    },
    cw_srd: { // 其他收入
        page_url: page_arr['cw_qtsr_tj']
    },
    cw_nbzz: { // 内部转账
        page_url: page_arr['cw_nbzz']
    },
    cw_xjyhdzb: { // 账户对账
        page_url: page_arr['cw_zhdz']
    },

    // 报表
    cw_rbb: { // 日报表
        page_url: page_arr['cw_rbb']
    },
    cw_ybb: { // 月报表
        page_url: page_arr['cw_ybb']
    },
    cw_mlb: { // 毛利表
        page_url: page_arr['cw_mlb'],
        pageParam: {
            title: '毛利表',
            obj: 'mlb',
        }
    },
    cw_sxmlb: { // 纱线毛利表
        page_url: page_arr['cw_sxmlb'],
        pageParam: {
            title: '纱线毛利',
            obj: 'sx_mlb',
        }
    },
    cw_cbhs: { // 成本核算
        page_url: page_arr['cw_cbhs']
    },

    // (资料)
    //  资料面板
    cp: { // 产品
        page_url: page_arr['shop_cp_cpzl']
    },
    sx: { //纱线
        page_url: page_arr['yarn']
    },
    shop_product_class: { // 产品类别
        page_url: page_arr['shop_product_class']
    },
    ck: { // 仓库
        page_url: page_arr['storehouse']
    },
    gsxx: { // 公司信息
        page_url: page_arr['company_information']
    },

    // 人员面板
    kh: { // 客户
        page_url: page_arr['base_type'],
        pageParam: {
            "title": '客户',
            "obj": 'custom',
            "isYuyin": false,
            "addurl": page_arr.custom_add,
            "searchurl": page_arr.search,
            "inputText": '搜索客户'
        }
    },
    bp_khtx: { //客户画像
        page_url: page_arr['customer_search'],
        pageParam: {
            return_page: html_name,
            BILL_PAGE: page_arr.xs_khfx_xq,
            djlx: 'khtx', // 客户画像
            page_type: 'kh'
        }
    },
    gys: { // 供应商
        page_url: page_arr['base_type'],
        pageParam: {
            "title": '供应商',
            "obj": 'supplier',
            "isYuyin": false,
            "addurl": page_arr.custom_add,
            "searchurl": page_arr.search,
            "inputText": '搜索供应商'
        }
    },
    jgs: { // 加工商
        page_url: page_arr['base_type'],
        pageParam: {
            "title": '加工商',
            "obj": 'processor',
            "isYuyin": false,
            "addurl": page_arr.custom_add,
            "searchurl": page_arr.search,
            "inputText": '搜索加工商'
        }
    },
    wl: { // 物流
        page_url: page_arr['base_type'],
        pageParam: {
            "title": '物流',
            "obj": 'logistics',
            "isYuyin": false,
            "addurl": page_arr.custom_add,
            "searchurl": page_arr.search,
            "inputText": '搜索物流'
        }
    },
    yg: { // 员工
        page_url: page_arr['employee']
    },

    // 财务面板
    zh: { // 账户
        page_url: page_arr['account']
    },
    fylx: { // 费用类型
        page_url: page_arr['cost_type'],
        pageParam: {
            "title": '费用类型',
            "obj": "cost",
            "isYuyin": false,
        }
    },
    srlx: { // 收入类型
        page_url: page_arr['cost_type'],
        pageParam: {
            "title": '收入类型',
            "obj": "income",
            "isYuyin": false,
        }
    },

    // ============== 纱线 ===============
    // 纱线销售
    sx_xsdd: { // 客户订单
        text: '客户订单',
        page_url: page_arr['sxxs_khdd_tj']
    },
    'sx_xsfhjs,sx_xsthjs': { // 发/退结算
        text: '发/退结算',
        page_url: page_arr['sxxs_fthjs_tj']
    },
    'sx_xsfhjs': { // 发结算
        text: '发/退结算',
        page_url: page_arr['sxxs_fthjs_tj']
    },
    'sx_xsthjs': { // 退结算
        text: '发/退结算',
        page_url: page_arr['sxxs_fthjs_tj']
    },
    'sx_xsfhd,sx_xsthd': { // 发/退货
        text: '发/退货',
        page_url: page_arr['sxxs_fthd_tj']
    },
    sx_xsbj: { // 销售报价
        text: '销售报价',
        page_url: page_arr['sxxs_xsbj_tj']
    },
    // 纱线库存
    sx_kc: { // 纱线库存
        text: '纱线库存',
        page_url: page_arr['sxkc_ck'],
        pageParam: {
            obj: 'cloth',
        }
    },
    sx_ckc: { // 查库存
        text: '查库存',
        page_url: page_arr['sxkc_ckc'],
        pageParam: {
            obj: 'cloth',
            title: '纱线库存',
            plader: '纱线名称',
        }
    },
    sx_kcyj: { // 库存预警
        text: '库存预警',
        page_url: page_arr['sxkc_kcyj'],
    },
    sx_hdb: { // 活动表
        text: '活动表',
        page_url: page_arr['select_sx_list'],
        pageParam: {
            page_type: "sxhdb_ck",
            type: 'sx'
            // showAllCk: true
        }
    },
    kc_sxpyd: { // 盘盈单
        text: '盘盈单',
        page_url: page_arr['sxkc_pyd']
    },
    kc_sxpd: { // 盘点单
        text: '盘点单',
        page_url: page_arr['sxkc_pdd']
    },
    kc_sxtbd: { // 调拨单
        text: '调拨单',
        page_url: page_arr['sxkc_tbd']
    },

    // 纱线采购
    sx_cgdd: { // 采购订单
        text: '采购订单',
        page_url: page_arr['sxcg_cgdd_tj'],
        pageParam: {}
    },
    'sx_cglhjs,sx_cgthjs': { // 来/退结算
        text: '来/退结算',
        page_url: page_arr['sxcg_lthjs_tj']
    },
    'sx_cglhjs': { // 来结算
        text: '来/退结算',
        page_url: page_arr['sxcg_lthjs_tj']
    },
    'sx_cgthjs': { // 退结算
        text: '来/退结算',
        page_url: page_arr['sxcg_lthjs_tj']
    },
    'sx_cglhd,sx_cgthd': { // 来/退货
        text: '来/退货',
        page_url: page_arr['sxcg_lthd_tj']
    },
    sx_cgbj: { // 采购报价
        text: '采购报价',
        page_url: page_arr['sxcg_cgbj_tj']
    },

    // 纱线加工
    sx_wwjg: { // 加工订单
        text: '加工订单',
        page_url: page_arr['sxjg_sxjg'],
        pageParam: {}
    },
    'sx_jglhjs,sx_jgthjs': { // 来/退结算
        text: '来/退结算',
        page_url: page_arr['sxjg_lthjs_tj']
    },
    'sx_jglhjs': { // 来结算
        text: '来/退结算',
        page_url: page_arr['sxjg_lthjs_tj']
    },
    'sx_jgthjs': { // 退结算
        text: '来/退结算',
        page_url: page_arr['sxjg_lthjs_tj']
    },
    'sx_jglhd,sx_jgthd': { // 来/退货
        text: '来/退货',
        page_url: page_arr['sxjg_lthd_tj']
    },
    sx_jgbj: { // 加工报价
        text: '加工报价',
        page_url: page_arr['sxjg_jgbj_tj']
    },

    // 下织
    sx_xzd: { // 下织单
        text: '下织单',
        page_url: page_arr['xz_xzd'],
        pageParam: {}
    },
    'sx_xzlhjs': { // 来货结算
        text: '来货结算',
        page_url: page_arr['xz_lhjs_tj']
    },
    'sx_xzlhd': { // 来货单
        text: '来货单',
        page_url: page_arr['xz_lhd_tj']
    },
    sx_xzbj: { // 下织报价
        text: '下织报价',
        page_url: page_arr['xz_xzbj']
    },
    'sx_lsd,sx_tsd': { // 来/退纱
        text: '来/退纱',
        page_url: page_arr['xz_lts']
    },
}

// 点击跳转对应链接
$('body').on('click', '.ui-icon-item:visible', function (e) {
    if (!flag) {
        return;
    }

    api.sendEvent({
        name: 'nav_has_slide',
        extra: {
            nav_has_slide: false
        }
    });

    e.stopPropagation();
    e.preventDefault();

    $('#shield').show();
    clearTimeout(timer);
    timer = setTimeout(function () {
        $('#shield').hide();
    }, 1000);

    var nowIdx = $('.swiper-slide:visible').index($(this).parents('.swiper-slide'));

    var pageType = $(this).data('type');
    var pageUrl = param[pageType];

    setTimeout(function () {
        mySwiper.slideTo(nowIdx);
    }, 250);
    var type, http_img = 'https://res.yunbuye.cn/imgs/gn_tips/', cont = 0;

    if ($(this).hasClass('auth-gray')) {
        var __auth = '';
        switch (pageType) {
            case 'shop_cp_cpzl':
            case 'shop_product_class':
                __auth = 'cp';
                break;
            case 'sc_kh':
                __auth = 'kh';
                break;
            case 'bp_xsfhd,bp_xsthd':
            case 'bp_cglhd,bp_cgthd':
            case 'bp_jglhjs,bp_jgthjs':
            case 'bp_jglhd,bp_jgthd':
                __auth = pageType;
                break;
            default:
                __auth = pageType;
                break;
        }

        fun.checkAuthExist({
            auth: __auth,
            name: $(this).find('.ui-icon-desc').text(),
            callback: showPicsAndTips
        })

        function showPicsAndTips() {
            switch (pageType) {
                case 'shop_cp_cpzl':
                    type = 'cp';
                case 'sc_kh':
                    type = 'kh';
                case 'bp_xsfhd,bp_xsthd':
                    type = 'bp_xsfthd';
                case 'bp_cglhd,bp_cgthd':
                    type = type ? type : 'bp_cglthd';
                case 'bp_jglhjs,bp_jgthjs':
                    type = type ? type : 'bp_jglthjs';
                case 'bp_jglhd,bp_jgthd':
                    type = type ? type : 'bp_jglthd';
                default:
                    if (cont == 1) return;
                    if (!Auth.check(pageType, 'view')) {
                        cont = 1;
                        type = type ? type : pageType;
                        http_img += (type + '.jpg');
                        var xmlHttp;
                        if (window.ActiveXObject) {
                            xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
                        }
                        else if (window.XMLHttpRequest) {
                            xmlHttp = new XMLHttpRequest();
                        }
                        xmlHttp.open("Get", http_img, false);
                        xmlHttp.send();
                        if (xmlHttp.status == 404) {
                            cont = 0;
                            fun.toast('升级版本后能获得该功能哟~')
                        } else {
                            cont = 0;

                            api.openWin({
                                name: page_arr['show_imgs'],
                                url: page_arr['show_imgs'],
                                reload: true,
                                slidBackType: 'edge',
                                delay: 50,
                                pageParam: {
                                    return_page: html_name,
                                    imgSrc: http_img
                                },
                                animation: {
                                    type: 'none',
                                    subType: "from_right",
                                    duration: 200
                                },
                                slidBackEnabled: false
                            });

                            // fun.showPageFull({
                            //     page_url: page_arr['show_imgs'],
                            //     pageParam: {
                            //         return_page: html_name,
                            //         imgSrc: http_img
                            //     },
                            // });


                            // photoBrowser.open({
                            //     images: [http_img],
                            //     placeholderImg: '../img/logo.png',
                            //     bgColor: '#000'
                            // }, function (ret, err) {
                            //     if (ret) {
                            //         if (ret['eventType'] == 'click') {
                            //             photoBrowser.close();
                            //         }
                            //     } else {
                            //     }
                            // });

                            // var imageBrowser = api.require('imageBrowser');
                            // imageBrowser.openImages({
                            //     imageUrls: [http_img]
                            // });
                        }
                    }
                    break;
            }
        }

        return;
    }

    // if (applyHide) {
    //     switch (pageType) {
    //         case 'shop_product_class':
    //         case 'shop_kh_gl':
    //         case 'shop_fans':
    //         case 'shop_dp_dt':
    //         case 'shop_dp_fkfx':
    //         case 'shop_bp_xsqk':
    //         case 'xs_xsfx':
    //         case 'bp_xsnyjl':
    //         case 'bp_xsnyfx':
    //         case 'shop_xq_fx':
    //             break;
    //         case 'shop_cp_cpzl':
    //             if (!Auth.check('cp', 'view')) {
    //                 fun.toast('升级版本后能获得该功能哟~');
    //                 return;
    //             };
    //             break;
    //         case 'sc_kh':
    //             if (!Auth.check('kh', 'view')) {
    //                 fun.toast('升级版本后能获得该功能哟~');
    //                 return;
    //             };
    //             break;
    //         case 'bp_xsfhd,bp_xsthd':
    //             type = 'bp_xsfthd';
    //         case 'bp_cglhd,bp_cgthd':
    //             type = type ? type : 'bp_xsfthd';
    //         case 'bp_jglhjs,bp_jgthjs':
    //             type = type ? type : 'bp_jglthjs';
    //         case 'bp_jglhd,bp_jgthd':
    //             type = type ? type : 'bp_jglthd';
    //         default:
    //             if (cont == 1) return;
    //             if (!Auth.check(pageType, 'view')) {
    //                 cont = 1;
    //                 type = type ? type : pageType;
    //                 http_img += (type + '.jpg');
    //                 var xmlHttp;
    //                 if (window.ActiveXObject) {
    //                     xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    //                 }
    //                 else if (window.XMLHttpRequest) {
    //                     xmlHttp = new XMLHttpRequest();
    //                 }
    //                 xmlHttp.open("Get", http_img, false);
    //                 xmlHttp.send();
    //                 if (xmlHttp.status == 404) {
    //                     cont = 0;
    //                     fun.toast('升级版本后能获得该功能哟~')
    //                 } else {
    //                     cont = 0;
    //                     photoBrowser.open({
    //                         images: [http_img],
    //                         placeholderImg: '../img/logo.png',
    //                         bgColor: '#000'
    //                     }, function (ret, err) {
    //                         if (ret) {
    //                             if (ret['eventType'] == 'click') {
    //                                 photoBrowser.close();
    //                             }
    //                         } else {
    //                             // console.log(JSON.stringify(err));
    //                         }
    //                     });
    //                 }
    //                 return;
    //             };
    //             break;
    //     }
    // }

    // 点击记录行直接跳转开单页，相当于常用应用功能
    var _pageType;
    switch (pageType) {
        case 'cw_srd'://收入单
            _pageType = 'cw_qtsr_kd';
        case 'cw_skd'://收款单
        case 'cw_fkd'://付款单
        case 'cw_ywtz'://业务调整
        case 'cw_fyd'://费用单
        case 'cw_nbzz'://内部转账
            _pageType = _pageType ? _pageType : pageType + '_kd';
            if (Auth.check(pageType, 'edit')) {
                if (!fun.checkKz()) return;
                fun.showPageFull({
                    page_url: page_arr[_pageType] || '',
                    pageParam: {
                        "type": "add",
                        opt: 'append',
                        return_page: html_name
                    },
                    flag: flag
                });
                return;
            }
            break;
        case 'bp_xsdd'://销售订单
            if (Auth.check('bp_xsdd', 'edit')) {
                if (!fun.checkKz()) return;
                PageShow.xskhdd();
                return;
            }
            break;
        case 'bp_xsfhjs'://销售发货单结算
            if (Auth.check('bp_xsfhjs', 'edit')) {
                if (!fun.checkKz()) return;
                PageShow.xsfhjs();
                return;
            }
            break;
        case 'bp_xsthjs'://销售退货单结算
            if (Auth.check('bp_xsthjs', 'edit')) {
                if (!fun.checkKz()) return;
                PageShow.xsthjs();
                return;
            }
            break;
        case 'bp_xsbj'://销售报价
            if (Auth.check('bp_xsbj', 'edit')) {
                if (!fun.checkKz()) return;
                var __route = [
                    {
                        url: page_arr.customer_search,
                        page_data: {
                            djlx: 'bp_xsbj',
                            LIST_PAGE: html_name,
                            BILL_PAGE: page_arr.xs_xsbj_kd,
                            return_page: html_name,
                            // save_return_page: html_name,
                            page_type: 'kh',
                            type: 'bp_xsbj',
                            from_page: html_name,
                            wldw_tmp: {
                                return_page: html_name,
                                page_type: 'kh',
                                djlx: 'bp_xsbj',
                                getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                            },
                            NOT_OPEN_AGAIN: false
                        }
                    },
                    {
                        url: page_arr.choice_product,
                        page_data: {
                            djlx: 'bp_xsbj',
                            return_page: html_name,
                            cp_tmp: {
                                return_page: html_name,
                            }
                        }
                    },
                    {
                        url: page_arr.xs_xsbj_kd,
                        page_data: {
                            // save_return_page: html_name,
                        }
                    }
                ];

                fun.showPageFull({
                    page_url: __route[0]['url'],
                    pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
                });
                return;
            }
            break;
        case 'kc_bptbd'://调拨单
            if (Auth.check('kc_bptbd', 'edit')) {
                // 页面顺序， 选择产品 -> 选择颜色 -> 开单编辑 -> 调拨单编辑
                // 默认读取有权限浏览的最后一张调拨单的调出仓库
                // 查找仓库信息。获取单号接口，有返回
                if (!fun.checkKz()) return;
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getBillsPageDefInfo,
                    data: {
                        djlx: 'kc_bptbd',
                        table: 'kc_bptbd_dj'
                    },
                    success: function (res) {
                        if (!res) {
                            res = {};
                        }
                        res.data = res.data || {};

                        var ck_id = res.data.ck_id || 0;
                        var dcck_id = res.data.dcck_id || 0;
                        var route = [
                            {
                                url: page_arr.choice_product,
                                page_data: {
                                    djlx: 'kc_bptbd',
                                    LIST_PAGE: html_name,
                                    BILL_PAGE: page_arr.kc_dbd_edit,
                                    cp_tmp: {
                                        __PAGE_INFO: {  // 仓库信息
                                            ck_id: ck_id,
                                            dcck_id: dcck_id,
                                        }
                                    },
                                    return_page: page_arr.kc_dbd,
                                    // BILL_PAGE: page_arr.kc_dbd_edit,
                                    // LIST_PAGE: page_arr.kc_dbd,
                                }
                            },
                            {
                                url: page_arr.select_list,
                                page_data: {
                                    page_type: 'cp_ys',
                                }
                            },
                            {
                                url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor,
                                page_data: {
                                    return_page: page_arr.choice_product
                                }
                            },
                            {
                                url: page_arr.kc_dbd_edit,
                                page_data: {
                                    return_page: page_arr.kc_dbd
                                }
                            }
                        ];

                        fun.showPageFull({
                            page_url: route[0].url,
                            pageParam: $.extend(true, { __route: route }, route[0]['page_data'])
                        });
                    }
                })
                return;
            }
            break;
        case 'kc_bppyd'://盘盈单
            if (Auth.check('kc_bppyd', 'edit')) {
                // 跳转顺序: 仓库搜索 -> 选产品 -> 选颜色 -> 开单编辑 -> 盘盈单编辑页面
                if (!fun.checkKz()) return;
                var __route = [ // 定义页面顺序
                    {
                        url: page_arr.select_list,
                        page_data: {
                            djlx: 'kc_bppyd',
                            page_type: 'hdb_ck',
                            __index: 0,
                            LIST_PAGE: html_name,
                            BILL_PAGE: page_arr.kc_pyd_edit,
                            return_page: html_name
                        },
                    },
                    {
                        url: page_arr.choice_product,
                        page_data: {
                            djlx: 'kc_bppyd',
                            NOT_OPEN_AGAIN: false
                        },
                    },
                    {
                        url: page_arr.select_list,
                        page_data: {
                            djlx: 'kc_bppyd',
                            page_type: 'cp_ys',
                            edit_row: false
                        }
                    },
                    {
                        url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor,
                        page_data: {
                            djlx: 'kc_bppyd',
                            return_page: page_arr.choice_product,
                            hsdj_fixed: 6
                        }
                    },
                    {
                        url: page_arr.kc_pyd_edit,
                        page_data: {
                            return_page: html_name,
                        },
                    }
                ];
                fun.showPageFull({
                    page_url: page_arr.select_list,
                    pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
                });
                return;
            }
            break;
        case 'kc_bpmxpkd'://明细盘亏
            if (Auth.check('kc_bpmxpkd', 'edit')) {
                // 跳转顺序: 调库存 -> 明细盘亏编辑
                if (!fun.checkKz()) return;
                var __route = [ // 定义页面顺序
                    {
                        url: page_arr.detailed_stock2,
                        page_data: {
                            LIST_PAGE: html_name,
                            BILL_PAGE: page_arr.kc_mxpk_edit,
                            djlx: 'kc_bpmxpkd',
                            return_page: html_name,
                            has_tm: true,   // 只查询开启明细的产品
                            __IS_NEW: true    // 标记新增
                        }
                    },
                    {
                        url: page_arr.kc_mxpk_edit,
                        page_data: {
                            djlx: 'kc_bpmxpkd',
                            return_page: html_name,
                        }
                    },
                ];
                var opt = {
                    page_url: __route[0]['url'],
                    pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
                };
                fun.showPageFull(opt);
                return;
            }
            break;
        case 'kc_bpzspd'://总数盘点
            if (Auth.check('kc_bpzspd', 'edit')) {
                // 页面打开顺序
                if (!fun.checkKz()) return;
                var __route = [
                    {
                        url: page_arr.detailed_stock2,
                        page_data: {
                            LIST_PAGE: html_name,
                            BILL_PAGE: page_arr.kc_zspd_edit,
                            goto_page: page_arr.kc_zspd_edit,
                            djlx: 'kc_bpzspd',
                            __IS_NEW: true,
                        }
                    },
                    {
                        url: page_arr.kc_zspd_edit,
                        page_data: {
                            return_page: page_arr.kc_zspd,
                        }
                    }
                ];
                var opt = {
                    page_url: __route[0]['url'],
                    pageParam: $.extend(true, { __route: __route, id: 0 }, __route[0]['page_data'])
                };
                fun.showPageFull(opt);
                return;
            }
            break;
        case 'bp_cgdd'://采购订单
            if (Auth.check('bp_cgdd', 'edit')) {
                if (!fun.checkKz()) return;
                var djlx = 'bp_cgdd';
                var __route = [
                    {
                        url: page_arr.customer_search,
                        page_data: {
                            LIST_PAGE: html_name,
                            BILL_PAGE: page_arr.cg_cgdd_kd,
                            djlx: djlx,
                            return_page: html_name,
                            page_type: 'gys',
                            wldw_tmp: {
                                return_page: html_name,
                                LIST_PAGE: html_name,
                                BILL_PAGE: page_arr.cg_cgdd_kd,
                                page_type: 'gys',
                                djlx: djlx,
                                getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                            },
                            NOT_OPEN_AGAIN: false,
                            edit_row: false,
                            loadScdj: true
                        }
                    },
                    {
                        url: page_arr.choice_product,
                        page_data: {
                            djlx: djlx,
                            return_page: html_name,
                            cp_tmp: {
                                return_page: html_name,
                            }
                        }
                    },
                    {
                        url: page_arr.cg_cgdd_kd,
                        page_data: {
                            return_page: html_name,
                        }
                    }
                ];

                fun.showPageFull({
                    page_url: __route[0].url,
                    pageParam: $.extend({ __route: __route }, __route[0]['page_data'])
                })
                return;
            }
            break;
        case 'bp_cglhjs'://采购来货结算
            if (Auth.check('bp_cglhjs', 'edit')) {
                if (!fun.checkKz()) return;
                var djlx = 'bp_cglhjs';
                var table = 'cglhjs_dj';
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getBillsPageDefInfo,
                    data: {
                        'djlx': djlx,
                        'table': table
                    },
                    success: function (res) {
                        var __PAGE_INFO = {};
                        if (res.status === 0) {
                            __PAGE_INFO = { ck_id: res.data.ck_id };
                        }

                        var kd_url;
                        if (djlx === 'bp_cglhjs') {
                            kd_url = page_arr.cg_lhjs_kd;
                        } else if (djlx === 'bp_cgthjs') {
                            kd_url = page_arr.cg_thjs_kd;
                        }

                        var __route = [
                            {
                                url: page_arr.customer_search,
                                page_data: {
                                    djlx: djlx,
                                    LIST_PAGE: html_name,
                                    BILL_PAGE: kd_url,
                                    return_page: html_name,
                                    page_type: 'gys',
                                    type: djlx,
                                    wldw_tmp: {
                                        return_page: html_name,
                                        page_type: 'gys',
                                        djlx: djlx,
                                        getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                                    },
                                    __PAGE_INFO: __PAGE_INFO,
                                    loadScdj: true
                                }
                            },
                            {
                                url: page_arr.choice_product,
                                page_data: {
                                    djlx: djlx,
                                    return_page: html_name,
                                    cp_tmp: {
                                        return_page: html_name
                                    }
                                }
                            },
                            {
                                url: kd_url,
                                page_data: {}
                            }
                        ];

                        fun.showPageFull({
                            page_url: __route[0].url,
                            pageParam: $.extend({}, { __route: __route }, __route[0]['page_data'])
                        });
                    }
                });
                return;
            }
            break;
        case 'bp_cgthjs'://采购退货结算
            if (Auth.check('bp_cgthjs', 'edit')) {
                if (!fun.checkKz()) return;
                var djlx = 'bp_cgthjs';
                var table = 'cgthjs_dj';
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getBillsPageDefInfo,
                    data: {
                        'djlx': djlx,
                        'table': table
                    },
                    success: function (res) {
                        var __PAGE_INFO = {};
                        if (res.status === 0) {
                            __PAGE_INFO = { ck_id: res.data.ck_id };
                        }

                        var kd_url;
                        if (djlx === 'bp_cglhjs') {
                            kd_url = page_arr.cg_lhjs_kd;
                        } else if (djlx === 'bp_cgthjs') {
                            kd_url = page_arr.cg_thjs_kd;
                        }

                        var __route = [
                            {
                                url: page_arr.customer_search,
                                page_data: {
                                    djlx: djlx,
                                    LIST_PAGE: html_name,
                                    BILL_PAGE: kd_url,
                                    return_page: html_name,
                                    page_type: 'gys',
                                    type: djlx,
                                    wldw_tmp: {
                                        return_page: html_name,
                                        page_type: 'gys',
                                        djlx: djlx,
                                        getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                                    },
                                    __PAGE_INFO: __PAGE_INFO,
                                    loadScdj: true
                                }
                            },
                            {
                                url: page_arr.choice_product,
                                page_data: {
                                    djlx: djlx,
                                    return_page: html_name,
                                    cp_tmp: {
                                        return_page: html_name
                                    }
                                }
                            },
                            {
                                url: kd_url,
                                page_data: {}
                            }
                        ];

                        fun.showPageFull({
                            page_url: __route[0].url,
                            pageParam: $.extend({}, { __route: __route }, __route[0]['page_data'])
                        });
                    }
                });
                return;
            }
            break;
        case 'bp_cgbj'://采购报价
            if (Auth.check('bp_cgbj', 'edit')) {
                if (!fun.checkKz()) return;
                var __route = [
                    {
                        url: page_arr.customer_search,
                        page_data: {
                            djlx: 'bp_cgbj',
                            LIST_PAGE: html_name,
                            BILL_PAGE: page_arr.cg_cgbj_kd,
                            return_page: html_name,
                            // save_return_page: html_name,
                            page_type: 'gys',
                            type: 'bp_cgbj',
                            from_page: html_name,
                            wldw_tmp: {
                                return_page: html_name,
                                page_type: 'gys',
                                djlx: 'bp_cgbj',
                                getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                            },
                            NOT_OPEN_AGAIN: false
                        }
                    },
                    {
                        url: page_arr.choice_product, page_data: {
                            djlx: 'bp_cgbj',
                            return_page: html_name,
                            cp_tmp: {
                                return_page: html_name,
                            }
                        }
                    },
                    {
                        url: page_arr.cg_cgbj_kd, page_data: {
                            // save_return_page: html_name,
                        }
                    }
                ];

                fun.showPageFull({
                    page_url: __route[0]['url'],
                    pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
                });
                return;
            }
            break;
    }

    fun.showPageFull({
        page_url: pageUrl['page_url'] || '',
        pageParam: pageUrl['pageParam'] || {},
        flag: flag
    });

    return false;
})

$('body').on('touchend', '.ui-icon-item', function (e) {
    setTimeout(function () {
        api.sendEvent({
            name: 'nav_has_slide',
            extra: {
                nav_has_slide: true
            }
        });
    }, 500);
})

$('body').on('click', '.icon-search:visible', function (e) {
    e.stopPropagation();
    e.preventDefault();

    api.sendEvent({
        name: 'nav_has_slide',
        extra: {
            nav_has_slide: false
        }
    });

    $('#shield').show();
    clearTimeout(timer);
    timer = setTimeout(function () {
        $('#shield').hide();
    }, 1000);
    // var nowIdx = $(this).parents('.swiper-slide').index();
    var nowIdx = $('.swiper-slide:visible').index($(this).parents('.swiper-slide'));

    setTimeout(function () {
        mySwiper.slideTo(nowIdx);
    }, 250);


    var pageType = $(this).parents('.ui-icon-item').data('type');
    var pageUrl = param[pageType];
    fun.showPageFull({
        page_url: pageUrl['page_url'] || '',
        pageParam: pageUrl['pageParam'] || {},
        flag: flag
    })

    return false;
})
$('body').on('click', '.icon-jia:visible', function (e) {
    e.stopPropagation();
    e.preventDefault();

    var pageType = $(this).parents('.ui-icon-item').data('type');
    var _pageType, title, obj;
    switch (pageType) {
        case 'shop_cp_cpzl'://店铺-产品
            pageType = pageType == 'shop_cp_cpzl' ? 'cp' : pageType;
            _pageType = _pageType ? _pageType : 'shop_product_compile';
        case 'cp'://产品
            _pageType = _pageType ? _pageType : 'shop_product_compile';
        case 'sx'://纱线
            _pageType = _pageType ? _pageType : 'yarn_edit';
        case 'ck'://仓库
            _pageType = _pageType ? _pageType : 'storehouse_add';
        case 'kh'://客户
        case 'sc_kh'://店铺-客户
            pageType = pageType == 'sc_kh' ? 'kh' : pageType;
            title = title ? title : '客户';
        case 'gys'://供应商
            title = title ? title : '供应商';
        case 'jgs'://加工商
            title = title ? title : '加工商';
        case 'wl'://物流
            title = title ? title : '物流';
            _pageType = _pageType ? _pageType : 'custom_add';
        case 'yg'://员工
            _pageType = _pageType ? _pageType : 'employee_add';
        case 'zh'://账户
            _pageType = _pageType ? _pageType : 'account_add';
            _pageType = _pageType ? _pageType : pageType + '_kd';
            if (Auth.check(pageType, 'edit')) {
                if (!fun.checkKz()) return;
                fun.showPageFull({
                    page_url: page_arr[_pageType] || '',
                    pageParam: {
                        "type": "add",
                        status: "add",
                        title: title,
                        type: pageType,
                        opt: 'append',
                    },
                    flag: flag
                })
                return;
            }
            break;
        case 'fylx':
            obj = 'cost';
        case 'srlx':
            obj = obj ? obj : 'income';
            if (Auth.check(pageType, 'edit')) {
                if (!fun.checkKz()) return;
                fun.showPageFull({
                    page_url: page_arr.cost_type,
                    pageParam: {
                        "type": "add",
                        obj: obj
                    },
                    flag: flag
                })
                return;
            }
            break;
    }
})


// 点击标题、点击图标
$('body').on('click', '.ui-choose-title:visible,.icon-xiangxia:visible,.icon-xiangshang:visible', function (e) {
    var $swiperSlide = $('.swiper-slide').eq(nowIdx);
    e.stopPropagation();
    var $dom;

    if ($(this).hasClass('ui-choose-title')) {
        $dom = $(this).siblings('.iconfont');
    } else {
        $dom = $(this);
    }

    if ($dom.hasClass('icon-xiangxia')) {
        $dom.removeClass('icon-xiangxia').addClass('icon-xiangshang');
    } else {
        $dom.removeClass('icon-xiangshang').addClass('icon-xiangxia');
    }
    if (!($(this).siblings('.ui-icon-list').children().length)) return; // 没有内容不执行
    $(this).siblings('.ui-icon-list').stop().slideToggle("fast", function () {
        // var swiperH = $swiperSlide.outerHeight();
        //     height: swiperH
        // })
        $swiper_wrap.css({
            height: $('.swiper-slide:visible').eq(nowIdx).outerHeight()  // 获取内容高度
        })
        restrictSwiperHeight(nowIdx);
    });
});
