// 库存几个开单窗口公用动作。common_fun文件之后


// 子类必须配置null字段的内容
var stockManager = {
    getDataUrl: null,       // 获取页面详情url
    postUrl: null,          // 删除/保存/审核/反审核/作废url
    authCheckName: null,    // Auth.check()方法的name

    djlx: null,             // 生成单号需要字段
    table: null,            // 生成单号需要字段

    headerTitle: null,      // 导航头标题
    data: {                 // 需要保存的数据
        dj: {
            id: '',
            save_time: '',
            jsr_id: 0,
            zdr_id: 0,
            md_id: '',
            kdsj: '',
            dj_lsh: '',
            dh: '',
            ck_id: '',
            is_zf: 0,
            bz: '',
            zps: 0,
            zsl: 0
        },
        jl: []
    },
    fsh: fun.getItem('sys_config')['fsh'],
    origin_data: { dj: { bz: '' }, jl: [] },        // 页面打开时最原始数据，新增时为空，编辑时为后台加载的数据
    zps: 0,
    zsl: 0,
    zje: 0,                  // 总金额,保存四位小数
    showedDw: '',            // 显示在底部导航栏的单位
    //
    hzData: [],               // 根据仓库汇总后的数据

    isLoadCbj: true,
    extraDJData: {},          // 扩展数据

    deleteRows: [],           // 需要逻辑删除的行记录
    isDckms: false,           // 是否多仓库模式 true 开启 | false 关闭
    isDeleteRows: false,      // 是否删除行记录 true 已删除 | false 未删除
    JD_FROM_JL: false,
    is_adjust_save: false,
    del_row_exclude_col: [],
    __PAGE_INIT_DATA: { dj: {}, jl: [] },
    dateCalendar: null,
    begin_lCalendar: new lCalendar()
};

// 初始化动作逻辑
// 打开页面必传参数 return_page
// 新增时必传数据 data.list， list为数组
// 编辑时必传参数 dh, id, zdr, kdsj
// 其他init初始化的动作，使用stockManager.initExtend();
page_init = function () {
    console.log('common page_data', page_data);
    stockManager.zh_list = fun.getItem('zh_list') || []; // 账户信息

    stockManager.ck_list = fun.getItem('ck_list') || [];              // 仓库列表

    if (!AuthVersionCheck.checkHide('hy')) {
        $('.hy-hide').removeClass('hy-hide');
    }
    $('.sum2').css('padding-left', $('.common2').width());
    stockManager.isDckms = $.nui.isTrue(fun.getItem('sys_config')['dckms_bp']);

    // 根据情况初始化获取成本价url
    if (stockManager.isLoadCbj && typeof Bills !== 'undefined') {
        Bills['AJAX_URL'] = { 'getDj': AJAX_URL.getKccpCbj }; // 获取产品成本url
    }

    stockManager.initStart();

    page_data.keyback = stockManager.isDataChange;


    stockManager.initHeader();
    stockManager.initHeaderAfter();
    stockManager.initDateTimePicker();

    __init();

    stockManager.initDomEvent();
    stockManager.initExtend();
    stockManager.initAddDataListener();
};

function __init() {
    $('button').hide();
    $('#much_btn,#print_btn,#del_btn,#share_btn').hide();
    if (page_data.id) {
        stockManager.apiGetData();
    } else {
        fun.showLoad();
        // 初始化头部导航栏
        // stockManager.initHeader();
        stockManager.initHeaderAfter();
        // stockManager.initDateTimePicker();

        if (page_data.data && page_data.data.list) {
            stockManager.initLoadCpcbj(page_data.data.list);
        } else {
            stockManager.initShowData();
        }
        stockManager.apiGetDh();
        fun.hideLoad();
    }
}

// api 方法 ----------------------------------------------------------------------------------
/**
 * 获取数据api
 */
stockManager.apiGetData = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.getDataUrl,
        data: {
            id: page_data.id,
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    stockManager.begin_lCalendar.disabled = false;
                    $('#kdsj').removeAttr('disabled');

                    stockManager.data = res.data;
                    page_data['dh'] = stockManager.data.dj.dh;

                    page_data['dj_is_sh'] = stockManager.data.dj['is_sh'];

                    stockManager.origin_data = JSON.parse(JSON.stringify(res.data));

                    stockManager.__PAGE_INIT_DATA = res.data;
                    $('#much_btn').hide();

                    // 初始化头部导航栏
                    // stockManager.initHeader();
                    stockManager.initHeaderAfter();
                    // if (false) {
                    //     stockManager.begin_lCalendar.disabled = false;
                    //     $('input,#kdsj,#wldw_mc').removeAttr('disabled');
                    // }

                    stockManager.apiDataLoaded();
                    console.log('stockManager.isInEdit()', stockManager.isInEdit())

                    if (!stockManager.isInEdit()) {
                        stockManager.begin_lCalendar.disabled = true;
                        $('#kdsj').attr('disabled', true);
                        // stockManager.initDateTimePicker();
                    }

                    $('#print_btn').show();
                    if ($.nui.isTrue(page_data.id)) {
                        $('#del_btn').show();
                    }
                    stockManager.initShowData();
                    break;
                default:
                    fun.alert({ msg: '获取单号失败！' });
                    break;
            }
        }
    })
};

// api数据加载完成调用方法
stockManager.apiDataLoaded = function () {
};

/**
 * 删除单据api
 */
stockManager.apiDelData = function () {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'delete')) return false;
    if (!Auth.qfmd({ 'key': 'delete', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'delete', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: { status: 'delete', scr_id: fun.getItem('user_info')['id'], dj_id: page_data.id ,__post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    stockManager.closePage(true);
                    break;
                case 'IS_NOT_FIND':
                    fun.toast('单据已被其他操作人员删除，无法删除');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh'
                        }
                    });
                    // fun.alert({msg:res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.alert({msg: res['msg']}, function () {
                    //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) stockManager.closePage();
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
};

stockManager.apiAuditError = function (res) {
    fun.toast(res['msg']);
};

/**
 * 审核单据api
 */
stockManager.apiAudit = function () {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'check')) return false;
    if (!Auth.qfmd({ 'key': 'check', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'check', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: { status: 'audit', shr_id: fun.getItem('user_info')['id'], dj_id: page_data.id,__post_sign: Bills['__post_sign'] },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('审核成功。');
                    stockManager.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    fun.toast('条码' + list['tm'] + '和库存信息不一致');
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_NOT_FIND':
                    // fun.toast(res['msg']);
                    fun.toast('单据已被其他操作人员删除，无法审核');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    // fun.alert({msg: res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    // if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1){
                    //     fun.alert({msg: res['msg']}, function () {
                    //         stockManager.closePage();
                    //     });
                    // }else{
                    stockManager.apiAuditError(res);
                    // }
                    break;
            }
        }
    })
};
/**
 * 反审核单据api
 */
stockManager.apiRevocatory = function () {
    // if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    // if (!Auth.check(stockManager.authCheckName, 'check')) return false;
    // if (!Auth.qfmd({ 'key': 'check', 'md_id': stockManager.data.dj.md_id })) return false;
    // if (!Auth.qfczy({ 'key': 'check', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    // fun.ajax({
    //     showLoad: true,
    //     hideLoad: true,
    //     url: stockManager.postUrl,
    //     data: {
    //         status: 'dbaudit',
    //         fhr_id: fun.getItem('user_info')['id'],
    //         dj_id: [page_data.id],
    //         is_fh: 0, // 生成新单
    //     },
    //     success: function (res) {
    //         switch (res['status']) {
    //             case 0:
    //                 fun.toast('取消审核成功。');
    //                 stockManager.closePage();
    //                 break;
    //             default:
    //                 fun.toast(res['msg']);
    //                 break;
    //         }
    //     }
    // });
};


/**
 * 作废单据api
 */
stockManager.apiObsolete = function (is_scxd) {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'invalid')) return false;
    if (!Auth.qfmd({ 'key': 'invalid', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'invalid', 'zdr_id': stockManager.data.dj.zdr_id })) return false;

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: {
            status: 'cancel',
            zfr_id: fun.getItem('user_info')['id'],
            dj_id: page_data.id,
            zf_yy: '', // 作废原因
            scxd: (is_scxd == 0) ? 1 : 0, // 生成新单
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            // if(is_scxd == 0){
            //   if (res['status'] == 0) {
            //     fun.toast('作废成功！');
            //     stockManager.closePage();
            //   }else{
            //     fun.toast(res['msg']);
            //   }
            // }else{
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('作废成功。');
                    if (is_scxd == 0) {
                        page_data.id = res['data']['dj_id'];
                    }
                    stockManager.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'];
                    var listInfo = {};
                    if ($.nui.isTrue(list)) listInfo = list[0];
                    var msg = '条码' + (listInfo['tm'] || '') + '和库存信息不一致';
                    fun.toast(msg);
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_JS':
                    fun.toast('单据已被结算过，无法作废。');
                    break;
                case 'WDYJE_LESS_BCDY':
                    fun.toast('超出了订金，无法作废单据。');
                    break;
                case 'IS_NOT_FIND':
                    // fun.toast(res['msg']);
                    fun.toast('单据已被其他操作人员删除，无法作废');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    // fun.alert({msg:res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    stockManager.apiObsoleteError(res);
                    break;
            }
            // }
        }
    })
};

stockManager.apiObsoleteError = function (res) {
    fun.toast(res['msg']);
};

stockManager.checkBeforeApiSaveAjax = function (callback) {
    callback(true);
};

stockManager.apiSaveError = function (res) {
    fun.toast(res['msg'].replace(/销售订单/, '客户订单'));
};

/**
 * 根据id，检查删除的行记录是否需要上传后台
 * @param row 行记录
 * @param key 查询的主键，默认是id
 */
stockManager.rowDeleteHandler = function (row, key) {
    stockManager.isDeleteRows = true;

    if ($.nui.isEmpty(key)) {
        key = 'id';
    }
    if (row) {// && $.nui.isTrue(row[key])
        row.is_delete = 1;
        if (row.mx && row.mx.length) { // 明细记录也设置删除状态
            for (var i = 0; i < row.mx.length; i++) {
                row.mx[i].is_delete = 1;
            }
        }
        stockManager.deleteRows.push(row);
    }
};


/**
 *  删除匹数、数量为0的数据
 *  返回仓库id集合
 */
stockManager.deleteEmptyRows = function () {
    var ckIds = [];
    var realSaveJl = [];
    var tmpArr = stockManager.data.jl;
    var deleteRows = false;
    for (var i = 0; i < tmpArr.length; i++) {
        if ($.nui.isEmpty(tmpArr[i].ps) && $.nui.isEmpty(tmpArr[i].zsl)) {
            var isDel = true;
            // 如果有些字段值不为空，即使匹数数量0也不删除
            for (var j = 0; j < stockManager.del_row_exclude_col.length; j++) {
                var key = stockManager.del_row_exclude_col[j];
                if ($.nui.isTrue(tmpArr[i][key])) {
                    isDel = false;
                    break;
                }
            }


            if (isDel) {
                deleteRows = true;
                stockManager.rowDeleteHandler(tmpArr[i]);
            } else {
                realSaveJl.push(tmpArr[i]);
                if (ckIds.indexOf(tmpArr[i].ck_id) === -1) {
                    ckIds.push(tmpArr[i].ck_id);
                }
            }
        } else {
            realSaveJl.push(tmpArr[i]);
            if (ckIds.indexOf(tmpArr[i].ck_id) === -1) {
                ckIds.push(tmpArr[i].ck_id);
            }
        }
    }
    // 删除数据后重新渲染
    stockManager.data.jl = realSaveJl;
    return { ckIds: ckIds, deleteRows: deleteRows };
};

/**
 * 保存单据api
 */
stockManager.apiSave = function () {
    var dj = {}, jl = [];
    var result = stockManager.deleteEmptyRows();
    stockManager.data.dj = stockManager.getSaveDj();
    stockManager.data = stockManager.getSaveData();

    var jl_list = []
    if ($.nui.isTrue(page_data['data'])) {
        jl_list = page_data['data']['jl_list']
    }
    var is_shop = 0, shop_type = '';
    $(jl_list).each(function (i, item) {
        if (item['is_shop'] === 1 || item['shop_type'] === 'shop') {
            is_shop = 1;
            shop_type = item['shop_type'] || '';
        }
    })
    stockManager.data.dj['is_shop'] = is_shop;
    stockManager.data.dj['shop_type'] = shop_type;
    if (!Check.kzrq({ sj: stockManager.data.dj.kdsj })) return false;
    if (!Check.yjrq({ sj: stockManager.data.dj.kdsj })) return false;

    if (stockManager.data.dj.dh === '') return fun.toast('单号不能为空');

    // var recordData = stockManager.data.jl.concat(stockManager.deleteRows), px = 0;

    // var tmpJl = [];
    // for (var i = 0; i < recordData.length; i++) {
    //     var val = $.extend(true, {mx: []}, recordData[i]);

    //     if ($.nui.isTrue(val['is_delete']) && $.nui.isEmpty(val['id'])) continue;

    //     var __tmp_data = {};

    //     // if (stockManager.djlx == 'kc_bptbd') {
    //         __tmp_data['mx'] = [];
    //     // }
    //     var tmpData = $.extend({}, val, __tmp_data);

    //     if ($.nui.isEmpty(tmpData['is_delete'])) {
    //         px += 1;
    //         tmpData['px'] = px;
    //     }

    //     // if (stockManager.djlx == 'kc_bptbd') {
    //         for (var j = 0; j < val['mx'].length; j++) {
    //             // 如果记录行删除的情况,则明细表也是得以删除的情况处理
    //             if ($.nui.isTrue(tmpData['is_delete'])) val['mx'][j]['is_delete'] = 1;
    //             // 当数量为0, 并且无id字段信息，则代表为新添加并且手动删除的信息，跳过不处理
    //             if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isTrue(val['mx'][j]['is_delete'])) continue;
    //             if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isEmpty(val['mx'][j]['sl'])) continue;
    //             tmpData['mx'].push(val['mx'][j]);
    //         }
    //     // }

    //     tmpJl.push(tmpData);
    // }
    var jl_list = [];
    var jl_data = stockManager.data.jl || [];
    for (var i = 0; i < jl_data.length; i++) {
        if ($.nui.isEmpty(jl_data[i]['is_delete'])) {
            jl_list.push(jl_data[i]);
        }
    }
    // stockManager.data.jl = tmpJl.slice(0);

    // 没开启【系统设置-多仓库模式】时，需约束：仓库不能为空。
    if ($.nui.isTrue(jl_list) && !stockManager.isDckms && $.nui.isEmpty(stockManager.data.dj['ck_id']))
        return fun.toast('仓库不能为空');

    // var result = stockManager.deleteEmptyRows();
    if (result.deleteRows) {
        setTimeout(function () {   // 放回调里执行，异步渲染
            stockManager.initShowData();
        }, 100);
    }

    if (stockManager.djlx == 'bp_cglhjs' || stockManager.djlx == 'bp_cgthjs'
        || stockManager.djlx == 'bp_cgdd' || stockManager.djlx == 'kc_bppyd'
        || stockManager.djlx == 'kc_bpmxpkd') {
        var realJl = [];
        for (var i = 0; i < stockManager.data.jl.length; i++) {
            var tmpData = stockManager.data.jl[i];

            // 如果 记录行 被删除, 则不需要判断 限制
            if ($.nui.isTrue(tmpData['is_delete'])) continue;
            if ($.nui.isEmpty(tmpData['ck_id'])) return fun.toast('请选择：【仓库】。');
            if ($.nui.isEmpty(tmpData['cp_ys_id'])) return fun.toast('请选择：【颜色】。');
            if ($.nui.isEmpty(tmpData['dw_id'])) return fun.toast('请选择：【单位】。');

            if (stockManager.djlx !== 'kc_bppyd' && stockManager.djlx !== 'kc_bpmxpkd') {
                if ($.nui.isEmpty(tmpData['jjdw_id'])) return fun.toast('请选择：【计价单位】。');
                if ($.nui.isEmpty(tmpData['ps']) && $.nui.isEmpty(tmpData['zsl'])) return fun.toast('请输入：【匹数】、【数量】。');
            }

            realJl.push(tmpData);
        }
        if (stockManager.djlx == 'bp_cgdd') {
            // stockManager.data.jl = realJl.slice(0);
        }
    }

    if ($.nui.isEmpty(jl_list)) return fun.toast(tips_arr['空单提示']);

    if (!stockManager.isDckms && !$.nui.isFieldValEqual('ck_id', stockManager.data.jl)['res']) {
        fun.toast('不允许调用多个仓库的布匹。');
        return false;
    }

    stockManager.checkBeforeApiSaveAjax(function (result) {
        console.log('---执行保存')
        if (result) {
            // console.log(JSON.stringify(realSaveJl.concat(stockManager.deleteRows)));
            // console.log(JSON.stringify({
            //     dj: stockManager.data.dj,
            //     jl: realSaveJl.concat(stockManager.deleteRows)
            // }));

            var djIsSame = $.nui.isObjEquals(stockManager.data.dj, stockManager.origin_data.dj);
            var jlIsSame = stockManager.data.jl.length == stockManager.origin_data.jl.length;

            if (stockManager.JD_FROM_JL || stockManager.data.dj['is_fh'] || (stockManager.data.dj['is_has'] && djIsSame && jlIsSame)) {
                __adjust();
                return;
            } else {
                __save();
            }

            function __save() {
                var __saveData = {
                    status: 'save',
                    dj: stockManager.data.dj,
                    jl: stockManager.data.jl,//.concat(cgddDelRows)
                    __post_sign: Bills['__post_sign']
                };

                if (Bills['djlx'] == 'kc_bpmxpkd') {
                    console.log(22222)
                    __saveData['dj']['kdsj'] = fun.formatDate(__saveData['dj']['kdsj']);
                    delete __saveData['dj']['is_sh'];
                    var tmpSaveJl = __saveData['jl'].slice(0);

                    for (var i = 0; i < tmpSaveJl.length; i++) {
                        tmpSaveJl[i]['mx'] = [];
                        console.log(i, tmpSaveJl[i]['rk_sj'].split('').reverse()[0])

                        delete tmpSaveJl[i]['bqsl'];
                        delete tmpSaveJl[i]['dd_dh'];
                        delete tmpSaveJl[i]['dd_dj_id'];
                        delete tmpSaveJl[i]['dd_jl_id'];
                        delete tmpSaveJl[i]['dd_kdsj'];
                        delete tmpSaveJl[i]['dj'];
                        delete tmpSaveJl[i]['zje'];
                        delete tmpSaveJl[i]['je'];
                        delete tmpSaveJl[i]['shuie'];
                        delete tmpSaveJl[i]['zydj'];
                        delete tmpSaveJl[i]['jjdw_id'];
                        delete tmpSaveJl[i]['jjdw_mc'];
                        delete tmpSaveJl[i]['jjsl'];
                        delete tmpSaveJl[i]['sssl'];
                        delete tmpSaveJl[i]['hsdj'];
                        delete tmpSaveJl[i]['hsje'];
                        delete tmpSaveJl[i]['hszje'];
                        delete tmpSaveJl[i]['sl'];
                        delete tmpSaveJl[i]['__uuid'];
                    }
                }

                console.log($.extend({}, __saveData));

                // if(stockManager.djlx=='bp_cglhjs') return;
                // return;

                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: stockManager.postUrl,
                    data: __saveData,
                    success: function (res) {
                        if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                        switch (res['status']) {
                            case 0:
                                // if (stockManager.JD_FROM_JL) {
                                //     stockManager.__adjust();
                                //     return;
                                // } else {
                                fun.toast('保存成功。');
                                stockManager.JD_FROM_JL = false;
                                stockManager.deleteRows = [];
                                page_data.id = res['data']['dj_id'];

                                if (stockManager.djlx == 'bp_cgdd') {
                                    stockManager.deleteRows = [];
                                    api.sendEvent({
                                        name: html_name,
                                        extra: {
                                            'status': 'refresh_dj'
                                        }
                                    });
                                    api.sendEvent({
                                        name: page_data['return_page'],
                                        extra: {
                                            'status': 'refresh',
                                            'closeLayer': true
                                        }
                                    });
                                } else {
                                    // api.sendEvent({
                                    //     name: page_data['return_page'],
                                    //     extra: {
                                    //         'status': 'refresh',
                                    //         'closeLayer': true
                                    //     }
                                    // });
                                    stockManager.closePage();
                                }
                                // }
                                break;
                            case 'DCK_LIST':
                                var list = res['dck_list'][0];
                                fun.toast('条码' + list['tm'] + '已被调用或已出库');
                                break;
                            default:
                                stockManager.apiSaveError(res);
                                break;
                        }
                    }
                });
            }


            function __adjust() {
                console.log('---执行单据调整保存')


                var tmp_djtz_jl = [];
                var djtz_jl = stockManager.data.jl.slice(0) || [];

                var tmpSaveObj = {};

                for (var i = 0; i < djtz_jl.length; i++) {
                    if (djtz_jl[i]['djtz_jl_jd']) {
                        delete stockManager.data.jl[i]['djtz_jl_jd'];
                        tmp_djtz_jl.push(djtz_jl[i]);
                        tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
                    } else if (djtz_jl[i]['dj_jd_from_jd']) {
                        delete stockManager.data.jl[i]['dj_jd_from_jd'];
                        tmp_djtz_jl.push(djtz_jl[i]);
                        tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
                    }
                }


                var save_data = $.extend(true, {}, {
                    status: 'adjust',
                    data: tmp_djtz_jl,
                    dj_id: stockManager.data.dj['id'],
                    __post_sign: Bills['__post_sign']
                });

                save_data['isSave'] = stockManager.is_adjust_save;

                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    loadTitle: '保存中...',
                    url: stockManager.postUrl,
                    data: save_data,
                    success: function (res) {
                        if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                        switch (res['status']) {
                            case 0:
                                stockManager.deleteRows = [];
                                if (stockManager.JD_FROM_JL) {
                                    if (stockManager.data.dj['is_fh']) {
                                        fun.toast('保存成功！');

                                        if (stockManager.djlx == 'bp_cgdd') {
                                            stockManager.deleteRows = [];
                                            api.sendEvent({
                                                name: html_name,
                                                extra: {
                                                    'status': 'refresh_dj',
                                                }
                                            });
                                            api.sendEvent({
                                                name: page_data['return_page'],
                                                extra: {
                                                    'status': 'refresh',
                                                    'closeLayer': true
                                                }
                                            });
                                        } else {
                                            // api.sendEvent({
                                            //     name: page_data['return_page'],
                                            //     extra: {
                                            //         'status': 'refresh',
                                            //         'closeLayer': true
                                            //     }
                                            // });
                                            stockManager.closePage();
                                        }

                                    } else {
                                        __save();
                                    }

                                } else {
                                    stockManager.JD_FROM_JL = false;
                                    fun.toast('保存成功！');
                                    if (stockManager.djlx == 'bp_cgdd') {
                                        stockManager.deleteRows = [];
                                        api.sendEvent({
                                            name: html_name,
                                            extra: {
                                                'status': 'refresh_dj',
                                            }
                                        });
                                        api.sendEvent({
                                            name: page_data['return_page'],
                                            extra: {
                                                'status': 'refresh',
                                                'closeLayer': true
                                            }
                                        });
                                    } else {
                                        // api.sendEvent({
                                        //     name: page_data['return_page'],
                                        //     extra: {
                                        //         'status': 'refresh',
                                        //         'closeLayer': true
                                        //     }
                                        // });
                                        stockManager.closePage();
                                    }
                                }

                                break;
                            case 'IS_NOT_FINISH':
                                fun.jdts({
                                    content: '部分产品还没来完货，你确定要结单吗？',
                                    yes: function () {
                                        fun.ajax({
                                            showLoad: true,
                                            hideLoad: true,
                                            loadTitle: '结单中...',
                                            url: stockManager.postUrl,
                                            data: $.extend(true, { 'notCheckFinish': 1 }, save_data),
                                            success: function (res) {
                                                Bills['__post_sign'] = $.nui.getRandomNum();
                                                switch (res['status']) {
                                                    case 0:
                                                        fun.toast('结单成功。');
                                                        // is_adjust_save = false;
                                                        api.sendEvent({
                                                            name: html_name,
                                                            extra: {
                                                                'status': 'refresh_dj',
                                                                'data': {}
                                                            }
                                                        });
                                                        api.sendEvent({
                                                            name: page_data['return_page'],
                                                            extra: {
                                                                'status': 'refresh',
                                                                'closeLayer': true
                                                            }
                                                        });
                                                        break;
                                                    default:
                                                        fun.toast(res['msg']);
                                                        break;
                                                }
                                            }
                                        });
                                    },
                                    no: function () {
                                        for (var key in tmpSaveObj) {
                                            for (var j = 0; j < stockManager.data.jl.length; j++) {
                                                if (key == stockManager.data.jl[j]['id']) {
                                                    stockManager.data.jl[j]['is_jd'] = !stockManager.data.jl[j]['is_jd'] ? 1 : 0;
                                                    stockManager.data.jl[j]['jdr_id'] = !stockManager.data.jl[j]['is_jd'] ? USER_INFO['id'] : 0;
                                                    stockManager.data.jl[j]['jdr_mc'] = !stockManager.data.jl[j]['is_jd'] ? USER_INFO['name'] : '';
                                                    stockManager.data.jl[j]['jd_sj'] = !stockManager.data.jl[j]['is_jd'] ? fun.formatDate(new Date()) : '';
                                                }
                                            }
                                        }

                                        stockManager.initShowData();
                                    }
                                });
                                break;
                            case 'IS_ZS_FKC':
                                var list = res['data']['list'][0];
                                var ps_display = list['bz_ps'] > 0;
                                var sl_display = list['bz_sl'] > 0;
                                var msg = [
                                    list['cp_bh'] + list['cp_mc'] + '\r\n',
                                    list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                    '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                                    '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                                ].join('');
                                fun.toast(msg);
                                break;
                            case 'IS_TM_FKC':
                                var list = res['data']['list'][0];
                                fun.toast('条码' + list['tm'] + '和库存信息不一致');
                                break;
                            case 'IS_MX_FKC':
                                var list = res['data']['list'][0];
                                var msg = [
                                    list['cp_bh'] + list['cp_mc'] + '\r\n',
                                    list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                    '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                                ].join('');
                                fun.toast(msg);
                                break;
                            case 'DDJ_NOT_EMPTY':
                                fun.jdts({
                                    content: '<div style="text-align:left;margin-top: -0.5rem;">未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
                                    btn: ['确定结单', '取消'],
                                    yes: function () {
                                        stockManager.is_adjust_save = true;
                                        __adjust();
                                    }
                                });
                                break;
                            default:
                                fun.toast(res['msg']);
                                break;
                        }
                    }
                });
            }
        }
    });
};


/**
 * 获取单号后回调
 */
stockManager.afterApiGetDh = function (data) {
    // return data;
};

/**
 * 获取单号
 */
stockManager.apiGetDh = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': stockManager.djlx,
            'table': stockManager.table
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    console.log(123)
                    $('.subtitle').text(res.data.dh);

                    stockManager.data.dj.dh = res.data.dh;

                    stockManager.initHeaderAfter();

                    stockManager.afterApiGetDh(res.data);
                    break;
                default:
                    fun.alert({ msg: '网络异常！' });
                    break;
            }
        }
    })
};

// 普通方法 -------------------------------------------------------------------------------
// 初始化开始时执行方法
stockManager.initStart = function () {
};
stockManager.initLoadCpcbj = function (initList) {
    stockManager.loadCpcbj(initList, function (list) {
        stockManager.data.jl = list;
        stockManager.initShowData();
    });
};

/**
 * 初始化dom事件
 */
stockManager.initDomEvent = function () {
    // 先解除bill.js的同名绑定事件
    $('body').off('tap', '#del_btn');
    //删除
    $('body').on('tap', '#del_btn', function (e) {
        e.stopPropagation();
        // 数据更改时，提示
        stockManager.data.dj = stockManager.getSaveDj();
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能删除！');
        }

        fun.dialog({
            content: '您确定要删除当前单据吗？',
            btn: ['删除', '取消'],
            yes: function () {
                stockManager.apiDelData();
            }
        });
    });
    //审核
    $('body').on('tap', '.audit', function (e) {
        e.stopPropagation();
        // 数据更改时，提示
        stockManager.data.dj = stockManager.getSaveDj();
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能审核！');
        }

        fun.dialog({
            content: '您确定要审核当前单据吗？',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiAudit();
            }
        });
    });
    //取消审核
    $('body').on('tap', '.revocatory', function (e) {
        e.stopPropagation();
        fun.dialog({
            content: '您确定要取消当前单据的审核状态吗？',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiRevocatory();
            }
        });
    });
    //作废
    $('body').on('tap', '.obsolete', function (e) {
        e.stopPropagation();
        fun.dialog({
            content: '您确定要作废当前单据吗？',
            btn: ['重新做单', '直接作废', '取消'],
            yes: function (datas) {
                stockManager.apiObsolete(datas.index)
            },
            no: function (datas) {
                stockManager.apiObsolete(datas.index)
            }
        });
    });

    //保存
    $('body').delay('tap', '.saves', function () {
        stockManager.apiSave();
    });

    // 添加事件
    $('body').on('tap', '.choice,.add-product', function () {
        stockManager.openAddPage();
    });

    // 删除记录行
    $('body').on('tap', '.delete-btn', function (e) {
        e.preventDefault();
        if (stockManager.isInEdit()) {
            var _this = this;
            fun.dialog({
                content: '你确定要删除当前记录吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    stockManager.deleteRow(_this);
                    stockManager.showSaveBtn();
                }
            });
        }
    });

    // 详情编辑
    $('body').on('tap', '.store-content', function (e) {
        e.preventDefault();
        stockManager.editRow(this);
    });

    // 添加备注输入事件
    $('body').on('change', '#bz', function (e) {
        e.preventDefault();
        stockManager.data.dj.bz = $(this).val();
    });
};

/**
 * 删除行记录逻辑
 * @param _this 点击行记录的this对象
 */
stockManager.deleteRow = function (_this) {
};

/**
 * 编辑行记录
 * @param _this 点击行记录的this对象
 */
stockManager.editRow = function (_this) {
};

/**
 * 扩展的初始化方法
 */
stockManager.initExtend = function () {
};

/**
 * 扩展的事件监听方法
 */
stockManager.eventListenerExtend = function (ret, err) {
};

/**
 * 通过id查找对应记录的下标
 * @param callback {function}
 */
stockManager.findIndex = function (callback) {
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        if (callback(stockManager.data.jl[i])) {
            return i;
        }
    }
    return -1;
};

/**
 * 获取提交后台的单据数据
 */
// stockManager.getSaveDj = function () {
//     var kdsj = $('#kdsj').text().trim();
//     var oriDj = JSON.parse(JSON.stringify(stockManager.origin_data.dj));
//     // delete oriDj['is_jd'];
//     // delete oriDj['is_fh'];
//     return $.extend(oriDj, {
//         id: Number(page_data['id'] || 0),
//         save_time: stockManager.data.dj.save_time || '', // 保存时间
//         jsr_id: stockManager.data.dj.jsr_id || 0,       // 经手人id
//         zdr_id: fun.getItem('user_info')['id'],      // 制单人id stockManager.data.dj.zdr_id ||
//         md_id: fun.getItem('user_info')['store_id'],  // 门店id stockManager.data.dj.md_id ||
//         kdsj: fun.formatDate(kdsj, 'YYYY-MM-DD HH:mm:ss'),             // 开单时间
//         dj_lsh: stockManager.data.dj.dj_lsh || '',        // 单据流水号
//         dh: $('.subtitle').text().trim() || '',     // 单号
//         ck_id: Number(stockManager.data.dj.ck_id || 0),
//         bz: $('#bz').val().trim() || '',
//         zps: parseInt($('#zps').text() || 0),
//         zsl: parseFloat($('#zsl').text() || 0),
//         is_sh: stockManager.data.dj.is_sh || 0
//     }, stockManager.extraDJData);
// };





// 添加数据的事件触发后，调用该方法
stockManager.addData = function () {
};

/**
 * 添加数据时监听方法
 */
stockManager.initAddDataListener = function () {
    api.addEventListener({ name: html_name }, function (ret, err) {
        if (ret.value.data && !$.nui.isEmpty(ret.value.data.list)) {
            stockManager.eventListenerAdd(ret, err);
        } else {
            stockManager.eventListenerExtend(ret, err);
        }
    });
};

// 默认的添加事件处理
stockManager.eventListenerAdd = function (ret, err) {
    console.log('eventListenerAdd', ret);
    // 只更新新添加数据的成本
    stockManager.loadCpcbj(ret.value.data.list, function (list) {
        stockManager.data.jl = stockManager.data.jl.concat(list);
        // 重新初始化显示数据
        stockManager.initShowData();
        stockManager.dataChangeShowSaveBtn();
    });
};

// 关闭页面，发送刷新事件
stockManager.closePage = function (flag) {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh'
        }
    });
    if (!flag) {
        api.sendEvent({
            name: html_name,
            extra: {
                'status': 'refresh_dj'
            }
        });
    } else {
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
    }

};

/**
 * 数据显示时转换处理，根据相同仓库合并
 * @returns {Array}
 */
stockManager.convertData = function () {
    var list = [], hzData = {};

    console.log(stockManager.data.jl);

    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var item = stockManager.data.jl[i];
        if ($.nui.isTrue(item['is_delete'])) continue;
        if (!hzData[item.ck_id]) {
            hzData[item.ck_id] = {
                ck_id: item.ck_id,
                ck_mc: item.ck_mc,
                list: []
            }
        }
        hzData[item.ck_id].list.push(item);
    }

    var ckIds = [];
    for (var ck_id in hzData) {
        if (hzData.hasOwnProperty(ck_id)) {
            list.push(hzData[ck_id]);
            ckIds.push(ck_id);
        }
    }

    // 没有开启多仓库
    if (!stockManager.isDckms) {
        stockManager.data.dj.ck_id = ckIds[0];
    } else {
        stockManager.data.dj.ck_id = 0;
    }

    console.log(list)

    stockManager.hzData = list;
    return list;
};

/**
 * 检查数据是否已经变化
 * @param origin_data  原始数据
 * @param data 最新数据
 * @returns {boolean} true 已经修改 | false 没有修改
 */
stockManager.checkDataChange = function (origin_data, data) {
    return !$.nui.isObjEquals(origin_data, data);
};

/**
 * 判断是否单据信息修改，只检查备注字段，其他需要自己重写
 * @returns {boolean}  true 已修改 | false 未修改
 */
stockManager.isDjDataChange = function () {
    return stockManager.origin_data.dj.bz !== stockManager.data.dj.bz || stockManager.origin_data.dj.kdsj !== stockManager.data.dj.kdsj;
};


stockManager.isDataNotChange = function () {
    if (!stockManager.isInEdit()) { // 非编辑状态，无法修改，直接返回
        // api.closeWin();
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
        return true;
    }
    return false;
};

/**
 * 判断页面数据是否修改
 */
stockManager.isDataChange = function () {
    stockManager.data.dj = stockManager.getSaveDj();

    if (stockManager.JD_FROM_JL && !stockManager.__PAGE_INIT_DATA.dj['is_jd']) {
        if ($('body').find('.data-change-skin').length) return;

        // // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        // if ($.nui.isEmpty(page_data.id) && stockManager.data.jl.length === 0 && stockManager.deleteRows.length === 0 && !stockManager.isDjDataChange() && !stockManager.isDeleteRows) {
        //     api.closeToWin({name: page_data.return_page});
        //     return false;
        // }

        if (!stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'refresh',
            //     }
            // });
            fun.useBack();
            api.closeToWin({ name: page_data.return_page });
            return;
        }

        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: stockManager.apiSave,
            no: function () {
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'refresh',
                        'closeLayer': true
                    }
                });
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh',
                //     }
                // });
                fun.useBack();
                api.closeToWin({ name: page_data.return_page });
            }
        });
        return false;
    }

    if (!stockManager.JD_FROM_JL && stockManager.isDataNotChange()) {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        // api.closeToWin({name: page_data.return_page});
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
        return false;
    }


    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
        if ($('body').find('.data-change-skin').length) return;

        // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        if ($.nui.isEmpty(page_data.id) && stockManager.data.jl.length === 0 && stockManager.deleteRows.length === 0
            && !stockManager.isDjDataChange() && !stockManager.isDeleteRows) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'refresh',
            //     }
            // });
            // api.closeToWin({name: page_data.return_page});
            setTimeout(function () {
                fun.useBack();
                api.closeToWin({ name: page_data.return_page })
            }, 200);
            return false;
        }


        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: stockManager.apiSave,
            no: function () {
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'refresh',
                        'closeLayer': true
                    }
                });
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh',
                //     }
                // });
                // api.closeToWin({name: page_data.return_page});
                setTimeout(function () {
                    fun.useBack();
                    api.closeToWin({ name: page_data.return_page })
                }, 200);
            }
        });
    } else {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        // api.closeToWin({name: page_data.return_page});
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
    }
};

/**
 * 封装获取成本逻辑
 * @param list 需要获取成本的数组
 * @param callback 获取成功后回调函数
 */
stockManager.loadCpcbj = function (list, callback) {
    if (Auth.check('yxckbpcbj', 'view')) {
        __getJlData = function () {
            // 处理定价单位id
            for (var i = 0; i < list.length; i++) {
                list[i]['jjdw_id'] = list[i]['dw_id'];
            }
            return list;
        };

        // 更新成本价
        __updateJlDataByIndex = function (item) {
            list[item.index]['cbj'] = item.data.dj;
        };

        __getAllDj({
            get_dj: true,
            callback: function () {
                callback(list);
            }
        });
    }
};

/**
 * 加载产品成本价，初始化数据
 */
stockManager.initShowData = function () {
    stockManager.beforeShowData();
    stockManager.renderData(stockManager.convertData());
};

/**
 * 点击添加按钮，具体内容自己实现
 */
stockManager.openAddPage = function () {
    throw Error("添加按钮动作未实现");
};

/**
 *  判断是否可以编辑
 */
stockManager.isInEdit = function () {
    var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
    return AUTH_EDIT ? !stockManager.data.dj['is_sh'] : false;
};
// 页面显示处理 --------------------------------------------------------------------------------
/**
 * 显示页面数据通用方法
 */
stockManager.renderData = function (data) {
    data = stockManager.beforeRenderData(data);

    console.log(data);

    // 总匹数，总数量，计价单位处理
    var html = [], dws = {};
    stockManager.zps = 0;
    stockManager.zsl = 0;
    stockManager.zje = 0;

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        var ck_mc = val['ck_mc'];
        if (val['ck_id'] && !ck_mc) {
            ck_mc = fun.getHouseValue(val.ck_id, 'name');
        }
        html.push('<a class="store-title" data-ck_id="' + val.ck_id + '" data-index=\'' + i + '\'>' + (ck_mc || ' ') + '</a>');
        html.push('<ul class="swipe-delete">');
        for (var j = 0; j < val['list'].length; j++) {
            var data_list = val['list'][j];
            // 统计显示单位名称
            if (!dws[data_list.dw_id]) {
                dws[data_list.dw_id] = data_list.dw_mc;
            }
            html.push(stockManager.initContentList(data_list));
        }
        html.push('</ul>');
        // html.push('         <div class="add-product"><i class="iconfont icon-tianjia"></i>&nbsp;添加产品</div>');
    }

    $('.storehouse').html(html.join(''));


    if (!stockManager.isInEdit()) {
        $('.swipe-delete').removeClass('swipe-delete');
    }

    // 只有一个单位时显示，多个时不显示
    var showedDw = [];
    for (var dwId in dws) {
        showedDw.push(dws[dwId]);
    }
    if (showedDw.length === 1) {
        stockManager.showedDw = showedDw[0];
    } else {
        stockManager.showedDw = '';
    }

    stockManager.afterRenderData();

    stockManager.renderFooter();
};
/**
 * 初始化化每个li内容,主要返回字符串内容
 */
stockManager.initContentList = function () {
    throw Error('stockManager.initContentList() 方法未实现');
};
/**
 * 渲染列表内容之后动作
 */
stockManager.afterRenderData = function () {
};
/**
 * 渲染列表内容之前动作
 */
stockManager.beforeRenderData = function (data) {
    return data;
};

/**
 * 初始化数据之前调用
 */
stockManager.beforeShowData = function () {
};


//解决底部按钮宽度问题
// stockManager.setButtonWidth = function () {
//     $('.right2 .button2:visible').css('width', 'calc(100% / ' + $('.right2 .button2:visible').length + ')');
// };

/**
 * 显示底部导航栏内容
 */
stockManager.renderFooter = function () {
    if (stockManager.isInEdit()) {// 有权限或者单据未审核
        $('.choice').show();
        $('.saves').show();//,.choice
        $('.choice,.add-product').css('display', 'inline-block');
        if (Auth.check(stockManager.authCheckName, 'check') && page_data.id) { // 有审核权限
            $('.saves').hide();
            $('.audit').show();
        }
        stockManager.inputBindEvent();
    } else {//有权限并且单据已审核
        $('#bz').attr('disabled', 'disabled');
        $('#del_btn').hide();
        $('.choice,.add-product').hide();

        if ((!stockManager.data.dj.is_zf) && Auth.check(stockManager.authCheckName, 'invalid') && stockManager.fsh) { // 未作废、有作废权限并且【系统设置-反审核】有开启
            $('.obsolete').show();
        }
        if ((!stockManager.data.dj.is_zf) && Auth.check(stockManager.authCheckName, 'invalid') && !stockManager.fsh) { // 未作废、有作废权限并且【系统设置-反审核】没有开启
            $('.revocatory').show();
        }
    }
    $('#bz').val(stockManager.data.dj['bz'] || '');
    // 总匹数/总数量
    $('#zps').text((stockManager.zps.fixed(2) || 0) + '匹');
    $('#zsl').text((stockManager.zsl.fixed(2) || 0) + stockManager.showedDw);
    $('#zje').text(stockManager.zje.fixed(2) + '元');    // 保存2位小数

    stockManager.afterRenderFooter();

    if (stockManager.data.dj['is_zf']) {
        fun.seal({ type: 'zf' });
    } else if (stockManager.data.dj['is_sh']) {
        fun.seal({ type: 'sh' });
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
    var AUTH_SH = Auth.check(stockManager.authCheckName, 'check');
    // var AUTH_FH = Auth.check(stockManager.authCheckName, 'recheck');
    // var AUTH_JD = Auth.check(stockManager.authCheckName, 'settle');
    var AUTH_ZF = Auth.check(stockManager.authCheckName, 'invalid');

    if (stockManager.data.dj.is_sh) {
        $('.obsolete').show();
    } else {
        $('.obsolete').hide();
        page_data.id && $('.audit').show();
    }

    if (stockManager.data.dj['is_zf']) {
        $('button').hide();
    }

    if (!AUTH_EDIT) {
        $('#del_btn,.choice,.add-product,.saves').hide();
        $('input').attr('disabled', 'disabled');
        $('.right2').hide();
    }

    if (!AUTH_SH) {
        $('.audit,.revocatory').hide();
    }
    if (!AUTH_ZF) {
        $('.obsolete').hide();
    }


    // stockManager.setButtonWidth();

    // 初始化准备提交的汇总数据
    stockManager.data.dj = stockManager.getSaveDj();
};

/**
 * 显示底部导航栏之后动作
 */
stockManager.afterRenderFooter = function () {
    // $('#zps').text(data['zps']+'匹'||'0匹');
    // $('#zsl').text(data['zsl'] + kcZspdEdit.showedDw || '0' + kcZspdEdit.showedDw);
};
/**
 * 初始化导航栏
 */
stockManager.initHeader = function () {
    var date = new Date();
    // 新单时，设置默认开单时间
    if (!page_data.id) {
        date.setSeconds(0, 0);
        var current_date = fun.formatDate(date, 'YYYY-MM-DD HH:mm:ss');
        stockManager.origin_data.dj.kdsj = current_date;
        stockManager.data.dj.kdsj = current_date;
    }

    $('#header').header({
        back: true,
        title: stockManager.headerTitle,
        subtitle: page_data['dh'] || '&nbsp;',
        appendBackBtnEvt: stockManager.isDataChange,
        del: true,//stockManager.isInEdit(), // 编辑状态，并且单据可以修改
        order_info: {
            show: true,
            person: page_data['zdr'] || fun.getItem('user_info')['name'],
            dateText: page_data['kdsj'] || fun.formatDate(date),
        },
        much: (stockManager.djlx == 'bp_cgdd') ? true : false,
        print: true,//$.nui.isTrue(page_data.id)
        share: true,//$.nui.isTrue(page_data.id)
    });

    $('#much_btn,#print_btn,#del_btn,#share_btn').hide();
};

stockManager.initHeaderAfter = function () {
    var date = new Date();
    if (!stockManager.isInEdit()) {
        $('#del_btn').hide();
    }

    $('.subtitle').text(stockManager.data.dj.dh || ' ');
    $('#zdr').html(stockManager.data.dj['zdr_mc'] || fun.getItem('user_info')['name']);
    $('#kdsj').html(fun.formatDate(stockManager.data.dj['kdsj']) || fun.formatDate(date));

    if ($.nui.isTrue(page_data.id)) $('#print_btn').show();
    if ($.nui.isTrue(page_data.id)) {
        if (['bp_cgdd', 'bp_cglhd', 'bp_cgthd'].indexOf(stockManager.djlx) > -1) $('#share_btn').show();

        // if (['bp_cglhjs', 'bp_cgthjs'].indexOf(stockManager.djlx) > -1 && $.nui.isTrue(stockManager.data.dj.is_sh)) $('#share_btn').show();

        if (['bp_cglhjs', 'bp_cgthjs'].indexOf(stockManager.djlx) > -1) {
            fun.setShareBtnDisplay(stockManager.data.dj);
        }
    }
};

// 设置分享按钮显示隐藏
function setShareBtnDisplay(data) {
    var __sys_config = fun.getItem('sys_config') || {};

    if ($.nui.isTrue(__sys_config['djshhcyxfx'])) {
        if ($.nui.isTrue(data['is_sh']) && $.nui.isEmpty(data['is_zf'])) {
            $('#share_btn').show();
        } else {
            $('#share_btn').hide();
        }
    } else {
        $('#share_btn').show();
    }
}


/**
 * 选择时间回调
 * @param date
 */
stockManager.kdsjChange = function (date) {
};


/**
 * 设置或者清空批号，根据仓库是否开启批次管理判断
 */
stockManager.generaPh = function (config) {
    // 仓库开启批次的，需要设置批号
    if (config.ckInfo.is_batch) {
        if (!config.item[config.key] || config.forceUpdate) {
            config.item[config.key] = fun.formatDate(config.date, 'YYYYMMDD');
        }
    } else {
        config.item[config.key] = '';
    }
};

/**
 * 初始化时间选择控件
 */
stockManager.initDateTimePicker = function () {
    // <link rel="stylesheet" type="text/css" href="../css/lCalendar.css">
    var link = document.createElement('link');
    link.type = "text/css";
    link.rel = "stylesheet";
    link.href = "../css/lCalendar.css";
    document.getElementsByTagName("head")[0].appendChild(link);

    stockManager.begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            stockManager.data.dj.kdsj = fun.formatDate(date, 'YYYY-MM-DD HH:mm');
            $('#kdsj').text(fun.formatDate(date));
            stockManager.kdsjChange(date);
            stockManager.dataChangeShowSaveBtn();
        }
    });
};


// 属性配置
html_name = page_arr.cg_lhjs_kd;

Bills.djlx = 'bp_cglhjs';
Bills['del_row_exclude_col'] = ['dd_jl_id', 'ckd_jl_id'];//'is_yy_tm',
// 获取布匹上次价需要
Bills.AJAX_URL = { getDj: AJAX_URL.getBpCgDjAndScdj };
Bills['config'] = {
    fy_zdy: 'bpcgzdyfy', // 费用自定义字段
    ck_zdy: 'bpckzdygl', // 仓库自定义字段
    kd_zdy: 'bpkdzdyzd', // 开单自定义字段
    dckms: 'dckms_bp',   // 多仓库模式
    dbtckjs: 'dbtckjs_bp', // 调不同仓库单结算
    adjs: 'adjs_bpcg',   // 按单结算
    dwgshsbl: 'dwgshsbl_bp', // 单位公式换算保留位数
    jesswr: 'jesswr_bpcg',   // 金额四舍五入
    bdjesswr: 'bdjesswr_bpcg', // 本单金额四舍五入
    dddjwlcddj: 'dddjwlcddj_bpcg', // 订单单价为0重读单价
    shuilv: 'sl_gys', //  系统设置-默认税率(采购)
};

Bills['print_config'] = { 'has_bar': 1 };

stockManager.getDataUrl = AJAX_URL.getBpCglhjsInfo;
stockManager.postUrl = AJAX_URL.saveBpCglhjsInfo;
stockManager.authCheckName = 'bp_cglhjs';
stockManager.isLoadCbj = false;

stockManager.djlx = 'bp_cglhjs';
stockManager.table = 'cglhjs_dj';

stockManager.headerTitle = '来货结算';

stockManager.fz_ys = [];
stockManager.fz_cp = [];
stockManager.zh_list = []; // 账户信息

stockManager.zjjsl = 0;     // 计价总数量
stockManager.hszje = 0;     // 换算总金额
stockManager.ck_list = [];              // 仓库列表
stockManager.updateRow = false; // 是否在编辑
stockManager.wldw = {};     // 往来单位信息
stockManager.zhInfo = {};   // 账户信息
stockManager.hyInfo = {};   // 货运信息
stockManager.dy_ids = [];   // 调单记录id
stockManager.dws = {};      // 计价单位集合
stockManager.selectCkIndex = -1;
stockManager.isGeneraPh = true;   // 自动生成批号

// 初始化开始时执行
stockManager.initStart = function () {
    fun.load_DATA_LIST(['wldw_gys']);
    if ($.nui.isEmpty(page_data.id)) {
        // 设置
        if (page_data.wldw) {
            Bills.wldw = { id: page_data.wldw.id };
            stockManager.wldw = page_data.wldw;
            stockManager.data.dj.wldw_id = page_data.wldw.id;
            stockManager.data.dj.wldw_mc = page_data.wldw.merchant_name;
            $('#wldw_mc').val(page_data.wldw.merchant_name);
        }
        stockManager.data.dj.fy_je = 0;
        stockManager.data.dj.zh_je = 0;

        stockManager.origin_data.dj.wldw_id = '';
        stockManager.origin_data.dj.wldw_qqje = '';
        stockManager.origin_data.dj.wldw_ljqk = '';
        stockManager.origin_data.dj.fy_je = 0;
        stockManager.origin_data.dj.ysje = 0;
        stockManager.origin_data.dj.zh_je = 0;
        stockManager.origin_data.dj.zh_id = '';
        stockManager.origin_data.dj.bz = '';
        stockManager.origin_data.dj.hy_id = '';
        stockManager.origin_data.dj.hy_je = '';
        stockManager.origin_data.dj.hy_dh = '';
    }
};

// 初始化扩展
stockManager.initExtend = function () {
    // fun.keyboardEject('.base2');
    // 加载获取辅助信息，需要在初始化时间之后
    if ($.nui.isEmpty(page_data.id)) {
        stockManager.loadFzInfo(true);
    }

    //账户搜索
    $('#account').on('tap', function () {
        if (stockManager.isInEdit()) {
            fun.showPageFull({
                page_url: page_arr.select_bank_list,
                pageParam: {
                    page_type: 'zh',
                    return_page: html_name
                }
            });
        }
    });

    // 其他类型搜索
    $('#fy_mc').on('tap', function () {
        if (stockManager.isInEdit()) {
            fun.showPageFull({
                page_url: page_arr.select_list,
                pageParam: {
                    page_type: 'fy',
                    return_page: html_name
                }
            });
        }
    });

    //供应商搜索
    $('#supplier').on('tap', function (e) {
        if ($(this).find('#wldw_mc').attr('disabled')) return;
        // 如果当前单据有调用：采购订单、退货单 的记录，则为不可用状态
        if ($.nui.isEmpty(stockManager.data.dj.is_has) && stockManager.isInEdit()) {
            fun.showPageFull({
                page_url: page_arr.customer_search,
                pageParam: {
                    page_type: 'gys',
                    return_page: html_name
                }
            });
        }
    });

    // 货运icon处理
    $('#select_hy_icon').on('click', function () {
        var this_selector = $(this).children('.iconfont');
        if (this_selector.hasClass('icon-xia')) { // 显示货运部分信息
            this_selector.removeClass('icon-xia').addClass('icon-shang');
            $('.hy').removeClass('none-important');
        } else {                                  // 隐藏货运部分信息
            this_selector.removeClass('icon-shang').addClass('icon-xia');
            $('.hy').addClass('none-important');
        }
    });

    // 选择物流信息
    $('#select_hy').on('tap', function () {
        if (stockManager.isInEdit()) {
            fun.showPageFull({
                page_url: page_arr.customer_search,
                pageParam: {
                    page_type: 'wl',
                    return_page: html_name
                }
            });
        }
    });

    // 监听付款金额变化, 计算累欠金额
    $('#zh_je').on('keyup', function () {
        stockManager.data.dj.zh_je = parseFloat($(this).val() || 0);
        // 计算累欠金额
        stockManager.setLjqk();
    });

    // 监听其他费用变化，应付金额变化，计算累欠金额
    // 应付 = 含税总金额 + 其他金额
    $('#fy_je').on('keyup', function () {
        var je = parseFloat($(this).val() || 0);
        je = isNaN(je) ? 0 : je;
        stockManager.data.dj.fy_je = je;
        var ys_je = (stockManager.hszje + je).fixed();
        $('#ysje').val(ys_je);
        // 计算累欠金额
        stockManager.setLjqk();
    });

    // 监听运费信息变化
    $('#hy_je').on('keyup', function () {
        stockManager.data.dj.hy_je = $(this).val() || 0;
    });
    // 监听货运单信息变化
    $('#hy_dh').on('keyup', function () {
        stockManager.data.dj.hy_dh = $(this).val() || 0;
    });

    // 监听选择仓库事件
    $('body').on('tap', '.store-title', function (e) {
        e.preventDefault();
        if ($(this).attr('disabled')) return;
        if (stockManager.isInEdit()) {
            stockManager.checkSelectCk($(this).data('index'), this);
        }
    });
};

// 选择仓库
stockManager.checkSelectCk = function (selectCkIndex, _this) {
    stockManager.selectCkIndex = selectCkIndex;
    var ck_id = $(_this).data('ck_id');
    var ck_list = fun.getItem('ck_list') || [];
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            page_type: 'ck',
            return_page: html_name,
            ck_type: (fun.getValByKey(ck_list, ck_id, 'type') === 'skyb' && fun.checkJlHasSk(stockManager.data.jl, ck_id)) ? 'skyb' : ''
        }
    })
};

// 获取布匹上次价
stockManager.loadCpcbj = function (list, callback1, options) {
    options = $.extend({ update_all: false, get_dj: false }, options);

    // update_all 表示全部需要重新获取成本价
    var update_list = list;
    if (!options.update_all) {  // update_all
        update_list = [];
        for (var i = 0; i < list.length; i++) {
            if (typeof list[i].scdj === 'undefined') {
                update_list.push(list[i]);
            }
            // 设置税率
            if (typeof list[i].shuilv === 'undefined') {
                list[i].shuilv = 0;
            }
        }
    }

    __getJlData = function () {
        return update_list;
    };

    __getDjInfo = function () {
        return stockManager.data.dj;
    };

    // 获取上次价
    __updateJlDataByIndex = function (item) {
        var list_item = update_list[item.index];
        list_item.scdj = item.data.scdj;
        // 修改单价、含税总金额
        if (options.get_dj) {
            list_item.hsdj = list_item.dj = item.data.dj;
            // 金额je / 含税金额hsje
            list_item.hsje = (list_item.hsdj * (list_item.jjsl || 0)).fixed();
            list_item.je = (list_item.dj * (list_item.jjsl || 0)).fixed();

            var mode = SYS_CONFIG.jesswr_bpcg;
            list_item.hszje = fun.sswr(list_item.hsje, mode);
            // 总金额zje / 入库价 zydj
            list_item.zje = fun.sswr(list_item.je, mode);
            list_item.zydj = ($.nui.isEmpty(list_item['zsl'])) ? 0 : (list_item['je'] / parseFloat(list_item['zsl'])).fixed();
        }
    };

    if (update_list.length) {
        __getAllDj({
            get_scdj: true,
            update_all: options.update_all,
            get_dj: options.get_dj,
            callback: function () {
                callback1(list);
            }
        });
    } else {
        callback1(list);
    }
};

// 检查跟原始数据是否变化
stockManager.checkDataChange = function (origin_data, data) {
    var tmp_data = JSON.parse(JSON.stringify(data));
    // 删除添加的额外字段
    for (var i = 0; i < tmp_data.jl.length; i++) {
        delete tmp_data.jl[i].__uuid;
        delete tmp_data.jl[i].__row_uuid;
        delete tmp_data.jl[i].ssdj;
        delete tmp_data.jl[i].__index;
        delete tmp_data.jl[i].bqsl;
        delete tmp_data.jl[i].sssl;
        delete tmp_data.jl[i].jg_lx;
        delete tmp_data.jl[i].jg_lx_mc;

        tmp_data.jl[i].ps = Number(tmp_data.jl[i].ps);
        tmp_data.jl[i].jjdw_id = Number(tmp_data.jl[i].jjdw_id);

        if (tmp_data.jl[i].mx && tmp_data.jl[i].mx.length) {
            for (var j = 0; j < tmp_data.jl[i].mx.length; j++) {
                delete tmp_data.jl[i].mx[j].bqsl;
            }
        }
    }

    tmp_data.dj.fp_id = tmp_data.dj.fp_id || 0;
    tmp_data.dj.bdje = tmp_data.dj.bdje || 0;
    tmp_data.dj.jsr_id = tmp_data.dj.jsr_id || 0;
    tmp_data.dj.ck_id = Number(tmp_data.dj.ck_id);
    tmp_data.dj.wldw_qqje = tmp_data.dj.wldw_qqje || 0;

    if (origin_data.dj) {
        origin_data.dj.zdr_id = fun.getItem('user_info')['id'];
        origin_data.dj.md_id = fun.getItem('user_info')['store_id'];
    }

    console.log(JSON.stringify(origin_data));
    console.log(JSON.stringify(tmp_data));
    return !$.nui.isObjEquals(origin_data, tmp_data);
};


// 加载数据后调用，设置表单头部信息
stockManager.apiDataLoaded = function () {
    stockManager.begin_lCalendar.disabled = false;
    $('input,#kdsj,#wldw_mc').removeAttr('disabled');

    // 加载往来单位信息
    stockManager.wldw = fun.getListInfoByKey(fun.getItem('wldw_gys_list'), stockManager.data.dj.wldw_id);
    // 编辑时，设置已有供应商信息
    $('#ljqk').val(stockManager.data.dj.wldw_ljqk);
    $('#qqje').val(stockManager.data.dj.wldw_qqje);
    $('#wldw_mc').val(stockManager.data.dj.wldw_mc);
    $('#ysje').val(stockManager.data.dj.ysje.fixed());
    // 加载辅助信息，不加载供应商累欠金额
    Bills.wldw = { id: stockManager.data.dj.wldw_id };
    stockManager.loadFzInfo(false);

    var zh_je = stockManager.isInEdit() ? (stockManager.data.dj.zh_je || '') : stockManager.data.dj.zh_je;
    $('#zh_je').val(zh_je || '');

    // zh_je 账户信息
    if (stockManager.data.dj.zh_id) {
        stockManager.zhInfo = fun.getListInfoByKey(stockManager.zh_list, stockManager.data.dj.zh_id);
        var icon = stockManager.zhInfo.icon;

        $('#zh_icon').attr('src', '../img/bank/' + icon).show();
        $('#zh_name').text(stockManager.data.dj.zh_mc || '');
    } else {
        $('#zh_icon').attr('src', '').hide();
        $('#zh_name').text('');
    }
    // fy_id 费用
    if (stockManager.data.dj.fy_id) {
        $('#fy_je').val(stockManager.data.dj.fy_je);
        $('#fy_mc').text(stockManager.data.dj.fy_mc || '');
    } else {
        $('#fy_je').val('');
        $('#fy_mc').text('其他');
    }
    // 货运信息
    if (stockManager.data.dj.hy_id) {
        stockManager.hyInfo = fun.getListInfoByKey(fun.getItem('wldw_wl_list'), stockManager.data.dj.hy_id);
        $('#hy_mc').val(stockManager.data.dj.hy_mc);
        $('#hy_je').val(stockManager.data.dj.hy_je || '');
        $('#hy_dh').val(stockManager.data.dj.hy_dh);
    }
};

// 初始化数据前处理
stockManager.beforeShowData = function () {
    var date = $('#kdsj').text().trim();

    // 设置唯一下标，因为要按仓库聚合一次，删除、编辑时需要
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var item = stockManager.data.jl[i];
        item.__uuid = $.nui.getRandomNum();

        // 仓库开启明细管理，批号使用当前日期
        if (stockManager.isGeneraPh) {
            stockManager.generaPh({
                item: item,
                ckInfo: fun.getListInfoByKey(stockManager.ck_list, item.ck_id),
                date: date,
                key: 'ph',
                forceUpdate: false
            });
        }

        // 没有排序
        if ($.nui.isEmpty(item.px) && item.px === '') {
            item.px = i;
        }
    }
    // 数据清0
    stockManager.zjjsl = 0;
    stockManager.hszje = 0;
    stockManager.dy_ids = [];
    stockManager.dws = {};
};

// 初始化具体内容
stockManager.initContentList = function (data_list) {
    var kh_dd = !!data_list['kh_dd_dh'] && !!data_list['kh_dd_dj_id'] && !!data_list['kh_id'];
    var kh_style = kh_dd ? 'height:9.5rem' : '';
    var delete_style = kh_dd ? 'height:9.5rem;line-height:9.5rem' : '';

    var html = ['<li class="store-info fixed" style="' + kh_style + '">'];
    html.push('<div class="le">');

    if (data_list.dd_dj_id || data_list.ckd_dj_id) { // 标志记录是调单记录，或者仓库单记录
        html.push('<div class="box"></div>');
        if (data_list.dd_dj_id) {
            stockManager.dy_ids.push(data_list.dd_dj_id);
        }
    }
    html.push('<div class="store-content" data-row=\'' + fun.formatString(JSON.stringify(data_list)) + '\'>');
    html.push('<p class="store-name">' + data_list['cp_bh'] + data_list['cp_mc'] + ' <i>' + data_list['cp_ys_bh'] + data_list['cp_ys_mc'] + '</i></p>');
    // html.push('<span>幅宽<i class="info-date">' + data_list['fk'] + '</i></span>');
    // html.push('<span>克重<i class="info-date">' + data_list['kz'] + '</i></span>');
    // html.push(!!data_list['gh'] ? '<span>缸号<i class="info-date">' + data_list['gh'] + '</i></span>' : '<span></span>');

    html.push('<span>匹数<i class="info-date">' + data_list['ps'] + '</i></span>');
    html.push('<span>数量<i class="info-date">' + data_list['zsl'] + data_list['dw_mc'] + '</i></span>');
    // 当 计价数量 <> 数量 时，计价数量 字体颜色用蓝色，反之，则为黑色
    if (data_list['jjsl'] !== data_list['zsl']) {
        html.push('<span>计价<i class="info-date price-cp">' + data_list['jjsl'] + '</i>' + data_list['jjdw_mc'] + '</span>');
    } else {
        html.push('<span>计价<i class="info-date">' + data_list['jjsl'] + data_list['jjdw_mc'] + '</i></span>');
    }

    // 总金额计算
    html.push('<p style="margin-bottom: 0;padding-bottom: 0;">');
    html.push('<span>单价<i class="info-date unitprice">' + data_list['hsdj'] + '</i></span>');
    html.push('<span><i class="info-date price">￥' + data_list.hszje.fixed() + '</i></span>');  // TODO 可能需要修改
    html.push('</p>');
    if (fun.getKdSetting('fk')) {
        html.push('                 <span>幅宽<i class="info-date">' + fun.is_value(data_list['fk']) + '</i></span>');
    }
    if (fun.getKdSetting('kz')) {
        html.push('                 <span>克重<i class="info-date">' + fun.is_value(data_list['kz']) + '</i></span>');
    }
    if (fun.getKdSetting('gg')) {
        html.push('                 <span>规格<i class="info-date">' + fun.is_value(data_list['gg']) + '</i></span>');
    }
    if (fun.getKdSetting('gh')) {
        html.push('                 <span>缸号<i class="info-date">' + fun.is_value(data_list['gh']) + '</i></span>');
    }
    //调单信息
    if (kh_dd) {
        html.push('<p class="odd-numbers">');
        html.push('<em>' + data_list.kh_mc + '</em>');
        html.push('<em>订单：' + data_list.kh_dd_dh + '</em>');
        html.push('</p>');
    }

    var zdy_arr = fun.getZdyfyArr('bpcgzdyfy', data_list);
    if (zdy_arr.length != 0) {
        html.push('                 <div class="manyExpenses">')
        html.push('                     <div>')
        html.push('                         <p class="manyExpenses-p">费用</p>')
        for (var k = 0; k < zdy_arr.length; k += 2) {
            html.push('                     <span class="manyExpenses-span">' + zdy_arr[k] + ' ' + zdy_arr[k + 1] + '元</span>');
        }
        html.push('                     </div>')
        html.push('                 </div>')
    }

    html.push('</div>');
    if ($.nui.isEmpty(stockManager.data.dj.is_sh)) {
        html.push('<div class="delete dels1 delete-btn ds" data-row=\'' + fun.formatString(JSON.stringify(data_list)) + '\'><b class="swipe-span">删除</b></div>');
    }
    html.push('</div>');
    html.push('</li>');

    // 总匹数，总数量合计
    stockManager.zps = $.nui.decimalAdd(stockManager.zps, data_list.ps);
    stockManager.zsl = $.nui.decimalAdd(stockManager.zsl, data_list.zsl);
    stockManager.zje = $.nui.decimalAdd(stockManager.zje, data_list.zje);
    stockManager.zjjsl = $.nui.decimalAdd(stockManager.zjjsl, data_list.jjsl || 0);
    stockManager.hszje = $.nui.decimalAdd(stockManager.hszje, data_list.hszje);
    if (!stockManager.dws[data_list.jjdw_id]) {
        stockManager.dws[data_list.jjdw_id] = data_list.jjdw_mc;
    }

    return html.join('');
};

stockManager.afterRenderFooter = function () {
    // 只有一个单位时显示，多个时不显示
    var showedDws = [];
    for (var dwId in stockManager.dws) {
        showedDws.push(stockManager.dws[dwId]);
    }
    var showedDw = '';
    if (showedDws.length === 1) {
        showedDw = showedDws[0];
    }

    // stockManager.zjjsl = stockManager.zjjsl.fixed(2);
    stockManager.zsl = stockManager.zsl.fixed(4);
    stockManager.hszje = __bdjeSswr(stockManager.hszje);
    $('#zsl').text((stockManager.zjjsl.fixed(2) || 0) + showedDw);
    $('#zje').text(stockManager.hszje + '元');  // 保留两位小数
};

// TODO 可优化，放列表循环理处理
stockManager.setDomDisabled = function () {
    var value = { wldw: false };
    var ck_ids = {};
    var SYS_CONFIG = fun.getItem('sys_config') || {};
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var row = stockManager.data.jl[i];
        if ($.nui.isTrue(row['is_delete'])) continue;
        // 记录表 有引用 订单的记录 或 仓库单的记录 则 往来单位不能修改
        if ($.nui.isTrue(row['dd_dj_id']) || $.nui.isTrue(row['ckd_dj_id']) || $.nui.isTrue(row['ybjl_id'])) value['wldw'] = true;

        // 如果是 引用仓库单记录，则判断 多仓库模式、调用不同仓库单结算 都没开启 则需把仓库设置为 不可用状态
        if ($.nui.isTrue(row['ckd_dj_id']) &&
            $.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) &&
            $.nui.isEmpty(SYS_CONFIG[Bills['config']['dbtckjs']])
        ) {
            ck_ids[row['ck_id']] = row['ck_id'];
            value['ck'] = true;
        }

        // 如果是 引用 有 引用条码记录 则 仓库不能修改
        if ($.nui.isTrue(row['is_yy_tm'])) {
            value['ck'] = true;
            ck_ids[row['ck_id']] = row['ck_id'];
        }

        // 如果 有 引用 条码采集窗口 则 仓库、往来单位 都不能修改
        if (row['yy_djlx'] === 'tmcj') {
            value['wldw'] = true;
            value['ck'] = true;
            ck_ids[row['ck_id']] = row['ck_id'];
        }


        if (stockManager.djlx == 'bp_cgthjs' && !fun.getHouseValue(row['ck_id'], 'is_detail') && fun.getHouseValue(row['ck_id'], 'is_batch')) {
            value['ck'] = true;
            ck_ids[row['ck_id']] = row['ck_id'];
        }
    }

    if ($.nui.isTrue(value['wldw'])) {
        $('#wldw_mc').attr('disabled', true);
    } else {
        $('#wldw_mc').removeAttr('disabled');
    }

    if ($.nui.isTrue(value['ck'])) {
        for (var key in ck_ids) {
            $('.store-title[data-ck_id="' + key + '"]').attr('disabled', true);
        }
    }
};

stockManager.afterRenderData = function () {
    //调单后设置供应商不可用状态
    stockManager.setDomDisabled();

    //  当前单据有调用：采购订单、退货单 的记录，或者已审核，设置供应商不可用状态
    if ($.nui.isEmpty(stockManager.data.dj.is_has) && !stockManager.isInEdit()) {
        $('#wldw_mc').attr('disabled', true);
    }
    // TODO 其他设置不可用状态，显示颜色(细节)

    if (!stockManager.isInEdit()) {
        $('input').attr('disabled', true);
    }

    // 获取含税总金额、其他费用金额，更新应付金额
    if (!stockManager.data.dj.fy_je) {
        stockManager.data.dj.fy_je = 0;
    }
    // 计算含税总金额
    stockManager.data.dj.bdje = stockManager.hszje;
    $('#ysje').val((__bdjeSswr(stockManager.data.dj.bdje) + stockManager.data.dj.fy_je).fixed());
    // 数据渲染完毕，重新计算累欠金额
    stockManager.setLjqk();
};

// 删除行记录
stockManager.deleteRow = function (_this) {
    var list_data = $(_this).data('row');
    // 查找具体下标,因为按仓库聚合过一次
    var foundIndex = stockManager.findIndex(function (item) {
        return item.__uuid === list_data.__uuid;
    });
    var delArr = stockManager.data.jl.splice(foundIndex, 1);
    stockManager.rowDeleteHandler(delArr[0]);
    stockManager.initShowData();
};

// 编辑行记录
stockManager.editRow = function (_this) {
    var list_data = $(_this).data('row');
    var index = stockManager.findIndex(function (item) {
        return item.__uuid === list_data.__uuid;
    });
    var ckInfo = fun.getListInfoByKey(stockManager.ck_list, list_data.ck_id);

    if (stockManager.isInEdit()) {
        // 判断总数编辑或者明细编辑
        fun.showPageFull({
            page_url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor,
            pageParam: {
                djlx: stockManager.djlx,
                return_page: html_name,
                list_data: list_data,
                ck_info: ckInfo,
                edit_row: true,
                row_index: index,
                bj_type: ckInfo.is_detail ? 'mx' : 'zs',
                __JL_DATA: stockManager.data.jl,
                __DJ_DATA: stockManager.getSaveDj(),
                __PAGE_EDIT: true,
                ck_is_disabled: $(_this).closest('.storehouse').find('.store-title').attr('disabled')
            }
        });
        stockManager.updateRow = true;
    } else {
        if (ckInfo.is_detail) {
            fun.showPageFull({
                page_url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.detailed_barcode,
                pageParam: {
                    djlx: stockManager.djlx,
                    list_data: list_data,
                    __PAGE_EDIT: false,    // 不允许编辑
                    __DJ_DATA: stockManager.data.dj,
                    __JL_DATA: stockManager.data.jl,
                    ck_is_disabled: $(_this).closest('.storehouse').find('.store-title').attr('disabled'),
                    return_page: html_name,
                    ck_info: ckInfo,
                    edit_row: true,
                    row_index: index,
                    bj_type: ckInfo.is_detail ? 'mx' : 'zs',
                }
            });
        } else {
            if (NEW_BILLS) {
                // 判断总数编辑或者明细编辑
                fun.showPageFull({
                    page_url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor,
                    pageParam: {
                        djlx: stockManager.djlx,
                        return_page: html_name,
                        list_data: list_data,
                        ck_info: ckInfo,
                        edit_row: true,
                        row_index: index,
                        bj_type: 'zs',
                        __JL_DATA: stockManager.data.jl,
                        __DJ_DATA: stockManager.data.dj,
                        __PAGE_EDIT: false,
                        ck_is_disabled: $(_this).closest('.storehouse').find('.store-title').attr('disabled')
                    }
                });
            }
        }
    }
};

// 辅助颜色/色号
// 产品辅助名称/编号
stockManager.loadFzInfo = function (loadLjqk) {
    __getWldwSubInfo({
        ljqk: loadLjqk,
        fz_cp: true,
        fz_ys: true,
        lxr: false,
        callback: function (res) {
            fun.hideLoad();
            // 前欠金额
            if (loadLjqk) {
                $('#qqje').val(res.ljqk);
                stockManager.data.dj.wldw_qqje = res.ljqk;
                stockManager.setLjqk();
            }

            // 辅助色号/颜色
            stockManager.fz_ys = res.fz_ys || [];
            fun.setFzys(stockManager.fz_ys, stockManager.data.jl);

            // 辅助编号/产品
            stockManager.fz_cp = res.fz_cp || [];
            fun.setFzcps(stockManager.fz_cp, stockManager.data.jl);
        }
    });
};

// 应付 = 含税总金额 + 其他金额
// 如果单据的对象为：客户
//   累欠 = 前欠 + 应付 – 付款
// 如果单据的对象为：供应商、加工商
//   累欠 = 前欠 – 应付 + 付款
stockManager.setLjqk = function () {
    var ysje = parseFloat($('#ysje').val() || 0);
    var zh_je = parseFloat($('#zh_je').val() || 0);

    ysje = isNaN(ysje) ? 0 : ysje;
    zh_je = isNaN(zh_je) ? 0 : zh_je;

    var ljqk;

    if (stockManager.wldw.type === 'kh') { // 客户
        ljqk = stockManager.data.dj.wldw_qqje - ysje + zh_je;
    } else { // 供应商、加工商
        ljqk = stockManager.data.dj.wldw_qqje + ysje - zh_je;
    }
    if (!isNaN(ljqk)) {
        $('#ljqk').val(ljqk.fixed());
    }
};

// 添加记录时处理
stockManager.add_rows = function (list) {
    stockManager.data.jl = list;
    // 设置辅助信息
    fun.setFzcps(stockManager.fz_cp, list);
    fun.setFzys(stockManager.fz_ys, list);
    // 如果是调库存的记录，获取单价。批号为空
    stockManager.initShowData();
};

// 选择供应商处理
stockManager.gysSelectHandler = function (wldw) {
    stockManager.wldw = wldw;
    stockManager.data.dj.wldw_id = wldw.id;

    Bills.wldw = { id: wldw.id };
    $('#wldw_mc').val(wldw.merchant_name);

    // 清空账户信息
    stockManager.data.dj.zh_id = '';
    stockManager.zhInfo = {};
    stockManager.data.dj.zh_je = 0; //账户金额
    stockManager.data.dj.zh_mc = '';

    $('#zh_icon').attr('src', '').hide();
    $('#zh_name').text('');
    $('#zh_je').val('');

    // 切换供应商，重新全部记录获取单价和上次价
    stockManager.loadCpcbj(stockManager.data.jl, function (list) {
        stockManager.data.jl = list;
        stockManager.initShowData();
        stockManager.dataChangeShowSaveBtn();

        setTimeout(function () {
            stockManager.loadFzInfo(true);
        }, 20);

    }, { update_all: true, get_dj: true });
};

// 重写该方法，不需要加载上次价
stockManager.initLoadCpcbj = function (initList) {
    stockManager.data.jl = initList;
    stockManager.initShowData();
};

// 记录行选择仓库处理
stockManager.selectCkHandler = function (hzData, newCkInfo) {
    var ckInfo = fun.getListInfoByKey(stockManager.ck_list, hzData.ck_id);
    var date = $('#kdsj').text().trim();

    for (var i = 0; i < hzData.list.length; i++) {
        hzData.list[i].ck_id = newCkInfo.id;
        hzData.list[i].ck_mc = newCkInfo.name;
        // 批号处理
        if (stockManager.isGeneraPh) {
            stockManager.generaPh({
                item: hzData.list[i],
                ckInfo: ckInfo,
                date: date,
                key: 'ph',
                forceUpdate: true
            });
        }
    }
    // 不是多仓库时，dj赋值
    if (!stockManager.isDckms) {
        stockManager.data.dj.ck_id = newCkInfo.id;
    }

    stockManager.initShowData();
};

// 事件回调
stockManager.eventListenerExtend = function (ret, err) {
    console.log('eventListenerExtend', ret);
    var status = ret.value.status;
    var data = ret.value.data;
    if (status === 'select_list') {
        if (data.page_type === 'zh') {            // 选择账户返回
            stockManager.data.dj.zh_id = data.list_data.id;
            stockManager.zhInfo = data.list_data;
            $('#zh_icon').attr('src', '../img/bank/' + data.list_data.icon).show();
            $('#zh_name').text(data.list_data.name);
        } else if (data.page_type === 'gys') {    // 选择供应商回调，需要更新辅助信息、账户信息
            if (!$.nui.isEmpty(data.list_data.id) && stockManager.data.dj.wldw_id !== data.list_data.id) {
                stockManager.gysSelectHandler(data.list_data);
            }
        } else if (data.page_type === 'fy') {     // 选择费用回调
            stockManager.data.dj.fy_id = data.list_data.id;
            $('#fy_mc').text(data.list_data.name);
        } else if (data.page_type === 'wl') {     // 选择物流信息回调
            stockManager.hyInfo = data.list_data;
            stockManager.data.dj.hy_id = data.list_data.id;
            stockManager.data.dj.hy_zh_id = 0;
            stockManager.data.dj.hy_zh_je = 0;
            $('#hy_mc').val(data.select_val);
        } else if (data.page_type === 'ck') {    // 选择仓库返回
            var hzData = stockManager.hzData[stockManager.selectCkIndex];
            if (!$.isEmptyObject(hzData)) {
                if (hzData.ck_id !== data.list_data.id) {

                    for (var i = 0; i < stockManager.data.jl.length; i++) {
                        if (stockManager.data.jl['is_delete']) continue;
                        if (stockManager.data.jl[i]['ck_id'] == hzData.ck_id && $.nui.isEmpty(stockManager.data.jl[i]['ckd_dj_id'])) {
                            stockManager.data.jl[i]['ck_id'] = data.list_data.id;
                            stockManager.data.jl[i]['ck_mc'] = data.list_data.name;
                            stockManager.data.jl[i]['cw_id'] = 0;
                            stockManager.data.jl[i]['cw_mc'] = '';
                            stockManager.data.jl[i]['ph'] = '';
                            stockManager.data.jl[i]['bp_kh_id'] = 0;
                            stockManager.data.jl[i]['bp_kh_mc'] = '';
                            stockManager.data.jl[i]['bp_gys_id'] = 0;
                            stockManager.data.jl[i]['bp_gys_mc'] = '';
                            stockManager.data.jl[i]['bp_jgs_id'] = 0;
                            stockManager.data.jl[i]['bp_jgs_mc'] = '';
                            stockManager.data.jl[i]['bp_ywy_id'] = 0;
                            stockManager.data.jl[i]['bp_ywy_mc'] = '';
                        }
                    }

                    stockManager.selectCkIndex = -1;
                    stockManager.selectCkHandler(hzData, data.list_data);
                }
            }
        }
    } else if (status === 'update_rows') {
        if (!stockManager.updateRow) {                      // 添加产品回调
            stockManager.add_rows(data.__JL_DATA);
        } else {                                            // 编辑详情回调
            stockManager.updateRow = false;
            stockManager.data.jl = data.__JL_DATA;
            stockManager.initShowData();
        }
    } else if (status === 'close_win') {
        stockManager.updateRow = false;
        stockManager.selectCkIndex = -1;
    } else if (status === 'cg_dycgdd') {                    // 调用采购订单回调
        stockManager.data.jl = data.__JL_DATA;
        // 重新初始化显示数据
        stockManager.initShowData();
        // 供应商赋值，并且设置为不可用。需要删除才能用
        if (data.wldw && data.wldw.id !== stockManager.data.dj.wldw_id) {
            stockManager.gysSelectHandler(data.wldw);
        } else {
            // 添加新数据, 辅助单位设置
            fun.setFzcps(stockManager.fz_cp, data.__JL_DATA);
            fun.setFzys(stockManager.fz_ys, data.__JL_DATA);
        }
    } else if (status === 'update') {                       // 选择仓库返回
        stockManager.updateRow = false;
        stockManager.selectCkIndex = -1;
    } else if (ret.value.status === 'refresh_dj') {
        __init();
    } else if (ret.value.status === 'update_phsz') {
        stockManager.initShowData();
    } else {
        stockManager.otherEventListener(ret, err);
    }

    var statusArr = [
        'select_list',
        'update_rows',
        'close_win',
        'cg_dycgdd',
        'update'
    ];
    // 根据返回状态检测数据判断显示保存按钮
    stockManager.checkStatusShowSaveBtn(statusArr, status);
};

// 空方法
stockManager.otherEventListener = function (ret, err) {
};

// 打开新增页面
stockManager.openAddPage = function () {
    var __PAGE_INFO = { ck_id: '' };

    if (stockManager.hzData.length) {
        __PAGE_INFO.ck_id = stockManager.hzData[0].ck_id;
    } else {
        if ($.nui.isEmpty(page_data.id)) {
            __PAGE_INFO = (page_data.cp_tmp && page_data.cp_tmp.__PAGE_INFO) || {};
        }
    }

    fun.showPageFull({
        page_url: page_arr.choice_product,
        pageParam: {
            djlx: stockManager.djlx,
            return_page: html_name,
            __PAGE_INFO: __PAGE_INFO,
            __JL_DATA: stockManager.data.jl,
            __DJ_DATA: stockManager.data.dj,
            jl_id_notin: stockManager.dy_ids,    // 调单的id集合
            loadScdj: true,
        }
    })
};


// 需要字段差别太大，重写该方法
stockManager.getSaveDj = function () {
    return $.extend(JSON.parse(JSON.stringify(stockManager.origin_data.dj)), {
        id: Number(page_data['id'] || 0),
        save_time: stockManager.data.dj.save_time || '', // 保存时间
        jsr_id: stockManager.data.dj.jsr_id || '',       // 经手人id
        wldw_id: stockManager.data.dj.wldw_id,
        wldw_qqje: stockManager.data.dj.wldw_qqje || '',    // 前欠金额
        zdr_id: fun.getItem('user_info')['id'],      // 制单人id stockManager.data.dj.zdr_id ||
        md_id: fun.getItem('user_info')['store_id'],  // 门店id stockManager.data.dj.md_id ||
        kdsj: fun.formatDate($('#kdsj').text().trim(), 'YYYY-MM-DD HH:mm:ss'),             // 开单时间
        dj_lsh: stockManager.data.dj.dj_lsh || '',        // 单据流水号
        dh: $('.subtitle').text().trim() || '',           // 单号
        ck_id: stockManager.data.dj.ck_id,
        fp_id: stockManager.data.dj.fp_id || '',
        fy_id: stockManager.data.dj.fy_id,
        fy_je: stockManager.data.dj.fy_je,
        bdje: __bdjeSswr(stockManager.data.dj.bdje || 0),
        zje: __bdjeSswr(stockManager.zje || 0),
        hszje: __bdjeSswr(stockManager.hszje || 0),
        ysje: parseFloat($('#ysje').val()),
        zh_id: stockManager.data.dj.zh_id,
        zh_je: stockManager.data.dj.zh_je,
        hy_id: stockManager.data.dj.hy_id,
        hy_je: stockManager.data.dj.hy_je,
        hy_zh_id: stockManager.data.dj.hy_zh_id,
        hy_zh_je: stockManager.data.dj.hy_zh_je,
        hy_dh: stockManager.data.dj.hy_dh,
        zps: parseInt($('#zps').text() || 0),
        zsl: stockManager.zsl,
        zjjsl: stockManager.zjjsl,
        bz: $('#bz').val().trim() || '',
    });
};

// 获取保存数据
stockManager.getSaveData = function () {
    var dj = {}, jl = [];

    var kdsj = $('#kdsj').text().trim();
    var oriDj = JSON.parse(JSON.stringify(stockManager.origin_data.dj));

    dj = {
        id: Number(page_data['id'] || 0),
        save_time: stockManager.data.dj.save_time || '', // 保存时间
        jsr_id: stockManager.data.dj.jsr_id || '',       // 经手人id
        wldw_id: stockManager.data.dj.wldw_id,
        wldw_qqje: stockManager.data.dj.wldw_qqje || '',    // 前欠金额
        zdr_id: fun.getItem('user_info')['id'],      // 制单人id stockManager.data.dj.zdr_id ||
        md_id: fun.getItem('user_info')['store_id'],  // 门店id stockManager.data.dj.md_id ||
        kdsj: fun.formatDate($('#kdsj').text().trim(), 'YYYY-MM-DD HH:mm:ss'),             // 开单时间
        dj_lsh: stockManager.data.dj.dj_lsh || '',        // 单据流水号
        dh: $('.subtitle').text().trim() || '',           // 单号
        ck_id: stockManager.data.dj.ck_id,
        fp_id: stockManager.data.dj.fp_id || '',
        fy_id: stockManager.data.dj.fy_id,
        fy_je: stockManager.data.dj.fy_je,
        bdje: __bdjeSswr(stockManager.data.dj.bdje || 0),
        zje: __bdjeSswr(stockManager.zje || 0),
        hszje: __bdjeSswr(stockManager.hszje || 0),
        ysje: parseFloat($('#ysje').val()),
        zh_id: stockManager.data.dj.zh_id,
        zh_je: stockManager.data.dj.zh_je,
        hy_id: stockManager.data.dj.hy_id,
        hy_je: stockManager.data.dj.hy_je,
        hy_zh_id: stockManager.data.dj.hy_zh_id,
        hy_zh_je: stockManager.data.dj.hy_zh_je,
        hy_dh: stockManager.data.dj.hy_dh,
        zps: parseInt($('#zps').text() || 0),
        zsl: stockManager.zsl,
        zjjsl: stockManager.zjjsl,
        bz: $('#bz').val().trim() || '',
    };

    dj = $.extend({}, JSON.parse(JSON.stringify(stockManager.origin_data.dj)), dj);
    var recordData = stockManager.data.jl.concat(stockManager.deleteRows), px = 0;
    for (var i = 0; i < recordData.length; i++) {
        var val = $.extend(true, { mx: [] }, recordData[i]);
        if ($.nui.isTrue(val['is_delete']) && $.nui.isEmpty(val['id'])) continue;

        var __tmp_data = {};

        __tmp_data['mx'] = [];
        var tmpData = $.extend({}, val, __tmp_data);

        if ($.nui.isEmpty(tmpData['is_delete'])) {
            px += 1;
            tmpData['px'] = px;
        }
        // // 未开启【系统设置-多仓库模式】时 ,把单据表的仓库赋值到记录表,反之认记录表的仓库
        // var ck_id = ($.nui.isEmpty(stockManager.isDckms)) ? dj['ck_id'] : (val['ck_id'] || 0);
        // tmpData['ck_id'] = ck_id;

        for (var j = 0; j < val['mx'].length; j++) {
            // 如果记录行删除的情况,则明细表也是得以删除的情况处理
            if ($.nui.isTrue(tmpData['is_delete'])) val['mx'][j]['is_delete'] = 1;
            // 当数量为0, 并且无id字段信息，则代表为新添加并且手动删除的信息，跳过不处理
            if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isTrue(val['mx'][j]['is_delete'])) continue;
            if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isEmpty(val['mx'][j]['sl'])) continue;
            tmpData['mx'].push(val['mx'][j]);
        }
        jl.push(tmpData);
    }
    var data = { dj: dj, jl: jl };
    stockManager.getJpdAndScp(data);
    return data;
};

stockManager.commonCheckBeforeApiSaveAjax = function (callback) {
    if ($.nui.isEmpty(stockManager.data.dj.wldw_id)) {
        fun.toast('供应商不能为空。');
        return callback(false);
    }

    if ($.nui.isEmpty(stockManager.data.dj.zh_je)) stockManager.data.dj.zh_id = 0;
    if ($.nui.isEmpty(stockManager.data.dj.fy_je)) stockManager.data.dj.fy_id = 0;

    if (stockManager.data.dj.zh_je && $.nui.isEmpty(stockManager.data.dj.zh_id)) {
        fun.toast('请选择账户。');
        return callback(false);
    }
    if (stockManager.data.dj.fy_je && $.nui.isEmpty(stockManager.data.dj.fy_id)) {
        fun.toast('请选择费用。');
        return callback(false);
    }

    if ($.nui.isEmpty(stockManager.data.dj.hy_id) && (!$.nui.isEmpty(stockManager.data.dj.hy_je) || !$.nui.isEmpty(stockManager.data.dj.hy_dh))) {
        fun.toast('请选择货运。');
        return callback(false);
    }

    var kd_date = fun.formatDate(stockManager.data.dj.kdsj, 'YYYY-MM-DD');

    // 当前单据的日期 < 当前往来单位的建立日期，则弹提示框
    if (kd_date < fun.formatDate(stockManager.wldw.date, 'YYYY-MM-DD')) {
        fun.toast(['单据日期不能小于往来单位建立日期'].join(''));
        return callback(false);
    }

    // 当前单据的日期 < 当前账户的建立日期，则弹提示框
    if (stockManager.data.dj.zh_id) {
        if (kd_date < fun.formatDate(stockManager.zhInfo.date, 'YYYY-MM-DD')) {
            fun.toast(['单据日期不能小于账户建立日期'].join(''));
            return callback(false);
        }
    }

    // 当前单据的日期 < 当前货运的建立日期，则弹提示框
    if ($.nui.isTrue(stockManager.data.dj.hy_id)) {
        if (kd_date < fun.formatDate(stockManager.hyInfo.date, 'YYYY-MM-DD')) {
            fun.toast(['单据日期不能小于货运建立日期'].join(''));
            return callback(false);
        }
    }

    // 如果仓库开启明细管理，仓库下所有记录行都需要明细匹
    for (var i = 0; i < stockManager.hzData.length; i++) {
        var hzData = stockManager.hzData[i];

        console.log('hzData', hzData)

        var ckInfo = fun.getListInfoByKey(stockManager.ck_list, hzData.ck_id);

        for (var j = 0; j < hzData.list.length; j++) {
            var item = hzData.list[j];
            if (item['is_delete']) continue;

            console.log(fun.isMxInvalid(ckInfo, item.mx))

            if (fun.isMxInvalid(ckInfo, item.mx)) {
                fun.toast('【' + ckInfo.name + '】已启用明细管理，请输入明细匹。');
                return callback(false);
            }
        }

    }

    return callback(true);
};


stockManager.checkHasZero = function () {
    var hasZero = false;
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var item = stockManager.data.jl[i];
        if (item.is_delete) continue;
        if ($.nui.isEmpty(item.hsdj)) {
            hasZero = true;
            break;
        }
    }
    return hasZero;
};

// 保存约束条件处理
stockManager.checkBeforeApiSaveAjax = function (callback) {
    stockManager.commonCheckBeforeApiSaveAjax(function (result) {
        // 前面约束检查不通过，返回
        if (!result) {
            return callback(false);
        }

        // var realJl = [];
        // for(var i=0;i<stockManager.data.jl.length;i++){
        //     var tmpData = stockManager.data.jl[i];
        //
        //     // 如果 记录行 被删除, 则不需要判断 限制
        //     if ($.nui.isTrue(tmpData['is_delete'])) continue;
        //     if ($.nui.isEmpty(tmpData['ck_id'])) return fun.toast('请选择：【仓库】。');
        //     if ($.nui.isEmpty(tmpData['cp_ys_id'])) return fun.toast('请选择：【颜色】。');
        //     if ($.nui.isEmpty(tmpData['dw_id'])) return fun.toast('请选择：【单位】。');
        //     if ($.nui.isEmpty(tmpData['jjdw_id'])) return fun.toast('请选择：【计价单位】。');
        //
        //     if ($.nui.isEmpty(tmpData['ps']) && $.nui.isEmpty(tmpData['zsl'])) return fun.toast('请输入：【匹数】、【数量】。');
        //
        //     realJl.push(tmpData);
        // }
        //
        // stockManager.data.jl = realJl.slice(0);

        // 单价为0时，提示部分产品单价为0
        if (stockManager.checkHasZero()) {
            stockManager.removeAlertClass();
            fun.dialog({
                content: '部分产品单价为0，您确定要保存吗？',
                btn: ['确定', '取消'],
                className: 'al-skin',
                anim: false,
                yes: function () {
                    callback(true);
                },
                no: function () {
                    callback(false);
                }
            });
        } else {
            callback(true);
        }
    });
};

// 检查供应商、前欠、累欠、其他、应付、付款、账户、备注、货运、运费、货运单、开单时间
stockManager.isDjDataChange = function () {
    return stockManager.data.dj.wldw_id !== stockManager.origin_data.dj.wldw_id ||
        stockManager.data.dj.wldw_qqje !== stockManager.origin_data.dj.wldw_qqje ||
        stockManager.data.dj.wldw_ljqk !== stockManager.origin_data.dj.wldw_ljqk ||
        stockManager.data.dj.fy_je !== stockManager.origin_data.dj.fy_je ||
        stockManager.data.dj.ysje !== stockManager.origin_data.dj.ysje ||
        stockManager.data.dj.zh_je !== stockManager.origin_data.dj.zh_je ||
        stockManager.data.dj.zh_id !== stockManager.origin_data.dj.zh_id ||
        stockManager.data.dj.bz !== stockManager.origin_data.dj.bz ||
        stockManager.data.dj.hy_id !== stockManager.origin_data.dj.hy_id ||
        stockManager.data.dj.hy_je !== stockManager.origin_data.dj.hy_je ||
        stockManager.data.dj.hy_dh !== stockManager.origin_data.dj.hy_dh ||
        stockManager.data.dj.kdsj !== stockManager.origin_data.dj.kdsj;
};

// 开单日期修改，修改批号，只针对开启批次管理的仓库
stockManager.kdsjChange = function (date) {
    if (stockManager.isGeneraPh) {
        for (var i = 0; i < stockManager.hzData.length; i++) {
            var hzData = stockManager.hzData[i];
            var ckInfo = fun.getListInfoByKey(stockManager.ck_list, hzData.ck_id);

            for (var j = 0; j < hzData.list.length; j++) {
                stockManager.generaPh({
                    item: hzData.list[j],
                    ckInfo: ckInfo,
                    date: date,
                    key: 'ph',
                    forceUpdate: true
                });
            }
        }
    }
};

//分享单据到微信
$('body').on('click', '#share_btn', function (_opt) {
    stockManager.data.dj = stockManager.getSaveDj();
    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
        return fun.toast('请先保存单据！');
    }
    fun.shareRequest({
        djlx: Bills['djlx'],
        id: page_data['id'],
    })
})

// 数据发生改变显示保存按钮
stockManager.dataChangeShowSaveBtn = function () {
    stockManager.data.dj = stockManager.getSaveDj();
    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) stockManager.showSaveBtn();
}

// 根据返回状态检测数据判断显示保存按钮
stockManager.checkStatusShowSaveBtn = function (statusArr, status) {
    // 返回状态数组
    if (statusArr.indexOf(status) > -1) stockManager.dataChangeShowSaveBtn();
}

// 显示保存按钮
stockManager.showSaveBtn = function () {
    if ($('.audit:visible').length) {
        $('.audit').hide();
    }
    if ($('.saves:visible').length) return;
    if (stockManager.data.dj['is_sh']) return;
    $('.saves').show();
}

// input输入框绑定事件
stockManager.inputBindEvent = function () {
    // 未审核数据改变显示保存按钮
    $('body').off('input propertychange', ':input').on('input propertychange', ':input', fun.throttle(stockManager.showSaveBtn, 300));
}

stockManager.removeAlertClass = function () {
    if ($('.data-change-skin').length) {
        $('.data-change-skin').removeClass('data-change-skin');
    }
}

// 获取剪匹数、实出匹
stockManager.getJpdAndScp = function (data) {
    if (page_data['djlx'] === 'bp_cgthjs') {
        $(data.jl).each(function (idx, item) { 
            if (item.is_delete) return true;
            var zps = 0;
            var scps = 0;
            var jps = 0;
            if ($.nui.isTrue(item.mx) && __getMxLength(item.mx)) {
                $(item.mx).each(function (index, mxItem) {
                    if (mxItem.is_delete) { // 排除被删除明细
                        return true;
                    }
                    zps++;
                    if (parseFloat(mxItem.sl) < parseFloat(mxItem.tm_sl || 0)) { // 修改后比调用记录小，剪匹数+1
                        jps++;
                    };
                })
                if (!zps && item.ps) {
                    zps = item.ps;
                }
            } else {
                if (item.ps) {
                    zps = item.ps;
                }
            }
            scps = zps - jps; // 实出匹
            item.jps = jps;
            item.ps = zps;
            item.scps = scps;
        })
    }
}