html_name = page_arr.cg_thjs_kd;

Bills.djlx = 'bp_cgthjs';

stockManager.getDataUrl = AJAX_URL.getBpCgthjsInfo;
stockManager.postUrl = AJAX_URL.saveBpCgthjsInfo;
stockManager.authCheckName = 'bp_cgthjs';

stockManager.djlx = 'bp_cgthjs';
stockManager.table = 'cgthjs_dj';

stockManager.headerTitle = '退货结算';
stockManager.isGeneraPh = false;  // 不自动生成批号

Bills['print_config'] = {};

// 重写累欠计算
// 如果单据的对象为：供应商、加工商
// 累欠 = 前欠 – 应收 + 收款
// 如果单据的对象为：客户
// 累欠 = 前欠 + 应收 – 收款
stockManager.setLjqk = function () {
    var ysje = parseFloat($('#ysje').val() || 0);
    var zh_je = parseFloat($('#zh_je').val() || 0);

    var ljqk;
    if (stockManager.wldw.type === 'kh') { // 客户
        ljqk = stockManager.data.dj.wldw_qqje + ysje - zh_je;
    } else { // 供应商、加工商
        ljqk = stockManager.data.dj.wldw_qqje - ysje + zh_je;
    }
    if (!isNaN(ljqk)) {
        $('#ljqk').val(ljqk.fixed());
    }
};

// 选择仓库检查处理
stockManager.checkSelectCk = function (selectCkIndex, _this) {
    stockManager.selectCkIndex = selectCkIndex;
    // 检查仓库记录行，有调库存记录的，有调退货单记录的，不允许编辑仓库
    var hzData = stockManager.hzData[selectCkIndex];
    var canSelect = true;
    for (var i = 0; i < hzData.list.length; i++) {
        if (hzData.list[i].is_yy_tm) {
            canSelect = false;
            break;
        }
        // 调用采购订单
        // if (hzData.list[i].dd_dj_id) {
        //     canSelect = false;
        //     break;
        // }
        // 调用退货单
        if (hzData.list[i].ckd_dj_id) {
            canSelect = false;
            break;
        }
    }

    if (canSelect) {
        var ck_id = $(_this).data('ck_id');
        var ck_list = fun.getItem('ck_list') || [];
        fun.showPageFull({
            page_url: page_arr.select_list,
            pageParam: {
                page_type: 'ck',
                return_page: html_name,
                ck_type: (fun.getValByKey(ck_list, ck_id, 'type') === 'skyb' && fun.checkJlHasSk(stockManager.data.jl, ck_id)) ? 'skyb' : ''
            }
        })
    }
};

// 编辑行记录
stockManager.editRow = function (_this) {
    var list_data = $(_this).data('row');
    var index = stockManager.findIndex(function (item) {
        return item.__uuid === list_data.__uuid;
    });
    var ckInfo = fun.getListInfoByKey(stockManager.ck_list, list_data.ck_id);

    var hasTm = existTm(list_data['mx'] || []);

    if ($.nui.isTrue(hasTm)) {
        fun.showPageFull({
            page_url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.detailed_barcode,
            pageParam: {
                djlx: stockManager.djlx,
                return_page: html_name,
                row_index: index,
                list_data: list_data,
                __PAGE_EDIT: stockManager.isInEdit(),
                __DJ_DATA: stockManager.data.dj,
                __JL_DATA: stockManager.data.jl,
                get_jjdw: true,
                __EDIT_ROW: true,
                ck_is_disabled: $(_this).closest('.storehouse').find('.store-title').attr('disabled'),
                ck_info: ckInfo,
                edit_row: true,
                bj_type: 'mx',
                get_dj_url: AJAX_URL.getBpCgDjAndScdj,
                MXTM: true
            }
        });
    } else {
        if (stockManager.isInEdit()) {
            // 通过仓库is_detail判断是否开启明细管理
            var bj_type = 'zs';     // 总数
            if (ckInfo.is_detail) {
                bj_type = 'mx';     // 明细
            }
            goto_single_editor(bj_type, true);
        } else {
            if (ckInfo.is_detail) {
                fun.showPageFull({
                    page_url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.detailed_barcode,
                    pageParam: {
                        djlx: stockManager.djlx,
                        list_data: list_data,
                        __PAGE_EDIT: false,
                        __DJ_DATA: stockManager.data.dj,
                        __JL_DATA: stockManager.data.jl,
                        ck_is_disabled: $(_this).closest('.storehouse').find('.store-title').attr('disabled'),

                        return_page: html_name,
                        row_index: index,
                        get_jjdw: true,
                        __EDIT_ROW: true,
                        ck_info: ckInfo,
                        edit_row: true,
                        bj_type: 'mx',
                        get_dj_url: AJAX_URL.getBpCgDjAndScdj,
                    }
                });
            } else {
                if (NEW_BILLS) {
                    fun.showPageFull({
                        page_url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor,
                        pageParam: {
                            djlx: stockManager.djlx,
                            return_page: html_name,
                            list_data: list_data,
                            ck_info: ckInfo,
                            edit_row: true,
                            row_index: index,
                            bj_type: 'zs',
                            get_dj_url: AJAX_URL.getBpCgDjAndScdj,
                            __JL_DATA: stockManager.data.jl,
                            __JL_DATA: stockManager.data.jl,
                            __PAGE_EDIT: false,
                            get_jjdw: true
                        }
                    });
                }
            }
        }
    }


    function goto_single_editor(bj_type, __PAGE_EDIT) {
        fun.showPageFull({
            page_url: NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor,
            pageParam: {
                djlx: stockManager.djlx,
                return_page: html_name,
                list_data: list_data,
                ck_info: ckInfo,
                edit_row: true,
                row_index: index,
                bj_type: bj_type,
                get_dj_url: AJAX_URL.getBpCgDjAndScdj,
                __JL_DATA: stockManager.data.jl,
                __DJ_DATA: stockManager.getSaveDj(),
                __PAGE_EDIT: __PAGE_EDIT,
                get_jjdw: true
            }
        });
    }
};

// 重写该方法，需要加载单价
stockManager.initLoadCpcbj = function (initList) {
    stockManager.loadCpcbj(initList, function (list) {
        stockManager.data.jl = list;
        stockManager.initShowData();
    }, { get_dj: true });
};

// 重写该方法
stockManager.eventListenerAdd = function (ret, err) {
    stockManager.add_rows(ret.value.data.list);
};

// 产品选择页面回调
stockManager.add_rows = function (list) {
    stockManager.loadCpcbj(list, function (arr) {
        // 添加新数据, 辅助单位设置
        fun.setFzcps(stockManager.fz_cp, arr);
        fun.setFzys(stockManager.fz_ys, arr);
        stockManager.data.jl = arr;
        stockManager.initShowData();
        stockManager.dataChangeShowSaveBtn();
    }, { get_dj: true });   // 需要读取单价
};

// 选择仓库处理，需要判断仓库类型
stockManager.selectCkHandler = function (hzData, newCkInfo) {
    var oriCkInfo = fun.getListInfoByKey(stockManager.ck_list, hzData.ck_id);
    if (fun.selectCkCheck(oriCkInfo, newCkInfo)) {
        for (var i = 0; i < hzData.list.length; i++) {
            hzData.list[i].ck_id = newCkInfo.id;
            hzData.list[i].ck_mc = newCkInfo.name;
        }
        stockManager.initShowData();
    }
};

// 其他回调
stockManager.otherEventListener = function (ret, err) {
    console.log('---');
    console.log(ret);
    console.log('---');
    var status = ret.value.status;
    var data = ret.value.data;
    if (status === 'update_row') {
        stockManager.data.jl[data.row_index] = data.row_data;
        stockManager.initShowData();
    } else if (status === 'dkc_add') {    // 编辑时调库存
        // 仓库类型
        // 1. 总仓        __dkc_callback()执行时，如果总仓没明细，会先删除再添加，因此无法根据回传的row_index确定编辑记录在__JL_DATA中下标，所以需要删除旧数据再添加。
        //                                如果总仓有明细，调库存时会新增一条数据，并且这条调库存记录会删除明细数据。所以不能删除旧记录行。
        // 2. 明细仓      __dkc_callback()执行时手动添加的明细数据和调库存的不会合并，所以手动添加的明细数据不能删除
        // 3. 条码仓      __dkc_callback()执行时会把原有mx[]记录拷贝到新数据，然后替换__JL_DATA中row_index对应下标的数据，这个过程原有记录id会被删除，需要把原有记录的id设置到__JL_DATA对应row_index的数据中
        // 编辑时才需要处理删除的记录行，否则记录行会增加
        if (page_data.id) {
            var row_index = ret.value.data.row_index;
            var row_data = stockManager.data.jl[row_index];

            var hasBar = existTm(row_data);
            var ckInfo = fun.getListInfoByKey(stockManager.ck_list, row_data.ck_id);

            // 编辑的是条码仓或者明细仓
            // 明细仓匹数数量都为0，需要删除
            if (hasBar || (ckInfo.is_detail && !($.nui.isEmpty(row_data.ps) && $.nui.isEmpty(row_data.zsl)))) {
                data.__JL_DATA[row_index].id = row_data.id;
            } else {
                // 总数模式，只处理没有明细数据时情况
                if (__getMxLength(row_data.mx) === 0) {
                    var delArr = stockManager.data.jl.splice(row_index, 1);
                    stockManager.rowDeleteHandler(delArr[0]);
                }
            }
            // 辅助单位设置
            fun.setFzcps(stockManager.fz_cp, data.__JL_DATA);
            fun.setFzys(stockManager.fz_ys, data.__JL_DATA);
        }
        // 调库存不用加载单价，单价会根据编辑的记录复制
        stockManager.data.jl = data.__JL_DATA;
        stockManager.initShowData();
    } else if (ret.value.status === 'delete_row') {     // 明细布匹删除全部条码后返回
        // 匹数/数量设置为0，照样显示。不删除记录行
        var row_index = ret.value.data.row_index;
        // var delArr = stockManager.data.jl.splice(row_index, 1);
        // stockManager.deleteEditRow = delArr[0];         // 记录删除的行记录
        // stockManager.rowDeleteHandler(delArr[0]);
        stockManager.data.jl[row_index] = ret.value.data.row_data;
        stockManager.initShowData();
    } else if (ret.value.status === 'refresh_dj') {
        __init();
    }

    var statusArr = [
        'update_row',
        'dkc_add',
        'delete_row'
    ];
    stockManager.checkStatusShowSaveBtn(statusArr, status);
};

stockManager.checkBeforeApiSaveAjax = function (callback) {
    stockManager.commonCheckBeforeApiSaveAjax(function (result) {
        // 前面约束检查不通过，返回
        if (!result) {
            return callback(false);
        }

        // 单价为0时，提示部分产品单价为0
        if (stockManager.checkHasZero()) {
            stockManager.removeAlertClass();
            fun.dialog({
                content: '部分产品单价为0，您确定要保存吗？',
                btn: ['确定', '取消'],
                className: 'al-skin',
                anim: false,
                yes: function () {
                    callback(true);
                },
                no: function () {
                    callback(false);
                }
            });
        } else {
            callback(true);
        }
    })
};

// 清除弹窗打开添加类名，造成的子级弹窗逻辑无法执行
stockManager.removeAlertClass = function () {
    if ($('.data-change-skin').length) {
        $('.data-change-skin').removeClass('data-change-skin');
    }
}

//分享单据到微信
$('body').on('click', '#share_btn', function (_opt) {
    stockManager.data.dj = stockManager.getSaveDj();
    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
        return fun.toast('请先保存单据！');
    }
    fun.shareRequest({
        djlx: Bills['djlx'],
        id: page_data['id'],
    })
})