/**
 * 发退货统计样式
 */
;(function () {

    var statistics = function () {
        var that = this;

        that.moduleType = 'bp';

        /**
         * 创建金额显示样式
         */
        that.createMoneyClass = function (money, search_data, djlx) {
            // 没有汇总的，按单据类型判断
            // 有汇总的，没汇总单号，按正负数判断， 0 是 正数
            // 有汇总的，有汇总单号，按单据类型判断
            if (search_data.group && search_data.group.indexOf('dh') === -1) {
                return money >= 0 ? 'color-money-red' : 'color-money-green';
            } else {
                if (/lhjs|fhjs/.test(djlx)) {
                    return 'color-money-red';
                } else {
                    return 'color-money-green';
                }
            }
        };

        that.createTitlebar = function (res, config) {
            var html = ['<div class="border-bottom padding-bottom-s">'];
            var wldw = !!fun.is_value(res['wldw_mc']),
                hmd = !!fun.is_value(res['zdr_mc']);

            if (wldw || hmd) {
                var align = 'align-left';
                html.push('<div class="title-bar-row">');
                // 没有往来单位时，数据左对齐
                if (wldw) {
                    var wldw_width = hmd ? '' : 'width: 95%;';
                    html.push('<div style="' + wldw_width + '">');
                    html.push('     <span class="font-bold font-ls">' + fun.is_value(res['wldw_mc']) + '</span>');
                    html.push('</div>');
                    align = 'align-right';
                }

                if (hmd) {
                    html.push('<div class="' + align + ' font-ss color-gray">');
                    html.push('<span class="margin-right-s">' + fun.formatTime(res['kdsj']) + '</span>');
                    html.push('<span class="margin-right-s">' + fun.is_value(res['zdr_mc']) + '</span>');

                    // 汇总的查询没有状态
                    if (!config.search_data.group || (/dh/i.test(config.search_data.group) && res['is_sh'] !== undefined)) {
                        html.push(fun.createIsShLabelHtml(res['is_sh'], res['is_has']));
                    }
                    html.push('</div>');
                }
                html.push('</div>');
            }

            //            console.log('config.search_data.group',config.search_data.group)

            // 共xx匹xx单位
            // 只汇总单号才显示总单位
            var zdw_mc = fun.getHzUnitName(config.search_data.group, res, 'zdw_mc_tmp');
            // var zdw_mc_tmp = (!config.search_data.group || (config.search_data.group && config.search_data.group.indexOf('dh') > -1 ))? res.zdw_mc_tmp : '';

            var psName = (that.moduleType == 'sx' ? '粒' : '匹');

            html.push('<div class="title-bar-row padding-top-s">');
            html.push('     <div>');
            html.push('         <span class="color-gray">共</span>');
            html.push('         <span>' + fun.is_value(res.dj_ps, 0) + psName + fun.is_value(res.dj_zsl, 0) + zdw_mc + '</span>');
            html.push('     </div>');
            html.push('     <div class="align-right">');
            if (config.showPrice) {
                html.push('      <span class="color-gray">' + (config.jsjeText || '应付') + '</span>');
                var moneyClass = that.createMoneyClass(res.dj_je, config.search_data, res.djlx);
                html.push('      <span class="' + moneyClass + '">￥' + fun.is_value(res.dj_je, 0) + '</span>');
            }
            html.push('     </div>');
            html.push('</div>');

            html.push('</div>');
            return html.join('');
        };

        that.createSubtitle = function (res, config) {
            var cp_bh = fun.is_value(res["cp_bh"]);
            var cp_mc = fun.is_value(res["cp_mc"]);
            var cp_ys_bh = fun.is_value(res["cp_ys_bh"]);
            var cp_ys_mc = fun.is_value(res["cp_ys_mc"]);

            // 空行不显示
            var htmlArr = [];
            if (!($.nui.isEmpty(cp_bh) && $.nui.isEmpty(cp_mc) && $.nui.isEmpty(cp_ys_bh) && $.nui.isEmpty(cp_ys_mc))) {
                htmlArr.push("<div class=\"row\" data-dj_data='" + fun.formatString(JSON.stringify(res)) + "'>");
                htmlArr.push("      <div>");

                var cpbhmc = '';

                if (that.moduleType == 'bp') {
                    cpbhmc = cp_bh + " " + cp_mc;
                    if (cp_bh || cp_mc) {
                        htmlArr.push("          <span>" + cpbhmc + "</span>");
                    }
                }else{
                    cpbhmc = cp_mc;
                    if (cp_mc) {
                        htmlArr.push("          <span>" + cpbhmc + "</span>");
                    }
                }

                if (cp_ys_bh || cp_ys_mc) {
                    htmlArr.push('          <span>' + cp_ys_bh + ' ' + cp_ys_mc + '</span>');
                }
                htmlArr.push('      </div>');
                htmlArr.push("</div>");
            }

            if (that.moduleType == 'bp') {
                // 幅宽、克重、规格
                // 如果 汇总条件有开启：幅宽克重、规格，则显示对应的字段。反之，则不显示。
                htmlArr.push(fun.createFkKzGgHtml(config.search_data, res));
            } else if (that.moduleType == 'sx') {
                // 显示品牌、地区、规格
                htmlArr.push(fun.createPpDqGgHtml(config.search_data, res, true));
            }

            return htmlArr.join('');
        };

        that.createSubdata = function (res, config) {
            // console.log('---------------'+ JSON.stringify(config));
            // 记录行单位，只有汇总产品/颜色，或者没有汇总条件时才显示


            var dw_mc = '';
            if (!config.search_data.group || (/cp|ys/.test(config.search_data.group))) {
                dw_mc = config.dw_tmp;
            }

            var htmlArr = ['<div class="bg-gray">'];

            // var tmp_group = config.search_data.group || '';
            // var jl_dw = '';
            // if ((!tmp_group || (tmp_group && (tmp_group.indexOf('cp_bh') > -1 || tmp_group.indexOf('cp_ys_bh') > -1)))) {
            //     jl_dw = fun.is_value(config['dw_tmp']) || '';
            // }
            var psName = (that.moduleType == 'sx' ? '粒' : '匹');

            htmlArr.push("     <div class=\"row\" data-dj_data='" + fun.formatString(JSON.stringify(res)) + "'>");
            htmlArr.push("         <div class=''>");
            htmlArr.push("              <span>" + (fun.is_value(config['ps_tmp']) + psName) + "</span><span>" + (fun.is_value(config['sl_tmp']) + dw_mc) + "</span>"); // ps_tmp
            htmlArr.push("          </div>");
            // 显示金额情况，除了自定义显示外，按产品、汇总
            // var choose = config.search_data.hz.choose; // choose.cp &&
            if (config.showPrice) {
                var hsdj = fun.is_value(res['hsdj'], 0);
                var hszje = fun.is_value(res['hszje'], 0);

                htmlArr.push("<div>");
                if ((!config.search_data.group || (config.search_data.group && config.search_data.group.indexOf('hsdj') > -1))) {  // 单价大于0才显示
                    htmlArr.push("<span class='color-gray'>单价</span><span>" + hsdj + "</span>");
                }
                htmlArr.push("</div>");

                var moneyClass = that.createMoneyClass(hszje, config.search_data, res.djlx);
                htmlArr.push("                    <div><span class='" + moneyClass + "'>￥" + hszje + "</span></div>");
            }
            htmlArr.push("    </div>");

            var qyssjms = that.moduleType == 'sx'?'qyssjms_sx':'qyssjms_bp';

            // 实售价模式开启，无论有没有汇总，都需要显示0
            if (config.SYS_CONFIG && Number(config.SYS_CONFIG[qyssjms])) {
                var sshk = parseFloat((config.zje - config.sszje).toFixed(2));
                // 根据汇总条件判断显示实售价
                var is_ssdj = config.search_data.group.indexOf('ssdj') > -1;
                htmlArr.push("<div class=\"row\"'>");

                if (is_ssdj) {
                    htmlArr.push("     <div>");
                    htmlArr.push("         <span class='color-gray'>实售价</span><span>" + config.ssdj + "</span>");
                    htmlArr.push("     </div>");
                }

                htmlArr.push("<div>");
                htmlArr.push("<span class='color-gray'>实售额</span><span>" + config.sszje + "</span>");
                htmlArr.push("</div>");

                htmlArr.push("     <div><span class='color-gray'>回扣</span><span>" + sshk + "</span></div>");

                if (!is_ssdj) {
                    htmlArr.push("     <div></div>");
                }
                htmlArr.push("</div>");
            }
            htmlArr.push("</div>");
            return htmlArr.join('');
        }
    };

    window.fthStatistics = new statistics();
})(window);
