/**
 * 公用的统计页面html代码组织方法
 */

; (function () {
    var statistics = function (order) {
        this.order = order;
    };

    // ---------------------------------- 渲染订单部分统计html代码 --------------------------
    var orderList = function () {
        var that = this;

        that.moduleType = 'bp';

        // 根据复核、结算状态创建对应的html代码
        that.createStatusLabelHtml = function (is_fh, is_jd, options, other_condition) {
            var _options = $.extend({ dd_lb_fh: undefined,dd_lx_fh: undefined, config: {} }, options);
            // 如果当前单据 已结单，则显示：​​已结单
            // 反之，如果当前单据 的类别有开启：复核 且 当前单据 已复核，则显示：​​已复核
            // 反之，如果当前单据 的类别有开启：复核 且 当前单据 未复核，则显示：​​未复核
            // 反之，如果当前单据 未结单，则显示：​​未结单
            // console.log('is_fh = '+ is_fh + ' dd_lb_fh = ' + dd_lb_fh + ' is_jd = ' + is_jd + ' djlx = ' + djlx);

            // if (is_jd) {
            //     return '<span class="button-green border-radius-s font-ss">已结单</span>';
            // } else {
            //     if (is_fh) {
            //         return '<span class="button-blue border-radius-s font-ss">已复核</span>';
            //     } else {
            //         if (other_condition) {
            //             return '<span class="button-gray border-radius-s font-ss">未复核</span>';
            //         } else {
            //             return '<span class="button-gray border-radius-s font-ss">未结单</span>';
            //         }
            //     }
            // }

            if (is_jd) {
                return '<span class="button-green border-radius-s font-ss">已结单</span>';
            } else {
                var dd_lb_fh = $.nui.isTrue(_options['config']['is_jg'])?_options['dd_lx_fh']:_options['dd_lb_fh'];
                if ($.nui.isTrue(dd_lb_fh)) {
                    if (is_fh) {
                        return '<span class="button-blue border-radius-s font-ss">已复核</span>';
                    } else {
                        return '<span class="button-gray border-radius-s font-ss">未复核</span>';
                    }
                } else {
                    return '<span class="button-gray border-radius-s font-ss">未结单</span>';
                }
            }
        };

        that.createTitlebar = function (res, config) {
            var path = "../img/bank/" + res['zh_tb'];
            var wldw = fun.is_value(res['wldw_mc']),
                hmd = !!fun.is_value(res['zdr_mc']);

            // console.log('------'+ JSON.stringify(res));
            var html = ['<div class="border-bottom padding-bottom-s">'];
            if (wldw) {
                html.push('<div class="title-bar-row">');
                var wldw_width = hmd ? '' : 'width: 95%;';
                html.push('    <div style="' + wldw_width + '">');
                if (wldw) {
                    html.push('    <span class="font-bold font-ls">' + fun.is_value(res['wldw_mc']) + '</span>');
                }

                html.push('    </div>');
                html.push('    <div class="align-right font-s color-gray">');
                html.push('        <span class="margin-right-s font-ss">' + fun.formatTime(res['kdsj']) + '</span>');
                html.push('        <span class="margin-right-s font-ss">' + fun.is_value(res['zdr_mc']) + '</span>');

                // 订单状态处理
                var hzDh = (/dh/i.test(config.group) && (res.is_fh !== undefined && res.dj_jd !== undefined));

                if (!config.group || hzDh) {
                    console.log('res.dd_lb_fh',res.dd_lb_fh)
                    html.push(that.createStatusLabelHtml(res.is_fh, res.dj_jd, {dd_lb_fh: res.dd_lb_fh, dd_lx_fh: res.dd_lx_fh,config: config}, config.other_condition)); // 订单状态处理
                }
                html.push('    </div>');
                html.push('</div>');
            }

            // 只汇总单号才显示总单位
            // var zdw_mc_tmp = (!config.group || (config.group && config.group.indexOf('dh') > -1)) ? res.zdw_mc_tmp : '';
            var zdw_mc = fun.getHzUnitName(config.group, res, 'zdw_mc_tmp');

            html.push('<div class="title-bar-row padding-top-s">');
            html.push('     <div>');
            if (config.type) { // 类型
                html.push('     <span class="margin-right-s">' + config.type + '</span>');
            }

            var psName = (that.moduleType == 'sx' ? '粒' : '匹');

            html.push('         <span class="color-gray">共</span>');
            html.push('         <span>' + fun.is_value(res.dj_ps, 0) + psName + fun.is_value(res.dj_zsl, 0) + zdw_mc + '</span>');
            html.push('     </div>');
            html.push('     <div class="align-right">');
            html.push('      <span class="color-money-red">￥' + fun.is_value(res.dj_je, 0) + '</span>');
            html.push('     </div>');
            html.push('</div>');

            if (that.moduleType == 'bp') {
                // 订金部分
                if (!!res['zh_je'] && res['zh_je'] > 0) {
                    html.push('<div class="title-bar-row padding-top-s">');
                    html.push('    <div style="width:100%;"><a class="df">订金</a>&nbsp;');
                    html.push('        <span>￥' + fun.is_value(res['zh_je'], 0) + '</span>&nbsp;');
                    if (fun.is_value(res['zh_tb'])) {
                        html.push('    <img src="' + path + '" class="account-icon">');
                    }
                    html.push('        <span>' + fun.is_value(res['zh_mc']) + '</span>');
                    html.push('    </div>');
                    html.push('</div>');
                }
            }

            html.push('</div>');
            return html.join('');
        };

        that.createSubtitle = function (res, config) {
            var html = [];
            var cp_bh = fun.is_value(res['cp_bh']);
            var cp_mc = fun.is_value(res['cp_mc']);
            var cp_ys_bh = fun.is_value(res['cp_ys_bh']);
            var cp_ys_mc = fun.is_value(res['cp_ys_mc']);

            if (!($.nui.isEmpty(cp_bh) && $.nui.isEmpty(cp_mc) && $.nui.isEmpty(cp_ys_bh) && $.nui.isEmpty(cp_ys_mc))) {
                html.push('<div class="row">');
                html.push('   <div style="width: 90%"> ');


                var cpbhmc = '';

                if (that.moduleType == 'bp') {
                    cpbhmc = cp_bh + " " + cp_mc;
                    if (cp_bh || cp_mc) {
                        html.push('          <span class="margin-right-s">' + cpbhmc + '</span>');
                    }
                } else {
                    cpbhmc = cp_mc;
                    if (cp_mc) {
                        html.push('          <span class="margin-right-s">' + cpbhmc + '</span>');
                    }
                }

                html.push('       <span>' + cp_ys_bh + ' ' + cp_ys_mc + '</span>');
                html.push('   </div>');
                if (config.showIcon && !config.group) {
                    var jsClass = res['is_jd'] ? 'color-gray-light' : 'color-blue-light';
                    // console.log('---------------'+ JSON.stringify(res));
                    html.push('   <div style="width: 10%;" class="align-right particulars"><i class="iconfont icon-basics2 ' + jsClass + '"></i></div>');
                }
                html.push('</div>');
            }


            if (that.moduleType == 'bp') {
                // 显示幅宽、克重、规格
                html.push(fun.createFkKzGgHtml(config.search_data, res));
            } else if (that.moduleType == 'sx') {
                // 显示品牌、地区、规格
                html.push(fun.createPpDqGgHtml(config.search_data, res, false, { isDD: true }));
            }

            // 货期 剩/超xx天
            if (res.hq) {
                html.push('<div class="row">');
                html.push('   <div style="width: auto;margin-right: 0.2rem;">');
                html.push('       <span class="margin-right-s color-gray">货期</span>');
                html.push('       <span>' + res.hq + '</span>');
                html.push('   </div>');

                html.push('   <div style="width: auto">');
                if (res.syts > 0) {
                    html.push('       <span class="color-blue-light days-padding">剩' + res.syts + '天</span>');
                } else if (res.syts < 0) {
                    html.push('       <span class="color-money-red days-padding">超' + Math.abs(res.syts) + '天</span>');
                }
                html.push('   </div>');

                html.push('<div></div>'); // 占位
                html.push('</div>');
            }
            return html.join('');
        };

        /**
         *
         * @param res
         * @param config  必传数据: { search_storage: '', group: '' }
         * @return {string}
         */
        that.createSubdata = function (res, config) {
            var html = ['<div class="bg-gray row-container">'];
            var sl_ps = fun.is_value(config.value['0'], 0);

            if (config.onlyShowJjcd || config.renderJdHtml && !config.group) {
                if (!config.onlyShowJjcd && (!$.nui.isEmpty(res.zt) || !$.nui.isEmpty(res.jd) || !$.nui.isEmpty(res.jjcd_mc))) {
                    html.push('      <div class="row">');

                    var ztStyle = !config.showJd ? 'width:calc(100% / 3 * 2);' : '';
                    var overflownone = 'width:calc(100% - 2rem);'

                    $.nui.isTrue(res.zt) && html.push('         <div style="' + ztStyle + '"><span style="vertical-align:middle;" class="color-gray">状态</span><span style="' + overflownone + '" class="overflow-ellipsis">' + fun.is_value(res.zt) + '</span></div>');
                    if (config.showJd) {
                        html.push('         <div><span class="color-gray">进度</span><span>' + fun.is_value(res.jd) + '</span></div>');
                    } else {
                        html.push('         <div style="width:0;"><span class="color-gray"> </span><span> </span></div>');
                    }
                    if ($.nui.isTrue(res.jjcd_mc)) {
                        html.push('         <div><span class="label-jjcd urgent" style="background-color: ' + res['jjcd_colour'] + '">' + fun.is_value(res.jjcd_mc) + '</span></div>');
                    } else {
                        html.push('         <div></div>');
                    }
                    // html.push('         <div></div>');
                    html.push('      </div>');
                } else {
                    if ($.nui.isTrue(res.jjcd_mc)) {
                        html.push('      <div class="row">');
                        html.push('         <div><span class="label-jjcd urgent" style="background-color: ' + res['jjcd_colour'] + '">' + fun.is_value(res.jjcd_mc) + '</span></div>');
                        html.push('      </div>');
                    } else {

                    }
                }
            }

            html.push('     <div class="row">');
            html.push('         <div><span class="color-gray">' + config.title['0'] + '</span><span>' + sl_ps + (config.isSelectNum == 1 ? (res['dw_mc'] || "") : "") + '</span></div>');
            html.push('         <div><span class="color-gray">' + config.title['1'] + '</span><span>' + fun.is_value(config.value['1'], 0) + '</span></div>');
            html.push('         <div><span class="color-gray">' + config.title['2'] + '</span><span>' + fun.is_value(config.value['2'], 0) + '</span></div>');
            html.push('     </div>');

            // 是否显示损耗、损耗率、超损耗
            if (config.showWaste) {
                html.push('     <div class="row">');
                html.push('         <div><span class="color-gray">损耗</span><span>' + parseFloat(res.shsl || 0) + '</span></div>');
                html.push('         <div><span class="color-gray">损耗</span><span>' + parseFloat(res.shl || 0) + '%</span></div>');
                html.push('         <div><span class="color-gray">超损</span><span>' + (parseFloat(res.shl || 0) - parseFloat(res.yjsh || 0)).fixed(4) + '%</span></div>');
                html.push('     </div>');
            }

            html.push('<div class="row">');
            html.push('<div><span class="color-gray">计价</span><span>' + fun.is_value(res['jjsl']) + fun.is_value(res['jjdw_mc']) + '</span></div>');
            if (!config.group) {
                html.push('<div><span class="color-gray">单价</span><span>' + fun.is_value(res['hsdj']) + '</span></div>');
            } else {
                html.push('<div></div>');
            }
            html.push('    <div><span class="color-gray">金额</span><span>' + fun.is_value(res['hszje'] || 0) + '</span></div>');
            html.push('</div>');

            // 计算进度
            // 如果当前记录行已经结单，则显示 100%
            // 如果过滤条件的类型 开启：匹数，进度 = 来货匹 / 匹数 * 100.00
            // 如果过滤条件的类型 开启：数量，进度 = 来货数 / 数量 * 100.00
            // 后台有计算

            var wclVar = config.isSelectNum ? parseFloat(res['wcs'] || 0) : parseFloat(res['wcp'] || 0);
            var progress = fun.is_value(wclVar) >= 100 ? 100 : fun.is_value(wclVar);
            progress = (progress < 0) ? 0 : progress;

            html.push('     <div class="row">');
            html.push('         <div class="progress-wrap">');
            html.push('             <span class="color-gray">进度</span>');
            html.push('             <div class="progress-bar border-radius-s progress-container"><div class="progress-bar-content border-radius-s" style="width: ' + progress + '%">&nbsp;</div></div>');
            html.push('         </div>');
            html.push('     </div>');

            html.push('</div>');
            return html.join('');
        };
    };


    window.statistics = new statistics(new orderList());
    // window.statistics.moduleType = 'bp';
})(window);


