var html_name = page_arr.cw_cbhs;
var search_data = {
  "hs_ycb": 1,
  "is_mobile" : 1
};
var page_list = [], page_str = '';

page_init = function () {
  //1)开始日期
  //  如果有月结过，则拿 月结日期 + 1 作为 开始日期。
  //  如果没月结过，则拿 开账日期 作为 开始日期。
  //2)结束日期
  //  根据 开始日期，显示相同年份、月份 最后一天的日期。
  //  如果该日期 大于 当天日期，则显示：当天日期。

  if ($.nui.isTrue(fun.getItem('sys_config')['yjrq'])) {
    search_data['begin_time'] = $.nui.dayjs(fun.getItem('sys_config')['yjrq']).add(1, 'day').format('YYYY-MM-DD');
  } else {
    search_data['begin_time'] = $.nui.dayjs(fun.getItem('sys_config')['kzrq']).format('YYYY-MM-DD');
  }
  var today = fun.formatDate(fun.getNowFormatDate(), 'YYYY-MM-DD');
  var end_date = $.nui.dayjs(search_data['begin_time']).endOf('month').format('YYYY-MM-DD');
  if(end_date > today){
    search_data['end_time'] = today;
  }else{
    search_data['end_time'] = end_date;
  }
  var times = search_data['begin_time'] + ' ~ ' + search_data['end_time']

  $('#header').header({
    back: true,
    title: '成本核算',
    text_btn: true,
    text_val: '刷新',
    subtitle: times,
  });
  getList();
  api.addEventListener({
    name: html_name,
  }, function (ret, err) {
    var temp = ret['value'];
    if (temp.status == 'refresh') {
      if (temp.page_type == 'zero') {
        getList();
      }
    }
  });

  // fun.scrollToBottom({}, function () {
  //     if (page_list.length > 0) {
  //         showList(fun.PagingData(page_list, 5) || []);
  //     } else {
  //         fun.createBottomLine('line', ".liss");
  //     }
  // });
}

function getList() {
  fun.ajax({
    showLoad: true,
    hideLoad: true,
    loadTitle: page_str,
    url: AJAX_URL.getCwCbhsInfo,
    data: search_data,
    timeout: 3600000,
    success: function (res) {
      if (res['status'] == 0) {
        if (!res['hs_ycb'] || res['hs_ycb'].length == 0) {
          $('.cbhs_btn').css('background', '#39B8FD');
          $('.info-name').html('成本<br>核算').addClass('business_accounting');
          $('.lines').hide();
          //fun.hideLoad();
          // return $('#line').html('<p class="empty_text cpfx_text">暂无数据！</p>');
          return fun.createDataEmptyTips({ dom: '#line', btnShow: false });
        }
        $('.cbhs_btn').css('background', '#FF484A');
        $('.info-name').html('预估<br>成本').addClass('estimate');
        page_list = res.hs_ycb;
        $('#line').empty();
        showList(page_list || []);
        //fun.hideLoad();
        // showData(page_list || []);
      } else {
        //fun.hideLoad();
        return fun.alert({ msg: '网络异常！' });
      }
      
    }
  });
}

function showList(data) {
  var Html = [];
  for (var i = 0; i < data.length; i++) {
    Html.push('<li class="liss">');
    Html.push('<p class="err-name">' + (data[i]['yc'] || '') + '</p>');
    Html.push('<p class="err-other"><span class="djlx">' + (data[i]['djlx_mc'] || '') + '</span><i class="mh">:</i><span class="djdh">' + (data[i]['dh'] || '') + '</span></p>');
    Html.push('<p class="err-other"><span class="wldw">' + (data[i]['wldw_mc'] || '') + '</span><span class="sj">' + (data[i]['kdsj'] || '') + '</span></p>');
    Html.push('</li>');
  };
  $('#line').html(Html.join(''));
}

//预估成本
$('body').on('tap', '.estimate', function () {
  search_data['hs_ycb'] = 0;
  zeroCost();
});

//成本核算
$('body').on('tap', '.business_accounting', function () {
  zeroCost();
});

//刷新
$('body').on('tap','#complete_btn',function(){
  page_str = ''; 
  search_data['hs_ycb'] = 1;
  getList();
});
//获取0成本记录||核算成本
function zeroCost(){
  page_str = '核算中';
  fun.ajax({
    showLoad: true,
    hideLoad: true,
    loadTitle: page_str,
    url: AJAX_URL.saveCwCbhsInfo,
    timeout: 3600000,
    data: $.extend({
      lcbjs: 0,
      zdy_bpxsthjs_cbj: 0,
      zdy_bpxsthjs_cbj_list: [],
      status: 'save'
    }, search_data),
    success: function (res) {
      if (res['status'] == 'LCB_TS') {
        if(res['data'] && res['data'].length > 0){
          fun.showPageFull({
            page_url: page_arr.cw_cbhs_zero,
            pageParam: {
              begin_time: search_data['begin_time'],
              end_time: search_data['end_time'],
              return_page: html_name
            }
          });
        }
      }else if (res['status'] == 0) {
        if (Auth.check('bp_kc', 'view')) {
          fun.dialog({
            content: "核算成功，库存成本已更新",
            btn: ['去看看', '我知道了'],
            yes: function () {
              fun.showPageFull({
                page_url: page_arr['kc_ck'],
                pageParam: {
                  obj: 'cloth',
                }
              })
            },
            no: function () {
              //fun.hideLoad();
              setTimeout(function () {
                api.closeWin({
                  name: html_name,
                });
              }, 200);
            }
          });
        } else {
          fun.alert({
            msg: '核算成功，库存成本已更新',
            callback: function () {
              //fun.hideLoad();
              setTimeout(function () {
                api.closeWin({
                  name: html_name,
                });
              }, 200);
            }
          });
          //fun.hideLoad();
        }
        //fun.hideLoad();

      } else {
        return fun.alert({ msg: '网络异常！' });
      }
      //fun.hideLoad();
    }
  });
}