var html_name = page_arr.cw_sxmlb;

var to_month = fun.getMonthArr(1)[0];
var page_list = [],
    photoBrowser = {},
    px_arr = [],
    ztj_data = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

var cwMlb = {
    sysConfig: null, // 系统设置数据
    enabledSsjmsSx: function () { }, // 是否实售价模式-布匹
    kzCbhsmsIsHs: function () { }, // 开账-成本核算模式是否为含税
};

// 是否开启实售价模式-布匹
cwMlb.enabledSsjmsSx = function () {
    return $.nui.isTrue(fun.toNumber(this.sysConfig.qyssjms_sx));
}

// 开账-成本核算模式是否为含税
cwMlb.kzCbhsmsIsHs = function () {
    var kzxx = this.sysConfig.kzxx;
    kzxx = typeof kzxx === 'string' ? JSON.parse(kzxx) : kzxx;
    return kzxx.cbhs === 'hs';
}

// 加载本地缓存数据
cwMlb.loadStorageData = function () {
    fun.load_DATA_LIST(['sys_config'], function () {
        cwMlb.sysConfig = fun.getItem('sys_config') || [];
    }, { showLoad: false });
}

// 总销售
cwMlb.zxs = function (data) {
    if (this.enabledSsjmsSx()) { // 开启实售价模式
        return {
            title: '实售数', // 实售数
            value: fun.is_value(data.sssl, 0) // 实售数
        }
    } else { // 没开启实售价模式
        return {
            title: '计价数', // 计价数
            value: fun.is_value(data.jjsl, 0) // 计价数量
        }
    }
}

// 销售额
cwMlb.xse = function (data) {
    if (this.enabledSsjmsSx()) {
        return {
            title: '实售额', // 实售额
            value: fun.is_value(data.sszje, 0) // 实售总金额
        }
    } else {
        // zje 字段已经判断了含税还是不含税
        return {
            title: '销售额',
            value: fun.is_value(data.zje, 0)
        }
    }
}

// 售价
cwMlb.sj = function (data) {
    if (this.enabledSsjmsSx()) {
        return {
            title: '实售价', // 实售价
            value: fun.is_value(data.ssdj, 0) // 实售总金额 / 实售数。
        }
    } else {
        var tempData = {};
        if (this.kzCbhsmsIsHs()) { // 【开账-成本核算模式】=含税
            tempData.title = '含税价'; // 含税价
        } else { // 【开账-成本核算模式】=不含税
            tempData.title = '单价'; // 单价
        }

        if ($.nui.isTrue(data.zje) || $.nui.isTrue(data.jjsl)) {
            tempData.value = fun.is_value(($.nui.decimalDiv(fun.toNumber(data.zje), fun.toNumber(data.jjsl))).fixed(6), 0);
        } else if ($.nui.isEmpty(data.zje) && $.nui.isEmpty(data.jjsl)) {
            tempData.value = 0;
        }
        // zje 字段已经判断了含税还是不含税
        return tempData;
    }
}

// 总销售额处理
cwMlb.zxse = function (data) {
    if (this.enabledSsjmsSx()) {
        return {
            title: '总实售额',
            value: fun.is_value(data.sszje, 0)
        }
    } else {
        return {
            title: '总销售额',
            value: fun.is_value(data.zje, 0)
        }
    }
}

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

page_init = function () {
    // console.log('page_data',page_data)
    cwMlb.loadStorageData();
    $('#header').header({
        back: true,
        title: '纱线毛利',
        filter: true,
        foot_input: {
            show: true,
            scan_icon: true,
            plader: '纱线名称',
        },
    });
    photoBrowser = api.require('photoBrowser');
    if ($.nui.isTrue(page_data['data'])) {
        search_data['begin_time'] = fun.Date(page_data['data']['kssj']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(page_data['data']['jssj']).Format('yy-mm-dd');
        search_storage['begin_date'] = fun.Date(page_data['data']['kssj']).Format('yy-mm-dd');
        search_storage['end_date'] = fun.Date(page_data['data']['jssj']).Format('yy-mm-dd');
        date_bar.setDate(search_storage);
    }
    getList(search_data);
    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret.value;
        switch (temp['status']) {
            case 'search':
                var param = temp.data;
                // search_data['keyword'] = param['LIKE_DATA'] || ''; //关键字
                search_data['begin_time'] = param.begin_date; //开始时间
                search_data['end_time'] = param.end_date; //结束时间
                search_data['cp_lb_id'] = param.sx_lb['id'] || ''; //纱线类别
                search_data['md_id'] = param.md['id'] || ''; //门店
                search_data['order'] = {};
                search_data['order']['ml'] = param.ml || '';
                search_data['order']['mll'] = param.mll || '';

                //搜索菜单需要缓存的数据
                // search_storage['keyword'] = search_data['keyword'];
                search_storage['begin_date'] = search_data['begin_time'];
                search_storage['end_date'] = search_data['end_time'];
                search_storage['cp_lb'] = param.sx_lb;
                search_storage['md'] = param.md;
                search_storage['order'] = {};
                search_storage['order']['ml'] = param.ml || '';
                search_storage['order']['mll'] = param.mll || '';
                //设置时间控件时间
                date_bar.setDate(search_storage);

                fun.setItem(html_name + 'sideslip', true);

                // $('#order_list').empty();
                fun.clearPage($('#order_list'));
                getList(search_data);
                break;
            case 'refresh':
                // $('#order_list').empty();
                fun.clearPage($('#order_list'));
                getList(search_data);
                break;
        }

    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-info");
        }
    });

    fun.orderListHeight({ dom: '#order_list', apiInit: true, setMinHeight: true });
}

function __getApiSafeHeight() {
    return api.safeArea.top || 0;
}

//获取数据
function getList(params) {
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSxMlbList,
        data: $.extend({
            type: "mlb_zb",
        }, params),
        success: function (res) {
            if (res['status'] == 0) {
                ztj_data = res['info'] || [];
                if (!res['data'] || res['data'].length == 0) {
                    $('#zml').text(0);
                    $('#zxse').text(0);
                    $('#zxse_desc').text(cwMlb.zxse(ztj_data).title);
                    //   $('#order_list').css({'position':'fixed','background':'#F5F5F5'});
                    //   return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '#order_list', btnShow: false, style: 'top:0.5rem;height:9rem;' });
                }
                fun.clearPage($('#order_list'));
                page_list = res.data;
                //   $('#order_list').css({'position':'relative'});
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}

function showList(data) {
    var datas = [];
    //显示合计数
    $('#zml').text(ztj_data['zml'] || 0);
    $('#zxse').text(ztj_data['zje'] || 0);
    $('#zxse_desc').text(cwMlb.zxse(ztj_data).title);
    var lists = sortByKey(data, 'zml', 'desc');
    // px_arr=[];
    // $.each(lists,function(i,ls){
    //   if(i<3){
    //     px_arr.push(ls);
    //   }
    // });
    datas = lists;

    if (!!search_storage && !!search_storage['order']) {
        if (!!search_storage['order']['ml'] || !!search_storage['order']['mll']) {
            if (search_storage['order']['ml'] == 'asc') {
                datas = sortByKey(data, 'ml', 'asc');
            } else if (search_storage['order']['ml'] == 'desc') {
                datas = sortByKey(data, 'ml', 'desc');
            }

            if (search_storage['order']['mll'] == 'asc') {
                datas = sortByKey(data, 'mll', 'asc');
            } else if (search_storage['order']['mll'] == 'desc') {
                datas = sortByKey(data, 'mll', 'desc');
            }
        }
    }
    // var one = 1,two=1,three=1;
    var html = [];
    $.each(datas, function (i, vals) {
        var zxs = cwMlb.zxs(vals);
        var xse = cwMlb.xse(vals);
        var sj = cwMlb.sj(vals);
        var img_url = (vals['tp']) ? fun.getImgPath(vals['tp']) : "../img/logo.png";
        var large_url = (vals['tp']) ? fun.getImgPath(vals['tp'], true) : "../img/logo.png";
        html.push('<div class="list-info lower-border-line">');
        html.push('<div class="info-top">');
        html.push('<div class="top-pic" large-url="' + large_url + '" index="' + i + '" data-img_url=\'' + (vals['tp'] ? JSON.stringify(vals['tp'].split(',')) : '') + '\'>');
        if (img_url == '../img/logo.png') {
            html.push('<img src="' + img_url + '" class="img mlb-pic logoss"></img>');
        } else {
            html.push('<img src="' + img_url + '" class="img mlb-pic">');
        }
        //   html.push('<img src="../img/mask.png" class="mask"></div>');
        html.push('</div>');
        html.push('<div class="product-info">');
        html.push('<p class="pro-name">');
        if ((i + 1) == 1) {
            html.push('<span class="logo-img"><img src="../img/jp.png" alt=""></span>');
        } else if ((i + 1) == 2) {
            html.push('<span class="logo-img"><img src="../img/yp.png" alt=""></span>');
        } else if ((i + 1) == 3) {
            html.push('<span class="logo-img"><img src="../img/tp.png" alt=""></span>');
        } else {
            html.push('<span class="logo-img logo-text">' + (i + 1) + '. </span>');
        }
        html.push('<span class="pro-title">' + fun.is_value(vals['cp_mc']) + '</span></p>');//fun.is_value(vals['cp_bh']) + ' ' +
        html.push('<p class="pro-feature">');
        html.push('<span class="fea color2">' + fun.is_value(vals['cp_ys_bh']) + ' ' + fun.is_value(vals['cp_ys_mc']) + '</span>');
        html.push('<span class="fk" style="display:none;">幅\\克 <em class="fk-v color2">0</em></span>');
        html.push('</p></div></div>');
        html.push('     <div class="info-bot">');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">' + zxs.title + '</span>');
        html.push('              <em class="name-con">' + zxs.value + ' ' + fun.is_value(vals['jjdw_mc']) + '</em>');
        html.push('         </p>');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">' + xse.title + '</span>');
        html.push('              <em class="name-con">' + xse.value + '</em>');
        html.push('         </p>');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">成本</span>');
        html.push('              <em class="name-con">' + fun.is_value(vals['cbj'] || 0) + '</em>');
        html.push('         </p>');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">' + sj.title + '</span>');
        html.push('              <em class="name-con">' + sj.value + '</em>');
        html.push('         </p>');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">总成本</span>');
        html.push('              <em class="name-con">' + fun.is_value(vals['zcb'] || 0) + '</em>');
        html.push('         </p>');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">毛利</span>');
        html.push('              <em class="name-con color1">' + fun.is_value(vals['ml'] || 0) + '</em>');
        html.push('         </p>');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">毛利率</span>');
        html.push('              <em class="name-con">' + fun.is_value(vals['mll'] || 0) + '%</em>');
        html.push('         </p>');
        html.push('         <p class="bot-list">');
        html.push('              <span class="bot-name">总毛利</span>');
        html.push('              <em class="name-con color1">' + fun.is_value(vals['zml'] || 0) + '</em>');
        html.push('         </p>');
        html.push('     </div>');
        html.push('</div>');
    });
    $('#order_list').append(html.join(''));
}

//点击键盘搜索
$('body').bind('search', "#foot_search", function (e) {
    search_data["keyword"] = $('#foot_search').val().trim();
    fun.clearPage($('#order_list'))
    getList(search_data);
});

//点击预览图片
$('body').on('tap', '.top-pic', function (e) {
    e.preventDefault();
    var img_arr = [];
    var __imgs = $(this).data('img_url');
    if ($.nui.isEmpty(__imgs)) return;
    if ($.isArray(__imgs)) {
        for (var i = 0; i < __imgs.length; i++) {
            img_arr.push(fun.getImgPath(__imgs[i], true));
        }
    } else {
        img_arr.push(fun.getImgPath(__imgs, true));
    }
    if (img_arr.length === 0) return;
    photoBrowser.open({
        images: img_arr,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
            // console.log(JSON.stringify(err));
        }
    });
    return false;
})

//点击扫码
$('body').on('tap', ".icon-saoma", function () {
    openScanner({
        callback: function (value) {
            $("#foot_search").val(value);
            if (!!$("#foot_search").val()) {
                search_data['keyword'] = $('#foot_search').val().trim();
                // $('#product_list').empty();
                fun.clearPage($('#order_list'))
                getList(search_data);
                return true;
            } else {
                fun.toast('扫码失败！');
                return true;
            }
        }
    });
});

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}

//对得到得数据进行排序
function sortByKey(array, key, type) {
    var arr = [];
    arr = array.sort(function (b, a) {//降序
        if (type == 'asc') {
            var y = a[key];
            var x = b[key];
        } else {
            var x = a[key];
            var y = b[key];
        }
        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    });
    return arr;
}

// 月份选择
var date_arr = fun.getMonthArr(6),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            // $('#order_list').empty();
            fun.clearPage($('#order_list'))
            getList(search_data);
        }
    });



fun.setItem(html_name + 'sideslip', true);
//打开搜索框
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "cp_lb",
            "text": "纱线类别",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            is_yarn: 1
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        },
        ],
        "sort": [
            {
                "key": "ml",
                "text": "毛利",
                "value": search_storage['order'] && search_storage['order']['ml'] || ""
            },
            {
                "key": "mll",
                "text": "毛利率",
                "value": search_storage['order'] && search_storage['order']['mll'] || ""
            },
        ],
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

/*
    1. 2个面包 预计 4块
    2. 5个苹果，预计12块
    3. 150
    4.
*/