var html_name = page_arr.cw_ywtz;
var page_list = [], ztj_data = [];
var temps;
var merchants_opt = [
    { "name": "客户", "column": "kh", "is_choose": 1 },
    { "name": "供应商", "column": "gys", "is_choose": 0 },
    { "name": "加工商", "column": "jgs", "is_choose": 0 },
    { "name": "物流", "column": "wl", "is_choose": 0 }
];

$('#header').header({
    back: true,
    title: '业务调账',
    add: Auth.check('cw_ywtz', 'edit'),
    filter: true, //筛选
});

var date_arr = fun.getDateArr(),
    to_month = fun.getLatelyTime(1,false), //获取本月第一天和最后一天
    search_data = {
        'begin_time': fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        'end_time': fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            $('#order_list').empty();
            getData();
        }
    });
var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var hnh = html_name + '_';
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(hnh + 'hz') || '')
    search_data = $.extend(true, {
        'hldj': fun.getItem(html_name + '_hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
        "hz": {
            "choose": {
                "lx_mc": fun.getItem(hnh + 'lx_mc', 0),
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "kh": fun.getItem(hnh + 'kh', 0),
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_data);

    getData();
    fun.setItem('je', '');
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];
        switch (temp['status']) {
            case 'search':
                search_data['begin_time'] = data['begin_date'];
                search_data['end_time'] = data['end_date'];
                date_bar.setDate({
                    begin_date: search_data['begin_time'],
                    end_date: search_data['end_time']
                });
                search_data['keyword'] = data['LIKE_DATA'] || '';//单号
                search_data['md_id'] = data['md']['id'] || '';
                search_data['md_mc'] = data['md']['text'] || '';
                search_data['order'] = {};
                search_data['order']['je'] = data['je'] || '';
                search_data['lx_id'] = data['ywtz_lb']['id'] || '';//类型id
                search_data['lx_mc'] = data['ywtz_lb']['text'] || '';

                search_data['wldw_id'] = data['merchants']['wldw_id'] || 0;
                search_data['wldw_mc'] = data['merchants']['wldw_mc'] || "";
                merchants_opt = data['merchants']['list'];//选择客商默认值

                fun.setItem('je', search_data['order']['je']);

                search_data['hldj'] = data['hldj'];
                search_data['xsmx'] = data['xsmx'];
                fun.setItem(html_name + '_hldj', search_data['hldj']);
                fun.setItem(html_name + '_xsmx', search_data['xsmx']);

                //汇总功能
                search_data['group'] = temp['data']['hz']['group'] || '';
                search_data['hz'] = temp['data']['hz'];
                var hc = temp['data']['hz']['choose'];

                console.log(hc)

                fun.setItem(hnh + 'lx_mc', hc['lx_mc']);
                fun.setItem(hnh + 'md_mc', hc['md_mc']);
                fun.setItem(hnh + 'kh', hc['kh']);
                fun.setItem(hnh + 'text', temp['data']['hz']['text']);
                fun.setItem(hnh + 'hz', search_data['group']);
                fun.setItem(html_name + 'sideslip', true);
                
                getData();
                break;
            case 'refresh':
                
                getData();
                break;
        }
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var n = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": (temps && temps['keyword'] ? temps['keyword'] : ''),
            "placeholder": "单号"
        },
        "time": {
            "begin_date": search_data['begin_time'],
            "end_date": search_data['end_time']
        },
        "choose_merchants": [{
            "key": "merchants",
            "text": "客户",
            "value": (search_data && search_data['wldw_mc'] ? search_data['wldw_mc'] : ''),
            "id": (search_data && search_data['wldw_id'] ? search_data['wldw_id'] : ''),
            "merchants_list": merchants_opt
        }, {
            key: "md",
            "text": "门店",
            "value": (temps && temps['md_mc'] ? temps['md_mc'] : ''),
            "id": (temps && temps['md_id'] ? temps['md_id'] : '')
        }, {
            key: "ywtz_lb",
            "text": "类型",
            "value": (temps && temps['lx_mc'] ? temps['lx_mc'] : ''),
            "id": (temps && temps['lx_id'] ? temps['lx_id'] : '')
        },
        {
            key: "hz",
            "text": "汇总",
            group: [
                { key: 'kh', name: '往来单位', columns: 'wldw_id,wldw_mc', choose: getHz('kh') },
                // { key: 'md_mc', name: '门店', columns: 'md_id,md_mc', choose: getHz('md_mc') },
                { key: 'lx_mc', name: '类型', columns: 'lx_mc', choose: getHz('lx_mc') },
            ],
            "value": getTwo('hz', 'text'),
        },
        ],
        "switch": [
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_data['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_data['hldj'] },
        ],
        "sort": [{
            "text": "金额",
            "key": "je",
            "value": (temps && temps['order']['je'] ? temps['order']['je'] : '')
        }],
    }
    if (n) {
        fun.setItem(html_name + 'sideslip', false)
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

function getHz(key, def) {
    def = def || 0;
    return (search_data['hz'] && search_data['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_data[key] && search_data[key][son]) || def;
}

function getData() {
    page_list = [];
    temps = $.extend({
        "keyword": "",
        "begin_time": "2018-12-08",
        "end_time": "2019-01-08",
        "wldw_id": 0,
        "wldw_mc": "",//客户
        "lx_id": 0,
        "lx_mc": "",
        "md_id": 0,
        "md_mc": "",
        "order": {
            "je": "",
        }
    }, search_data);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getYwtztj,
        data: temps,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    if (!res['data'] || res['data'].length == 0) {
                        $('#tj1').text(0);
                        // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                        return fun.createDataEmptyTips({ dom: '#order_list', btnText: '新增业务调账单', auth: 'cw_ywtz' });
                    }
                    // var info_list = res.data; // order_data = [];
                    ztj_data = res.info;
                    // for (var i = 0; i < info_list.length; i++) {
                    //     order_data.push({
                    //         wldw_mc: (info_list[i]['wldw_mc'] || ''),
                    //         md_mc: (info_list[i]['md_mc'] || ''),
                    //         zdr_mc: (info_list[i]['zdr_mc'] || ''),
                    //         kdsj: (info_list[i]['kdsj'] || ''),
                    //         dh: (info_list[i]['dh'] || ''),
                    //         dj_id: (info_list[i]['dj_id'] || ''),
                    //         djlx_mc: (info_list[i]['lx_mc'] || ''),//单据类型
                    //         wldw_qqje: (info_list[i]['wldw_qqje'] || ''),//前欠
                    //         je: (info_list[i]['je'] || ''),//金额
                    //         wldw_ljqk: (info_list[i]['wldw_ljqk'] || ''),//累欠
                    //         bz: (info_list[i]['bz'] || ''),//备注
                    //     });
                    // }
                    // if (!!order_data[0]) {
                    $('#order_list').empty();
                    page_list = fun.createApiDataIndex(res.data);

                    showList(fun.PagingData(page_list));
                    // }
                    $('.djlx').each(function () {
                        if (!$(this).data('lx')) {
                            $(this).hide();
                        }
                    });
                    $('.bz').each(function () {
                        if (!$(this).data('bz')) {
                            $(this).hide();
                        }
                    });
                    break;
                default:
                    fun.alert({ msg: res['msg'] });
                    break;
            }

        }
    });
}

function showList(data) {
    // 获得三个数组 [object,object]
    $('#tj1').text(ztj_data[0]['je']);
    //5235.22  总调账
    //alert(ztj_data[0]['je'])
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                var hKH = !!fun.is_value(res['wldw_mc']);
                var hKD = !!fun.is_value(res['kdsj']);
                var hZDR = !!fun.is_value(res['zdr_mc']);

                var html = [];

                if (hKH || hKD || hZDR) {
                    html.push('<div class="title-bar-row">');
                    hKH && html.push('          <div><span class="font-bold color-black">' + fun.is_value(res['wldw_mc']) + '</span>&nbsp;<span>' + fun.createWldwTypeLabelHtml(res['wldw_type']) + '</span>&nbsp;</div>');
                    (hKD || hZDR) && html.push('<div class="align-right color-gray font-ss"><a>' + fun.formatTime(res['kdsj']) + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a>&nbsp;<a>' + fun.createIsShLabelHtml(res['is_sh']) + '</a></div>');
                    html.push('</div>');
                }

                return html.join('');

            },
            subtitle: function (res) {
                var hLB = !!fun.is_value(res['je']);

                var html = [];
                if (hLB) {
                    html.push('<div class="row" data-list=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
                    html.push('     <div>' + fun.is_value(res['lx_mc'], '金额') + '</div>');
                    html.push('     <div class="align-right color-button-red"><span>￥</span><span>' + fun.is_value(res['je'], 0) + '</span>&nbsp;</div>');
                    html.push('</div>');
                }

                return html.join('');
            },
            subdata: function (res) {
                var through = !!fun.getItem(html_name + '_' + 'hz');

                if ($.nui.isEmpty(res['wldw_qqje']) && $.nui.isEmpty(res['wldw_ljqk'])) {
                    return '';
                }

                var html = [];

                if (!through) {
                    html.push('<div class="row bg-gray" data-list=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
                    html.push('     <div><span class="color-gray">&nbsp;前欠</span><span>' + fun.is_value(res['wldw_qqje']) + '</span></div>');
                    html.push('     <div class="align-right"><span class="color-gray">累欠</span><span>' + fun.is_value(res['wldw_ljqk']) + '&nbsp;&nbsp;</span></div>');
                    html.push('</div>');
                }

                return html.join('');
            }
        },
    });
}

// 业务调账-开单
// $('body').on('tap', '#add_btn', function() {
//     fun.showPageFull({
//         page_url: page_arr.cw_ywtz_kd,
//         pageParam: {}
//     });
// });

fun.tjContentTap(function (list) {
    if (!fun.checkKz()) return;
    if ($.nui.isEmpty(list['dj_id'])) return;

    fun.showPageFull({
        page_url: page_arr.cw_ywtz_kd,
        pageParam: {
            return_page: html_name,
            id: list['dj_id'],
            dh: list['dh'],
            kdsj: list['kdsj'],
            zdr_mc: list['zdr_mc']
        }
    })
});

//添加按钮
$('body').on('tap', '#add_btn', function () {
    if (!fun.checkKz()) return;
    fun.showPageFull({
        page_url: page_arr.cw_ywtz_kd,
        pageParam: {
            return_page: html_name,
        }
    });
})

$('body').on('click', '.row-list', function () {
    if (fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var list = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isEmpty(list['dj_id'])) return;
    fun.showPageFull({
        page_url: page_arr.cw_ywtz_kd,
        pageParam: {
            return_page: html_name,
            id: list['dj_id'],
            dh: list['dh'],
            kdsj: list['kdsj'],
            zdr_mc: list['zdr_mc']
        }
    })
})