var html_name = page_arr.edit_panel;
var timeEnd = 0;
var timeStart = 0;
var time = 0;
var is_sort = false;
var editPanel = {
    originData: [],
    saveData: [],
    sysConfig: {}, // 系统设置数据
    phszPanel: [] // 偏好设置面板数据
};

// 页面是否有更改
editPanel.pageIsEdit = function () {
    return JSON.stringify(editPanel.originData) !== JSON.stringify(editPanel.saveData);
}

// 加载系统设置数据
editPanel.loadConfigData = function (callBack) {
    fun.load_DATA_LIST(['sys_config'], function () {
        editPanel.sysConfig = fun.getItem('sys_config') || {};
        var phszPanel = editPanel.getPhszPanelPropName();
        var sysConfigPhszPanel = editPanel.sysConfig[phszPanel];
        editPanel.phszPanel = $.nui.isTrue(sysConfigPhszPanel) ? (typeof sysConfigPhszPanel === 'string' ? JSON.parse(sysConfigPhszPanel) : sysConfigPhszPanel) : [];
        editPanel.phszPanelDataIsEmptyConcat();
        editPanel.originData = JSON.parse(JSON.stringify(editPanel.phszPanel));
        editPanel.saveData = JSON.parse(JSON.stringify(editPanel.phszPanel));
        if (typeof callBack === 'function') callBack();
    }, { showLoad: true, hideLoad: true });
}

// 获取系统设置偏好设置键名
editPanel.getPhszPanelPropName = function () {
    var companyId = fun.getItem('company_info') ? fun.toNumber(fun.getItem('company_info')['company_id']) : 0;
    var accountId = fun.getItem('account_info') ? fun.toNumber(fun.getItem('account_info')['account_id']) : 0;
    return 'phszpanel_' + companyId + '_' + accountId;
}


// 偏好设置值为空读默认偏好设置面板数据
editPanel.phszPanelDataIsEmptyConcat = function () {
    if ($.nui.isEmpty(this.phszPanel)) {
        this.phszPanel = PANEL_DATA.concat(PANEL_DATA_OBJ);
    }
}

// 获取系统设置保存数据
editPanel.getSysConfigSaveData = function (panelData) {
    panelData = panelData || [];
    return {
        type: 'sys',
        list: [
            {
                key: editPanel.getPhszPanelPropName(),
                value: JSON.stringify(panelData)
            }
        ]
    }
}

$('#header').header({
    back: true,
    title: '编辑数据面板',
    appendBackBtnEvt: saveData,
    text_btn: true
});

var Sortable = new Sortable($('#list_content')[0], {
    animation: 150,
    disabled: true,
    onEnd: function (evt) { //拖拽完毕之后发生该事件
        Sortable.options.disabled = true;
        is_sort = true;
    }
});

page_init = function () {
    init();
}

function init() {
    showList();
}

function showList() {
    editPanel.loadConfigData(function () {
        var phszPanel = JSON.parse(JSON.stringify(editPanel.phszPanel));

        if ($.nui.isTrue(phszPanel)) {
            var style = [];
            $(phszPanel).each(function (i, arr) {
                var _class = ((arr['view'] == 1) ? "nui-active" : "");
                var colour = color[i % color.length];
                var bg = "background-color:" + colour + ";";
                var display = '';
                var disabled = '';
                if ($.nui.isTrue(arr.authName)) { // 权限存储到后端，并且没有预览权限
                    if (!Auth.check(arr.authName, 'view')) {
                        display = 'none';
                    };
                }
                switch (arr['key']) {
                    case 'fx_ksgjl':
                        if (NEW_ANALYSIS) {
                            _class = 'nui-active';
                            disabled = 'disabled';
                        }
                        break;
                    case 'fx_cyyy':
                    case 'fx_sxxsqs':
                    case 'fx_sxcgqs':
                    case 'fx_sxjgqs':
                    case 'fx_sxkcqk':
                    case 'fx_sxmlph':
                        if (AuthVersionCheck.checkHide('ycsx')) {
                            display = 'none';
                        }
                        break;
                }
                style.push('<li style="display: ' + display + ';" id="' + arr['id'] + '" data-row=\'' + fun.formatString(JSON.stringify(arr)) + '\' class="bottom-list lower-border-line">');
                style.push('   <i class="iconfont more icon-gengduo"></i>');
                style.push('    <span>' + arr['name'] + '</span>');
                style.push('    <div class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + disabled + ' ' + _class + '">');
                style.push('        <div class="nui-switch-handle"></div>');
                style.push('    </div>');
                style.push('</li>');

            });
            style.push('<div class="top">');
            style.push('     <label class="title">按住可上下调整看板的顺序</label>');
            style.push('     <label class="title">开关控制卡片的显示或隐藏</label>');
            style.push('</div>');

            $('#list_content').html(style.join(''));
        }
    });
}


//监听长按事件
function getTimeNow() {
    var now = new Date();
    return now.getTime();
}
function touchend() {
    clearInterval(time);//如果按下时间不到1000毫秒便弹起，
}
function touchstart(obj) {
    timeStart = getTimeNow();//获取鼠标按下时的时间
    time = setInterval(function () {
        Sortable.options.disabled = false;
        if (timeEnd - timeStart > 700) {//如果此时检测到的时间与第一次获取的时间差有1000毫秒
            clearInterval(time);//便不再继续重复此函数 （clearInterval取消周期性执行）
            if ($api.attr($api.last(obj), 'style')) {
                $api.removeAttr($api.last(obj), 'style');
            }
        }
    }, 100);
}


//关闭页面
function close_page() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh',
            'is_sort': is_sort
        }
    });
    setTimeout(function () {
        api.closeWin();
    }, 500);
}

//点击开关
$('body').on('tap', '.nui-switch-btn', function () {
    var row = $(this).parent().data('row');
    row['view'] = $(this).hasClass('nui-active') ? 1 : 0;
    $(this).parent().data('row', row);
    is_sort = true;
})
//保存数据
function saveData() {
    var panel_arr = [];
    $('.bottom-list').each(function (i, obj) {
        var row = $(obj).data('row');
        panel_arr.push({
            "authName": fun.is_value(row.authName),
            "id": fun.toNumber(fun.is_value(row['id'], 0)),
            "name": fun.is_value(row['name']),
            "key": fun.is_value(row['key']),
            "sort": fun.toNumber(i + 1),
            "view": fun.toNumber(fun.is_value(row['view'], 0)),
            "icon": fun.is_value(row['icon'])
        })
    })

    editPanel.saveData = panel_arr;

    var isEdit = editPanel.pageIsEdit();

    // true 修改、false 没修改
    if (isEdit) { // 页面有修改
        if ($.nui.isTrue(panel_arr)) {
            fun.ajax({
                showLoad: false,
                hideLoad: false,
                url: AJAX_URL.saveSysConfig,
                data: editPanel.getSysConfigSaveData(panel_arr),
                success: function (res) {
                    if (res['status'] == 0) {
                        fun.load_DATA_LIST(['sys_config'], function () {
                            fun.toast('修改成功！');
                            close_page();
                        }, { showLoad: false })
                    }
                },
                error: function (err) {
                    fun.hideLoad();
                    close_page();
                },
            });
        }
    } else {
        api.closeWin();
    }
}

//点击完成
$('body').on('click', '#complete_btn', function () {
    saveData();
});