var page_name = page_arr.feedBack; // 页面名称
var saveData = { // 保存的数据
    type: 'cp', // 意见类型
    content: '', // 反馈的内容
    images: '' // 意见图片(字符串保存)
}; // 保存数据
var feedBack = {};
var imgMax = {
    yjfk: 0
}; // 意见反馈最大添加图片张数

var imgInfo = []; // 临时存储相册图片路径
var count = 0; // 相册图片递归终止变量
var photoBrowser = null; // 拍照单选图片
var UIAlbumBrowser = null; // 多选图片

// 内容主体距离头部距离
feedBack.pageStyleInit = function () {
    $('.content').css({
        paddingTop: api.safeArea.top + $('#header').outerHeight() - fun.computedHtmlFontSize()
    })

    $('.openCamera').css({
        paddingBottom: api.safeArea.bottom - fun.computedHtmlFontSize()
    })

    if (!(/^-/.test(api.safeArea.bottom - fun.computedHtmlFontSize()))) { // 负值padding无效
        feedBack.bottomBtnInit();
    }
}

// 初始化事件
feedBack.bindEvent = function () {
    // 删除图片
    $('body').on('click', '.packs', function (e) {
        e.stopPropagation();
        var _thatParent = $(this).parents('.feedback-img');

        fun.dialog({
            content: '你确定要删除图片吗?',
            btn: ['删除', '取消'],
            isClose: false,
            yes: function () {
                _thatParent.remove();
                if ($('.feedback-img').length === 8) {
                    var html = [];
                    html.push('<div class="fk-img item-img">');
                    html.push('    <img src="../img/null.png" class="img" />');
                    html.push('</div>');
                    $('.m-bottom').append(html.join(''));
                }

                var len = $('.feedback-img').length;
                if (len === 0) { // 全部添加图片都删除
                    $('.m-bottom').addClass('null-img-style');
                    $('.m-bottom').removeClass('exist-img-style');
                }
                imgMax['yjfk'] = 9 - len;
                layer.closeAll();
            },
        });
        return false;
    });

    // 顶部导航切换
    $('body').on('tap', '.btn-nav', function () {
        if (!$(this).hasClass('btn-blue')) {
            $(this).addClass('btn-blue');
            $(this).siblings().removeClass('btn-blue');
        }
        saveData['type'] = $(this).data('type');
    });

    // 大图预览
    $('body').on('click', '.feedback-img', function () {
        var temp = feedBack.getImgPath();
        var active = $(this).index();
        var showImgArr = [];
        for (var i = 0; i < temp.length; i++) {
            showImgArr.push(fun.getImgPath(temp[i], true));
        }
        photoBrowser.open({
            images: showImgArr,
            placeholderImg: '../img/logo.png',
            bgColor: '#000',
            activeIndex: active
        }, function (ret, err) {
            if (ret) {
                if (ret['eventType'] == 'click') {
                    photoBrowser.close();
                }
            }
        });
    })

    // 提交按钮点击事件
    $('body').on('click', '#submitRz', fun.throttle(function (e) {
        e.stopPropagation();
        if (!$('#cpjy').val().trim()) return fun.toast('请输入意见。');
        feedBack.saveData();

        // 提交方法
        // api.closeWin();
    }, 300));

    // 点击弹出相册
    $('body').on('tap', '.item-img', function (e) {
        e.stopPropagation();
        // if ($(this).attr('disabled')) return;
        // if ($('.m-bottom:visible').find('.fkImg').length >= 9) {
        //     return fun.toast('只允许上传9张图片。');
        // }
        $('#openCamera,.box').show();
    });

    // 拍照
    $('#paizhao').off('click').on('click', function (e) {
        QuestPermission.requestPermission('camera', null, function () {
            feedBack.closeCamera();
            api.getPicture({
                sourceType: 'camera',
                encodingType: 'jpg',
                mediaValue: 'pic',
                destinationType: 'base64',
                allowEdit: true,
                quality: 90,
                targetWidth: 900,
                targetHeight: 900,
                saveToPhotoAlbum: false
            }, function (ret, err) {
                if (ret) {
                    if (ret.data) feedBack.addImgToImgs(ret);
                } else {
                }
            });
        });

    });

    // 从相册中选择
    $('#selectPhoto').off('click').on('click', function (e) {
        e.stopPropagation();
        e.preventDefault();
        feedBack.closeCamera();
        var max = 6;
        if (imgMax['yjfk'] === 0) {
            imgMax['yjfk'] = 6;
        }
        max = imgMax['yjfk'] >= max ? max : imgMax['yjfk'];

        // 20200927 点击很多次确定会返回上一个页面，这里要限制只执行一次
        var UIAlbumBrowserTimer = null;
        var UIAlbumBrowserTimerFlag = true;

        QuestPermission.requestPermission(['photos'], null, function () {
            UIAlbumBrowser.imagePicker({
                max: max,//最多选择图片的数量，默认为9
                showCamera: false,//禁止访问相机
                styles: {
                    bg: '#fff',
                    nav: {
                        cancelColor: '#000',//取消按钮颜色
                        nextStepColor: '#000',//确定按钮颜色
                        cancelText: '取消',
                        finishText: '确定'
                    },
                },
                // isOpenPreview: true
            }, function (ret) {

                if(UIAlbumBrowserTimerFlag) {
                    UIAlbumBrowserTimerFlag = false;
                    clearTimeout(UIAlbumBrowserTimer);
                    UIAlbumBrowserTimer = null;
                    UIAlbumBrowserTimer = setTimeout(function(){
                        UIAlbumBrowserTimerFlag = true;
                    }, 1000);
    
                    nextConfirm(ret);
                }

                function nextConfirm(ret){
                    if (ret.eventType == 'nextStep') { // 确定事件
                        fun.showLoad();
                        var u = navigator.userAgent;
                        var list = ret['list'] || [];
                        if ($.nui.isEmpty(list)) return UIAlbumBrowser.closePicker();
                        fun.UploadRestriction(list, function () {
                            if (u.indexOf('Android') > -1 || u.indexOf('Linux') > -1) {//安卓路径无误
                                UIAlbumBrowser.closePicker();
                                feedBack.addImgToImgs(list, true);
                            } else if (!!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) { // ios路径需转化,包括iPad
                                UIAlbumBrowser.closePicker();
                                feedBack.IOSChange(list, function (temporary) {
                                    feedBack.addImgToImgs(temporary, true);
                                })
                            }
                        });
                    }
                }
                
                if (ret.eventType === 'cancel') { // 取消事件

                }
            })
        });

    });

    // 取消调用相册拍照
    $('#cancelPhoto').on('click', function (e) {
        e.stopPropagation();
        feedBack.closeCamera();
    });

    // // 取消拍照
    // $('#cancelPhoto').off('tap').on('tap', function () {
    //     setTimeout(function () {
    //         // hideCameraHint();
    //     }, 50);
    // });
}

// 转化iso路径（写函数声明格式是为了公用方法里有转化图片路径的调用）
function IOSChange(list, callback) {
    var temporary = list;
    $.each(list, function (i, item) {
        UIAlbumBrowser.transPath({
            path: item['path'],
            quality: 100
        }, function (res, err) {
            if (res) {
                temporary[i]['path'] = res['path'];
                if (i >= list.length - 1) {
                    if (typeof callback === 'function') callback(temporary);
                }
            }
        });
    })
};

// 转化iso路径
feedBack.IOSChange = IOSChange;

// 递归取base64，执行渲染方法
feedBack.addImgs = function (param, callback) {
    if (count >= param.length) {
        count = 0;
        if (typeof callback === 'function') callback(param);
        return param;
    }
    count++;
    fun.getUrlBase64(param[count - 1]['path'], param[count - 1]['suffix'], function (base64) {
        param[count - 1]['base64'] = base64;
        feedBack.addImgs(param, callback);
    });
}

// 添加图片
feedBack.addImgToImgs = function (data, Introduction) {
    if (Introduction) { // 多选图片
        feedBack.addImgs(data, function (param) {
            fun.imagePickerRender({
                pushHtml: [],
                allImageData: param,
                end: function (params) {
                    var html = params.html || [];
                    var cpCount = $('.feedback-img').length;
                    $('.item-img').before(html.join(''));
                    cpCount += data.length;
                    imgMax['yjfk'] = 9 - cpCount;
                    if (cpCount >= 9) {
                        $('.item-img').remove();
                    }
                    if (cpCount > 0) { // 有添加图片
                        $('.m-bottom').addClass('exist-img-style');
                        $('.m-bottom').removeClass('null-img-style');
                    }
                    imgInfo = [];
                    fun.hideLoad();
                },
                renderHtml: function (params) {
                    var url = fun.is_value(params.imgUrl); // 图片路径
                    var imgName = fun.is_value(params.imgName); // 图片名称
                    var html = params.html || [];
                    var index = params.index;
                    html.push('<div class="fk-img feedback-img">');
                    html.push('    <div class="delete-img" style="display: block;">');
                    html.push('        <div class="packs">');
                    html.push('            <i class="iconfont icon-fork fork"></i>');
                    html.push('        </div>');
                    html.push('    </div>');
                    html.push('    <img src="' + url + '" alt="" class="img" large-url="" data-name="' + imgName + '">');
                    html.push('</div>');
                }
            });
        })

    } else {
        feedBack.showSingleData(data);
    }
}

// 单选图片渲染
feedBack.showSingleData = function (pictureData) {
    var fileData = {
        data: pictureData,
        index: 0
    };
    fun.fileUpload(fileData, function (imgName) {
        var html = [];
        var url = fun.is_value(pictureData.data);
        html.push('<div class="fk-img feedback-img">');
        html.push('    <div class="delete-img" style="display: block;">');
        html.push('        <div class="packs">');
        html.push('            <i class="iconfont icon-fork fork"></i>');
        html.push('        </div>');
        html.push('    </div>');
        html.push('    <img src="' + url + '" alt="" class="img" large-url="" data-name="' + imgName + '">');
        html.push('</div>');

        // 拍照渲染
        var imgCount = $('.feedback-img').length;
        ++imgCount;
        $('.item-img').before(html.join(''));
        if (imgCount >= 9) {
            imgCount = 9;
            $('.item-img').remove();
        }
        imgMax['yjfk'] = 9 - imgCount;

        if (imgCount > 0) { // 有添加图片
            $('.m-bottom').addClass('exist-img-style');
            $('.m-bottom').removeClass('null-img-style');
        }
        fun.hideLoad();
    });
    $('#openCamera').hide();
}

// 多选图片渲染
feedBack.showMoreData = function (data) {
    var html = [];
    $(data).each(function (idx, item) {
        html.push('<div class="fk-img feedback-img">');
        html.push('    <div class="delete-img" style="display: block;">');
        html.push('        <div class="packs">');
        html.push('            <i class="iconfont icon-fork fork"></i>');
        html.push('        </div>');
        html.push('    </div>');
        html.push('    <img src="' + fun.getImgPath(item['img']) + '" alt="" class="img" large-url="" data-name="' + item['img'] + '">');
        html.push('</div>');
    });

    var cpCount = $('.feedback-img').length;
    $('.item-img').before(html.join(''));
    cpCount += data.length;
    imgMax['yjfk'] = 9 - cpCount;
    if (cpCount >= 9) {
        $('.item-img').remove();
    }
    if (cpCount > 0) { // 有添加图片
        $('.m-bottom').addClass('exist-img-style');
        $('.m-bottom').removeClass('null-img-style');
    }
    imgInfo = [];
    fun.hideLoad();
}

// 关闭相册
feedBack.closeCamera = function () {
    $('#openCamera, .box').hide();
}

// 页面初始化
feedBack.init = function () {
    feedBack.pageStyleInit();
    feedBack.bindEvent();
}

// 意见反馈提交方法
feedBack.saveData = function () {
    saveData['images'] = feedBack.getImgPath().join(',');
    saveData['content'] = $('#cpjy').val().trim();
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveFeedBack,
        data: {
            'user_id': fun.getItem('user_info') ? fun.getItem('user_info')['account_id'] : 0,
            'company_id': fun.getItem('company_info') ? fun.getItem('company_info')['company_id'] : 0,
            'app_type': "app",
            'type': saveData['type'],
            'content': saveData['content'],
            'images': saveData['images']
        },
        success: function (res) {
            console.log(res);
            if (res['status'] === 0) { // 请求成功
                fun.toast('感谢您的反馈，祝您生活愉快！');
                setTimeout(function () {
                    api.closeWin();
                }, 2000);
            } else { // 请求失败
                fun.toast({ msg: '网络异常！' });
            }
        }
    })
}

// 获取img路径
feedBack.getImgPath = function () {
    var temp = [];
    if ($.nui.isTrue($('.feedback-img').length)) { // 有图片
        $('.feedback-img').each(function () {
            temp.push($(this).find('.img').data('name'));
        })
    }
    return temp;
}

// 返回触发
feedBack.isDataChange = function () {
    saveData['images'] = feedBack.getImgPath().join(',');
    // 如果 意见输入框 为空 且 图片 为空，则直接返回上一级页面
    if ($.nui.isEmpty($('#cpjy').val().trim()) && $.nui.isEmpty(saveData['images'])) return api.closeWin();
    fun.dialog({
        content: '您确定要保存吗？',
        btn: ['提交', '放弃', '取消'],
        shadeClose: false,
        yes: function () { // 提交反馈 按钮 点击事件。  提交
            // ...保存方法
            feedBack.saveData();
            layer.closeAll();
            // api.closeWin();
        },
        no: function () { // 放弃
            api.closeWin();
        }
    });
}


page_init = function () {
    // 头部标题栏
    $('#header').header({
        back: true,
        title: '意见反馈',
        // add:true,
        appendBackBtnEvt: feedBack.isDataChange
    });

    feedBack.init();

    photoBrowser = api.require('photoBrowser');
    UIAlbumBrowser = api.require('UIAlbumBrowser'); // 多选图片模块

    fun.setKeyBoard({
        isIos: {
            showFn: feedBack.keyBoardShow,
            hideFn: feedBack.keyBoardHide
        },
        isAnd: {
            showFn: feedBack.keyBoardShow,
            hideFn: feedBack.keyBoardHide
        }
    })
};

// 键盘弹起
// feedBack.keyBoardShow = function () {
//     $('#bottom_btn').css({
//         paddingBottom: 0
//     })
// }

// 键盘收起
feedBack.keyBoardHide = function () {
    feedBack.bottomBtnInit();
}

// 底部适配虚拟home键
feedBack.bottomBtnInit = function () {
    $('#bottom_btn').css({
        paddingBottom: api.safeArea.bottom - fun.computedHtmlFontSize()
    })
}

// console.log($('.m-bottom').html());
