var html_name = page_arr.kc_mxpk_barcode;

var kc_mxpk_barcode = {
    ROW_DATA: {},
    __DJ_DATA: {},
    edit_row: []        // 修改的明细记录，包括删除、修改
};

/**
 * 页面必传参数
 * return_page 事件通知页面
 * list_data 点击的汇总行信息
 * __DJ_DATA 单据信息
 */
page_init = function () {
    console.log('kc_mxpk_barcode', page_data);

    console.log(JSON.stringify(page_data))

    kc_mxpk_barcode.ROW_DATA = page_data['list_data'];
    kc_mxpk_barcode.__DJ_DATA = page_data['__DJ_DATA'] || {};

    kc_mxpk_barcode.initHeader();

    $('.content').css({
        height: 'calc(100% - 5rem)',
        top: '5rem'
    });

    $('.editor-wrap').css({
        height: '5rem'
    })

    $('#shys').text((kc_mxpk_barcode.ROW_DATA['cp_ys_bh'] || '') + (kc_mxpk_barcode.ROW_DATA['cp_ys_mc'] || ''));

    if ($.nui.isTrue(page_data.__PAGE_EDIT)) {
        $('#list').addClass('swipe-delete');
        $('.dbd-show').show();
    } else {
        $('.dbd-show').hide();
        $('#list').removeClass('swipe-delete');
    }

    kc_mxpk_barcode.showList(kc_mxpk_barcode.ROW_DATA['mx']);

    kc_mxpk_barcode.initPageData(kc_mxpk_barcode.ROW_DATA);
    fun.inputType();
};


kc_mxpk_barcode.initHeader = function () {
    $('#header').header({
        back: true,
        title: (kc_mxpk_barcode.ROW_DATA['cp_bh'] || '') + (kc_mxpk_barcode.ROW_DATA['cp_mc'] || ''),
        // text_btn: page_data.__PAGE_EDIT,
        // text_val: '完成',
        appendBackBtnEvt: function () {
            kc_mxpk_barcode.sendData(true);
        }
    });
};

// 发送数据
kc_mxpk_barcode.sendData = function (closeWin) {
    if (page_data.__PAGE_EDIT && !$.nui.isEmpty(kc_mxpk_barcode.edit_row)) {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'update_row',
                'data': {
                    row_data: kc_mxpk_barcode.edit_row,
                }
            }
        });
    }

    if (closeWin) {
        setTimeout(function () {
            api.closeWin();
        }, 200);
    }
};

// 渲染明细列表
kc_mxpk_barcode.showList = function (mx) {
    var html = [];
    for (var i = 0; i < mx.length; i++) {
        var val = mx[i];
        if ($.nui.isTrue(val['is_delete'])) continue;
        var kcSl = fun.toNumber(val['kc_sl']); // 库存数量
        var sl = fun.toNumber(val['sl']); // 调用数

        // 半匹出库
        var color = ((kcSl > 0 && sl > 0) && (sl !== kcSl)) ? 'bpck-color' : ''; // 半匹出库字体颜色变化
        html.push('<li class="list-term lower-border-line" data-list_data=\'' + fun.formatString(JSON.stringify(val)) + '\' data-index="' + i + '">');
        html.push('     <div class="le">');
        html.push('         <span class="summary ' + color + '">' + val['sl'] + '</span>');
        html.push('         <span class="unit">' + kc_mxpk_barcode.ROW_DATA['dw_mc'] + '</span>');
        html.push('         <span class="text">' + (val['tm'] || '') + '</span>');
        html.push('         <div class="delete dels1 delete-btn" data-index="' + i + '">删除</div>');
        html.push('     </div>');
        html.push('</li>');
    }
    $('#list').html(html.join(''));
};

// 初始化数据
kc_mxpk_barcode.initPageData = function (row) {
    $('#header_title').data('cp_id', row['cp_id']);

    var cp_info = fun.getListInfoByKey(fun.getItem('cp_list') || [], row['cp_id']);
    var cp_imgs = cp_info['imgs'] || '';
    cp_imgs = cp_imgs.split(',')[0];

    var img_url = (cp_imgs) ? fun.getImgPath(cp_imgs) : "../img/logo.png";

    $('.img-box').css({
        background: 'url(' + img_url + ') no-repeat',
        backgroundSize: '100%',
        backgroundPosition: 'center center'
    });

    createPhszHtml();

    $('#fk').val(row['fk'] || '');
    $('#kz').val(row['kz'] || '');
    $('#gg').val(row['gg'] || '');
    $('#gh').val(row['gh'] || '');
    $('#ps').val(row['ps'] || 0);
    $('#sl').val(row['zsl'] || 0);
    $('#dw').text(row['dw_mc'] || '单位').data('dw_id', row['dw_id'] || 0);
};

// 创建偏好设置html
function createPhszHtml(callback) {
    var html = [];
    var ghHtml = [];
    var tmp_sys_config = fun.getItem('sys_config') || {};
    var kdphsz = tmp_sys_config['kdphsz'] || '';
    var arr = kdphsz.split(',') || [];

    var fkkz_show = (kdphsz.indexOf('fk,kz') > -1) ? '' : 'display:none;';
    var gg_show = (kdphsz.indexOf('gg') > -1) ? '' : 'display:none;';
    var gh_show = (kdphsz.indexOf('gh') > -1) ? '' : 'display:none;';

    html.push('<div class="in-block fk-wrap" style="' + fkkz_show + '">');
    html.push('     <span class="label-info">幅宽</span>');
    html.push('     <input id="fk" class="" type="text" readonly="readonly"/>');
    html.push('</div>');
    html.push('<div class="in-block kz-wrap" style="' + fkkz_show + '">');
    html.push('     <span class="label-info">克重</span>');
    html.push('     <input id="kz" class="" type="text" readonly="readonly"/>');
    html.push('</div>');
    html.push('<div class="in-block gg-wrap" style="' + gg_show + '">');
    html.push('     <span class="label-info">规格</span>');
    html.push('     <input id="gg" class="" type="text" readonly="readonly"/>');
    html.push('</div>');

    var fkkz_disabled = $('#fk').attr('disabled') || $('#kz').attr('disabled');
    var gg_disabled = $('#gg').attr('disabled');
    var gh_disabled = $('#gh').attr('disabled');

    if (arr.length > 3) {
        $('.fkkzgggh').html(html.join(''));
        if ($('.only-gh').length) {
            $('.only-gh').remove();
        }
        ghHtml.push('<div class="in-block gh-wrap" style="' + gh_show + '">');
        ghHtml.push('     <span class="label-info">缸号</span>');
        ghHtml.push('     <input id="gh" class="" type="text" readonly="readonly"/>');
        ghHtml.push('</div>');
        $('.fkkzgggh').after('<li class="edit-list only-gh">' + ghHtml.join('') + '</li>');

        $('.editor-wrap').css({
            height: '7.5rem'
        });

        $('#list').css({
            height: 'calc(100% - 7rem)',
            top: '12rem'
        });

    } else {
        html.push('<div class="in-block gh-wrap" style="' + gh_show + '">');
        html.push('     <span class="label-info">缸号</span>');
        html.push('     <input id="gh" class="" type="text" readonly="readonly"/>');
        html.push('</div>');

        $('.fkkzgggh').html(html.join(''));
        if ($('.only-gh').length) {
            $('.only-gh').remove();
        }
        $('#list').css({
            height: 'calc(100% - 4.5rem)',
            top: '9.5rem'
        });
    }

    if (fkkz_show && gg_show && gh_show) {
        $('.fkkzgggh').hide();
        $('.editor-wrap').css({
            height: '2.5rem'
        });
        $('#list').css({
            height: 'calc(100% - 4.5rem)',
            top: '7rem'
        });
    } else {
        $('.editor-wrap').css({
            height: 2.5 * (arr.length > 3?3:2)+'rem'
        });
        $('.fkkzgggh').show();
    }

    // for (var i = 0; i < $('.fkkzgggh>div:visible').length; i++) {
    //     var _dom = $('.fkkzgggh>div:visible').eq(i);
    //     if (i == 0 || i == 3) {
    //         _dom.css('width', '30%');
    //     } else {
    //         _dom.css('width', '35%');
    //     }
    // }

    if (fkkz_disabled) {
        $('#fk,#kz').attr('disabled', true);
    }
    if (gg_disabled) {
        $('#gg').attr('disabled', true);
    }
    if (gh_disabled) {
        $('#gh').attr('disabled', true);
    }

    if (typeof callback === 'function') callback();
}

// 计算总匹数 和 总数量
kc_mxpk_barcode.calcZpsZsl = function (arr) {
    var zps = 0, zsl = 0;

    for (var i = 0; i < arr.length; i++) {
        if ($.nui.isTrue(arr[i]['is_delete'])) continue;
        zps = $.nui.decimalAdd(zps, arr[i].ps < 0 ? 0 : arr[i].ps);
        zsl = $.nui.decimalAdd(zsl, parseFloat(arr[i]['sl'] || 0));
    }

    $('#ps').val(zps || 0);
    $('#sl').val(zsl || 0);
};

// 事件绑定 ------------------------------------------------------------------------------------------

// 删除
$('body').on('touchend', '.delete-btn', function (e) {
    e.preventDefault();
    if ($(this).attr('disabled')) return;
    if (!$.nui.isTrue(page_data.__PAGE_EDIT)) return;

    var row = $(this).closest('li').data('list_data') || {};
    var val = row['sl'];
    var index = $(this).closest('li').data('index');
    fun.dialog({
        content: '你确定要删除：【' + val + (row['dw_mc'] || '') + '】的布匹吗？',
        btn: ['删除', '取消'],
        yes: function () {
            var item = kc_mxpk_barcode.ROW_DATA.mx[index];

            // 处理删除的条码
            page_data.tm_arr = page_data.tm_arr || [];
            for (var i = 0; i < page_data.tm_arr.length; i++) {
                if (page_data.tm_arr[i] === item.tm) {
                    page_data.tm_arr.splice(i, 1);
                    break;
                }
            }

            if (item.__uuid) {    // 删除原有的记录
                item.is_delete = 1;
                kc_mxpk_barcode.edit_row.push(item);
            } else {               // 不是删除原有的记录，直接删除
                kc_mxpk_barcode.ROW_DATA.mx.splice(index, 1);
            }

            kc_mxpk_barcode.showList(kc_mxpk_barcode.ROW_DATA.mx);
            kc_mxpk_barcode.calcZpsZsl(kc_mxpk_barcode.ROW_DATA.mx);
        }
    });
    return false;
});

// 行记录点击
$('body').on('tap', '.list-term', function (e) {
    if (!$.nui.isTrue(page_data.__PAGE_EDIT)) return;
    var row = $(this).data('list_data');
    var index = $(this).data('index');

    var content = [];
    content.push('<div class="edit-wrap">');
    content.push('  <div class="edit-title"><span>修改数量</span></div>');
    content.push('  <div class="edit-row"><label class="edit-label">出库数</label><input id="cks" type="text" class="cks-input num-input" num_type="2" decimal_digits="4"/><span id="dw_mc" class="dw-text">' + kc_mxpk_barcode.ROW_DATA['dw_mc'] + '</span></div>');
    content.push('  <div class="edit-row"><label class="edit-label">库存数</label><span id="kcs" class="show-text">' + (row['kc_sl'] || ' ') + '</span></div>');
    content.push('</div>');

    var oldSl = row['sl'];
    var kc_sl = row.kc_sl;

    fun.dialog({
        content: content.join(''),
        btn: ['确定', '取消'],
        success: function () {
            $('#cks').val(row['sl']).select();
            $('#kcs').text(row['kc_sl']);

            setTimeout(function () {
                $('#cks').focus();
            }, 200);
        },
        yes: function () {
            var newSl = parseFloat($('#cks').val().trim() || 0);
            if (isNaN(newSl) || oldSl === newSl) {
                layer.closeAll();
                return false;
            }

            // 如果当前仓库有开启：不负库存
            // 当用户修改的数量大于该布匹对应的库存数时，修改无效。自动跳回没修改前的值
            if ($.nui.isTrue(fun.getHouseValue(row.ck_id, 'is_minus'))) {
                if (newSl < 0) {
                    layer.closeAll();
                    return false;
                }
            }
            // 布匹数量不能为0
            if (newSl === 0) {
                return fun.toast('请输入布匹数量');
            }

            var item = kc_mxpk_barcode.ROW_DATA.mx[index];
            if (newSl > kc_sl) {            // 新增数量，不能大于库存数量
                fun.toast('该布匹最多只能发：' + kc_sl + fun.is_value(kc_mxpk_barcode.ROW_DATA['dw_mc']));
                $('#cks').val(fun.is_value(oldSl, 0));
                return false;
            } else if (newSl < kc_sl) {     // 新增数量，小于库存数量时，算半匹出库
                // 添加修改的行记录, ps、sl
                if (item.ps > 0) {
                    // item.ps = item.ps - 1;
                }
            } else {                        // 新增数量，等于库存数量时，匹数等于1
                item.ps = 1;
            }

            item.sl = newSl;
            kc_mxpk_barcode.edit_row.push(item);

            // 渲染数据，计算总匹数、总数量
            kc_mxpk_barcode.showList(kc_mxpk_barcode.ROW_DATA.mx);
            kc_mxpk_barcode.calcZpsZsl(kc_mxpk_barcode.ROW_DATA.mx);
            layer.closeAll();
        },
        isClose: false
    });
});

// 调库存处理
$('body').on('tap', '.stock-btn', function (e) {
    e.preventDefault();

    kc_mxpk_barcode.sendData(false);

    var cp_ys_info = {
        cp_ys_id: kc_mxpk_barcode.ROW_DATA.cp_ys_id,
        cp_ys_bh: kc_mxpk_barcode.ROW_DATA.cp_ys_bh,
        cp_ys_mc: kc_mxpk_barcode.ROW_DATA.cp_ys_mc,
    };

    var cp_info = {
        id: kc_mxpk_barcode.ROW_DATA.cp_id,
        name: kc_mxpk_barcode.ROW_DATA.cp_mc,
        number: kc_mxpk_barcode.ROW_DATA.cp_bh
    };

    fun.showPageFull({
        page_url: page_arr.detailed_stock2,
        pageParam: {
            djlx: page_data.djlx,
            return_page: html_name,
            goto_page: page_data['return_page'],
            ck_id: kc_mxpk_barcode.ROW_DATA.ck_id,
            cp_info: cp_info,
            cp_ys_info: cp_ys_info,
            disabledCpCkYs: true,
            tm_arr: page_data.tm_arr,
            __row_data: kc_mxpk_barcode.ROW_DATA,
            __JL_DATA: [],
            ck_is_disabled: page_data['ck_is_disabled']
        }
    });
});

// 完成
$('body').on('tap', '#complete_btn', function (e) {
    e.stopPropagation();
    kc_mxpk_barcode.sendData(true);
});
