// 库存几个开单窗口公用动作。common_fun文件之后


// 子类必须配置null字段的内容
var stockManager = {
    getDataUrl: null,       // 获取页面详情url
    postUrl: null,          // 删除/保存/审核/反审核/作废url
    authCheckName: null,    // Auth.check()方法的name

    djlx: null,             // 生成单号需要字段
    table: null,            // 生成单号需要字段

    headerTitle: null,      // 导航头标题
    data: {                 // 需要保存的数据
        dj: {
            id: '',
            save_time: '',
            jsr_id: 0,
            zdr_id: 0,
            md_id: '',
            kdsj: '',
            dj_lsh: '',
            dh: '',
            ck_id: '',
            is_zf: 0,
            bz: '',
            zps: 0,
            zsl: 0
        },
        jl: []
    },
    fsh: fun.getItem('sys_config')['fsh'],
    origin_data: { dj: { bz: '' }, jl: [] },        // 页面打开时最原始数据，新增时为空，编辑时为后台加载的数据
    zps: 0,
    zsl: 0,
    zje: 0,                  // 总金额,保存四位小数
    showedDw: '',            // 显示在底部导航栏的单位
    //
    hzData: [],               // 根据仓库汇总后的数据

    isLoadCbj: true,
    extraDJData: {},          // 扩展数据

    deleteRows: [],           // 需要逻辑删除的行记录
    isDckms: false,           // 是否多仓库模式 true 开启 | false 关闭
    isDeleteRows: false,      // 是否删除行记录 true 已删除 | false 未删除
    JD_FROM_JL: false,
    is_adjust_save: false,
    del_row_exclude_col: [],
    __PAGE_INIT_DATA: { dj: {}, jl: [] },
    dateCalendar: null,
    begin_lCalendar: new lCalendar()
};

// 初始化动作逻辑
// 打开页面必传参数 return_page
// 新增时必传数据 data.list， list为数组
// 编辑时必传参数 dh, id, zdr, kdsj
// 其他init初始化的动作，使用stockManager.initExtend();
page_init = function () {
    // console.log('common page_data', page_data);

    if (!AuthVersionCheck.checkHide('hy')) {
        $('.hy-hide').removeClass('hy-hide');
    }

    stockManager.isDckms = $.nui.isTrue(fun.getItem('sys_config')['dckms_bp']);

    // 根据情况初始化获取成本价url
    if (stockManager.isLoadCbj && typeof Bills !== 'undefined') {
        Bills['AJAX_URL'] = { 'getDj': AJAX_URL.getKccpCbj }; // 获取产品成本url
    }

    stockManager.initStart();

    page_data.keyback = stockManager.isDataChange;


    stockManager.initHeader();
    stockManager.initHeaderAfter();
    stockManager.initDateTimePicker();

    __init();

    stockManager.initDomEvent();
    stockManager.initExtend();
    stockManager.initAddDataListener();
};

function __init() {
    $('button').hide();
    $('#much_btn,#print_btn,#del_btn,#share_btn').hide();
    if (page_data.id) {
        stockManager.apiGetData();
    } else {
        fun.showLoad();
        // 初始化头部导航栏
        // stockManager.initHeader();
        stockManager.initHeaderAfter();
        // stockManager.initDateTimePicker();

        if (page_data.data && page_data.data.list) {
            stockManager.initLoadCpcbj(page_data.data.list);
        } else {
            stockManager.initShowData();
        }
        stockManager.apiGetDh();
        fun.hideLoad();
    }
}

// api 方法 ----------------------------------------------------------------------------------
/**
 * 获取数据api
 */
stockManager.apiGetData = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.getDataUrl,
        data: {
            id: page_data.id,
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    stockManager.begin_lCalendar.disabled = false;
                    $('#kdsj').removeAttr('disabled');

                    stockManager.data = res.data;
                    page_data['dh'] = stockManager.data.dj.dh;

                    page_data['dj_is_sh'] = stockManager.data.dj['is_sh'];

                    stockManager.origin_data = JSON.parse(JSON.stringify(res.data));

                    stockManager.__PAGE_INIT_DATA = res.data;
                    $('#much_btn').hide();

                    // 初始化头部导航栏
                    // stockManager.initHeader();
                    stockManager.initHeaderAfter();
                    // if (false) {
                    //     stockManager.begin_lCalendar.disabled = false;
                    //     $('input,#kdsj,#wldw_mc').removeAttr('disabled');
                    // }

                    stockManager.apiDataLoaded();
                    console.log('stockManager.isInEdit()', stockManager.isInEdit())

                    if (!stockManager.isInEdit()) {
                        stockManager.begin_lCalendar.disabled = true;
                        $('#kdsj').attr('disabled', true);
                        // stockManager.initDateTimePicker();
                    }

                    $('#print_btn').show();
                    if ($.nui.isTrue(page_data.id)) {
                        $('#del_btn').show();
                    }
                    stockManager.initShowData();
                    break;
                default:
                    fun.alert({ msg: '获取单号失败！' });
                    break;
            }
        }
    })
};

// api数据加载完成调用方法
stockManager.apiDataLoaded = function () {
};

/**
 * 删除单据api
 */
stockManager.apiDelData = function () {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'delete')) return false;
    if (!Auth.qfmd({ 'key': 'delete', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'delete', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: { status: 'delete', scr_id: fun.getItem('user_info')['id'], dj_id: page_data.id,__post_sign: Bills['__post_sign'] },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    stockManager.closePage(true);
                    break;
                case 'IS_NOT_FIND':
                    fun.toast('单据已被其他操作人员删除，无法删除');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh'
                        }
                    });
                    // fun.alert({msg:res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.alert({msg: res['msg']}, function () {
                    //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) stockManager.closePage();
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
};

stockManager.apiAuditError = function (res) {
    fun.toast(res['msg']);
};

/**
 * 审核单据api
 */
stockManager.apiAudit = function () {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'check')) return false;
    if (!Auth.qfmd({ 'key': 'check', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'check', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: { status: 'audit', shr_id: fun.getItem('user_info')['id'], dj_id: page_data.id ,__post_sign: Bills['__post_sign'] },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('审核成功。');
                    stockManager.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    fun.toast('条码' + list['tm'] + '和库存信息不一致');
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_NOT_FIND':
                    // fun.toast(res['msg']);
                    fun.toast('单据已被其他操作人员删除，无法审核');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    // fun.alert({msg: res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    // if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1){
                    //     fun.alert({msg: res['msg']}, function () {
                    //         stockManager.closePage();
                    //     });
                    // }else{
                    stockManager.apiAuditError(res);
                    // }
                    break;
            }
        }
    })
};
/**
 * 反审核单据api
 */
stockManager.apiRevocatory = function () {
    // if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    // if (!Auth.check(stockManager.authCheckName, 'check')) return false;
    // if (!Auth.qfmd({ 'key': 'check', 'md_id': stockManager.data.dj.md_id })) return false;
    // if (!Auth.qfczy({ 'key': 'check', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    // fun.ajax({
    //     showLoad: true,
    //     hideLoad: true,
    //     url: stockManager.postUrl,
    //     data: {
    //         status: 'dbaudit',
    //         fhr_id: fun.getItem('user_info')['id'],
    //         dj_id: [page_data.id],
    //         is_fh: 0, // 生成新单
    //     },
    //     success: function (res) {
    //         switch (res['status']) {
    //             case 0:
    //                 fun.toast('取消审核成功。');
    //                 stockManager.closePage();
    //                 break;
    //             default:
    //                 fun.toast(res['msg']);
    //                 break;
    //         }
    //     }
    // });
};


/**
 * 作废单据api
 */
stockManager.apiObsolete = function (is_scxd) {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'invalid')) return false;
    if (!Auth.qfmd({ 'key': 'invalid', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'invalid', 'zdr_id': stockManager.data.dj.zdr_id })) return false;

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: {
            status: 'cancel',
            zfr_id: fun.getItem('user_info')['id'],
            dj_id: page_data.id,
            zf_yy: '', // 作废原因
            scxd: (is_scxd == 0) ? 1 : 0, // 生成新单
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            // if(is_scxd == 0){
            //   if (res['status'] == 0) {
            //     fun.toast('作废成功！');
            //     stockManager.closePage();
            //   }else{
            //     fun.toast(res['msg']);
            //   }
            // }else{
            switch (res['status']) {
                case 0:
                    fun.toast('作废成功。');
                    if (is_scxd == 0) {
                        page_data.id = res['data']['dj_id'];
                    }
                    stockManager.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'];
                    var listInfo = {};
                    if ($.nui.isTrue(list)) listInfo = list[0];
                    var msg = '条码' + (listInfo['tm'] || '') + '和库存信息不一致';
                    fun.toast(msg);
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_JS':
                    fun.toast('单据已被结算过，无法作废。');
                    break;
                case 'WDYJE_LESS_BCDY':
                    fun.toast('超出了订金，无法作废单据。');
                    break;
                case 'IS_NOT_FIND':
                    // fun.toast(res['msg']);
                    fun.toast('单据已被其他操作人员删除，无法作废');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    // fun.alert({msg:res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    stockManager.apiObsoleteError(res);
                    break;
            }
            // }
        }
    })
};

stockManager.apiObsoleteError = function (res) {
    fun.toast(res['msg']);
};

stockManager.checkBeforeApiSaveAjax = function (callback) {
    callback(true);
};

stockManager.apiSaveError = function (res) {
    fun.toast(res['msg'].replace(/销售订单/, '客户订单'));
};

/**
 * 根据id，检查删除的行记录是否需要上传后台
 * @param row 行记录
 * @param key 查询的主键，默认是id
 */
stockManager.rowDeleteHandler = function (row, key) {
    stockManager.isDeleteRows = true;

    if ($.nui.isEmpty(key)) {
        key = 'id';
    }
    if (row) {// && $.nui.isTrue(row[key])
        row.is_delete = 1;
        if (row.mx && row.mx.length) { // 明细记录也设置删除状态
            for (var i = 0; i < row.mx.length; i++) {
                row.mx[i].is_delete = 1;
            }
        }
        stockManager.deleteRows.push(row);
    }
};


/**
 *  删除匹数、数量为0的数据
 *  返回仓库id集合
 */
stockManager.deleteEmptyRows = function () {
    var ckIds = [];
    var realSaveJl = [];
    var tmpArr = stockManager.data.jl;
    var deleteRows = false;
    for (var i = 0; i < tmpArr.length; i++) {
        if ($.nui.isEmpty(tmpArr[i].ps) && $.nui.isEmpty(tmpArr[i].zsl)) {
            var isDel = true;
            // 如果有些字段值不为空，即使匹数数量0也不删除
            for (var j = 0; j < stockManager.del_row_exclude_col.length; j++) {
                var key = stockManager.del_row_exclude_col[j];
                if ($.nui.isTrue(tmpArr[i][key])) {
                    isDel = false;
                    break;
                }
            }


            if (isDel) {
                deleteRows = true;
                stockManager.rowDeleteHandler(tmpArr[i]);
            } else {
                realSaveJl.push(tmpArr[i]);
                if (ckIds.indexOf(tmpArr[i].ck_id) === -1) {
                    ckIds.push(tmpArr[i].ck_id);
                }
            }
        } else {
            realSaveJl.push(tmpArr[i]);
            if (ckIds.indexOf(tmpArr[i].ck_id) === -1) {
                ckIds.push(tmpArr[i].ck_id);
            }
        }
    }
    // 删除数据后重新渲染
    stockManager.data.jl = realSaveJl;
    return { ckIds: ckIds, deleteRows: deleteRows };
};

/**
 * 保存单据api
 */
stockManager.apiSave = function () {
    stockManager.data.dj = stockManager.getSaveDj();

    if (!Check.kzrq({ sj: stockManager.data.dj.kdsj })) return false;
    if (!Check.yjrq({ sj: stockManager.data.dj.kdsj })) return false;

    if (stockManager.data.dj.dh === '') return fun.toast('单号不能为空');

    var recordData = stockManager.data.jl.concat(stockManager.deleteRows), px = 0;

    var tmpJl = [];
    for (var i = 0; i < recordData.length; i++) {
        var val = $.extend(true, { mx: [] }, recordData[i]);

        if ($.nui.isTrue(val['is_delete']) && $.nui.isEmpty(val['id'])) continue;

        var __tmp_data = {};

        // if (stockManager.djlx == 'kc_bptbd') {
        __tmp_data['mx'] = [];
        // }
        var tmpData = $.extend({}, val, __tmp_data);

        if ($.nui.isEmpty(tmpData['is_delete'])) {
            px += 1;
            tmpData['px'] = px;
        }

        // if (stockManager.djlx == 'kc_bptbd') {
        for (var j = 0; j < val['mx'].length; j++) {
            // 如果记录行删除的情况,则明细表也是得以删除的情况处理
            if ($.nui.isTrue(tmpData['is_delete'])) val['mx'][j]['is_delete'] = 1;
            // 当数量为0, 并且无id字段信息，则代表为新添加并且手动删除的信息，跳过不处理
            if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isTrue(val['mx'][j]['is_delete'])) continue;
            if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isEmpty(val['mx'][j]['sl'])) continue;
            tmpData['mx'].push(val['mx'][j]);
        }
        // }

        tmpJl.push(tmpData);
    }

    stockManager.data.jl = tmpJl.slice(0);

    // 没开启【系统设置-多仓库模式】时，需约束：仓库不能为空。
    if ($.nui.isTrue(stockManager.data.jl) && !stockManager.isDckms && $.nui.isEmpty(stockManager.data.dj['ck_id']))
        return fun.toast('仓库不能为空');

    var result = stockManager.deleteEmptyRows();
    if (result.deleteRows) {
        setTimeout(function () {   // 放回调里执行，异步渲染
            stockManager.initShowData();
        }, 100);
    }

    if (stockManager.djlx == 'bp_cglhjs' || stockManager.djlx == 'bp_cgthjs'
        || stockManager.djlx == 'bp_cgdd' || stockManager.djlx == 'kc_bppyd'
        || stockManager.djlx == 'kc_bpmxpkd') {
        var realJl = [];
        for (var i = 0; i < stockManager.data.jl.length; i++) {
            var tmpData = stockManager.data.jl[i];

            // 如果 记录行 被删除, 则不需要判断 限制
            if ($.nui.isTrue(tmpData['is_delete'])) continue;
            if ($.nui.isEmpty(tmpData['ck_id'])) return fun.toast('请选择：【仓库】。');
            if ($.nui.isEmpty(tmpData['cp_ys_id'])) return fun.toast('请选择：【颜色】。');
            if ($.nui.isEmpty(tmpData['dw_id'])) return fun.toast('请选择：【单位】。');

            if (stockManager.djlx !== 'kc_bppyd' && stockManager.djlx !== 'kc_bpmxpkd') {
                if ($.nui.isEmpty(tmpData['jjdw_id'])) return fun.toast('请选择：【计价单位】。');
                if ($.nui.isEmpty(tmpData['ps']) && $.nui.isEmpty(tmpData['zsl'])) return fun.toast('请输入：【匹数】、【数量】。');
            }

            realJl.push(tmpData);
        }
        if (stockManager.djlx == 'bp_cgdd') {
            // stockManager.data.jl = realJl.slice(0);
        }
    }

    if ($.nui.isEmpty(stockManager.data.jl)) return fun.toast(tips_arr['空单提示']);

    if (!stockManager.isDckms && !$.nui.isFieldValEqual('ck_id', stockManager.data.jl)['res']) {
        fun.toast('不允许调用多个仓库的布匹。');
        return false;
    }

    stockManager.checkBeforeApiSaveAjax(function (result) {
        console.log('---执行保存')
        if (result) {
            // console.log(JSON.stringify(realSaveJl.concat(stockManager.deleteRows)));
            // console.log(JSON.stringify({
            //     dj: stockManager.data.dj,
            //     jl: realSaveJl.concat(stockManager.deleteRows)
            // }));

            var djIsSame = $.nui.isObjEquals(stockManager.data.dj, stockManager.origin_data.dj);
            var jlIsSame = stockManager.data.jl.length == stockManager.origin_data.jl.length;

            if (stockManager.JD_FROM_JL || stockManager.data.dj['is_fh'] || (stockManager.data.dj['is_has'] && djIsSame && jlIsSame)) {
                __adjust();
                return;
            } else {
                __save();
            }

            function __save() {
                var __saveData = {
                    status: 'save',
                    dj: stockManager.data.dj,
                    jl: stockManager.data.jl,//.concat(cgddDelRows)
                    __post_sign: Bills['__post_sign']
                };

                if (Bills['djlx'] == 'kc_bpmxpkd') {
                    console.log(22222)
                    __saveData['dj']['kdsj'] = fun.formatDate(__saveData['dj']['kdsj']);
                    delete __saveData['dj']['is_sh'];
                    var tmpSaveJl = __saveData['jl'].slice(0);

                    for (var i = 0; i < tmpSaveJl.length; i++) {
                        tmpSaveJl[i]['mx'] = [];
                        console.log(i, tmpSaveJl[i]['rk_sj'].split('').reverse()[0])

                        delete tmpSaveJl[i]['bqsl'];
                        delete tmpSaveJl[i]['dd_dh'];
                        delete tmpSaveJl[i]['dd_dj_id'];
                        delete tmpSaveJl[i]['dd_jl_id'];
                        delete tmpSaveJl[i]['dd_kdsj'];
                        delete tmpSaveJl[i]['dj'];
                        delete tmpSaveJl[i]['zje'];
                        delete tmpSaveJl[i]['je'];
                        delete tmpSaveJl[i]['shuie'];
                        delete tmpSaveJl[i]['zydj'];
                        delete tmpSaveJl[i]['jjdw_id'];
                        delete tmpSaveJl[i]['jjdw_mc'];
                        delete tmpSaveJl[i]['jjsl'];
                        delete tmpSaveJl[i]['sssl'];
                        delete tmpSaveJl[i]['hsdj'];
                        delete tmpSaveJl[i]['hsje'];
                        delete tmpSaveJl[i]['hszje'];
                        delete tmpSaveJl[i]['sl'];
                        delete tmpSaveJl[i]['__uuid'];
                    }
                }

                console.log($.extend({}, __saveData));

                // if(stockManager.djlx=='bp_cglhjs') return;
                // return;

                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: stockManager.postUrl,
                    data: __saveData,
                    success: function (res) {
                        if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                        switch (res['status']) {
                            case 0:
                                // if (stockManager.JD_FROM_JL) {
                                //     stockManager.__adjust();
                                //     return;
                                // } else {
                                fun.toast('保存成功。');
                                stockManager.JD_FROM_JL = false;
                                stockManager.deleteRows = [];
                                page_data.id = res['data']['dj_id'];

                                if (stockManager.djlx == 'bp_cgdd') {
                                    stockManager.deleteRows = [];
                                    api.sendEvent({
                                        name: html_name,
                                        extra: {
                                            'status': 'refresh_dj'
                                        }
                                    });
                                    api.sendEvent({
                                        name: page_data['return_page'],
                                        extra: {
                                            'status': 'refresh',
                                            'closeLayer': true
                                        }
                                    });
                                } else {
                                    // api.sendEvent({
                                    //     name: page_data['return_page'],
                                    //     extra: {
                                    //         'status': 'refresh',
                                    //         'closeLayer': true
                                    //     }
                                    // });
                                    stockManager.closePage();
                                }
                                // }
                                break;
                            case 'DCK_LIST':
                                var list = res['dck_list'][0];
                                fun.toast('条码' + list['tm'] + '已被调用或已出库');
                                break;
                            default:
                                stockManager.apiSaveError(res);
                                break;
                        }
                    }
                });
            }


            function __adjust() {
                console.log('---执行单据调整保存')


                var tmp_djtz_jl = [];
                var djtz_jl = stockManager.data.jl.slice(0) || [];

                var tmpSaveObj = {};

                for (var i = 0; i < djtz_jl.length; i++) {
                    if (djtz_jl[i]['djtz_jl_jd']) {
                        delete stockManager.data.jl[i]['djtz_jl_jd'];
                        tmp_djtz_jl.push(djtz_jl[i]);
                        tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
                    } else if (djtz_jl[i]['dj_jd_from_jd']) {
                        delete stockManager.data.jl[i]['dj_jd_from_jd'];
                        tmp_djtz_jl.push(djtz_jl[i]);
                        tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
                    }
                }


                var save_data = $.extend(true, {}, {
                    status: 'adjust',
                    data: tmp_djtz_jl,
                    dj_id: stockManager.data.dj['id'],
                    __post_sign: Bills['__post_sign']
                });

                save_data['isSave'] = stockManager.is_adjust_save;

                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    loadTitle: '保存中...',
                    url: stockManager.postUrl,
                    data: save_data,
                    success: function (res) {
                        if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                        switch (res['status']) {
                            case 0:
                                stockManager.deleteRows = [];
                                if (stockManager.JD_FROM_JL) {
                                    if (stockManager.data.dj['is_fh']) {
                                        fun.toast('保存成功！');

                                        if (stockManager.djlx == 'bp_cgdd') {
                                            stockManager.deleteRows = [];
                                            api.sendEvent({
                                                name: html_name,
                                                extra: {
                                                    'status': 'refresh_dj',
                                                }
                                            });
                                            api.sendEvent({
                                                name: page_data['return_page'],
                                                extra: {
                                                    'status': 'refresh',
                                                    'closeLayer': true
                                                }
                                            });
                                        } else {
                                            // api.sendEvent({
                                            //     name: page_data['return_page'],
                                            //     extra: {
                                            //         'status': 'refresh',
                                            //         'closeLayer': true
                                            //     }
                                            // });
                                            stockManager.closePage();
                                        }

                                    } else {
                                        __save();
                                    }

                                } else {
                                    stockManager.JD_FROM_JL = false;
                                    fun.toast('保存成功！');
                                    if (stockManager.djlx == 'bp_cgdd') {
                                        stockManager.deleteRows = [];
                                        api.sendEvent({
                                            name: html_name,
                                            extra: {
                                                'status': 'refresh_dj',
                                            }
                                        });
                                        api.sendEvent({
                                            name: page_data['return_page'],
                                            extra: {
                                                'status': 'refresh',
                                                'closeLayer': true
                                            }
                                        });
                                    } else {
                                        // api.sendEvent({
                                        //     name: page_data['return_page'],
                                        //     extra: {
                                        //         'status': 'refresh',
                                        //         'closeLayer': true
                                        //     }
                                        // });
                                        stockManager.closePage();
                                    }
                                }

                                break;
                            case 'IS_NOT_FINISH':
                                fun.jdts({
                                    content: '部分产品还没来完货，你确定要结单吗？',
                                    yes: function () {
                                        fun.ajax({
                                            showLoad: true,
                                            hideLoad: true,
                                            loadTitle: '结单中...',
                                            url: stockManager.postUrl,
                                            data: $.extend(true, { 'notCheckFinish': 1 }, save_data),
                                            success: function (res) {
                                                Bills['__post_sign'] = $.nui.getRandomNum();
                                                switch (res['status']) {
                                                    case 0:
                                                        fun.toast('结单成功。');
                                                        // is_adjust_save = false;
                                                        api.sendEvent({
                                                            name: html_name,
                                                            extra: {
                                                                'status': 'refresh_dj',
                                                                'data': {}
                                                            }
                                                        });
                                                        api.sendEvent({
                                                            name: page_data['return_page'],
                                                            extra: {
                                                                'status': 'refresh',
                                                                'closeLayer': true
                                                            }
                                                        });
                                                        break;
                                                    default:
                                                        fun.toast(res['msg']);
                                                        break;
                                                }
                                            }
                                        });
                                    },
                                    no: function () {
                                        for (var key in tmpSaveObj) {
                                            for (var j = 0; j < stockManager.data.jl.length; j++) {
                                                if (key == stockManager.data.jl[j]['id']) {
                                                    stockManager.data.jl[j]['is_jd'] = !stockManager.data.jl[j]['is_jd'] ? 1 : 0;
                                                    stockManager.data.jl[j]['jdr_id'] = !stockManager.data.jl[j]['is_jd'] ? USER_INFO['id'] : 0;
                                                    stockManager.data.jl[j]['jdr_mc'] = !stockManager.data.jl[j]['is_jd'] ? USER_INFO['name'] : '';
                                                    stockManager.data.jl[j]['jd_sj'] = !stockManager.data.jl[j]['is_jd'] ? fun.formatDate(new Date()) : '';
                                                }
                                            }
                                        }

                                        stockManager.initShowData();
                                    }
                                });
                                break;
                            case 'IS_ZS_FKC':
                                var list = res['data']['list'][0];
                                var ps_display = list['bz_ps'] > 0;
                                var sl_display = list['bz_sl'] > 0;
                                var msg = [
                                    list['cp_bh'] + list['cp_mc'] + '\r\n',
                                    list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                    '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                                    '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                                ].join('');
                                fun.toast(msg);
                                break;
                            case 'IS_TM_FKC':
                                var list = res['data']['list'][0];
                                fun.toast('条码' + list['tm'] + '和库存信息不一致');
                                break;
                            case 'IS_MX_FKC':
                                var list = res['data']['list'][0];
                                var msg = [
                                    list['cp_bh'] + list['cp_mc'] + '\r\n',
                                    list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                    '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                                ].join('');
                                fun.toast(msg);
                                break;
                            case 'DDJ_NOT_EMPTY':
                                fun.jdts({
                                    content: '<div style="text-align:left;margin-top: -0.5rem;">未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
                                    btn: ['确定结单', '取消'],
                                    yes: function () {
                                        stockManager.is_adjust_save = true;
                                        __adjust();
                                    }
                                });
                                break;
                            default:
                                fun.toast(res['msg']);
                                break;
                        }
                    }
                });
            }
        }
    });
};


/**
 * 获取单号后回调
 */
stockManager.afterApiGetDh = function (data) {
    // return data;
};

/**
 * 获取单号
 */
stockManager.apiGetDh = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': stockManager.djlx,
            'table': stockManager.table
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    console.log(123)
                    $('.subtitle').text(res.data.dh);

                    stockManager.data.dj.dh = res.data.dh;

                    stockManager.initHeaderAfter();

                    stockManager.afterApiGetDh(res.data);
                    break;
                default:
                    fun.alert({ msg: '网络异常！' });
                    break;
            }
        }
    })
};

// 普通方法 -------------------------------------------------------------------------------
// 初始化开始时执行方法
stockManager.initStart = function () {
};
stockManager.initLoadCpcbj = function (initList) {
    stockManager.loadCpcbj(initList, function (list) {
        stockManager.data.jl = list;
        stockManager.initShowData();
    });
};

/**
 * 初始化dom事件
 */
stockManager.initDomEvent = function () {
    // 先解除bill.js的同名绑定事件
    $('body').off('tap', '#del_btn');
    //删除
    $('body').on('tap', '#del_btn', function (e) {
        e.stopPropagation();
        // 数据更改时，提示
        stockManager.data.dj = stockManager.getSaveDj();
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能删除！');
        }

        fun.dialog({
            content: '您确定要删除当前单据吗？',
            btn: ['删除', '取消'],
            yes: function () {
                stockManager.apiDelData();
            }
        });
    });
    //审核
    $('body').on('tap', '.audit', function (e) {
        e.stopPropagation();
        // 数据更改时，提示
        stockManager.data.dj = stockManager.getSaveDj();
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能审核！');
        }

        fun.dialog({
            content: '您确定要审核当前单据吗？',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiAudit();
            }
        });
    });
    //取消审核
    $('body').on('tap', '.revocatory', function (e) {
        e.stopPropagation();
        fun.dialog({
            content: '您确定要取消当前单据的审核状态吗？',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiRevocatory();
            }
        });
    });
    //作废
    $('body').on('tap', '.obsolete', function (e) {
        e.stopPropagation();
        fun.dialog({
            content: '您确定要作废当前单据吗？',
            btn: ['重新做单', '直接作废', '取消'],
            yes: function (datas) {
                stockManager.apiObsolete(datas.index)
            },
            no: function (datas) {
                stockManager.apiObsolete(datas.index)
            }
        });
    });

    //保存
    $('body').delay('tap', '.saves', function () {
        stockManager.apiSave();
    });

    // 添加事件
    $('.choice').on('tap', function () {
        stockManager.openAddPage();
    });

    // 删除记录行
    $('body').on('tap', '.delete-btn', function (e) {
        e.preventDefault();
        if (stockManager.isInEdit()) {
            var _this = this;
            fun.dialog({
                content: '你确定要删除当前记录吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    stockManager.deleteRow(_this);
                    stockManager.showSaveBtn();
                }
            });
        }
    });

    // 详情编辑
    $('body').on('tap', '.store-content', function (e) {
        e.preventDefault();
        stockManager.editRow(this);
    });

    // 添加备注输入事件
    $('body').on('change', '#bz', function (e) {
        e.preventDefault();
        stockManager.data.dj.bz = $(this).val();
    });
};

/**
 * 删除行记录逻辑
 * @param _this 点击行记录的this对象
 */
stockManager.deleteRow = function (_this) {
};

/**
 * 编辑行记录
 * @param _this 点击行记录的this对象
 */
stockManager.editRow = function (_this) {
};

/**
 * 扩展的初始化方法
 */
stockManager.initExtend = function () {
};

/**
 * 扩展的事件监听方法
 */
stockManager.eventListenerExtend = function (ret, err) {
};

/**
 * 通过id查找对应记录的下标
 * @param callback {function}
 */
stockManager.findIndex = function (callback) {
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        if (callback(stockManager.data.jl[i])) {
            return i;
        }
    }
    return -1;
};

/**
 * 获取提交后台的单据数据
 */
stockManager.getSaveDj = function () {
    var kdsj = $('#kdsj').text().trim();
    var oriDj = JSON.parse(JSON.stringify(stockManager.origin_data.dj));
    // delete oriDj['is_jd'];
    // delete oriDj['is_fh'];
    return $.extend(oriDj, {
        id: Number(page_data['id'] || 0),
        save_time: stockManager.data.dj.save_time || '', // 保存时间
        jsr_id: stockManager.data.dj.jsr_id || 0,       // 经手人id
        zdr_id: fun.getItem('user_info')['id'],      // 制单人id stockManager.data.dj.zdr_id ||
        md_id: fun.getItem('user_info')['store_id'],  // 门店id stockManager.data.dj.md_id ||
        kdsj: fun.formatDate(kdsj, 'YYYY-MM-DD HH:mm:ss'),             // 开单时间
        dj_lsh: stockManager.data.dj.dj_lsh || '',        // 单据流水号
        dh: $('.subtitle').text().trim() || '',     // 单号
        ck_id: Number(stockManager.data.dj.ck_id || 0),
        bz: $('#bz').val().trim() || '',
        zps: parseInt($('#zps').text() || 0),
        zsl: parseFloat($('#zsl').text() || 0),
        is_sh: stockManager.data.dj.is_sh || 0
    }, stockManager.extraDJData);
};

// 添加数据的事件触发后，调用该方法
stockManager.addData = function () {
};

/**
 * 添加数据时监听方法
 */
stockManager.initAddDataListener = function () {
    api.addEventListener({ name: html_name }, function (ret, err) {
        if (ret.value.data && !$.nui.isEmpty(ret.value.data.list)) {
            stockManager.eventListenerAdd(ret, err);
        } else {
            stockManager.eventListenerExtend(ret, err);
        }
    });
};

// 默认的添加事件处理
stockManager.eventListenerAdd = function (ret, err) {
    console.log('eventListenerAdd', ret);
    // 只更新新添加数据的成本
    stockManager.loadCpcbj(ret.value.data.list, function (list) {
        stockManager.data.jl = stockManager.data.jl.concat(list);
        // 重新初始化显示数据
        stockManager.initShowData();
        stockManager.dataChangeShowSaveBtn();
    });
};

// 关闭页面，发送刷新事件
stockManager.closePage = function (flag) {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh'
        }
    });
    if (!flag) {
        api.sendEvent({
            name: html_name,
            extra: {
                'status': 'refresh_dj'
            }
        });
    } else {
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
    }

};

/**
 * 数据显示时转换处理，根据相同仓库合并
 * @returns {Array}
 */
stockManager.convertData = function () {
    var list = [], hzData = {};

    console.log(stockManager.data.jl);

    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var item = stockManager.data.jl[i];
        if (!hzData[item.ck_id]) {
            hzData[item.ck_id] = {
                ck_id: item.ck_id,
                ck_mc: item.ck_mc,
                list: []
            }
        }
        hzData[item.ck_id].list.push(item);
    }

    var ckIds = [];
    for (var ck_id in hzData) {
        if (hzData.hasOwnProperty(ck_id)) {
            list.push(hzData[ck_id]);
            ckIds.push(ck_id);
        }
    }

    // 没有开启多仓库
    if (!stockManager.isDckms) {
        stockManager.data.dj.ck_id = ckIds[0];
    } else {
        stockManager.data.dj.ck_id = 0;
    }

    console.log(list)

    stockManager.hzData = list;
    return list;
};

/**
 * 检查数据是否已经变化
 * @param origin_data  原始数据
 * @param data 最新数据
 * @returns {boolean} true 已经修改 | false 没有修改
 */
stockManager.checkDataChange = function (origin_data, data) {
    return !$.nui.isObjEquals(origin_data, data);
};

/**
 * 判断是否单据信息修改，只检查备注字段，其他需要自己重写
 * @returns {boolean}  true 已修改 | false 未修改
 */
stockManager.isDjDataChange = function () {
    return stockManager.origin_data.dj.bz !== stockManager.data.dj.bz || stockManager.origin_data.dj.kdsj !== stockManager.data.dj.kdsj;
};


stockManager.isDataNotChange = function () {
    if (!stockManager.isInEdit()) { // 非编辑状态，无法修改，直接返回
        // api.closeWin();
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
        return true;
    }
    return false;
};

/**
 * 判断页面数据是否修改
 */
stockManager.isDataChange = function () {
    stockManager.data.dj = stockManager.getSaveDj();

    if (stockManager.JD_FROM_JL && !stockManager.__PAGE_INIT_DATA.dj['is_jd']) {
        if ($('body').find('.data-change-skin').length) return;

        // // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        // if ($.nui.isEmpty(page_data.id) && stockManager.data.jl.length === 0 && stockManager.deleteRows.length === 0 && !stockManager.isDjDataChange() && !stockManager.isDeleteRows) {
        //     api.closeToWin({name: page_data.return_page});
        //     return false;
        // }

        if (!stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'refresh',
            //     }
            // });
            fun.useBack();
            api.closeToWin({ name: page_data.return_page });
            return;
        }

        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: stockManager.apiSave,
            no: function () {
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'refresh',
                        'closeLayer': true
                    }
                });
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh',
                //     }
                // });
                fun.useBack();
                api.closeToWin({ name: page_data.return_page });
            }
        });
        return false;
    }

    if (!stockManager.JD_FROM_JL && stockManager.isDataNotChange()) {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        // api.closeToWin({name: page_data.return_page});
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
        return false;
    }


    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
        if ($('body').find('.data-change-skin').length) return;

        // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        if ($.nui.isEmpty(page_data.id) && stockManager.data.jl.length === 0 && stockManager.deleteRows.length === 0 && !stockManager.isDjDataChange() && !stockManager.isDeleteRows) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'refresh',
            //     }
            // });
            // api.closeToWin({name: page_data.return_page});
            setTimeout(function () {
                fun.useBack();
                api.closeToWin({ name: page_data.return_page })
            }, 200);
            return false;
        }


        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: stockManager.apiSave,
            no: function () {
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'refresh',
                        'closeLayer': true
                    }
                });
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh',
                //     }
                // });
                // api.closeToWin({name: page_data.return_page});
                setTimeout(function () {
                    fun.useBack();
                    api.closeToWin({ name: page_data.return_page })
                }, 200);
            }
        });
    } else {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        // api.closeToWin({name: page_data.return_page});
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
    }
};

/**
 * 封装获取成本逻辑
 * @param list 需要获取成本的数组
 * @param callback 获取成功后回调函数
 */
stockManager.loadCpcbj = function (list, callback) {
    if (Auth.check('yxckbpcbj', 'view')) {
        __getJlData = function () {
            // 处理定价单位id
            for (var i = 0; i < list.length; i++) {
                list[i]['jjdw_id'] = list[i]['dw_id'];
            }
            return list;
        };

        // 更新成本价
        __updateJlDataByIndex = function (item) {
            list[item.index]['cbj'] = item.data.dj;
        };

        __getAllDj({
            get_dj: true,
            callback: function () {
                callback(list);
            }
        });
    }
};

/**
 * 加载产品成本价，初始化数据
 */
stockManager.initShowData = function () {
    stockManager.beforeShowData();
    stockManager.renderData(stockManager.convertData());
};

/**
 * 点击添加按钮，具体内容自己实现
 */
stockManager.openAddPage = function () {
    throw Error("添加按钮动作未实现");
};

/**
 *  判断是否可以编辑
 */
stockManager.isInEdit = function () {
    var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
    return AUTH_EDIT ? !stockManager.data.dj['is_sh'] : false;
};
// 页面显示处理 --------------------------------------------------------------------------------
/**
 * 显示页面数据通用方法
 */
stockManager.renderData = function (data) {
    data = stockManager.beforeRenderData(data);

    console.log(data);

    // 总匹数，总数量，计价单位处理
    var html = [], dws = {};
    stockManager.zps = 0;
    stockManager.zsl = 0;
    stockManager.zje = 0;

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        var ck_mc = val['ck_mc'];
        if (val['ck_id'] && !ck_mc) {
            ck_mc = fun.getHouseValue(val.ck_id, 'name');
        }
        html.push('<a class="store-title" data-ck_id="' + val.ck_id + '" data-index=\'' + i + '\'>' + (ck_mc || ' ') + '</a>');
        html.push('<ul class="swipe-delete">');
        for (var j = 0; j < val['list'].length; j++) {
            var data_list = val['list'][j];
            // 统计显示单位名称
            if (!dws[data_list.dw_id]) {
                dws[data_list.dw_id] = data_list.dw_mc;
            }
            html.push(stockManager.initContentList(data_list));
        }
        html.push('</ul>')
    }

    // html.push('         <div class="add-product"><i class="iconfont icon-tianjia"></i>&nbsp;添加产品</div>');

    $('.storehouse').html(html.join(''));


    if (!stockManager.isInEdit()) {
        $('.swipe-delete').removeClass('swipe-delete');
    }

    // 只有一个单位时显示，多个时不显示
    var showedDw = [];
    for (var dwId in dws) {
        showedDw.push(dws[dwId]);
    }
    if (showedDw.length === 1) {
        stockManager.showedDw = showedDw[0];
    } else {
        stockManager.showedDw = '';
    }

    stockManager.afterRenderData();

    stockManager.renderFooter();
};
/**
 * 初始化化每个li内容,主要返回字符串内容
 */
stockManager.initContentList = function () {
    throw Error('stockManager.initContentList() 方法未实现');
};
/**
 * 渲染列表内容之后动作
 */
stockManager.afterRenderData = function () {
};
/**
 * 渲染列表内容之前动作
 */
stockManager.beforeRenderData = function (data) {
    return data;
};

/**
 * 初始化数据之前调用
 */
stockManager.beforeShowData = function () {
};


//解决底部按钮宽度问题
stockManager.setButtonWidth = function () {
    $('.right2 .button2:visible').css('width', 'calc(100% / ' + $('.right2 .button2:visible').length + ')');
};

/**
 * 显示底部导航栏内容
 */
stockManager.renderFooter = function () {
    if (stockManager.isInEdit()) {// 有权限或者单据未审核
        $('.saves').show();//,tianjia
        $('.choice').show();
        $('.choice').css('display', 'inline-block');
        if (Auth.check(stockManager.authCheckName, 'check') && page_data.id) { // 有审核权限
            $('.audit').show();
            $('.saves').hide();
        }
        stockManager.inputBindEvent();
    } else {//有权限并且单据已审核
        $('#bz').attr('disabled', 'disabled');
        $('#del_btn').hide();
        $('.choice').hide();

        if ((!stockManager.data.dj.is_zf) && Auth.check(stockManager.authCheckName, 'invalid') && stockManager.fsh) { // 未作废、有作废权限并且【系统设置-反审核】有开启
            $('.obsolete').show();
        }
        if ((!stockManager.data.dj.is_zf) && Auth.check(stockManager.authCheckName, 'invalid') && !stockManager.fsh) { // 未作废、有作废权限并且【系统设置-反审核】没有开启
            $('.revocatory').show();
        }
    }
    $('#bz').val(stockManager.data.dj['bz'] || '');
    // 总匹数/总数量
    $('#zps').text((stockManager.zps.fixed(2) || 0) + '匹');
    $('#zsl').text((stockManager.zsl.fixed(2) || 0) + stockManager.showedDw);
    $('#zje').text(stockManager.zje.fixed(2) + '元');    // 保存2位小数

    stockManager.afterRenderFooter();

    if (stockManager.data.dj['is_zf']) {
        fun.seal({ type: 'zf' });
    } else if (stockManager.data.dj['is_sh']) {
        fun.seal({ type: 'sh' });
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
    var AUTH_SH = Auth.check(stockManager.authCheckName, 'check');
    // var AUTH_FH = Auth.check(stockManager.authCheckName, 'recheck');
    // var AUTH_JD = Auth.check(stockManager.authCheckName, 'settle');
    var AUTH_ZF = Auth.check(stockManager.authCheckName, 'invalid');

    if (stockManager.data.dj.is_sh) {
        $('.obsolete').show();
    } else {
        $('.obsolete').hide();
        page_data.id && $('.audit').show();
    }

    if (stockManager.data.dj['is_zf']) {
        $('button').hide();
    }

    if (!AUTH_EDIT) {
        $('#del_btn,.choice,.saves').hide();
        $('input').attr('disabled', 'disabled');
        $('.right').hide();
    }

    if (!AUTH_SH) {
        $('.audit,.revocatory').hide();
    }
    if (!AUTH_ZF) {
        $('.obsolete').hide();
    }


    stockManager.setButtonWidth();

    // 初始化准备提交的汇总数据
    stockManager.data.dj = stockManager.getSaveDj();
};

/**
 * 显示底部导航栏之后动作
 */
stockManager.afterRenderFooter = function () {
    // $('#zps').text(data['zps']+'匹'||'0匹');
    // $('#zsl').text(data['zsl'] + kcZspdEdit.showedDw || '0' + kcZspdEdit.showedDw);
};
/**
 * 初始化导航栏
 */
stockManager.initHeader = function () {

    var date = new Date();
    // 新单时，设置默认开单时间
    if (!page_data.id) {
        date.setSeconds(0, 0);
        var current_date = fun.formatDate(date, 'YYYY-MM-DD HH:mm:ss');
        stockManager.origin_data.dj.kdsj = current_date;
        stockManager.data.dj.kdsj = current_date;
    }

    $('#header').header({
        back: true,
        title: stockManager.headerTitle,
        subtitle: page_data['dh'] || '&nbsp;',
        appendBackBtnEvt: stockManager.isDataChange,
        del: true,//stockManager.isInEdit(), // 编辑状态，并且单据可以修改
        order_info: {
            show: true,
            person: page_data['zdr'] || fun.getItem('user_info')['name'],
            dateText: page_data['kdsj'] || fun.formatDate(date),
        },
        much: (stockManager.djlx == 'bp_cgdd') ? true : false,
        print: true,//$.nui.isTrue(page_data.id)
        share: true,//$.nui.isTrue(page_data.id)
    });

    $('#much_btn,#print_btn,#del_btn,#share_btn').hide();
};

stockManager.initHeaderAfter = function () {
    var date = new Date();
    if (!stockManager.isInEdit()) {
        $('#del_btn').hide();
    }

    $('.subtitle').text(stockManager.data.dj.dh || ' ');
    $('#zdr').html(stockManager.data.dj['zdr_mc'] || fun.getItem('user_info')['name']);
    $('#kdsj').html(fun.formatDate(stockManager.data.dj['kdsj']) || fun.formatDate(date));

    if ($.nui.isTrue(page_data.id)) $('#print_btn').show();
    if ($.nui.isTrue(page_data.id)) {
        if (['bp_cgdd', 'bp_cglhjs', 'bp_cgthjs', 'bp_cglhd', 'bp_cgthd'].indexOf(stockManager.djlx) > -1) $('#share_btn').show();
    }

};

/**
 * 选择时间回调
 * @param date
 */
stockManager.kdsjChange = function (date) {
};


/**
 * 设置或者清空批号，根据仓库是否开启批次管理判断
 */
stockManager.generaPh = function (config) {
    // 仓库开启批次的，需要设置批号
    if (config.ckInfo.is_batch) {
        if (!config.item[config.key] || config.forceUpdate) {
            config.item[config.key] = fun.formatDate(config.date, 'YYYYMMDD');
        }
    } else {
        config.item[config.key] = '';
    }
};

/**
 * 初始化时间选择控件
 */
stockManager.initDateTimePicker = function () {
    // <link rel="stylesheet" type="text/css" href="../css/lCalendar.css">
    var link = document.createElement('link');
    link.type = "text/css";
    link.rel = "stylesheet";
    link.href = "../css/lCalendar.css";
    document.getElementsByTagName("head")[0].appendChild(link);

    stockManager.begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            stockManager.data.dj.kdsj = fun.formatDate(date, 'YYYY-MM-DD HH:mm');
            $('#kdsj').text(fun.formatDate(date));
            stockManager.kdsjChange(date);
            stockManager.dataChangeShowSaveBtn();
        }
    });
};


html_name = page_arr.kc_mxpk_edit;

var Bills = Bills || {};

stockManager.isLoadCbj = false;

stockManager.getDataUrl = AJAX_URL.getBppkdInfo;
stockManager.postUrl = AJAX_URL.saveBppkdInfo;
stockManager.authCheckName = 'kc_bpmxpkd';

Bills.djlx = 'kc_bpmxpkd';

stockManager.djlx = 'kc_bpmxpkd';
stockManager.table = 'kc_bpmxpkd_dj';

stockManager.headerTitle = '明细盘亏';

// 自定义属性
stockManager.houseInfo = null;   // 仓库数据
stockManager.tm_arr = null;      // 需要过滤的条码信息
stockManager.showedHzData = [];    // 二次汇总后，用于渲染展示的汇总数据

// fun.keyboardEject('.base');
// methods ------------------------------------------------------------------
// 不需要获取成本价
stockManager.loadCpcbj = function (list, callback) {
    callback(list);
};

// 重写判断数据是否已经修改方法方法
stockManager.checkDataChange = function (origin_data, data) {
    var tmpData = JSON.parse(JSON.stringify(data));

    // 删除添加的标志
    for (var i = 0; i < tmpData.jl.length; i++) {
        delete tmpData.jl[i].__uuid;
        delete tmpData.jl[i].sl;
    }

    if (origin_data.dj) {
        origin_data.dj.zdr_id = fun.getItem('user_info')['id'];
        origin_data.dj.md_id = fun.getItem('user_info')['store_id'];
    }


    // console.log(JSON.stringify(origin_data));
    // console.log(JSON.stringify(tmpData));
    return !$.nui.isObjEquals(origin_data, tmpData);
};


/**
 * 重写该方法，每条记录设置uuid, 汇总后判断需要
 */
stockManager.beforeShowData = function () {
    stockManager.tm_arr = [];
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        stockManager.data.jl[i].__uuid = $.nui.getRandomNum();
        // 不是原来保存的记录，获取条码信息，重新调库存需要过滤
        if (stockManager.data.jl[i].tm) {
            stockManager.tm_arr.push(stockManager.data.jl[i].tm);
        }
    }
};

/**
 * 按相同产品再进行一次汇总,添加mx明细
 * @param data
 * @returns {Array}
 */
stockManager.beforeRenderData = function (data) {
    var newData = [];
    // 循环仓库
    for (var i = 0; i < data.length; i++) {
        var dataItem = {
            ck_id: data[i].ck_id,
            ck_mc: data[i].ck_mc,
            list: []
        };

        // 循环产品，进行产品汇总。
        // 根据产品编号、产品名称、色号。颜色、幅宽、克重、缸号、单位、单位2(需求提供)
        // 根据字段cp_bh、cp_id、fk、kz、gh、cp_ys_id、dw_id、dw2_id汇总判断
        var cp = {};
        for (var j = 0; j < data[i].list.length; j++) {
            var cpItem = data[i].list[j];
            var key = stockManager.createKey(cpItem);
            if (!cp[key]) {
                cp[key] = { list: [] };
            }
            cpItem.sl = cpItem.zsl;
            cp[key].list.push(cpItem);
        }

        // 产品合并
        for (var cp_id in cp) {
            var cpItemList = cp[cp_id];
            var cpItem = {
                is_yy_tm: 1,
                cp_bh: cpItemList.list[0].cp_bh,
                cp_id: cpItemList.list[0].cp_id,
                cp_mc: cpItemList.list[0].cp_mc,
                cp_ys_id: cpItemList.list[0].cp_ys_id,
                cp_ys_bh: cpItemList.list[0].cp_ys_bh,
                cp_ys_mc: cpItemList.list[0].cp_ys_mc,
                ck_id: cpItemList.list[0].ck_id,
                dw_id: cpItemList.list[0].dw_id,
                dw2_id: cpItemList.list[0].dw2_id,
                dw2_mc: cpItemList.list[0].dw2_mc,
                dw_mc: cpItemList.list[0].dw_mc,
                ps: cpItemList.list[0].ps,
                zsl: cpItemList.list[0].zsl,
                jjsl: cpItemList.list[0].zsl,
                jjdw_mc: cpItemList.list[0].dw_mc,
                fk: cpItemList.list[0].fk,
                kz: cpItemList.list[0].kz,
                gh: cpItemList.list[0].gh
            };
            // 如果只有一条记录，明细即自己
            // 如果多条记录，合并匹数与数量
            if (cpItemList.list.length > 1) {
                var zps = 0, zsl = 0;
                for (var k = 0; k < cpItemList.list.length; k++) {
                    zps = $.nui.decimalAdd(zps, cpItemList.list[k].ps);
                    zsl = $.nui.decimalAdd(zsl, cpItemList.list[k].zsl);
                }
                cpItem.ps = zps;
                cpItem.zsl = zsl;
            }

            cpItem.mx = cpItemList.list;
            dataItem.list.push(cpItem);
        }
        newData.push(dataItem);
    }
    // 存储二次汇总的数据
    stockManager.showedHzData = newData;
    return newData;
};


// 渲染页面内容
stockManager.initContentList = function (data_list) {
    var html = ['<li class="store-info fixed">'];

    if (Auth.check('yxckbpcbj', 'view')) {
        html.push('<div class="le pyd">');
    } else {
        html.push('<div class="le pyd" data-row=\'' + fun.formatString(JSON.stringify(data_list)) + '\'>');
    }

    html.push('<div class="store-content" data-row=\'' + fun.formatString(JSON.stringify(data_list)) + '\'>');
    html.push('<p class="store-name">' + data_list['cp_bh'] + data_list['cp_mc'] + ' <i>' + data_list['cp_ys_bh'] + data_list['cp_ys_mc'] + '</i></p>');
    
    html.push('<span>匹数<i class="info-date">' + data_list['ps'] + '</i></span>');
    html.push('<span>数量<i class="info-date">' + data_list['zsl'] + ' ' + data_list['dw_mc'] + '</i></span>');
    html.push('<span> <i class="info-date"> </i></span>');
    if(fun.getKdSetting('fk')){
        html.push('<span>幅宽<i class="info-date">' + fun.is_value(data_list['fk']) + '</i></span>');
    }
    if(fun.getKdSetting('kz')){
        html.push('<span>克重<i class="info-date">' + fun.is_value(data_list['kz']) + '</i></span>');
    }
    if(fun.getKdSetting('gg')){
        html.push('<span>规格<i class="info-date">' + fun.is_value(data_list['gg']) + '</i></span>');
    }
    if(fun.getKdSetting('gh')){
        html.push('<span>缸号<i class="info-date">' + fun.is_value(data_list['gh']) + '</i></span>');
    }
    html.push('</div>');

    if ($.nui.isEmpty(stockManager.data.dj.is_sh)) {
        html.push('<div class="delete dels1 delete-btn" data-row=\'' + fun.formatString(JSON.stringify(data_list)) + '\'><b class="swipe-span">删除</b></div>');
    }
    html.push('</div>');
    html.push('</li>');

    // 总匹数，总数量合计
    stockManager.zps = $.nui.decimalAdd(stockManager.zps, Number(data_list['ps']));
    stockManager.zsl = $.nui.decimalAdd(stockManager.zsl, Number(data_list['zsl']));

    stockManager.extraDJData.zsl = stockManager.zsl;
    return html.join('');
};

// 其他处理逻辑
stockManager.afterRenderData = function () {
    // 设置删除按钮高度 line-height
    var contentHeight = $('.store-info').height();
    $('.ds').css('height', contentHeight).css('line-height', contentHeight + 'px');

    // 加载汇总数据中第一个仓库详情, 编辑详情时开单编辑页面需要
    if (stockManager.hzData.length > 0) {
        stockManager.houseInfo = fun.getListInfoByKey(fun.getItem('ck_list'), stockManager.hzData[0].ck_id);
    } else {
        stockManager.houseInfo = null;
    }
};


stockManager.createKey = function (row) {
    return row.cp_bh + String(row.cp_id) + row.fk + row.kz + row.gh + String(row.cp_ys_id) + String(row.dw_id) + String(row.dw2_id);
};

// 删除行记录
stockManager.deleteRow = function (_this) {
    const list_data = $(_this).data('row');
    // 根据mx删除数据
    for (var i = 0; i < list_data.mx.length; i++) {
        const index = stockManager.findIndex(function (item) {
            return list_data.mx[i].__uuid === item.__uuid;
        });

        // 明细盘亏删除，获取的是记录下mx数据
        var delArr = stockManager.data.jl.splice(index, 1);
        stockManager.rowDeleteHandler(delArr[0]);
    }
    stockManager.initShowData();
};

// 编辑行记录
stockManager.editRow = function (_this) {
    fun.showPageFull({
        page_url: page_arr.kc_mxpk_barcode,
        pageParam: {
            djlx: stockManager.djlx,
            list_data: $(_this).data('row'),
            __PAGE_EDIT: stockManager.isInEdit(),
            __DJ_DATA: stockManager.data.dj,
            return_page: html_name,
            tm_arr: stockManager.tm_arr,
            ck_is_disabled: true,//$(_this).closest('.storehouse').find('.store-title').attr('disabled')
        }
    });
};

// 打开调库存页面
stockManager.openAddPage = function () {
    var ck_id = stockManager.houseInfo ? stockManager.houseInfo.id : '';

    fun.showPageFull({
        page_url: page_arr.detailed_stock2,
        pageParam: {
            djlx: stockManager.djlx,
            ck_id: ck_id,                   // 获取仓库数据
            goto_page: page_arr.kc_mxpk_edit,
            __JL_DATA: stockManager.data.jl,
            has_tm: true,                   // 只查询开启明细的产品
            tm_arr: stockManager.tm_arr,    // 需要过滤的条码
            __IS_NEW: false                   // 标记非新增
        }
    });
};


stockManager.apiSaveError = function (res) {
    switch (res['status']) {
        case 'DCK_LIST':
            var list = res['dck_list'][0];
            fun.toast('条码' + list['tm'] + '已被调用或已出库');
            break;
        default:
            fun.toast(res['msg']);
            break;
    }
};

stockManager.checkBeforeApiSaveAjax = function (callback) {
    var canSave = true;
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var tmpData = stockManager.data.jl[i];
        if ($.nui.isTrue(fun.getHouseValue(tmpData['ck_id'], 'is_batch')) && $.nui.isEmpty(tmpData['ph'])) {
            fun.toast('【' + fun.getHouseValue(tmpData['ck_id'], 'name') + '】已启用批次管理，产品的批号不能为空。');
            canSave = false;
            break;
        }
    }
    callback(canSave);
};


// 事件处理
stockManager.eventListenerExtend = function (ret, err) {
    // 不能根据数组下标做删除，循环删除时数据会不正确
    if (ret.value.status === 'update_row' && ret.value.data.row_data) {
        var row_data = ret.value.data.row_data;
        var length = row_data.length;

        $.each(row_data, function (index, item) {
            if (item.__uuid) {
                // 查找真正下标
                var rowIndex = stockManager.findIndex(function (row) {
                    return row.__uuid === item.__uuid;
                });

                if (item.is_delete) {  // 删除原有记录
                    var delArr = stockManager.data.jl.splice(rowIndex, 1);
                    stockManager.rowDeleteHandler(delArr[0]);
                } else {  // 修改原有记录, 只修改匹数与数量
                    stockManager.data.jl[rowIndex].ps = item.ps;
                    stockManager.data.jl[rowIndex].zsl = item.sl;
                }
            }

            if (index + 1 === length) {
                // 重新渲染内容
                stockManager.initShowData();
            }
        });
    } else if (ret.value.status === 'dkc_add') {        // 编辑行时调库存，记录都是新增，不用替换
        stockManager.data.jl = stockManager.data.jl.concat(ret.value.data.__JL_DATA);
        stockManager.initShowData();
    } else if (ret.value.status === 'refresh_dj') {
        __init();
    }

    // 根据返回状态检测数据判断显示保存按钮
    stockManager.checkStatusShowSaveBtn(ret.value.status);
};

stockManager.apiDataLoaded = function () {
    stockManager.begin_lCalendar.disabled = false;
    $('input,#kdsj').removeAttr('disabled');
};

// 显示保存按钮
stockManager.showSaveBtn = function () {
    if ($('.audit:visible').length) {
        $('.audit').hide();
    }
    if ($('.saves:visible').length) return;
    if(stockManager.data.dj['is_sh']) return;
    $('.saves').show();
}

// 数据发生改变显示保存按钮
stockManager.dataChangeShowSaveBtn = function () {
    stockManager.data.dj = stockManager.getSaveDj();
    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) stockManager.showSaveBtn();
}

// 根据返回状态检测数据判断显示保存按钮
stockManager.checkStatusShowSaveBtn = function (status) {
    var statusArr = [ // 返回状态数组
        'update_row',
        'dkc_add'
    ];
    if (statusArr.indexOf(status) > -1) stockManager.dataChangeShowSaveBtn();
}

// input输入框绑定事件
stockManager.inputBindEvent = function () {
    // 未审核数据改变显示保存按钮
    $('body').off('input propertychange', ':input').on('input propertychange', ':input', fun.throttle(stockManager.showSaveBtn, 300));
}