var html_name = page_arr.online_list;
var loginType = 'mobile', cut_name = '手机', delId_arr = [];
var timer = null;

var COMPANY_INFO = fun.getItem('company_info') || {};
$('#header').header({
    back: true,
    title: '在线列表',
    shutdown: true,
    appendBackBtnEvt: isDataChange
});

page_init = function () {
    //无云服务浏览权限隐藏按钮
    if(!Auth.check('yfw', 'view')){
        $('#shutdown_btn').hide();
    }
    //主账号显示关闭云服务按钮
    if(fun.getItem('user_info')['is_admin'] == 1){
        $('#shutdown_btn').show();
    }
    //安卓返回键
    page_data['keyback'] = isDataChange;

    //如果用户的采集器版本没有包括：仓储管理则隐藏
    if(!fun.checkVersion2()['isCcgl']){
        $('.collector').hide();
    }

    //如果用户的验布机版本没有包括：验布系统则隐藏
    if(!fun.checkVersion2()['isYyb']){
        $('.cloth').hide();
    }

    //获取数据
    getList(loginType);
    setTimer();

    //下拉刷新
    api.setRefreshHeaderInfo({
        bgColor: '#3c3c3c',
        textColor: '#fff',
        textDown: '下拉刷新.',
        textUp: '松开刷新',
        loadingImg: 'widget://img/update.png'
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        clearInterval(timer);
        getList(loginType)
    });
}

//切换上方标签页
$('body').on('tap', '.nav', function () {
    $(this).addClass('active').siblings().removeClass('active');
    loginType = $(this).data('type');
    cut_name = $(this).text();
    $('#swipe').empty();
    delId_arr = [];
    getList(loginType);
});

//获取公司在线列表（loginType表示登录类型）
function getList(loginType) {
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.getCompanyOnlineList,
        data: {
            "login_type": loginType,
            "company_id": COMPANY_INFO['company_id']
        },
        success: function (res) {
            switch (res.status) {
                case ResponseCode.request_error.status:
                    fun.dialog({
                        content: res['data']['msg'] || '提示语...',
                        btn: ["我知道了"],
                    });
                    break;
                case ResponseCode.request_show_company_success.status:
                    $('#tj_zxrs').text(res['data']['now_count'][loginType]);
                    if (loginType === 'cjq' || loginType === 'ybj') {
                        $('#tj_zzds').text('无限');
                    } else {
                        $('#tj_zzds').text(res['data']['max_count'][loginType]);
                    }
                    if (res['data'][loginType].length === 0){
                        $('#swipe').empty();
                        return;
                    }
                    showList(res['data'][loginType], loginType);
                    break;
            }
        }
    });
}

//设置定时器实现定时刷新
function setTimer() {
    if(timer !== null) clearInterval(timer);

    var timer = setInterval(function () {
        getList(loginType);
    }, 10000);
}

//渲染公司在线列表
function showList(data, loginType) {
    var Html = [];
    // var dataContent = ReverseRankingDate(data, "upline_time");
    $.each(data, function (i, obj) {
        Html.push('<li class="work" data-id="' + (obj.account_id || '') + '">');
        Html.push('    <div class="left">');
        Html.push('         <div class="right-title">');
        Html.push('             <span class="title">' + (obj.account_name || '') + '</span>');
        Html.push('             <span class="title2">' + (exhibitTime.show(obj.upline_time) || '') + '</span>');
        Html.push('         </div>');
        Html.push('         <div class="right-title">');
        Html.push('             <span class="summar">' + (obj.book_name || '') + '</span>');
        if (loginType !== 'web' && loginType !== 'cjq') {
            Html.push('             <span class="time">(' + (obj.device_name || '') + ')</span>');
        }
        Html.push('         </div>');
        Html.push('    </div>');
        // Html.push('    <div class="right">');
        // Html.push('      <span class="ld clearfix" data-name="' + (obj.account_name || '') + '">');
        // Html.push('        <i class="iconfont icon-lianjie-duankai"></i>');
        // Html.push('      </span>');
        // Html.push('    </div>');
        Html.push('    <span class="ld" data-name="' + (obj.account_name || '') + '"><i class="iconfont icon-lianjie-duankai"></i></span></div>');
        Html.push('</li>');
    });
    $('#swipe').html(Html.join(''));
    if (loginType == 'cjq') {
        $('.time').hide();
        $('.summar').css('width', 'calc(100% - 0.5rem)');
    } else if (loginType == 'ybj') {
        $('.time').hide();
        $('.summar').css('width', 'calc(100% - 0.5rem)');
    }
}

//断开连接
$('body').on('tap', '.ld', function (e) {
    e.stopPropagation();
    var _this = $(this).parent();
    var id = $(this).parent().data('id');
    var name = $(this).data('name');
    fun.dialog({
        content: '你确定要断开【' + name + '】吗？',
        btn: ['确定', '取消'],
        yes: function () {
            _this.remove();
            onlyOffline(loginType, id);
        }
    });
});

//强制公司的某用户下线
function onlyOffline(loginType, id) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.setOfflineUser,
        data: {
            "login_type": loginType,
            "account_id": id,
            "handler_name": fun.getItem('user_info')['name']
        },
        success: function (res) {
            switch (res.status) {
                case ResponseCode.request_error.status:
                case ResponseCode.account_offline.status:
                    fun.dialog({
                        content: res['msg'] || '提示语...',
                        btn: ['我知道了']
                    });
                    break;
                case ResponseCode.operation_success.status:
                    getList(loginType);
                    break;
            }
        }
    });
}

//全部断开 TODO（2020-03-25 此阶段暂时没做）
// $('body').on('tap', '.disconnected', function (e) {
//     e.stopPropagation();
//     fun.dialog({
//         content: '您确定要断开【' + cut_name + '】的连接人员吗？',
//         btn: ['删除', '取消'],
//         yes: function () {
//             for (var i = 0; i < delId_arr.length; i++) {
//                 $('[id="' + delId_arr[i] + '"]').remove();
//             }
//         }
//     });
// });

//刷新
$('body').on('tap', '.freshen', function (e) {
    delId_arr = [];
    getList();
});

//时间显示
var exhibitTime = (function () {
    return {
        show: function (date) {
            date = date.replace(/-/g, '/');
            var format = this.format(date); // 格式化方式
            return fun.dateFormat(format, date);
        },
        hasCurrentTime: function (date) { // 是否是当前时间
            var nowDay = new Date().getDate(); // 当前天数
            var newDate = fun.dateFormat('yyyy/MM/dd hh:mm', date);
            var compareDate = new Date(newDate).getDate();
            return nowDay === compareDate;
        },
        format: function (date) { // 时间格式化方式
            var format = '';
            if (this.hasCurrentTime(date)) { // 当天登录，显示时分
                format = 'hh:mm';
            } else { // 不是当前登录，显示月日 
                format = 'MM-dd';
            }
            return format;
        }
    }
})();


//封装的日期排序方法
// function ReverseRankingDate(data, p) {
//     for (i = 0; i < data.length - 1; i++) {
//         for (j = 0; j < data.length - 1 - i; j++) {
//             console.log(Date.parse(data[j][p]));
//             if (Date.parse(data[j][p]) < Date.parse(data[j + 1][p])) {
//                 var temp = data[j];
//                 data[j] = data[j + 1];
//                 data[j + 1] = temp;
//             }
//         }
//     }
//     return data;
// }

// 返回
function isDataChange(){
    //清除定时器
    if(timer !== null)clearInterval(timer)

    setTimeout(function(){
        api.closeWin();
    },200)
}

// 响应码
ResponseCode = {
    connect_success: {
        'status': 6000,
        'msg': '连接成功'
    },
    operation_success: {
        'status': 0,
        'msg': '操作成功'
    },
    request_success: {
        'status': 6002,
        'msg': '数据请求成功'
    },
    request_show_company_success: {
        'status': 0,
        'msg': '公司在线列表'
    },

    param_error: {
        'status': 6010,
        'msg': '参数有误'
    },
    request_error: {
        'status': 6011,
        'msg': '请求参数有误'
    },
    account_offline: {
        'status': 6012,
        'msg': '找不到此用户或此用户未在线'
    },

    max_count: {
        'status': 6020,
        'msg': '此站点已满员'
    },

    elsewhere_login: {
        'status': 6030,
        'msg': '此账号已被登录'
    },

    web_upline: {
        'status': 6050,
        'msg': '您的账号在电脑端登录'
    },
    web_online: {
        'status': 6051,
        'msg': '电脑端已登录'
    },
    web_downline: {
        'status': 6052,
        'msg': '您的账号在电脑端下线'
    },
    web_offline: {
        'status': 6053,
        'msg': '您的账号未在电脑端登录'
    },
    web_refresh_state: {
        'status': 6054,
        'msg': '当前电脑端状态'
    },

    mobile_forced_offline: {
        'status': 6060,
        'msg': '您已被手机端强制下线'
    },
    company_forced_offline: {
        'status': 6061,
        'msg': '您已被管理员强制下线'
    },
    cloud_close_offline: {
        'status': 6062,
        'msg': '云服务关闭强制所有设备下线'
    },
};

//关闭
$('body').on('tap','#shutdown_btn',function(){
    fun.dialog({
        content: '关闭云服务后，所有用户将退出软件且无法使用。需主账号才能重新开启。',
        className: 'service-layer',
        btn: ['确定关闭', '取消'],
        yes: function () {
            $.ajax({
                type: 'POST',
                url: AJAX_URL.setCloud,
                data: {
                    company_id: COMPANY_INFO['company_id'],
                    is_open: 0
                },
                success: function (res) {
                    if(res.status == 0){
                        fun.showLoad('关闭中...');
                        api.sendEvent({
                            name: page_arr.index,
                            extra: {
                                'status': 'service',
                            }
                        });
                    }
                }
            })
        },
    });
});