$('#header').header({
    back: true,
    title: '修改密码'
});

fun.keyboardEject('.sub');
$('#old_pwd').focus();

$('#save_btn').on('tap', function () {
    var old_pwd = $('#old_pwd').val(),
        new_pwd = $('#new_pwd').val(),
        confirm_pwd = $('#confirm_pwd').val();
    if (old_pwd.length == 0) {
        return fun.toast('旧密码不能为空。');
    } else if (new_pwd.length == 0) {
        return fun.toast('新密码不能为空。');
    } else if (confirm_pwd.length == 0) {
        return fun.toast('确认密码不能为空。');
    } else if(old_pwd.length < 6){
        return  fun.toast('请输入6位及以上密码。');
    } else if (new_pwd != confirm_pwd) {
        return fun.toast('新密码不一致。');
    }
    getdata({
        "old_pwd": old_pwd,
        "pwd": new_pwd
    });
})
$(function () {
    $('#new_pwd').keyup(function () {
        var strongRegex = new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9])(?=.*\\W).*$", "g");
        var mediumRegex = new RegExp("^(?=.{7,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$", "g");
        var enoughRegex = new RegExp("(?=.{6,}).*", "g");
        
        if (false == enoughRegex.test($(this).val())) {
            $('#level').removeClass('pw-weak');
            $('#level').removeClass('pw-medium');
            $('#level').removeClass('pw-strong');
            $('#level').addClass(' pw-defule');
            $('.list-text').text('密码较弱，建议再设置复杂点').css('color','#e70000');
            //密码小于六位的时候，密码强度图片都为灰色 
            
        }
        else if (strongRegex.test($(this).val())) {
            $('#level').removeClass('pw-weak');
            $('#level').removeClass('pw-medium');
            $('#level').removeClass('pw-strong');
            $('#level').addClass(' pw-strong');
            $('.list-text').text('您的密码很安全~~').css('color','#18e4ed');
            //密码为八位及以上并且字母数字特殊字符三项都包括,强度最强 
        }
        else if (mediumRegex.test($(this).val())) {
            $('#level').removeClass('pw-weak');
            $('#level').removeClass('pw-medium');
            $('#level').removeClass('pw-strong');
            $('#level').addClass(' pw-medium');
            $('.list-text').text('密码较良好，建议复杂点更安全').css('color','#6ba000');
            //密码为七位及以上并且字母、数字、特殊字符三项中有两项，强度是中等 
        }
        else {
            $('#level').removeClass('pw-weak');
            $('#level').removeClass('pw-medium');
            $('#level').removeClass('pw-strong');
            $('#level').addClass('pw-weak');
            $('.list-text').text('密码较弱，建议再设置复杂点').css('color','#e70000');
            //如果密码为6为及以下，就算字母、数字、特殊字符三项都包括，强度也是弱的
        }
        return true;
    });
})

function getdata(opt) {
    var num;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveAccount,
        data: $.extend({}, {
            "id": (fun.getItem('account_info')['account_id'] || 0),
            "type": "pwd",
            "old_pwd": "",
            "pwd": ""
        }, (opt || {})),
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast('修改成功。');
                    setTimeout(function () {
                        api.closeWin();
                    }, 1000)
                    break;
                case 104:
                    num += 1; 
                    fun.toast('旧密码错误。');
                    break;
            }
        }
    })
}