var html_name = page_arr.personal_online;
page_init = function () {
    refresh();
}

//点击图标
$('body').on('click', '.close', function () {
    api.closeWin();
})

//点击断开（目前只有全部断开的接口）
$('body').on('click','li',function(){
    fun.dialog({
        content: '您要断开该连接吗？',
        btn: ['确定', '取消'],
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.setOfflineUser,
                data: {
                    "login_type": "web",
                    "account_id": fun.getItem('account_info')['account_id'],
                    "handler_name": fun.getItem('user_info')['name']
                },
                success: function (res) {
                    switch (res.status) {
                        case ResponseCode.request_error.status:
                        case ResponseCode.account_offline.status:
                            fun.dialog({
                                content: res['msg'] || '提示语...',
                                btn: ["我知道了"],
                            })
                            break;
                        case ResponseCode.operation_success.status:
                            api.sendEvent({
                                name: page_data.return_page,
                                extra: {
                                    status: 'offline',
                                }
                            })
                            setTimeout(function () {
                                api.closeWin();
                            }, 200)
                    }
                },
                error: function () {
                    setTimeout(function () {
                        api.closeWin();
                    }, 200)
                }
            });
        }
    });
})

//全部退出
$('body').on('click', '.out', function () {
    fun.dialog({
        content: '是否退出所有Windows云布业？',
        btn: ['确定', '取消'],
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.setOfflineUser,
                data: {
                    "login_type": "web",
                    "account_id": fun.getItem('account_info')['account_id'],
                    "handler_name": fun.getItem('user_info')['name']
                },
                success: function (res) {
                    switch (res.status) {
                        case ResponseCode.request_error.status:
                        case ResponseCode.account_offline.status:
                            fun.dialog({
                                content: res['msg'] || '提示语...',
                                btn: ["确定"],
                            })
                            break;
                        case ResponseCode.operation_success.status:
                            api.sendEvent({
                                name: page_data.return_page,
                                extra: {
                                    status: 'offline',
                                }
                            })
                            setTimeout(function () {
                                api.closeWin();
                            }, 200)
                    }
                },
                error: function () {
                    setTimeout(function () {
                        api.closeWin();
                    }, 200)
                }
            });
        }
    });

})

//刷新
function refresh() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getUserOnlineState,
        data: {
            "login_type": "web",
            "account_id": fun.getItem('account_info')['account_id']
        },
        success: function (res) {
            switch (res.status) {
                case ResponseCode.request_error.status:
                case ResponseCode.web_offline.status: // web端不在线
                    fun.dialog({
                        content: res['msg'] || '提示语...',
                        btn: ["我知道了"],
                    })
                    break;
                case ResponseCode.web_refresh_state.status:
                    var html = [];
                    $(res['data']['web']).each(function (idx, item) {
                        html.push('<li>');
                        html.push('  <span class="address">' + item.book_name + '</span>');
                        html.push('  <i class="iconfont icon-lianjie-duankai"></i>');
                        html.push('  <p class="place"><span class="time">' + item.upline_time + '</span><span>' + item.login_address + '</span></p>');
                        html.push('</li>');
                    })
                    $('ul').html(html.join(''));
                    break;
            }
        },
        error: function () {
            fun.toast('网络异常');
        }
    });
}

// 响应码
ResponseCode = {
    connect_success: {
        'status': 6000,
        'msg': '连接成功'
    },
    operation_success: {
        'status': 0,
        'msg': '操作成功'
    },
    request_success: {
        'status': 6002,
        'msg': '数据请求成功'
    },
    request_show_company_success: {
        'status': 6003,
        'msg': '公司在线列表'
    },

    param_error: {
        'status': 6010,
        'msg': '参数有误'
    },
    request_error: {
        'status': 6011,
        'msg': '请求参数有误'
    },
    account_offline: {
        'status': 6012,
        'msg': '找不到此用户或此用户未在线'
    },

    max_count: {
        'status': 6020,
        'msg': '此站点已满员'
    },

    elsewhere_login: {
        'status': 6030,
        'msg': '此账号已被登录'
    },

    web_upline: {
        'status': 6050,
        'msg': '您的账号在电脑端登录'
    },
    web_online: {
        'status': 6051,
        'msg': '电脑端已登录'
    },
    web_downline: {
        'status': 6052,
        'msg': '您的账号在电脑端下线'
    },
    web_offline: {
        'status': 6053,
        'msg': '您的账号未在电脑端登录'
    },
    web_refresh_state: {
        'status': 0,
        'msg': '当前电脑端状态'
    },

    mobile_forced_offline: {
        'status': 6060,
        'msg': '您已被手机端强制下线'
    },
    company_forced_offline: {
        'status': 6061,
        'msg': '您已被管理员强制下线'
    },

};