var html_name = page_arr.printer_list;
var ipPattern = /((2(5[0-5]|[0-4]\d))|[0-1]?\d{1,2})(\.((2(5[0-5]|[0-4]\d))|[0-1]?\d{1,2})){3}/;

$('#header').header({
    back: true,
    title: '打印机',
    lanya: true,
    add: true
});
var ble, bluetoothSPP, bluetoothHY;
var lyList = [];

page_init = function () {
    ble = api.require('ble');
    // bluetoothSPP = api.require('bluetoothSPP');
    bluetoothHY = api.require('bluetoothHY');
    getAllPrinterList();
    fun.inputType();
};

//打印机ip判断
$('body').on('blur', '#dy_ip', function (e) {
    e.stopPropagation();

    var str = $(this).val().trim();
    if (!str) return;

    if (!ipPattern.test(str)) {
        fun.toast('ip地址格式输入错误，请重新输入。');
        $(this).val('');
    }
});

function sendBackData(list) {
    api.sendEvent({
        name: page_data['return_page'] + '_select_device',
        extra: {
            'status': 'select_device',
            'data': {
                list: list
            }
        }
    });

    setTimeout(function () {
        api.closeWin();
    }, 200);
}

//修改本地打印机
$('body').on('click', '.local-list', function (e) {
    var list = $(this).data('list') || {};

    if (page_data['type'] == 'select_device') {
        sendBackData(list);
        return;
    }

    if ($.nui.isTrue(list['is_cloud'])) return;

    printerLocal({
        type: 'edit',
        data: list,
        index: list['__index']
    });

});

//修改蓝牙
$('body').on('click', '.lanya-list', function (e) {
    var list = $(this).data('list') || {};

    if (page_data['type'] == 'select_device') {
        sendBackData(list);
        return;
    }

    if ($.nui.isTrue(list['is_cloud'])) return;

    bleDialog({
        type: 'edit',
        data: list,
        index: list['__index']
    });

});

//修改云打印
$('body').on('click', '.cloud-list', function (e) {
    var list = $(this).data('list') || {};
    var _this = this;

    if (!!page_data['print_select']) {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'select_device',
                'data': {
                    id: list['id'],
                    name: list['device_name']
                }
            }
        });
    
        setTimeout(function () {
            api.closeWin();
        }, 200);
        return;
    }
    if (page_data['type'] == 'select_device') {
        sendBackData(list);
        return;
    }

    if (!$.nui.isTrue(list['is_cloud'])) return;

    var html = [];

    html.push('<div class="ydy-dialog">');
    html.push('     <div class="ydy-dialog-title">云打印</div>');
    html.push('     <div class="ydy-ipt-wrap">');
    html.push('         <label for="ydy_name"></label><input id="ydy_name" class="ydy-input" value="' + list['device_name'] + '" type="text" placeholder="名称">');
    html.push('     </div>');
    html.push('     <div class="ydy-ipt-wrap">');
    html.push('         <label for="ydy_bm"></label><input readonly="readonly" id="ydy_bm" class="ydy-input" value="' + list['device_id'] + '" type="text" placeholder="制造编码">');
    html.push('     </div>');
    html.push('</div>');

    fun.dialog({
        type: 1,
        className: 'ydy-dialog-skin',
        content: html.join(''),
        isClose: false,
        btn: ['保存', '取消'],
        // success: function () {
        //
        // },
        yes: function () {
            list['device_name'] = $('#ydy_name').val().trim() || list['device_id'];
            $(_this).data('list', $.extend({}, list));

            saveCloud();
        }
    });
});

//保存云打印
function saveCloud(options) {
    var _options = $.extend({
        data: {}
    }, options);

    var save_data = [];
    for (var i = 0; i < $('.cloud-list').length; i++) {
        var list = $('.cloud-list').eq(i).data('list') || {};
        save_data.push(list);
    }
    savePrinterConfig();

    function savePrinterConfig() {
        fun.printerCloud({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.savePrintDeviceInfo,
            data: save_data,
            callback: function (res) {
                switch (res['status']) {
                    case 0:
                        fun.toast('修改成功');
                        getAllPrinterList(function () {
                            layer.closeAll();
                        });
                        break;
                    case 'NOT_ALLOW_DUPLICATE':
                        // getAllPrinterList();
                        return fun.toast('名称不能重复');
                        break;
                    default:
                        return fun.toast('操作失败，请稍后重试');
                        break;
                }
            }
        });
    }
}

//所有打印机列表
function getAllPrinterList(callback) {
    getList(function (data) {
        var SYS_CONFIG = fun.getItem('sys_config') || {};
        fun.load_DATA_LIST(['sys_config'], function () {
            SYS_CONFIG = fun.getItem('sys_config') || {};
        });

        var list = [];

        // if ($.nui.isTrue(SYS_CONFIG['ydy'])) {
        for (var i = 0; i < data.length; i++) {
            data[i]['is_cloud'] = 1;
            list.push(data[i]);
        }
        // }

        if (!page_data['print_select']) {
            var list1 = fun.getItem('printer_local') || [];

            for (var i = 0; i < list1.length; i++) {
                if ($.nui.isTrue(list1[i])) {
                    list1[i]['__index'] = i;
                }
            }

            var list2 = fun.getItem('printer_lanya') || [];

            for (var i = 0; i < list2.length; i++) {
                if ($.nui.isTrue(list2[i])) {
                    list2[i]['__index'] = i;
                }
            }

            list = list.concat(list1, list2);
        }


        showList(list);
        if (typeof callback === 'function') callback();
    });
}

function getList(callback) {
    fun.load_printer_cloud(callback);
}


// function printerCloud() {
//     var html = [];
//     html.push(' <div class="printer-mi">');
//     html.push('     <p>打印机设置</p>');
//     html.push('     <ul>');
//     html.push('         <li><input placeholder="名称"></li>');
//     html.push('         <li><input placeholder="打印机编号"></li>');
//     html.push('         <li><input placeholder="检验码"></li>');
//     html.push('         <li><input placeholder="纸张类型" id="zzlx" readonly="readonly"></li>');
//     html.push('         <li><input placeholder="门店" id="md" readonly="readonly"></li>');
//     html.push('         <li class="printer-an">');
//     html.push('             <i id="xygk" class="amount stop-btn nui-switch nui-switch-md nui-unactive nui-switch-btn stop-btn2"><i class="nui-switch-handle"></i></i>');
//     html.push('             <span>默认</span>');
//     html.push('         </li>');
//     html.push('     </ul>');
//     html.push(' </div>');
//     option = {
//         content: html.join(''),
//         className: 'printer-list',
//         btn: ['保存', '取消'],
//     }
//     option.success = function () {
//         //单选
//         $('#zzlx').on('touchend', function () {
//             var $this = $(this);
//             var val = $this.text();
//             var merchants_list = [
//                 {"name": "标签纸", "column": "bqz", "is_choose": 1},
//                 {"name": "票据纸", "column": "pjz", "is_choose": 0},
//                 {"name": "热敏纸", "column": "rmz", "is_choose": 0},
//                 {"name": "普通纸", "column": "ptz", "is_choose": 0}
//             ];
//             $(merchants_list).each(function (i, arr) {
//                 if (arr['name'] == val) {
//                     merchants_list[i]['is_choose'] = 1;
//                 } else {
//                     merchants_list[i]['is_choose'] = 0;
//                 }
//             });
//             fun.showBookList({
//                 list: merchants_list,
//                 choose: function (res) {
//                     $this.val('');
//                     $this.val(res['name']).data('type', res['column']);
//                 }
//             })
//         })
//         //选择门店
//         $('#md').on('click', function () {
//             fun.showPageFull({
//                 page_url: page_arr.select_list,
//                 pageParam: {
//                     return_page: html_name,
//                     page_type: 'md',
//                 }
//             });
//         })
//         api.addEventListener({
//             name: html_name,
//         }, function (ret, err) {
//             // console.log(ret)
//             var temp = ret['value'];
//             switch (temp['status']) {
//                 case 'select_list':
//                     $('#md').val(temp['data']['select_val']).data('id', temp['data']['id']);
//                     break;
//             }
//         });
//     }
//     fun.dialog(option);
// }

function printerLocal(options) {
    var __opt = $.extend({ type: 'add', index: null, data: {} }, options);
    console.log(__opt)
    var html = [];
    html.push(' <div class="printer-mi">');
    html.push('     <p>打印机设置</p>');
    html.push('     <ul class="local-store" data-list=\'' + fun.formatString(JSON.stringify(__opt['data'])) + '\'>');
    html.push('         <li><input id="dy_mc" class="" placeholder="名称"></li>');
    html.push('         <li><input id="dy_ip" class="" placeholder="IP"></li>');
    html.push('         <li><input id="dy_port" class="num-input" num_type="4" decimal_digits="0" placeholder="端口" value="6932" maxlength="7"></li>');
    // html.push('         <li><input placeholder="打印机编号"></li>');
    // html.push('         <li><input placeholder="检验码"></li>');
    // html.push('         <li><input placeholder="纸张类型" id="zzlx" readonly="readonly"></li>');
    // html.push('         <li><input placeholder="门店" id="md" readonly="readonly"></li>');
    html.push('         <li><input type="text" readonly="readonly" placeholder="打印机" id="dy_printer"></li>');
    html.push('         <li class="printer-an">');
    html.push('             <i id="is_default" class="amount stop-btn nui-switch nui-switch-md nui-unactive nui-switch-btn stop-btn2"><i class="nui-switch-handle"></i></i>');
    html.push('             <span>默认</span>');
    html.push('         </li>');
    html.push('     </ul>');
    html.push(' </div>');
    var option = {
        content: html.join(''),
        className: 'printer-list local-dialog',
        btn: ['保存', '取消'],
        isClose: false
    };
    option.success = function () {
        if (__opt['type'] == 'edit') {
            var tmpData = __opt['data'] || {};
            $('#dy_mc').val(tmpData['device_name'] || '');
            $('#dy_ip').val(tmpData['ip'] || '');
            $('#dy_port').val(tmpData['port'] || '');
            $('#dy_printer').val(tmpData['printer'] || '');

            if (tmpData['is_default']) {
                $('#is_default').addClass('nui-active').removeClass('nui-unactive');
            } else {
                $('#is_default').addClass('nui-unactive').removeClass('nui-active');
            }
        }


        $('body')
            .off('tap', '#dy_printer')
            .on('tap', '#dy_printer', function (e) {
                e.stopPropagation();
                var _this = this;

                var tmp_ip = $('#dy_ip').val().trim();
                var tmp_port = $('#dy_port').val().trim();
                var tmp_printer = $(this).val().trim();

                fun.setPrintConfig('ip', tmp_ip);
                fun.setPrintConfig('port', tmp_port);

                Print.connectLocal({
                    success: function (res) {
                        var list = (res['data'] && res['data']['list'] || []) || [];
                        var tmpList = [];

                        for (var i = 0; i < list.length; i++) {
                            tmpList.push({
                                id: $.nui.getRandomNum(),
                                name: list[i],
                                is_choose: tmp_printer == list[i]
                            })
                        }
                        tmpList.unshift({
                            id: $.nui.getRandomNum(),
                            name: '',
                            is_choose: tmp_printer === ''
                        });

                        console.log(list);

                        fun.showBookList({
                            width: '280px',
                            shadeClose: true,
                            list: tmpList,
                            choose: function (res) {
                                console.log(res);
                                $(_this).val(res['name']);
                            }
                        });
                    }
                });
            });
    };
    option.yes = function () {
        var device_ip = $('#dy_ip').val().trim();
        var device_port = $('#dy_port').val().trim();
        var device_name = $('#dy_mc').val().trim();
        var device_printer = $('#dy_printer').val().trim();

        if ($.nui.isEmpty(device_ip)) {
            return fun.toast('IP不能为空。');
        } else if ($.nui.isEmpty(device_port)) {
            return fun.toast('端口不能为空。');
        }

        if ($.nui.isEmpty(device_name)) {
            device_name = device_ip;
        }

        var tmp_storage = fun.getItem('printer_local') || [];

        var data = {
            // id: $.nui.getRandomNum(),
            // device_name: device_name,
            // ip: device_ip,
            // port: device_port,
            // is_default: $('#is_default').hasClass('nui-active') ? 1 : 0,
            // is_cloud: 0
        };

        if (__opt['type'] == 'add') {
            data = {
                id: $.nui.getRandomNum(),
                device_name: device_name,
                ip: device_ip,
                port: device_port,
                is_default: $('#is_default').hasClass('nui-active') ? 1 : 0,
                is_cloud: 0,
                printer: device_printer
            };
        } else if (__opt['type'] == 'edit') {
            var tmp_list = $('.local-store').data('list') || {};
            data = {
                id: tmp_list['id'],
                device_name: device_name,
                ip: device_ip,
                port: device_port,
                is_default: $('#is_default').hasClass('nui-active') ? 1 : 0,
                is_cloud: 0,
                printer: device_printer
            };
        }

        function checHasDefault() {
            for (var i = 0; i < tmp_storage.length; i++) {
                if (tmp_storage[i]['is_default']) {
                    return true;
                }
            }
            return false;
        }


        for (var i = 0; i < tmp_storage.length; i++) {
            if (data['is_default']) {
                tmp_storage[i]['is_default'] = 0;
            }
        }

        if (!tmp_storage.length) data['is_default'] = 1;

        if (__opt['type'] === 'add') {
            for (var i = 0; i < tmp_storage.length; i++) {
                var checkArr = tmp_storage[i];

                if (checkArr['device_name'] == data['device_name']) {
                    return fun.toast('名称不能重复。');
                } else if (checkArr['ip'] == data['ip']) {
                    return fun.toast('IP不能重复。');
                }
            }
            tmp_storage.push(data);
        } else if (__opt['type'] === 'edit') {
            if (__opt['index'] !== null) {
                tmp_storage[__opt['index']] = data;

                if (!checHasDefault()) {
                    data['is_default'] = 1;
                    tmp_storage[__opt['index']] = data;
                }

                for (var i = 0; i < tmp_storage.length; i++) {
                    var checkArr = tmp_storage[i];

                    if (checkArr['id'] != data['id']) {
                        if (checkArr['device_name'] == data['device_name']) {
                            return fun.toast('名称不能重复。');
                        } else if (checkArr['ip'] == data['ip']) {
                            return fun.toast('IP不能重复。');
                        }
                    }
                }
            }
        }

        if (data['is_default']) {
            fun.setPrintConfig('ip', data['ip']);
            fun.setPrintConfig('port', data['port']);
            fun.setItem('print_default_config', data);
        }

        fun.setItem('printer_local', tmp_storage);

        getAllPrinterList(function () {
            return fun.toast(__opt['type'] === 'add' ? '添加成功！' : '修改成功！');
        });
        layer.closeAll();
    };
    fun.dialog(option);
}

function showList(data) {
    var html = [];

    // if (page_data['type'] == 'select_device') {
    //     $('#wrap').removeClass('swipe-delete');
    // }

    for (var i = 0; i < data.length; i++) {
        var val = data[i];

        var id_ip = $.nui.isTrue(val['is_cloud']) ? val['device_id'] : val['ip'];
        var local_class = $.nui.isTrue(val['is_cloud']) ? 'exclude-list cloud-list' : 'local-list';

        var sec_name = '';//第二行名称

        var _class = '';//打印机列表类名
        var icon_class = ''; //图标的类名
        var printer_lx = '';//打印机类型
        var delClass = '';//左滑删除的类名

        if ($.nui.isTrue(val['is_cloud'])) {
            _class = 'exclude-list cloud-list';
            icon_class = 'icon-cloud';
            printer_lx = 'cloud';

            sec_name = val['device_id'];
        } else if ($.nui.isTrue(val['is_lanya'])) {
            _class = 'lanya-list';
            icon_class = 'icon-lanya';
            printer_lx = 'lanya';

            sec_name = val['device_mc'];
            delClass = 'lanya-del';
        } else {
            _class = 'local-list';
            icon_class = 'icon-pc';
            printer_lx = 'local';

            sec_name = val['ip'];
            delClass = 'local-del';
        }

        html.push('<li class="li-list ' + _class + '" data-list=\'' + fun.formatString(JSON.stringify(val)) + '\'>');
        html.push(' <div class="le">');
        html.push('     <div class="row">');

        html.push('<i class="iconfont ' + icon_class + '"></i>');

        html.push('         <span class="printer-name">' + val['device_name'] + '</span>');
        // val['is_cloud'] && html.push('         <span class="label-tag">云</span>');
        val['is_default'] && html.push('         <span class="radius"></span>');
        html.push('     </div>');
        html.push('     <div class="row">');
        if (printer_lx === 'lanya' && val['device_name'] == sec_name) {
            html.push('         <span class="printer-id">&nbsp;</span>');
        } else {
            html.push('         <span class="printer-id">' + sec_name + '</span>');
        }
        html.push('     </div>');
        (printer_lx !== 'cloud') && html.push('     <span class="dels1 delete ' + delClass + '">删除</span>');
        html.push(' </div>');
        html.push('</li>');
    }

    $('#wrap').html(html.join(''));
}


function bleDialog(options) {
    var _options = $.extend({ type: 'add', data: {} }, options);
    var html = [];
    var _data = _options['data'];

    html.push('<div class="ydy-dialog" data-list=\'' + fun.formatString(JSON.stringify(_data)) + '\'>');
    html.push('     <div class="ydy-dialog-title">蓝牙打印</div>');
    html.push('     <div class="ydy-ipt-wrap">');
    html.push('         <label for="ydy_name"></label><input id="lanya_name" class="ydy-input" value="' + fun.is_value(_data['device_name']) + '" type="text" placeholder="名称">');
    html.push('     </div>');
    html.push('     <div class="ydy-ipt-wrap">');
    html.push('         <label for="ydy_bm"></label><input readonly="readonly" id="lanya_id" class="ydy-input" value="' + fun.is_value(_data['device_mc']) + '" type="text" placeholder="设备名称">');
    html.push('     </div>');
    html.push('</div>');

    fun.dialog({
        type: 1,
        className: 'ydy-dialog-skin',
        content: html.join(''),
        btn: ['保存', '取消'],
        // isClose: false,
        yes: function () {
            var lanya_name = $('#lanya_name').val().trim();
            var lanya_id = $('#lanya_id').val().trim();


            if ($.nui.isEmpty(lanya_name)) {
                lanya_name = lanya_id;
            }

            var tmp_storage = fun.getItem('printer_lanya') || [];

            var tmp_data = {};

            if (_options['type'] == 'add') {
                tmp_data = {
                    id: $.nui.getRandomNum(),
                    device_name: lanya_name,
                    device_mc: lanya_id,
                    device_address: _data['device_address'],
                    device_id: _data['device_id'],
                    is_cloud: 0,
                    is_lanya: 1
                };
            } else if (_options['type'] == 'edit') {
                var tmp_list = $('.ydy-dialog').data('list') || {};
                tmp_data = {
                    id: tmp_list['id'],
                    device_name: lanya_name,
                    device_mc: lanya_id,
                    device_address: tmp_list['device_address'],
                    device_id: tmp_list['device_id'],
                    is_cloud: 0,
                    is_lanya: 1
                };
            }

            if (_options['type'] === 'add') {
                for (var i = 0; i < tmp_storage.length; i++) {
                    var checkArr = tmp_storage[i];

                    if (checkArr['device_name'] == tmp_data['device_name']) {
                        return fun.toast('名称已存在，请重新输入。');
                    }
                }
                tmp_storage.push(tmp_data);
            } else if (_options['type'] === 'edit') {
                if (_options['index'] !== null) {
                    tmp_storage[_options['index']] = tmp_data;

                    for (var i = 0; i < tmp_storage.length; i++) {
                        var checkArr = tmp_storage[i];

                        if (checkArr['id'] != tmp_data['id']) {
                            if (checkArr['device_name'] == tmp_data['device_name']) {
                                return fun.toast('名称已存在，请重新输入。');
                            }
                        }
                    }
                }
            }

            fun.setItem('printer_lanya', tmp_storage);
            fun.toast((_options['type'] == 'add' ? '添加' : '修改') + '成功。');

            if (_options['type'] == 'edit') {
                bluetoothHY.openBT({
                    'address': tmp_data['device_address']
                }, function (ret, err) {
                    if (ret && ret.status == 0) {
                    } else {
                    }
                });
            }

            getAllPrinterList();
            layer.closeAll();
        }
    });
}


//添加本地打印机
$('body').on('tap', '#add_btn', function (e) {
    e.stopPropagation();
    // if ($('.collapse-wrap').hasClass('open')) {
    //     $('.collapse-wrap').removeClass('open');
    // } else {
    //     $('.collapse-wrap').addClass('open');
    // }

    // bluetoothHY.isOpen(function(ret,err){
    //     if (ret && ret.status == true) {
    //         fun.toast('已连接')
    //     } else {
    //         fun.toast(err.msg || '未连接');
    //     }
    // });

    printerLocal();
});

//初始化蓝牙
function initBle() {
    ble.initManager(function (ret) {
        console.log(ret)
        switch (ret.state) {
            case 'poweredOn':
                bluetoothHY.closeBT(function (ret) {
                    if (ret && ret.status == true) {
                    } else {
                    }
                });

                scanDevices();
                break;
            case 'poweredOff':
                return fun.toast('请开启蓝牙');
                break;
            case 'unauthorized':
                return fun.toast('该设备未授权蓝牙');
                break;
            case 'unsupported':
                return fun.toast('该设备不支持蓝牙');
                break;
            case 'resetting':
                return fun.toast('蓝牙正在重置');
                break;
            default:
                return fun.toast('蓝牙连接失败');
                break;
        }
    });
}

//扫描蓝牙设备
function scanDevices() {
    // if ($.nui.isEmpty(lyList)) {

    bluetoothHY.startScan(function (ret, err) {
        console.log(ret)
        if (ret && ret.status == true) {
            fun.showLoad('扫描设备中...');

            setTimeout(function () {
                bluetoothHY.getBoundDevices(function (ret, err) {
                    if (ret) {
                        lyList = [];
                        lyList = ret['devices'].slice(0);

                        showBleList(ret['devices']);
                    } else {
                        return fun.toast('获取蓝牙设备失败');
                    }
                });
                fun.hideLoad();
            }, 6000);

        } else {
            fun.toast('开启失败！请检查是否开启蓝牙、APP定位权限及系统定位服务！');
        }
    });
    // } else {
    //     bluetoothHY.getBoundDevices(function (ret, err) {
    //         if (ret) {
    //             lyList = [];
    //             lyList = ret['devices'].slice(0);
    //
    //             showBleList(ret['devices']);
    //         } else {
    //             return fun.toast('获取蓝牙设备失败');
    //         }
    //     });
    // }
}


//显示蓝牙列表
function showBleList(list) {
    console.log(JSON.stringify(list));

    var lanyaList = [];
    var systemType = api.systemType;

    for (var i = 0; i < list.length; i++) {
        var val = list[i];
        console.log(val)
        if (val['name'] === 'Unknown') continue;

        var androidCon = true;

        if (systemType == "android") {
            androidCon = (val['bluetoothClass'] == 'IMAGING');
        } else {
            androidCon = true;
        }
        if (val['name'] && val['name'].indexOf('HM-A300') > -1 && androidCon) {
            lanyaList.push({
                id: val['address'],
                name: val['name'] || val['address']
            });
        }
    }

    if ($.nui.isEmpty(lanyaList)) {
        lyList = [];
        return fun.toast('附近没有可用的蓝牙打印机设备');
    }

    fun.showBookList({
        width: '280px',
        shadeClose: true,
        list: lanyaList,
        choose: function (res) {
            console.log(res);

            var tmpData = {};

            var tmp_storage = fun.getItem('printer_lanya') || [];
            var tmp_data = {
                id: $.nui.getRandomNum(),
                device_name: '',
                device_mc: res['name'],
                device_address: res['id'],
                device_id: res['id'],
                is_cloud: 0,
                is_lanya: 1
            };

            for (var i = 0; i < tmp_storage.length; i++) {
                var checkArr = tmp_storage[i];

                if (checkArr['device_mc'] == tmp_data['device_mc']) {
                    return fun.toast('该蓝牙打印机已存在。');
                }
            }

            fun.showLoad('连接中...');
            bluetoothHY.openBT({
                'address': res['id']
            }, function (ret, err) {
                if (ret && ret.status == 0) {
                    fun.toast('连接成功');
                    fun.hideLoad();
                    setTimeout(function () {
                        bleDialog({
                            type: 'add',
                            data: {
                                device_name: '',
                                device_mc: res['name'],
                                device_id: res['id'],
                                device_address: res['id']
                            }
                        });
                    }, 500);
                } else {
                    fun.toast("连接失败");
                    fun.hideLoad();
                }
            });
        }
    })
}


//添加蓝牙打印机
$('body').on('tap', '#lanya_btn', function (e) {
    e.stopPropagation();
    var _this = this;
    var location_times = $(_this).data('location_times') || 0;
    // var permissionList = [];
    // // 定位权限，蓝牙打印需要，安卓10
    // if (api.systemType === 'android'&& (parseFloat(api.systemVersion) >= 10)) {
    //     permissionList.push('location');
    // }
    // var resultList = [];
    // if($.nui.isTrue(permissionList)){
    //     // 先判断有没权限
    //     resultList = api.hasPermission({
    //         list: permissionList
    //     });
    // }

    // var requestArr = [];

    // for (var i = 0; i < resultList.length; i++) {
    //     if (!resultList[i].granted) {
    //         requestArr.push(resultList[i].name);
    //     }
    // }

    var requestArr = QuestPermission.hasPermission('location');

    // if ($.nui.isTrue(requestArr)) {
    //     api.confirm({
    //         title: '提醒',
    //         msg: '安卓版本10的手机，蓝牙打印需要获取定位的权限',
    //         buttons: ['去设置', '取消']
    //     }, function (ret, err) {
    //         var index = ret.buttonIndex;
    //         if (index == 1) {
    //             // 没有对应的权限就去请求
    //             api.requestPermission({
    //                 list: requestArr,
    //                 code: 1
    //             }, function (ret, err) {
    //                 initBle();
    //             });
    //         }
    //     });
    // } else {
    //     initBle();
    // }

    if (api.systemType === 'android'&& (parseFloat(api.systemVersion) >= 10) && location_times <= 2) {
        api.alert({
            title: '提醒',
            msg: '该功能需要开启APP定位权限及系统定位服务，用于提供准确的定位及蓝牙打印服务\r\n',
            buttons: ['我知道了']
        }, function (ret, err) {
            location_times++;
            $(_this).data('location_times', (location_times));
            initBle();
        });
    } else {
        initBle();
    }
});


//return fun.toast('名称已存在，请重新输入');
//return fun.toast('添加成功');

// $('body').on('tap', function (e) {
//     $('.collapse-wrap').removeClass('open');
// });
//
// $('body').on('tap', '.collapse-li', function (e) {
//     $('.collapse-wrap').removeClass('open');
// });


//云打印
// $('body').on('tap', '#print_cloud', function (e) {
//     // Show.printerCloud();
//     // printerCloud();
// });


//本地打印
// $('body').on('tap', '#print_local', function (e) {
//     // Show.printerLocal();
//     printerLocal();
// });

//删除本地打印
$('body').on('click', '.local-del', function (e) {
    e.stopPropagation();

    var $closeLi = $(this).closest('li');
    var row = $closeLi.data('list') || {};
    var __index = row['__index'];

    var tmp_storage = fun.getItem('printer_local') || [];

    fun.dialog({
        content: '你确定要删除【' + row['device_name'] + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            var sliceData = tmp_storage.splice(__index, 1);

            console.log(sliceData)

            if ($.nui.isEmpty(tmp_storage)) {
                fun.setPrintConfig('ip', '');
                fun.setPrintConfig('port', '');
                fun.clearItem('print_default_config');
            } else {
                if (sliceData[0]['is_default']) {
                    tmp_storage[0]['is_default'] = 1;
                    fun.setPrintConfig('ip', tmp_storage[0]['ip']);
                    fun.setPrintConfig('port', tmp_storage[0]['port']);
                    fun.setItem('print_default_config', tmp_storage[0]);
                }
            }

            fun.setItem('printer_local', tmp_storage);
            getAllPrinterList(function () {
                return fun.toast('删除成功！');
            });
        }
    });
});


//删除蓝牙打印
$('body').on('click', '.lanya-del', function (e) {
    e.stopPropagation();

    var $closeLi = $(this).closest('li');
    var row = $closeLi.data('list') || {};
    var __index = row['__index'];

    var tmp_storage = fun.getItem('printer_lanya') || [];

    fun.dialog({
        content: '你确定要删除【' + row['device_name'] + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            var sliceData = tmp_storage.splice(__index, 1);

            console.log(sliceData)

            fun.setItem('printer_lanya', tmp_storage);
            getAllPrinterList(function () {
                return fun.toast('删除成功！');
            });
        }
    });
});
