var _save_data = [];
var clickStatus = '';
var inputValue, inputChange;
var UIChatBox;

page_init = function () {
    $('#header').header({
        back: true,
        title: '常用术语',
        add: true,
        appendBackBtnEvt: isDataChange
    });
    UIChatBox = api.require('UIChatBox');   //聊天模块
    //安卓返回
    page_data.keyback = function () {
        isDataChange();
    };
    getData();
}

// 数据请求
function getData() {
    fun.ajax({
        type: 'get',
        showLoad: true,
        hideLoad: true,
        header: {
            "X-Requested-With": XMLHttpRequest
        },
        url: AJAX_URL.terms + '/?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        success: function (res) {
            _save_data = res;
            showData(res || []);
        }
    })
}

// 渲染数据
function showData(data) {
    var html = [];
    if (data.length === 0) {
        $('.cysy-add').show();
        $('.cysy-list').hide();
        html.push('<img src="../img/shop/cysy.png" class="cysy-img">');
        html.push('<p class="title-top">管理自己的常用术语</p>');
        html.push('<p class="color-gray title-bottom">跟客户一对一沟通时，减少重复输入</p>');
        html.push('<button type="button" class="font-ms theme-color cysy-button">添加常用术语</button>');
        html.push('<p class="color-gray font-ss title-bottom">可点击右上角 : + 进行快速添加</p>');
        $(".cysy-add").html(html.join(''));
    } else {
        $('.cysy-add').hide();
        $('.cysy-list').show();
        for (var i = 0; i < data.length; i++) {
            html.push('<li class="cysy-lst" data-index=' + i + ' data-list=\'' + JSON.stringify(data[i]) + '\'>');
            html.push('    <div class="le">');
            html.push('        <div class="cysy-box">');
            html.push('            <i class="iconfont icon-gengduo color-gray font-xls"></i>');
            html.push('            <span>' + transEmo(data[i].body) + '</span>');
            html.push('        </div>');
            html.push('        <div class="delete dels1 delete-btn">删除</div>');
            html.push('    </div>');
            html.push('</li>');
        }
        html.push('    <p class="font-ss color-gray cysy-lst-bottom">点击进行' + (page_data.type === 'chat' ? '返回' : '修改') + '、左滑进行删除、按住进行更换顺序</p>');
        $(".cysy-list").html(html.join(''));
        $('#cysy-bottom').css('height', api.safeArea.bottom + 'px');
        $('#content').css('margin-bottom', api.safeArea.bottom + 'px');
    }
}

// 添加
$('body').on('tap', '.cysy-button, #add_btn', function () {
    clickStatus = 'add';
    openUIChatBox();
});

// 记录行
var keyupNo = true;
var edit_index = 0;
$('body').on('tap', '.cysy-box', function () {
    var data = $(this).parents('.cysy-lst').data('list');
    var index = $(this).parents('.cysy-lst').data('index');
    if (page_data.type === 'chat') {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                data: data.content
            }
        });
        closeWin();
    } else {
        if (keyupNo == true) {
            openUIChatBox();
            UIChatBox.value({
                msg: data.content
            });
            UIChatBox.popupKeyboard();
            keyupNo = false;
        } else {
            UIChatBox.closeKeyboard();
            keyupNo = true;
        }
        clickStatus = 'edit';
        edit_index = index;
    }
});

// 删除
$('body').on('tap', '.delete-btn', function () {
    var data = $(this).parents('.cysy-lst').data('list');
    var __this = $(this).parents('.cysy-lst');
    fun.dialog({
        content: '您确定要删除当前术语吗？',
        yes: function () {
            fun.ajax({
                type: 'delete',
                showLoad: true,
                hideLoad: true,
                header: {
                    "X-Requested-With": XMLHttpRequest
                },
                url: AJAX_URL.terms + '/' + data.id +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
                success: function () {
                    getData();
                }
            })
        },
        success: function () {
            closeUIChatBox();
        }
    });
});

// 拖拽
var Sortable = new Sortable($('#content .cysy-list')[0], {
    delay: 220,
    animation: 150,
    draggable: '.cysy-lst',
    onEnd: function (evt) {
        if (evt.oldIndex != evt.newIndex) {
            var sorArr = [];
            for(var i = 0; i < $('.cysy-lst').length; i++){
                sorArr.push($('.cysy-lst').eq(i).data('list').id)
            }
            $.ajax({
                type: "PUT",
                header: {
                    "X-Requested-With": XMLHttpRequest
                },
                data: {
                    "ids": sorArr
                },
                url: AJAX_URL.newOrder + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
                success: function () {
                    getData();
                }
            })
        }
    }
});

//打开聊天面板
function openUIChatBox() {
    UIChatBox.open({
        autoFocus: true,
        emotionPath: 'widget://image/emotion',
        styles: {
            // 表情按钮  
            emotionBtn: {
                normalImg: 'widget://image/face1.png'
            },
            // 输入框
            indicator: {
                target: 'both',
                color: '#c4c4c4',
                activeColor: '#9e9e9e'
            },
            // 发送按钮
            sendBtn: {
                titleColor: '#fff',
                bg: 'rgb(16,181,246)',
                activeBg: '#46a91e',
                titleSize: 14
            }
        }
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'send') closeUIChatBox();
            // 发送消息    
            if ($.nui.isTrue(ret['msg'])) httpData(ret['msg']);
        } else {
            console.log(err)
        }
    });

    moveUIChatBox();
    valueChanged();
    heightChange();
}

function moveUIChatBox() {
    UIChatBox.addEventListener({
        target: 'inputBar',
        name: 'move'
    }, function (ret, err) {
        if (ret) {
            if ($.nui.isTrue(ret.panelHeight)) {
                if ($.nui.isTrue(_save_data)) {
                    if (api.systemType == 'ios') {
                        setTimeout(function () {
                            $('#ding').css('height', ret.panelHeight + ret.inputBarHeight);
                            var body_height = $('#content').outerHeight();
                            $('body').scrollTop(body_height);
                        }, 5)
                    }
                    if (api.systemType == 'android') {
                        $('#ding').css('height', ret.panelHeight + ret.inputBarHeight);
                        var body_height = $('#content').outerHeight();
                        $('body').scrollTop(body_height);
                    }
                }
            } else {
                if ($.nui.isTrue(ret.inputBarHeight)) {
                    $('#ding').css('height', ret.inputBarHeight);
                } else {
                    closeUIChatBox()
                }
            }
        } else {
            console.log(err)
        }
    });
}

// 监听输入框值是否改变
function valueChanged() {
    UIChatBox.addEventListener({
        target: 'inputBar',
        name: 'valueChanged'
    }, function (ret, err) {
        if ($.nui.isTrue(ret)) {
            if ($.nui.isTrue(ret.value)) {
                inputChange = true;
                inputValue = ret.value;
            } else {
                inputChange = false;
            }
        } else {
            console.log(err)
        }
    })
}

// 监听输入框高度变化
function heightChange() {
    UIChatBox.addEventListener({
        target: 'inputBar',
        name: 'change'
    }, function (ret, err) {
        setTimeout(function () {
            if (ret) {
                $('#ding').css('height', ret.inputBarHeight);
                var body_height = $('#content').outerHeight();
                $('body').scrollTop(body_height);
            } else {
                console.log(err)
            }
        }, 0)
    })
}

// 关闭聊天面板
function closeUIChatBox() {
    $('#ding').css('height', '0');
    UIChatBox.closeKeyboard();
    UIChatBox.close();
}

function closeWin() {
    setTimeout(function(){
        api.closeWin();
    },200)
}

function httpData(value,index) {
    if (clickStatus == 'add') {
        $.ajax({
            type: "POST",
            header: {
                "X-Requested-With": XMLHttpRequest
            },
            url: AJAX_URL.terms + '/?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
            data:{
                "body": value.replace(/\s*/g, "")
            },
            success: function () {
                getData();
            }
        })
    }
    if (clickStatus == 'edit') {
        var _data = $('.cysy-lst').eq(edit_index).data('list');
        var _id = _data.id;
        $.ajax({
            type: "PUT",
            header: {
                "X-Requested-With": XMLHttpRequest
            },
            url: AJAX_URL.terms + '/'+ _id +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
            data:{
                "body": value.replace(/\s*/g, "")
            },
            success: function () {
                getData();
            }
        })
    }
}

//文字表情转换
function transEmo(emoMsg) {
    var emoPath, transMsg;
    var reg = /\[(.*?)\]/gm;
    transMsg = emoMsg.replace(reg, function (match) {
        for (var i = 0, len = emoData.length; i < len; i++) {
            if (emoData[i].text === match) {
                emoPath = '../image/emotion/' + emoData[i].name + '.png';
                return '<img width="20" height="20" src="' + emoPath + '" />'
            }
        }
        return match;
    });
    return transMsg;
}

// 监听返回
function isDataChange() {
    console.log(edit_index)
    if ($.nui.isTrue(_save_data) && _save_data[edit_index].content !== inputValue && inputChange === true) {
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            yes: function () {
                if ($.nui.isTrue(inputValue)) {
                    httpData(inputValue);
                    closeWin();
                }
            },
            success: function () {
                closeUIChatBox();
                inputChange = false;
            },
            no: function () {
                closeWin();
            }
        });
    } else {
        closeWin();
    }
}