var html_name = page_arr['shop_dp_fkfx']; // 访客分析
var interval = 0; // echarts X轴显示间隔
var axisX = []; // echarts X轴显示范围
var echartShowData = []; // echart显示数据
var pageList = []; // 分页渲染列表数据
var reset = {}; // 重置按钮传参数据
var last = {
    date: $('.btn_click').length - 1 // 限制切换同一个tab造成的再次请求
}

// 搜索的数据
var search_data = { // 获取本月第一天和最后一天
    begin_time: fun.Date(fun.getMonthArr(1)[0]['begin_date']).Format('yy-mm-dd'),
    end_time: fun.Date(fun.getMonthArr(1)[0]['end_date']).Format('yy-mm-dd'),
    groudType: 'date', // 默认是按天进行查询
    fans: { // 粉丝搜索数据
        id: '', // 粉丝id
        name: '' // 粉丝名称
    }
};

// 访客合计
var total = {
    member_count: 0, // 访客人数
    visit_count: 0 // 访问次数
}

// 页面整体初始化函数
page_init = function () {
    console.log(html_name);
    console.log(page_data);
    $('#header').header({ // 头部初始化
        back: true,
        filter: true,
        title: '访客分析'
    });

    // 该页面筛选按钮是否可以打开
    fun.setItem(html_name + 'sideslip', true);

    // 事件监听
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        fun.showLoad();
        var temp = ret['value'];
        console.log('监听');
        console.log(temp);
        switch (temp['status']) {
            case 'search': // 监听搜索页
                search(temp, 'search');
                break;
            case 'reset': // 监听重置按钮
                search(temp, 'reset');
                break;
        }
    });

    init(); // 页面初始化
    bindEvent(); // 事件初始化
    fun.scrollToBottom({}, function () { // 滚动底部分页渲染
        if ($('#origin_list').children('.empty-tips-wrap').length) return;
        if ($.nui.isTrue(pageList)) {
            fun.showLoad();
            showOriData(fun.PagingData(pageList, 10) || []);
            setTimeout(function () {
                fun.hideLoad();
            }, 200);
        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
            var rangeList = parseFloat($('.content').css('marginTop')) + ($('.content').outerHeight() - $('#origin_list').outerHeight());
            var listHeight = $(window).height() - rangeList;
            if ($('#origin_list').outerHeight() >= listHeight) {
                fun.createBottomLine('origin_list', '.origin-list');
                $('.empty_bottom').show();
                return;
            }
        }
    });
}

// 搜索处理
function search(temp, type) {
    interval = 0;
    axisX = [];
    echartShowData = [];
    var date = {
        begin_time: temp['data']['begin_date'],
        end_time: temp['data']['end_date']
    }
    fun.setItem(html_name + 'sideslip', true); // 筛选按钮,是否可以打开

    if ($.nui.isTrue(fun.statisticTime(date))) return fun.hideLoad();
    fun.searchRange('.btn_click', date, last);

    if (type === 'reset') {
        search_data['fans']['id'] = '';
        search_data['fans']['name'] = '';
    } else {
        search_data['fans']['id'] = ''; // 粉丝id
        search_data['fans']['text'] = ''; // 粉丝名称
    }

    search_data['begin_time'] = temp['data']['begin_date']; // 起始时间
    search_data['end_time'] = temp['data']['end_date']; // 结束时间
    $('#begin_date').text(fun.dateFormat('yyyy.MM.dd', search_data['begin_time'])); // 起始时间
    $('#end_date').text(fun.dateFormat('yyyy.MM.dd', search_data['end_time'])); // 结束时间
    restrictRanking(); // 根据过滤条件显示数据来源
    getList(); // 根据搜索条件查询数据
}

// 根据过滤条件  粉丝 不为空，则隐藏：数据来源的 排行和 右箭头。
function restrictRanking() {
    if ($.nui.isTrue(search_data['fans']['name'])) {
        $('#ranking').hide();
    } else {
        $('#ranking').show();
    }
}

// 页面初始化
function init() {
    fun.showLoad();
    $('#begin_date').text(fun.getLatelyTime(30, false)['begin_date']); // 起始时间
    $('#end_date').text(fun.getLatelyTime(30, false)['end_date']); // 结束时间
    search_data['begin_time'] = fun.getLatelyTime(30, true)['begin_date'];
    search_data['end_time'] = fun.getLatelyTime(30, true)['end_date'];
    reset = { // 重置日期
        begin_date: fun.getLatelyTime(30, true)['begin_date'],
        end_date: fun.getLatelyTime(30, true)['end_date']
    }
    restrictRanking(); // 根据过滤条件显示数据来源
    getList(); // 初始化渲染数据
}

// 初始化echart图数据
function echartsDataInit(data) {
    var mark = data.every(function (item, idx) {
        return item === 0;
    })

    if (mark) {
        for (var i = 0; i < data.length; i++) {
            data[i] = '';
        }
    }
}

// 获取数据列表
function getList() {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getVisitorFxList, // 获取访客分析
        data: {
            start_date: search_data['begin_time'],
            end_date: search_data['end_time'],
            groud: {
                create_time: search_data['groudType'], // 按什么方式给数据
            },
            member_id: search_data['fans']['id'] || '',
        },
        success: function (res) {
            if (res['status'] === 0) {
                var data = res['data'];
                pageList = [];
                pageList = data['visitor_rank_list'];
                // 渲染数据
                $(data['date_list']).each(function (idx, item) {
                    echartShowData[idx] = item['count'];
                })
                showHeaderTotal(data); // 头部合计显示
                resetData(pageList); // 默认降序显示数据
                showData(fun.PagingData(pageList || []));
            }
        }
    })
}

// 头部合计
function showHeaderTotal(data) {
    if ($.nui.isTrue(data['info'])) {
        total['member_count'] = data['info']['member_count'];
        total['visit_count'] = data['info']['visit_count'];
    } else {
        total['member_count'] = 0;
        total['visit_count'] = 0;
    }

    // 渲染数据
    $('#member_count').text(total['member_count']); // 人数
    $('#visit_count').text(total['visit_count']); // 次数
}

// 显示页面数据
function showData(data) {
    $('#origin_list').html('');
    echartsDataInit(echartShowData); // 初始化echart图数据
    fun.statisticTime(search_data); // 访客分析数据初始化
    fun.showGraphic(); // 渲染echarts图
    showOriData(data); // 渲染数据来源
    $('.now-time-list:first').show();
}

// 重置数据
function resetData(data) {
    data.sort(function (a, b) {
        return fun.getTimeStamp(b['create_time']) - fun.getTimeStamp(a['create_time']);
    })
    for (var i = 0; i < data.length; i++) {
        var item = data[i];
        if ($.nui.isTrue(item['visitor_list'])) {
            item['visitor_list'].sort(function (x, y) {
                return y['count'] - x['count'];
            })
        } else {
            continue;
        }
    }
}

// 渲染数据来源
function showOriData(data) {
    if ($.nui.isTrue(data)) {
        var html = [];
        $(data).each(function (idx, item) {
            if (!item.cs_count && !item.rs_count) return true; // 人数和参观次数都为0，则不显示该记录行
            var arrowDirectionClass = 'icon-xia';
            var mark = true;
            if (idx === 0) { // 首条列表项展开，箭头为上，其它初始默认合拢状态，箭头为下
                arrowDirectionClass = 'arrow-down icon-xia';
            } else {
                mark = false;
            }
            var groupTime;
            html.push('<div class="origin-item over-hide">');
            html.push('     <p class="data_hang font-ss color-gray rank-title analyze-line-height" data-mark="' + mark + '">');
            switch (search_data['groudType']) {
                case 'date': // 按天汇总
                    groupTime = fun.dateFormat('yyyy-MM-dd', item['create_time']);
                    break;
                case 'month': // 按月汇总
                    groupTime = fun.dateFormat('yyyy-MM', item['create_time']);
                    break;
                // 没有default
            }
            html.push('        <span>' + groupTime + '</span>');
            html.push('        <span class="gong">共 ：' + (item['rs_count'] || 0) + '人，' + (item['cs_count'] || 0) + '次</span>');
            html.push('         <i class="iconfont arrow-mark float-right ' + arrowDirectionClass + '"></i>');

            html.push('     </p>');
            html.push('     <div class="now-time-list">');
            if ($.nui.isTrue(item['visitor_list'])) {
                $(item['visitor_list']).each(function (index, items) {
                    var rowsTime;
                    var name = items['nickname']; // 显示微信昵称

                    switch (search_data['groudType']) {
                        case 'date': // 按天汇总
                            rowsTime = fun.formatDate(fun.Date(items['create_time'], true), 'HH:mm');
                            break;
                        case 'month': // 按月汇总
                            rowsTime = fun.getRowTime(fun.formatDate(fun.Date(items['create_time'], true), 'MM月DD号'));
                            break;
                    }

                    if ($.nui.isTrue(items['kh_lxr'])) {
                        if ($.nui.isTrue(items['kh_mc'])) {
                            name = items['kh_mc'] + ' @ ' + items['kh_lxr'];
                        } else if ($.nui.isEmpty(items['kh_lxr'])) {
                            name = items['kh_mc'];
                        }
                    }
                    html.push('        <div class="main clear-space">');
                    if ($.nui.isTrue(items['avatar_url'])) {
                        var imgUrl = '';
                        if (/http/.test(items['avatar_url'])) { // 完整路径
                            imgUrl = items['avatar_url'];
                        } else {
                            imgUrl = IMG_PATH + 'shop/' + items['avatar_url'];
                        }
                        html.push('            <img class="circle over-hide vertical-middle" src="' + imgUrl + '">');
                    } else {
                        html.push('            <img class="circle over-hide vertical-middle transparent" src="">');
                    }
                    html.push('             <div class="right-container clear-space">')
                    html.push('                 <span class="wechat font-ls text-overflow vertical-middle analyze-line-height">' + fun.is_value(name) + '</span>');
                    html.push('                 <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right">' + (items['count'] || 0) + '次</span>');
                    html.push('                 <span class="font-ms color-gray text-overflow vertical-middle analyze-line-height data-time yby-right">' + rowsTime + '</span>');
                    html.push('             </div>');
                    html.push('        </div>');
                })
            }
            html.push('    </div>');
            html.push('</div>');
        })
        $('#origin_list').append(html.join(''));
    }

    if (!$('#origin_list').children().length) { // 列表数据为空
        $('#origin_list').addClass('empty-wrap');
        fun.createDataEmptyTips({ dom: '#origin_list', btnShow: false });
    }
    fun.hideLoad();
}

// console.log($('#origin_list').html());
// console.log($('#origin_list').html());

// 初始化事件
function bindEvent() {
    // 跳转到访客分析排行页面 
    $('body').on('tap', '.data_origin', function () {
        if ($.nui.isTrue(search_data['fans']['name'])) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.dp_fkfxph,
            pageParam: {
                begin_time: search_data['begin_time'],
                end_time: search_data['end_time'],
                total: total,
                type: 'fkfxph',
                rankType: 'fk'
            }
        });
        fun.hideLoad();
    })

    // 打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        axisX = [];
        echartShowData = [];
        var sideslip = fun.getItem(html_name + 'sideslip'); // 搜索页是否可以打开
        var options = {
            time: {
                begin_date: search_data['begin_time'], // 起始时间
                end_date: search_data['end_time'], // 结束时间
                text: {
                    begin_text: '开始日期',
                    end_text: '结束日期'
                }
            },
            choose_merchants: [
                {
                    key: "fans", // key值
                    text: "粉丝",
                    value: search_data['fans']['name'] || '', // 粉丝名称
                    id: (search_data && search_data['fans']['id'] ? search_data['fans']['id'] : '') // 门店id
                }
            ]
        };
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    return_page: html_name,
                    search_data: options,
                    reset: reset,
                    is_restbutton: true,
                    type: 'shop_dp_fkfx'
                },
            });
        }
    })

    // 日期切换
    $('body').on('tap', '.btn_click', fun.debounce(function () {
        if (last['date'] === $(this).index()) return;
        last['date'] = $(this).index();
        axisX = [];
        echartShowData = [];
        $(this).addClass('main-color').siblings().removeClass('main-color');
        var selTime = $(this).data('time');
        var tempObj = null;
        fun.showLoad();
        switch (selTime) {
            case 'this_year': // 本年
                tempObj = fun.getYearArr(1)[0];
                break;
            case 'last_month': // 上月
                tempObj = fun.getLastMonth();
                break;
            case 'this_month': // 本月
                tempObj = fun.getMonthArr(1)[0];
                break;
            case 'lately_seven': // 近7天
                tempObj = fun.getLatelyTime(7, false);
                break;
            case 'lately_fifteen': // 近15天
                tempObj = fun.getLatelyTime(15, false);
                break;
            case 'lately_thirty': // 近30天
                tempObj = fun.getLatelyTime(30, false);
                break;
        }

        $('#begin_date').text(tempObj['begin_date']);
        $('#end_date').text(tempObj['end_date']);

        search_data['begin_time'] = fun.Date(tempObj['begin_date']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(tempObj['end_date']).Format('yy-mm-dd');

        fun.statisticTime(search_data);
        getList();
    }, 350))

    // 收缩功能
    $('body').on('tap', '.rank-title', function () {
        if ($.nui.isEmpty($(this).siblings().children().length)) return;
        $(this).siblings().stop().slideToggle(500);
        var $arrow = $(this).find('.icon-xia');
        var mark = $(this).data('mark');
        if (mark) { // 当前展开效果
            console.log(mark);
            $arrow.removeClass('rotate-arrow-up');
            $arrow.addClass('rotate-arrow-down');
        } else { // 当前收起效果
            $arrow.addClass('rotate-arrow-up');
        }
        $(this).data('mark', !mark);
    })

}




// console.log($('#origin_list').html());