var html_name = page_arr['dp_fkfxph']; // 页面名称 
var pageList = [];

var showDataArr = {
    fkFxPhData: [], // 访客分析排行数据
    nyJlPhData: [] // 拿样记录排行数据
}

page_init = function () {
    var title = '';
    switch (page_data['rankType']) {
        case 'fk':
            title = '访客分析'
            break;
        case 'jy':
            title = '剪样排行'
            break;
        case 'sk':
            title = '色卡排行'
            break;
        // 没有default
    }
    $('#header').header({
        back: true,
        title: title,
        appendBackBtnEvt: closePage
    });

    init();
    bindEvent();

    fun.scrollToBottom({}, function () { // 滚动底部分页渲染
        if (pageList.length > 0) {
            fun.showLoad();
            showOriData(fun.PagingData(pageList, 10) || []);
            setTimeout(function () {
                fun.hideLoad();
            }, 200);

        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
            var listHeight = $(window).height() - (parseFloat($('.total').css('marginTop')) + $('.total').outerHeight() + $('.date').outerHeight() + $('.rank-desc').outerHeight());
            var listH = $('#rank_list').outerHeight();
            if (listH >= listHeight) { // 超出区域
                fun.createBottomLine('rank_list', ".content");
                $('.empty_bottom').show();
                return;
            }
        }
    });
}

// 关闭当前页面
function closePage() {
    setTimeout(function () {
        api.closeWin();
    }, 500);
}

function init() {
    if (page_data['rankType'] === 'jy' || page_data['rankType'] === 'sk') {
        $('.sort-text').css({
            width: 'calc(100% - 2.5rem)',
            textAlign: 'right'
        })
        $('.sort-btn').css({
            marginLeft: '0.5rem'
        })
    }
    getList();
}

// 设置显示数据默认访问（次）降序排序
function descendOrder(showDataArr, bool) {
    if (bool) { // 升序
        switch (page_data['type']) {
            case 'nyjlph': // 拿样记录排行
                showDataArr.sort(function (a, b) {
                    return a['zsl'] - b['zsl'];
                });
                break;
            case 'fkfxph': // 访客分析排行
                showDataArr.sort(function (a, b) {
                    return a['count'] - b['count'];
                });
                break;
            // 没有default
        }
    } else { // 降序
        switch (page_data['type']) {
            case 'nyjlph': // 拿样记录排行
                showDataArr.sort(function (a, b) {
                    return b['zsl'] - a['zsl'];
                });
                break;
            case 'fkfxph': // 访客分析排行
                showDataArr.sort(function (a, b) {
                    return b['count'] - a['count'];
                });
                break;
        }
    }
    console.log(showDataArr);
}

// 拿到请求数据
function getList() {
    showHeaderTotal(); // 头部合计显示
    switch (page_data['type']) {
        case 'fkfxph': // 访客分析排行
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.getVisitorRankList,
                data: {
                    begin_time: page_data['begin_time'],
                    end_time: page_data['end_time'],
                    number: 20,
                    num_asc: 0,
                },
                success: function (res) {
                    console.log(res);
                    if (res['status'] === 0) {
                        var data = res['data'];
                        if ($.nui.isEmpty(data)) return;
                        showDataArr['fkFxPhData'] = data.slice(0);
                        pageList = data.slice(0);
                        descendOrder(pageList, false);
                        showData(fun.PagingData(pageList || [])); // 渲染数据
                    } else {
                        console.log(res);
                    }
                }
            })
            break;
        case 'nyjlph': // 拿样记录排行
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.getNyPh,
                data: {
                    type: page_data['rankType'], // 色卡还是剪样排行
                    // jg_lx_mc: page_data['rankType'], // 色卡还是剪样排行
                    begin_time: page_data['begin_time'],
                    end_time: page_data['end_time'],
                    number: 20,
                    num_asc: 0, // 默认降序显示
                },
                success: function (res) {
                    if (res['status'] === 0) {
                        var data = res['data'];
                        if ($.nui.isEmpty(data)) return;
                        showDataArr['nyJlPhData'] = data.slice(0);
                        pageList = data.slice(0);
                        descendOrder(pageList, false);
                        showData(fun.PagingData(pageList || []));
                    } else {
                        console.log(res);
                    }
                }
            })
            break;
        // 没有default
    }
}

// 头部合计显示
function showHeaderTotal() {
    var tempObj = {
        rankTitleLeft: '',
        rankTitleRight: '',
        title_left_count: '',
        title_right_count: '',
        rank_mc: '',
        rank_count: ''
    }
    switch (page_data['type']) {
        case 'nyjlph': // 拿样记录排行
            tempObj['rankTitleLeft'] = '产品';
            tempObj['rankTitleRight'] = '数量';
            tempObj['rank_mc'] = '产品';
            tempObj['rank_count'] = '数量';
            tempObj['title_left_count'] = page_data['total']['cp_zsl'] || 0; // 统计合计（暂没接口）
            tempObj['title_right_count'] = page_data['total']['zsl'] || 0; // 统计合计（暂没接口）
            break;
        case 'fkfxph': // 访客分析排行
            tempObj['rankTitleLeft'] = '人数';
            tempObj['rankTitleRight'] = '次数';
            tempObj['rank_mc'] = '粉丝';
            tempObj['rank_count'] = '访问 (次) ';
            tempObj['title_left_count'] = page_data['total']['member_count'] || 0;
            tempObj['title_right_count'] = page_data['total']['visit_count'] || 0;
            break;
        // 没有default
    }
    $('.rank-title-left').text(tempObj['rankTitleLeft']);
    $('.rank-title-total').text(tempObj['rankTitleRight']);
    $('#title_left_count').text(tempObj['title_left_count']);
    $('#title_right_count').text(tempObj['title_right_count']);
    $('#rank_mc').text(tempObj['rank_mc']);
    $('#rank_count').text(tempObj['rank_count']);
    $('.date').text(page_data['begin_time'] + ' ~ ' + page_data['end_time']);
}

function showData(data) {
    if ($.nui.isTrue(data)) {
        var html = [];
        $(data).each(function (idx, item) {
            console.log(item);
            html.push('<li class="clear-space rank-line-height yby-left">');
            switch (idx) {
                case 0:
                    html.push('		<div class="clear-space content-width-27 yby-center ranking">');
                    html.push('			<img src="../img/jp.png" class="vertical-middle" style="height:1rem;">');
                    html.push('		</div>');
                    break;
                case 1:
                    html.push('		<div class="clear-space content-width-27 yby-center ranking">');
                    html.push('			<img src="../img/yp.png" class="vertical-middle" style="height:1rem;">');
                    html.push('		</div>');
                    break;
                case 2:
                    html.push('		<div class="clear-space content-width-27 yby-center ranking">');
                    html.push('			<img src="../img/tp.png" class="vertical-middle" style="height:1rem;">');
                    html.push('		</div>');
                    break;
                default:
                    html.push('<div class="font-ls content-width-27 yby-center ranking">' + (idx + 1) + '</div>');
            }

            switch (page_data['type']) {
                case 'nyjlph': // 拿样记录排行
                    var name = item['cp_mc'] ? item['cp_bh'] + ' ' + item['cp_mc'] : item['cp_bh'];
                    var count = item['zsl'] < 10 ? '&nbsp;' + item['zsl'] : item['zsl']; // 总数量
                    if ($.nui.isTrue(item['cp_tp'])) { // 有产品主图
                        var imgSrc = '';
                        if (/http/.test(item['cp_tp'])) {
                            imgSrc = item['cp_tp'];
                        } else {
                            imgSrc = fun.getImgPath(item['cp_tp']);
                        }
                        html.push('<div class="show-mark">');
                        html.push('     <img src="' + imgSrc + '" class="vertical-middle wechat-portrait normal show-mark-img">');
                        html.push('     <img src="../img/mask.png" alt="" class="show-decorate-img">');
                        html.push('</div>');
                    } else if ($.nui.isEmpty(item['cp_tp'])) { // 没有产品主图
                        html.push('<div class="show-logo">');
                        html.push('    <img src="../img/logo.png" class="vertical-middle wechat-portrait normal null-img-logo">');
                        html.push('</div>');
                    }
                    html.push('		<span class="vertical-middle font-ls nick-name text-overflow">' + name + '</span>');
                    html.push('		<span class="total-num font-ls count-txt text-overflow">' + count + '</span>');
                    html.push('</li>');
                    break;
                case 'fkfxph': // 访客分析排行
                    var count = item['count'] < 10 ? '&nbsp;' + item['count'] : item['count']; // 访问次数
                    var name = item['fan_info']['nickname']; // 显示微信昵称
                    if ($.nui.isTrue(item['fan_info']['kh_lxr'])) {
                        if ($.nui.isTrue(item['fan_info']['kh_mc'])) {
                            name = item['fan_info']['kh_mc'] + ' @ ' + item['fan_info']['kh_lxr'];
                        } else if ($.nui.isEmpty(item['fan_info']['kh_lxr'])) {
                            name = item['fan_info']['kh_mc'];
                        }
                    }
                    if ($.nui.isTrue(item['fan_info']['avatar_url'])) {
                        var imgSrc = '';
                        if (/http/.test(item['fan_info']['avatar_url'])) {
                            imgSrc = tem['fan_info']['avatar_url'];
                        } else {
                            imgSrc = IMG_PATH + 'shop/' + item['fan_info']['avatar_url'];
                        }
                        html.push('			<img src="' + imgSrc + '" class="vertical-middle wechat-portrait">');
                    } else if ($.nui.isEmpty(item['fan_info']['avatar_url'])) {
                        html.push('			<img src="" class="vertical-middle wechat-portrait">');
                    }
                    html.push('		<span class="vertical-middle font-ls nick-name text-overflow" style="width:33%">' + ($.nui.isTrue(name) ? name : '') + '</span>');
                    html.push('		<span class="total-num font-ls count-txt text-overflow">' + count + '</span>');
                    html.push('</li>');
                    break;
                // 没有default
            }
        })
        $('.content').append(html.join(''));
    }

    setTimeout(function () {
        fun.hideLoad();
    }, 200)
}

// 排序处理
function handleUp() {
    $('#below').removeClass('sort-color-gray');
    $('#up').addClass('sort-color-gray');
    $(this).data('type', 'below');
}

// 排序处理
function handleDown() {
    $('#up').removeClass('sort-color-gray');
    $('#below').addClass('sort-color-gray');
    $(this).data('type', 'up');
}

// console.log($('.content').html());

// 绑定事件
function bindEvent() {
    // 点击排序
    $('body').on('tap', '.sort-btn-wrap', function () {
        fun.showLoad();
        if (page_data['type'] === 'nyjlph') {
            if ($.nui.isEmpty(showDataArr['nyJlPhData'])) fun.hideLoad();
        } else if (page_data['type'] === 'fkfxph') {
            if ($.nui.isEmpty(showDataArr['fkFxPhData'])) fun.hideLoad();
        }

        var type = $(this).data('type'); // 点击升序还是降序
        var name = '';
        $(".content li").not(':first').remove();
        if (type === 'up') {
            handleUp.call(this);
            switch (page_data['type']) {
                case 'nyjlph':
                    name = 'nyJlPhData';
                    break;
                case 'fkfxph':
                    name = 'fkFxPhData';
                    break;
                // 没有default
            }
            descendOrder(showDataArr[name], false);
        } else {
            handleDown.call(this);
            switch (page_data['type']) {
                case 'nyjlph':
                    name = 'nyJlPhData';
                    break;
                case 'fkfxph':
                    name = 'fkFxPhData';
                    break;
                // 没有default
            }
            descendOrder(showDataArr[name], true);
        }
        showData(showDataArr[name]);
    })
}