var html_name = page_arr['shop_dp_nyjl']; // 拿样记录
var interval = 0; // echarts X轴显示间隔
var axisX = []; // echarts X轴显示范围
var echartShowData = []; // echart显示数据
var pageList = []; // 分页渲染列表数据
var reset = {}; // 重置按钮传参数据
var last = { // 限制切换同一个tab造成的再次请求
    tab: 0,
    date: $('.btn_click').length - 1
}
// 搜索的数据
var search_data = {
    begin_time: fun.Date(fun.getMonthArr(1)[0]['begin_date']).Format('yy-mm-dd'),
    end_time: fun.Date(fun.getMonthArr(1)[0]['end_date']).Format('yy-mm-dd'),
    rankType: 'sk', // 排行类型
    groudType: 'date',
    cp: { // 产品搜索页面 
        id: '',
        text: ''
    }
};

// 访客合计
var total = {
    cp_zsl: 0, // 产品个数
    zsl: 0 // 产品数量
}

page_init = function () {
    console.log(html_name);
    console.log(page_data);

    $('#header').header({ // 头部初始化
        back: true,
        filter: true,
        title: '拿样记录'
    });

    // 该页面筛选按钮是否可以打开
    fun.setItem(html_name + 'sideslip', true);

    // 事件监听
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'search': // 监听搜索页
                search(temp, 'search');
                break;
            case 'reset': // 监听搜索页
                search(temp, 'reset');
                break;
        }
    });

    init(); // 页面初始化
    bindEvent(); // 事件初始化
    fun.scrollToBottom({}, function () { // 滚动底部分页渲染
        if ($('#origin_list').children('.empty-tips-wrap').length) return;
        if ($.nui.isTrue(pageList)) {
            fun.showLoad();
            showOriData(fun.PagingData(pageList, 10) || []);
            setTimeout(function () {
                fun.hideLoad();
            }, 200);
        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
            var rangeList = parseFloat($('.content').css('marginTop')) + ($('.content').outerHeight() - $('#origin_list').outerHeight());
            var listHeight = $(window).height() - rangeList;
            if ($('#origin_list').outerHeight() >= listHeight) {
                fun.createBottomLine('origin_list', '.origin-list');
                $('.empty_bottom').show();
                return;
            }
        }
    });
}

// 搜索处理
function search(temp, type) {
    interval = 0;
    axisX = [];
    echartShowData = [];
    var date = {
        begin_time: temp['data']['begin_date'],
        end_time: temp['data']['end_date']
    }
    fun.setItem(html_name + 'sideslip', true); // 筛选按钮,是否可以打开

    if ($.nui.isTrue(fun.statisticTime(date))) return;
    fun.searchRange('.btn_click', date, last);

    if (type === 'reset') {
        search_data['cp']['id'] = '';
        search_data['cp']['text'] = '';
    } else {
        search_data['cp'] = temp['data']['cp'];
    }

    search_data['begin_time'] = temp['data']['begin_date'];
    search_data['end_time'] = temp['data']['end_date'];

    $('#begin_date').text(fun.dateFormat('yyyy.MM.dd', search_data['begin_time'])); // 起始时间
    $('#end_date').text(fun.dateFormat('yyyy.MM.dd', search_data['end_time'])); // 结束时间

    restrictRanking(); // 根据过滤条件显示数据来源
    getList(); // 根据搜索条件查询数据
}

// 获取数据列表
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNyjlInfo,
        data: {
            cp_id: Number(search_data['cp']['id']),
            begin_time: search_data['begin_time'],
            end_time: search_data['end_time'],
            type: search_data['rankType']
        },
        success: function (res) {
            console.log('拿样记录数据');
            console.log(res);
            if (res['status'] === 0) { // 请求成功
                var list = res['list'];
                pageList = [];
                pageList = res['info_list'];
                switch (search_data['rankType']) {
                    case 'sk': // 色卡
                        $(list).each(function (idx, item) {
                            echartShowData[idx] = item['sl'];
                        })
                        break;
                    case 'jy': // 剪样
                        $(list).each(function (idx, item) {
                            echartShowData[idx] = item['sl'];
                        })
                        break;
                    // 没有default:
                }
                showHeaderTotal(res); // 头部合计显示
                resetData(pageList); // 默认降序显示数据
                showData(fun.PagingData(pageList || [])); // 渲染数据
            }
        }
    })
}

// 页面初始化
function init() {
    $('#begin_date').text(fun.getLatelyTime(30, false)['begin_date']); // 起始时间
    $('#end_date').text(fun.getLatelyTime(30, false)['end_date']); // 结束时间
    search_data['begin_time'] = fun.getLatelyTime(30, true)['begin_date'];
    search_data['end_time'] = fun.getLatelyTime(30, true)['end_date'];
    reset = { // 重置日期
        begin_date: fun.getLatelyTime(30, true)['begin_date'],
        end_date: fun.getLatelyTime(30, true)['end_date']
    }
    restrictRanking(); // 根据过滤条件显示数据来源
    getList(); // 初始化渲染数据
}

// 获取产品搜索数据
function getTwo(key, son, def) {
    def = def || "";
    return (search_data[key] && search_data[key][son]) || def;
}

// 如果过滤条件产品不为空，则隐藏数据来源的 排行和 右箭头。
function restrictRanking() {
    if ($.nui.isTrue(search_data['cp']['text'])) {
        $('#ranking').hide();
    } else {
        $('#ranking').show();
    }
}

// 头部合计
function showHeaderTotal(data) {
    if ($.nui.isTrue(data['hj'])) {
        // 合计显示
        total['cp_zsl'] = data['hj']['cp_zsl'];
        total['zsl'] = data['hj']['zsl'];
    } else {
        total['cp_zsl'] = 0;
        total['zsl'] = 0;
    }

    // 渲染数据
    $('#product_count').text(total['cp_zsl']); // 产品总数量
    $('#count').text(total['zsl']); // 总数量
}

// 显示页面数据
function showData(data) {
    $('#origin_list').html('');
    echartsDataInit(echartShowData); // 初始化echart图数据
    fun.statisticTime(search_data);
    fun.showGraphic(); // 渲染echarts图
    showOriData(data); // 渲染数据来源
    $('.now-time-list:first').show();
}

// 初始化echart图数据
function echartsDataInit(data) {
    var mark = data.every(function (item, idx) {
        return item === 0;
    })

    if (mark) {
        for (var i = 0; i < data.length; i++) {
            data[i] = '';
        }
    }
}

// 重置数据
function resetData(data) {
    data.sort(function (a, b) {
        return fun.getTimeStamp(b['sj']) - fun.getTimeStamp(a['sj']);
    })
    for (var i = 0; i < data.length; i++) {
        var item = data[i];
        if ($.nui.isTrue(item['mx'])) {
            item['mx'].sort(function (x, y) {
                return y['zsl'] - x['zsl'];
            })
        } else {
            continue;
        }
    }
}

// echart图tab选项
function tabSwitch() {
    $(this).addClass('active').siblings().removeClass('active');
}

// 渲染数据来源
function showOriData(data) {
    if ($.nui.isTrue(data)) {
        var html = [];
        $(data).each(function (idx, item) {
            if (!item['cp_count'] && !item['sl_count']) return true; // 产品和数量都为0，不显示该记录行
            var arrowDirectionClass = 'icon-xia';
            var mark = true;
            if (idx === 0) { // 首条列表项展开，箭头为上，其它初始默认合拢状态，箭头为下
                arrowDirectionClass = 'arrow-down icon-xia';
            } else {
                mark = false;
            }
            html.push('<div class="origin-item over-hide">');
            html.push('     <p class="data_hang font-ss color-gray rank-title analyze-line-height" data-mark="' + mark + '">');
            switch (search_data['groudType']) {
                case 'date': // 按天汇总
                    html.push('         <span>' + fun.dateFormat('yyyy-MM-dd', item['sj']) + '</span>');
                    break;
                case 'month': // 按月汇总
                    html.push('         <span>' + fun.dateFormat('yyyy-MM', item['sj']) + '</span>');
                    break;
                // 没有default
            }
            switch (search_data['rankType']) {
                case 'sk': // 色卡
                    html.push('        <span class="gong">共 ：' + (item['cp_count'] || 0) + '个产品，' + (item['sl_count'] || 0) + '份</span>');
                    break;
                case 'jy': // 剪样
                    html.push('        <span class="gong">共 ：' + (item['cp_count'] || 0) + '个产品，数量' + (item['sl_count'] || 0) + '</span>');
                    break;
                // 没有default
            }
            html.push('         <i class="iconfont arrow-mark float-right ' + arrowDirectionClass + '"></i>');
            html.push('     </p>');
            html.push('     <div class="now-time-list">');
            if ($.nui.isTrue(item['mx'])) {
                $(item['mx']).each(function (index, items) {
                    var name = $.nui.isTrue(items['cp_mc']) ? items['cp_bh'] + ' ' + items['cp_mc'] : items['cp_bh']; // 显示微信昵称
                    var imgUrl = '';
                    var transparent = $.nui.isTrue(items['cp_tp']) ? '' : 'transparent';
                    if ($.nui.isTrue(items['cp_tp'])) {
                        if (/http/.test(items['cp_tp'])) { // 完整路径
                            imgUrl = items['cp_tp'];
                        } else {
                            imgUrl = fun.getImgPath(items['cp_tp']);
                        }
                    }
                    html.push('        <div class="main clear-space">');
                    if ($.nui.isTrue(imgUrl)) { // 有图片
                        html.push('         <div class="show-mark">');
                        html.push('             <img class="circle over-hide vertical-middle normal ' + transparent + '" src="' + imgUrl + '">');
                        html.push('             <img src="../img/mask.png" alt="" class="img-mark">');
                        html.push('         </div>');
                    } else { // 没图片
                        html.push('         <div class="show-logo">');
                        html.push('             <img class="circle over-hide vertical-middle normal transparent null-img-logo" src="../img/logo.png"></img>');
                        html.push('         </div>');
                    }
                    html.push('             <div class="right-container clear-space">');
                    html.push('                 <span class="wechat font-ls text-overflow vertical-middle analyze-line-height">' + name + '</span>');
                    if (search_data['rankType'] === 'sk') { // 色卡
                        html.push('             <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">' + (items['zsl'] || 0) + '份</span>');
                    } else if (search_data['rankType'] === 'jy') { // 剪样
                        html.push('             <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">数量' + (items['zsl'] || 0) + '</span>');
                    }
                    html.push('             </div>');
                    html.push('        </div>');
                })
            }
            html.push('    </div>');
            html.push('</div>');
        })
        $('#origin_list').append(html.join(''));
    }
    if (!$('#origin_list').children().length) { // 列表数据为空
        $('#origin_list').addClass('empty-wrap');
        fun.createDataEmptyTips({ dom: '#origin_list', btnShow: false });
    }
}

// 获取选中类型
var getSelType = (function () {
    var name = '';
    var rankType = '';
    return function (type) {
        switch (type) {
            case 'sk':
                name = '（份）';
                rankType = 'sk';
                break;
            case 'jy':
                name = '（数量）';
                rankType = 'jy';
                break;
            // 没有default
        }
        $('.show-unit').text(name);
        search_data['rankType'] = rankType;
    }
})()

// 初始化事件
function bindEvent() {
    // 跳转到拿样记录排行页面 
    $('body').on('tap', '.data_origin', function () {
        if ($.nui.isTrue(search_data['cp']['text'])) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.dp_fkfxph,
            pageParam: {
                begin_time: search_data['begin_time'],
                end_time: search_data['end_time'],
                total: total,
                type: 'nyjlph', // 拿样分析排行
                rankType: search_data['rankType']
            }
        });
        fun.hideLoad();
    })

    // 打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        axisX = [];
        echartShowData = [];
        var sideslip = fun.getItem(html_name + 'sideslip'); // 搜索页是否可以打开
        var options = {
            time: {
                begin_date: search_data['begin_time'], // 起始时间
                end_date: search_data['end_time'], // 结束时间
                text: {
                    begin_text: '开始日期',
                    end_text: '结束日期'
                }
            },
            choose_merchants: [
                {
                    key: "cp", // key值
                    text: "产品",
                    value: getTwo('cp', 'text'), // 粉丝名称
                    id: getTwo('cp', 'id') // 门店id
                }
            ]
        };
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    return_page: html_name,
                    search_data: options,
                    reset: reset,
                    is_restbutton: true,
                    type: 'shop_dp_nyjl'
                },
                // y: fun.fontUnit(header)
            });
        }
    })

    // 日期切换
    $('body').on('tap', '.btn_click', fun.debounce(function () {
        if (last['date'] === $(this).index()) return;
        last['date'] = $(this).index();
        axisX = [];
        echartShowData = [];
        $(this).addClass('main-color').siblings().removeClass('main-color');
        var selTime = $(this).data('time');
        var tempObj = null;
        switch (selTime) {
            case 'this_year': // 本年
                tempObj = fun.getYearArr(1)[0];
                break;
            case 'last_month': // 上月
                tempObj = fun.getLastMonth();
                break;
            case 'this_month': // 本月
                tempObj = fun.getMonthArr(1)[0];
                break;
            case 'lately_seven': // 近7天
                tempObj = fun.getLatelyTime(7, false);
                break;
            case 'lately_fifteen': // 近15天
                tempObj = fun.getLatelyTime(15, false);
                break;
            case 'lately_thirty': // 近30天
                tempObj = fun.getLatelyTime(30, false);
                break;
        }

        $('#begin_date').text(tempObj['begin_date']);
        $('#end_date').text(tempObj['end_date']);

        search_data['begin_time'] = fun.Date(tempObj['begin_date']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(tempObj['end_date']).Format('yy-mm-dd');

        fun.statisticTime(search_data);
        getList();
    }, 300))

    // 色卡、剪样选中
    $('body').on('tap', '.tab-sel', fun.debounce(function () {
        if (last['tab'] === $(this).index()) return;
        last['tab'] = $(this).index();
        tabSwitch.call(this);
        getSelType($(this).data('type'));
        getList();
    }, 300))
}

// 收缩功能
$('body').on('tap', '.rank-title', function () {
    if ($.nui.isEmpty($(this).siblings().children().length)) return;
    $(this).siblings().stop().slideToggle(500);
    var $arrow = $(this).find('.icon-xia');
    var mark = $(this).data('mark');
    if (mark) { // 当前展开效果
        console.log(mark);
        $arrow.removeClass('rotate-arrow-up');
        $arrow.addClass('rotate-arrow-down');
    } else { // 当前收起效果
        $arrow.addClass('rotate-arrow-up');
    }
    $(this).data('mark', !mark);
})
// console.log($('#origin_list').html());
