var html_name = page_arr['shop_bp_xsqk']; // 拿样记录
var interval = 0; // echarts X轴显示间隔
var axisX = []; // echarts X轴显示范围
var echartShowData = []; // echart显示数据
var pageList = []; // 分页渲染列表数据
var reset = {}; // 重置按钮传参数据

var last = { // 限制切换同一个tab造成的再次请求
    type: 0, // 金额，数量
    tab: 0, // 客户，产品
    date: $('.btn_click').length - 1, // 日期
}

var fansData = []; // 粉丝列表数据
// 搜索的数据
var search_data = {
    begin_time: fun.Date(fun.getMonthArr(1)[0]['begin_date']).Format('yy-mm-dd'),
    end_time: fun.Date(fun.getMonthArr(1)[0]['end_date']).Format('yy-mm-dd'),
    cp: { // 产品搜索页面 
        id: '',
        text: ''
    },
    kh: {
        id: '',
        text: '',
    },
    tab: 'kh', // kh / cp
    type: 'je', // je / sl
    groudType: 'date', // 默认是按天进行查询
    fans: { // 粉丝搜索数据
        book_id: fun.getItem('book_info')['id'],
        is_wgl: '',
        keyword: ''
    }
};

// 访客合计
var total = {
    zje: 0, // 总金额
    zsl: 0 // 总数量
}

// 页面初始化
page_init = function () {
    console.log(page_data);

    $('#header').header({ // 头部初始化
        back: true,
        filter: true,
        title: '销售情况'
    });

    // 该页面筛选按钮是否可以打开
    fun.setItem(html_name + 'sideslip', true);

    // 事件监听
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        console.log('返回的数据哦', ret)
        var temp = ret.value;
        switch (temp['status']) {
            case 'search': // 监听搜索页
                search(temp, 'search');
                break;
            case 'reset': // 监听重置按钮
                search(temp, 'reset');
                break;
        }
    });
    init(); // 页面初始化
    bindEvent(); // 事件初始化

    fun.scrollToBottom({}, function () { // 滚动底部分页渲染
        if ($('#origin_list').children('.empty-tips-wrap').length) return;
        if ($.nui.isTrue(pageList)) {
            fun.showLoad();
            showOriData(fun.PagingData(pageList, 10) || []);
            setTimeout(function () {
                fun.hideLoad();
            }, 200);
        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
            var rangeList = parseFloat($('.content').css('marginTop')) + ($('.content').outerHeight() - $('#origin_list').outerHeight());
            var listHeight = $(window).height() - rangeList;
            if ($('#origin_list').outerHeight() >= listHeight) {
                fun.createBottomLine('origin_list', '.origin-list');
                $('.empty_bottom').show();
                return;
            }
        }
    });
}

// 搜索处理
function search(temp, type) {
    interval = 0;
    axisX = [];
    echartShowData = [];
    var date = {
        begin_time: temp['data']['begin_date'],
        end_time: temp['data']['end_date']
    }
    fun.setItem(html_name + 'sideslip', true); // 筛选按钮,是否可以打开
    if ($.nui.isTrue(fun.statisticTime(date))) return;
    fun.searchRange('.btn_click', date, last);
    if (type === 'reset') { // 重置
        search_data['cp']['id'] = '';
        search_data['cp']['text'] = '';
        search_data['kh']['id'] = '';
        search_data['kh']['text'] = '';
    } else { // 搜索
        search_data['cp'] = temp['data']['cp'];
        search_data['kh'] = temp['data']['kh'];
    }
    search_data['begin_time'] = temp['data']['begin_date'];
    search_data['end_time'] = temp['data']['end_date'];

    $('#begin_date').text(fun.dateFormat('yyyy.MM.dd', search_data['begin_time'])); // 起始时间
    $('#end_date').text(fun.dateFormat('yyyy.MM.dd', search_data['end_time'])); // 结束时间
    getList(); // 根据搜索条件查询数据
}

// 获取数据列表
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getXsqk, // 销售情况
        data: {
            tab: search_data['tab'],
            wldw_id: search_data['kh']['id'],
            cp_id: search_data['cp']['id'],
            begin_time: search_data['begin_time'],
            end_time: search_data['end_time'],
            type: search_data['type']
        },
        success: function (res) {
            if (res['status'] === 0) { // 请求成功
                resetList(); // 清空列表数据
                pageList = res['info_list'];
                echartsShowData(res);
                showHeaderTotal(res); // 头部合计显示
                resetData(pageList); // 默认降序显示数据
                getFansList(pageList);
            }
        }
    })
}

// 获取粉丝列表
function getFansList(pageList) {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getFanInfo,
        data: search_data['fans'],
        success: function (res) {
            if (res['status'] == 0) {
                fansData = res['data']['data'];
                showData(fun.PagingData(pageList || [])); // 渲染数据
            }
        }
    })
}

// 清空列表数据
function resetList() {
    echartShowData = [];
    pageList = [];
}

// echarts图展示数据
function echartsShowData(res) {
    $(res['list']).each(function (idx, item) {
        echartShowData[idx] = item[search_data['type']];
    })
}

// 页面初始化
function init() {
    $('#begin_date').text(fun.getLatelyTime(30, false)['begin_date']); // 起始时间
    $('#end_date').text(fun.getLatelyTime(30, false)['end_date']); // 结束时间
    search_data['begin_time'] = fun.getLatelyTime(30, true)['begin_date'];
    search_data['end_time'] = fun.getLatelyTime(30, true)['end_date'];
    reset = { // 重置日期
        begin_date: fun.getLatelyTime(30, true)['begin_date'],
        end_date: fun.getLatelyTime(30, true)['end_date']
    }
    getList(); // 初始化渲染数据
}

// 获取产品搜索数据
function getTwo(key, son, def) {
    def = def || "";
    return (search_data[key] && search_data[key][son]) || def;
}

// 初始化echarts数据
function echartsDataInit(data) {
    var mark = data.every(function (item, idx) {
        return item === 0;
    })

    if (mark) {
        for (var i = 0; i < data.length; i++) {
            data[i] = '';
        }
    }
}

// 重置数据
function resetData(data) {
    data.sort(function (a, b) {
        return fun.getTimeStamp(b['sj']) - fun.getTimeStamp(a['sj']);
    })
    var name = '';
    switch (search_data['type']) {
        case 'je': // 金额
            name = 'hsje';
            break;
        case 'sl': // 数量
            name = 'zsl';
            break;
        // 没有default;
    }
    for (var i = 0; i < data.length; i++) {
        var item = data[i];
        if ($.nui.isTrue(item['mx'])) {
            item['mx'].sort(function (x, y) {
                return y[name] - x[name];
            })
        } else {
            continue;
        }
    }
}

// 类型切换函数
function tabSwitch() {
    $(this).addClass('active').siblings().removeClass('active');
}

// 格式化时间
function getSjFormat(date, type) {
    var val = '';
    switch (type) {
        case 'date':
            val = fun.dateFormat('yyyy-MM-dd', date);
            break;
        case 'month':
            val = fun.dateFormat('yyyy-MM', date);
            break;
        // 没有default
    }
    return val;
}

// 获取随机颜色值
function getRanBgColor(idx) {
    return order_color[idx % order_color.length];
}

// 固定小数位数，智能识别
function numFixed(val, num) {
    return parseFloat(val).fixed(num);
}

// 头部合计
function showHeaderTotal(data) {
    if ($.nui.isTrue(data['hj'])) {
        // 合计显示
        total['zje'] = data['hj']['zje'];
        total['zsl'] = data['hj']['zsl'];
    } else {
        total['zje'] = 0;
        total['zsl'] = 0;
    }
    // 渲染数据
    // $('#zje').text(numFixed(total['zje'], 4)); // 总金额
    // $('#zsl').text(numFixed(total['zsl'], 2)); // 总数量
    $('#zje').text(total['zje']); // 总金额
    $('#zsl').text(total['zsl']); // 总数量
}

// 显示页面数据
function showData(data) {
    $('#origin_list').html('');
    echartsDataInit(echartShowData); // 初始化echart图数据
    fun.statisticTime(search_data); // 访客分析数据初始化
    fun.showGraphic(); // 渲染echarts图
    showOriData(data); // 渲染数据来源
    $('.now-time-list:first').show();
}

// 获取值，值不存在返回0
function getVal(val) {
    if ($.nui.isEmpty(val)) {
        return 0;
    }
    return val;
}

// 渲染客户标签数据
function showKhList(data) {
    if ($.nui.isTrue(data)) {
        var html = [];
        $(data).each(function (idx, item) {
            switch (search_data['type']) {
                case 'je': // 往来人数和金额都为0，则不显示该记录行
                    if (!item['wldw_count'] && !item['je_count']) return true;
                    break;
                case 'sl': // 往来人数和数量都为0，则不显示该记录行
                    if (!item['wldw_count'] && !item['sl_count']) return true;
                    break;
            }
            var arrowDirectionClass = 'icon-xia';
            var mark = true;
            if (idx === 0) { // 首条列表项展开，箭头为上，其它初始默认合拢状态，箭头为下
                arrowDirectionClass = 'arrow-down icon-xia';
            } else {
                mark = false;
            }
            html.push('<div class="origin-item over-hide">');
            html.push('    <p class="data_hang font-ss color-gray rank-title analyze-line-height" data-mark="' + mark + '">');
            switch (search_data['groudType']) {
                case 'date': // 按天汇总
                    html.push('         <span>' + getSjFormat(item['sj'], 'date') + '</span>');
                    break;
                case 'month': // 按月汇总
                    html.push('         <span>' + getSjFormat(item['sj'], 'month') + '</span>');
                    break;
                // 没有default
            }
            switch (search_data['type']) {
                case 'je': // 金额
                    // html.push('        <span class="gong">共 ：' + getVal(item['wldw_count']) + '人，总金额 ：' + numFixed(getVal(item['je_count']), 4) + '</span>');
                    html.push('        <span class="gong">共 ：' + getVal(item['wldw_count']) + '人，总金额 ：' + getVal(item['je_count']) + '</span>');
                    break;
                case 'sl': // 数量
                    // html.push('        <span class="gong">共 ：' + getVal(item['wldw_count']) + '人，总数量 ：' + numFixed(getVal(item['sl_count']), 2) + '</span>');
                    html.push('        <span class="gong">共 ：' + getVal(item['wldw_count']) + '人，总数量 ：' + getVal(item['sl_count']) + '</span>');
                    break;
                // 没有default
            }

            html.push('         <i class="iconfont arrow-mark float-right ' + arrowDirectionClass + '"></i>');

            html.push('    </p>');
            html.push('    <div class="now-time-list">');
            if ($.nui.isTrue(item['mx'])) {
                $(item['mx']).each(function (index, items) {
                    var fansUrl = getWechatUrl(items, fansData);
                    // 要做的
                    html.push('     <div class="main clear-space">');
                    if ($.nui.isEmpty(fansUrl)) {
                        html.push('         <span class="circle over-hide vertical-middle kh-mc-style" style="background-color:' + getRanBgColor(index) + ';">' + fun.getLastName(items['wldw_mc']) + '</span>');
                    } else {
                        var imgUrl = '';
                        if (/http/.test(fansUrl)) { // 完整路径
                            imgUrl = fansUrl;
                        } else {
                            imgUrl = fun.getImgPath(fansUrl, null, { url: SHOP_IMG, type: 'shop' });
                        }
                        html.push('         <img class="circle over-hide vertical-middle" src="' + imgUrl + '">');
                    }
                    html.push('         <div class="right-container clear-space">');
                    html.push('             <span class="wechat font-ls text-overflow vertical-middle analyze-line-height">' + fun.is_value(items['wldw_mc']) + '</span>');
                    switch (search_data['type']) {
                        case 'je': // 金额
                            // html.push('            <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">￥' + numFixed(getVal(items['hsje']), 4) + '</span>');
                            html.push('            <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">￥' + getVal(items['hsje']) + '</span>');
                            break;
                        case 'sl': // 数量
                            // html.push('         <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">' + numFixed(getVal(items['zsl']), 2) + '</span>');
                            html.push('         <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">' + getVal(items['zsl']) + '</span>');
                            break;
                        // 没有default
                    }
                    html.push('         </div>');
                    html.push('     </div>');
                })
            }
            html.push('    </div>');
            html.push('</div>');
        })
        return html.join('');
    }
}

// 获取联系人微信头像
function getWechatUrl(data, fansData) {
    for (var i = 0; i < fansData.length; i++) {
        var item = fansData[i];
        if (data['lxr_id'] === item['kh_lxr_id']) {
            return item['avatar_url'];
        }
    }
    return false;
}

// 渲染产品标签数据
function showCpList(data) {
    var html = [];
    $(data).each(function (idx, item) {
        switch (search_data['type']) {
            case 'je': // 产品和金额都为0，则不显示该记录行
                if (!item['cp_count'] && !item['je_count']) return true;
                break;
            case 'sl': // 产品和数量都为0，则不显示该记录行
                if (!item['cp_count'] && !item['sl_count']) return true;
                break;
        }

        var arrowDirectionClass = 'icon-xia';
        var mark = true;

        if (idx === 0) { // 首条列表项展开，箭头为上，其它初始默认合拢状态，箭头为下
            arrowDirectionClass = 'arrow-down icon-xia';
        } else {
            mark = false;
        }

        html.push('<div class="origin-item over-hide">');
        html.push('    <p class="data_hang font-ss color-gray rank-title analyze-line-height" data-mark="' + mark + '">');
        switch (search_data['groudType']) {
            case 'date': // 按天汇总
                html.push('         <span>' + getSjFormat(item['sj'], 'date') + '</span>');
                break;
            case 'month': // 按月汇总
                html.push('         <span>' + getSjFormat(item['sj'], 'month') + '</span>');
                break;
            // 没有default
        }
        switch (search_data['type']) {
            case 'je': // 金额
                // html.push('        <span class="gong">共 ：' + getVal(item['cp_count']) + '个，总金额 ：' + numFixed(getVal(item['je_count']), 4) + '</span>');
                html.push('        <span class="gong">共 ：' + getVal(item['cp_count']) + '个，总金额 ：' + getVal(item['je_count']) + '</span>');
                break;
            case 'sl': // 数量
                // html.push('        <span class="gong">共 ：' + getVal(item['cp_count']) + '个，总数量 ：' + numFixed(getVal(item['sl_count']), 2) + '</span>');
                html.push('        <span class="gong">共 ：' + getVal(item['cp_count']) + '个，总数量 ：' + getVal(item['sl_count']) + '</span>');
                break;
            // 没有default
        }

        html.push('         <i class="iconfont arrow-mark float-right ' + arrowDirectionClass + '"></i>');
        html.push('    </p>');
        html.push('    <div class="now-time-list">');
        if ($.nui.isTrue(item['mx'])) {
            $(item['mx']).each(function (index, items) {
                var imgUrl = '';
                var name = $.nui.isTrue(items['cp_mc']) ? items['cp_bh'] + ' ' + items['cp_mc'] : items['cp_bh'];
                html.push('     <div class="main clear-space">');
                if ($.nui.isTrue(items['cp_tp'])) {
                    if (/http/.test(items['cp_tp'])) { // 完整路径
                        imgUrl = items['cp_tp'];
                    } else {
                        imgUrl = fun.getImgPath(items['cp_tp']);
                    }
                    html.push('         <div class="show-mark">');
                    html.push('             <img class="circle over-hide vertical-middle normal" src="' + imgUrl + '">');
                    html.push('             <img src="../img/mask.png" alt="" class="img-mark">');
                    html.push('         </div>');
                } else {
                    html.push('         <div class="show-logo">');
                    html.push('             <img class="circle over-hide vertical-middle normal transparent null-img-logo" src="../img/logo.png"></img>');
                    html.push('         </div>');
                }
                // html.push('         <img class="circle over-hide vertical-middle normal ' + transparent + '" src="' + imgUrl + '">');
                html.push('         <div class="right-container clear-space">');
                html.push('             <span class="wechat font-ls text-overflow vertical-middle analyze-line-height">' + fun.is_value(name) + '</span>');
                switch (search_data['type']) {
                    case 'je': // 金额
                        // html.push('     <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">￥' + numFixed(getVal(items['hsje']), 4) + '</span>');
                        html.push('     <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">￥' + getVal(items['hsje']) + '</span>');
                        break;
                    case 'sl': // 数量
                        // html.push('     <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">' + numFixed(getVal(items['zsl']), 2) + '</span>');
                        html.push('     <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right nyjl-line-width">' + getVal(items['zsl']) + '</span>');
                        break;
                    // 没有default
                }
                html.push('         </div>');
                html.push('     </div>');
            })
        }
        html.push('    </div>');
        html.push('</div>');
    })
    return html.join('');
}

// 渲染数据来源
function showOriData(data) {
    switch (search_data['tab']) {
        case 'kh':
            $('#origin_list').append(showKhList(data));
            break;
        case 'cp':
            $('#origin_list').append(showCpList(data));
            break;
        // 没有default;
    }

    if (!$('#origin_list').children().length) { // 列表数据为空
        $('#origin_list').addClass('empty-wrap');
        fun.createDataEmptyTips({ dom: '#origin_list', btnShow: false });
    }
}

// 获取选中类型
var getSelType = (function () {
    var name = '';
    var rankType = '';
    return function (type) {
        switch (type) {
            case 'je':
                name = '（元）';
                rankType = 'je';
                break;
            case 'sl':
                name = '';
                rankType = 'sl';
                break;
            // 没有default
        }
        $('.show-unit').text(name);
        search_data['type'] = rankType;
    }
})()

// 初始化事件
function bindEvent() {
    // 根据tab的状态，跳转对应的链接(产品->客户分析，产品->产品分析)
    $('body').on('tap', '.paihang', function () {
        fun.showLoad();
        // 当前筛选页的开始时间和结束时间
        var search_time = { begin_time: search_data['begin_time'], end_time: search_data['end_time'] }
        if (search_data['tab'] === 'cp') { // 产品分析
            var temp = {
                page_url: page_arr.xs_cpfx,
                pageParam: {
                    cp_id: search_data['cp']['id'] || 0,
                    type: '', // 给个空，防止跳转过去报错
                    return_page: html_name,
                    search_time: search_time,
                    search_cpmc: search_data['cp']['text']
                }
            };
        } else if (search_data['tab'] === 'kh') { // 客户分析
            var temp = {
                page_url: page_arr.xs_khfx,
                pageParam: {
                    wldw_mc: search_data['kh']['text'],
                    wldw_id: search_data['kh']['id'],
                    type: '', // 给个空，防止跳转过去报错
                    return_page: html_name,
                    search_time: search_time
                }
            }
        }
        fun.showPageFull(temp);
        fun.hideLoad();
    })

    // 打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        axisX = [];
        echartShowData = [];
        var sideslip = fun.getItem(html_name + 'sideslip'); // 搜索页是否可以打开
        var options = {
            time: {
                begin_date: search_data['begin_time'], // 起始时间
                end_date: search_data['end_time'], // 结束时间
                text: {
                    begin_text: '开始日期',
                    end_text: '结束日期'
                }
            },
            choose_merchants: [
                {
                    key: "cp", // key值
                    text: "产品",
                    value: getTwo('cp', 'text'),
                    id: getTwo('cp', 'id')
                },
                {
                    key: "kh",
                    text: "客户",
                    value: getTwo('kh', 'text'),
                    id: getTwo('kh', 'id')
                }
            ]
        };
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    return_page: html_name,
                    search_data: options,
                    reset: reset,
                    is_restbutton: true,
                    type: 'shop_dp_xsqk'
                },
                // y: fun.fontUnit(header)
            });
        }
    })

    // 日期切换
    $('body').on('tap', '.btn_click', fun.debounce(function () {
        if (last['date'] === $(this).index()) return;
        last['date'] = $(this).index();
        axisX = [];
        echartShowData = [];
        $(this).addClass('main-color').siblings().removeClass('main-color');
        var selTime = $(this).data('time');
        var tempObj = null;
        switch (selTime) {
            case 'this_year': // 本年
                tempObj = fun.getYearArr(1)[0];
                break;
            case 'last_month': // 上月
                tempObj = fun.getLastMonth();
                break;
            case 'this_month': // 本月
                tempObj = fun.getMonthArr(1)[0];
                break;
            case 'lately_seven': // 近7天
                tempObj = fun.getLatelyTime(7, false);
                break;
            case 'lately_fifteen': // 近15天
                tempObj = fun.getLatelyTime(15, false);
                break;
            case 'lately_thirty': // 近30天
                tempObj = fun.getLatelyTime(30, false);
                break;
        }

        $('#begin_date').text(tempObj['begin_date']);
        $('#end_date').text(tempObj['end_date']);

        search_data['begin_time'] = fun.Date(tempObj['begin_date']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(tempObj['end_date']).Format('yy-mm-dd');

        fun.statisticTime(search_data);
        getList();
    }, 350))

    // 色卡选中，剪样选中
    $('body').on('tap', '.tab-sel', fun.debounce(function () {
        if (last['type'] === $(this).index()) return;
        last['type'] = $(this).index();
        tabSwitch.call(this);
        getSelType($(this).data('type'));
        getList();
    }, 350))

    // 客户，产品，标签页切换
    $('#user-tab li').on('tap', fun.debounce(function () {
        if (last['tab'] === $(this).index()) return;
        last['tab'] = $(this).index();

        switch ($(this).data('tab')) {
            case 'kh':
                search_data['tab'] = 'kh'; // 需要调整为 kh
                break;
            case 'cp':
                search_data['tab'] = 'cp'; // 需要调整为 cp
                break;
            // 没有default
        }
        $('#user-tab li').find('.title-text').removeClass('active');
        $(this).find('.title-text').addClass('active');
        getList();
    }, 350));

    // 收缩功能
    $('body').on('tap', '.rank-title', function () {
        if ($.nui.isEmpty($(this).siblings().children().length)) return;
        $(this).siblings().stop().slideToggle(500);
        var $arrow = $(this).find('.icon-xia');
        var mark = $(this).data('mark');
        if (mark) { // 当前展开效果
            console.log(mark);
            $arrow.removeClass('rotate-arrow-up');
            $arrow.addClass('rotate-arrow-down');
        } else { // 当前收起效果
            $arrow.addClass('rotate-arrow-up');
        }
        $(this).data('mark', !mark);
    })
}


// console.log($('#origin_list').html());

// 注释了id，方法提到外面，点击箭头变动
