var html_name = page_arr.shop_fans_xq;

page_init = function () {
    $('#header').header({
        back: true,
        title: '粉丝详情',
    })

    showHtml('sj');
    bindEvent();

    $('#nav li').eq(0).addClass('on');
    $('#top').css('top', api.safeArea.top + $('#header').height());
    //iphoneX适配
    $('#content').css({
        'padding-bottom': api.safeArea.bottom + 'px',
        'padding-top': api.safeArea.top + $('#header').height() + $('#top').height()
    })
}

function showEcharts(type) {
    var myChart = echarts.init(document.getElementById(type + "_container"));
    var dz_data = [78, 60, 60, 70, 69, 20, 30]
    var dz_titlename = ['线上到访', '分享小店', '点赞小店', '产看产品', '2D试衣', '3D试衣', '跟进聊天'];
    var dz_valdata = [20, 20, 20, 20, 20, 20, 20];
    option = null;
    switch (type) {
        case 'dz':
            option = {
                backgroundColor: '#fff',
                xAxis: {
                    show: false
                },
                grid: {
                    left: '3%',
                    right: '3%',
                    bottom: '5%',
                    top: '5%',
                    containLabel: true
                },
                yAxis: [{
                    show: true,
                    data: dz_titlename,
                    inverse: true,
                    axisLine: {
                        show: false
                    },
                    splitLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        textStyle: {
                            color: '#000',
                            fontSize: 14
                        },
                        formatter: function(value, index) {
                            return [
                                '{title|' + value + '} '
                            ].join('\n')
                        },
                        rich: {}
                    },
        
                }, {
                    show: true,
                    inverse: true,
                    data: dz_valdata,
                    axisLabel: {
                        textStyle: {
                            color: '#000',
                            fontSize: 14
                        }
                    },
                    axisLine: {
                        show: false
                    },
                    splitLine: {
                        show: false
                    },
                    axisTick: {
                        show: false
                    },
        
                }],
                series: [{
                    name: '条',
                    type: 'bar',
                    yAxisIndex: 0,
                    data: dz_data, 
                    barWidth: 10,
                    itemStyle: {
                        normal: {
                            barBorderRadius: 30,
                            color: '#3D9CFA',
                        }
                    }
                    // label: {
                    //     normal: {
                    //         show: true,
                    //         position: 'inside',
                    //         formatter: '{c}%'
                    //     }
                    // },
                }]
            };
            break;

        case 'fx':
            option = {
                backgroundColor: '#fff',
                tooltip: {
                    trigger: 'item',
                    formatter: '{a} <br/>{b} : {c} ({d}%)'
                },
                legend: {
                    left: 'center',
                    top: 'bottom',
                    data: ['rose1', 'rose2', 'rose3', 'rose4', 'rose5', 'rose6']
                },
                series: [{
                    type: 'pie',
                    // startAngle: 240,
                    radius: ['30%', '70%'],
                    center: ['50%', '45%'],
                    roseType: 'radius',
                    label: {
                        normal: {
                            textStyle: {
                                color: 'rgba(255, 255, 255, 0.3)'
                            }
                        }
                    },
                    labelLine: {
                        normal: {
                            lineStyle: {
                                color: 'rgba(255, 255, 255, 0.3)'
                            },
                            smooth: 0.2,
                            length: 10,
                            length2: 20
                        }
                    },
                    data: [
                        {value: 35, name: 'rose1'},
                        {value: 5, name: 'rose2'},
                        {value: 15, name: 'rose3'},
                        {value: 25, name: 'rose4'},
                        {value: 20, name: 'rose5'},
                        {value: 10, name: 'rose6'}
                    ],
                    itemStyle: {
                        // color: {
                        //     type: 'linear',
                        //     x: 0,
                        //     y: 0,
                        //     x2: 1,
                        //     y2: 0,
                        //     colorStops: [
                        //         { 'offset': 0, 'color': color_data[i]['begin_color'] },
                        //         { 'offset': 1, 'color': color_data[i]['end_color'] }
                        //     ],
                        //     globalCoord: false
                        // }
                        color: function (params) {
                            var color_data = [
                                {
                                    'begin_color': '#55b1ec',
                                    'end_color': '#71cfff',
                                }, {
                                    'begin_color': '#5eaadb',
                                    'end_color': '#8d81f1',
                                }, {
                                    'begin_color': '#ffae51',
                                    'end_color': '#ff7760',
                                }, {
                                    'begin_color': '#ff5d3c',
                                    'end_color': '#ff9858'
                                }, {
                                    'begin_color': '#f3618f',
                                    'end_color': '#fc4d84'
                                }, {
                                    'begin_color': '#f774b5',
                                    'end_color': '#de2f81'
                                }
                            ];
                            return new echarts.graphic.LinearGradient(0, 0, 1, 0, [{ //颜色渐变函数 前四个参数分别表示四个位置依次为左、下、右、上
                                    offset: 0,
                                    color: color_data[params.dataIndex].begin_color
                                }, {
                                    offset: 1,
                                    color: color_data[params.dataIndex].end_color
                                }]
                            )                            
                        }
                    }
                }]
            };
            break;
    }
    if (option && typeof option === "object") {
        myChart.setOption(option, true);
        myChart.on('tap', function (param) {
        });
    }
}

function showHtml(type) {
    $('.container').hide();
    if (type != 'sj') {
        $('#' + type + '_container').show();
        showEcharts(type);
    }

    var html = [];
    $('#box').empty();
    switch (type) {
        case 'sj':
            html.push('<div class="yby-center color-gray font-ss fans-sj-date">今天</div>');
            html.push('<div class="fans-sj-xq clear">');
            html.push('    <img src="../img/product2.png" class="float-left fans-img">');
            html.push('    <div class="float-right" style="width: calc(100% - 3.3rem);">');
            html.push('        <p class="margin-top-s clear">');
            html.push('            <span class="write-over font-ls float-left" style="max-width: 75%;">微信昵称</span>');
            html.push('            <span class="font-ss color-gray float-right margin-top-s">5分钟前</span>');
            html.push('        </p>');
            html.push('        <p class="page clear" style="margin-top: .3rem;" data-page="lt">');
            html.push('            <span class="float-left font-ss" style="width: 90%;">在【<span class="theme-font-color">801#弹力布</span>】停留了2分钟，看来TA对这款产品很感兴趣哦</span>');
            html.push('            <span class="iconfont font-ss icon-youfanhui float-right margin-top-s"></span>');
            html.push('        </p>');
            html.push('    </div>');
            html.push('</div>');
            break;

        default:
            html.push('<ul class="fans-dz-data color-gray vertical-middle clear">');
            html.push('    <li class="float-left">');
            html.push('        <span class="font-ls">03-04 ~ 01-07</span>');
            html.push('        <span class="iconfont icon-xiala font-ms"></span>');
            html.push('    </li>');
            if (type == 'fx') {
                html.push('    <li class="float-right yby-margin-left4">');
                html.push('        <span class="font-ls">类别</span>');
                html.push('        <span class="iconfont icon-xiala font-ms"></span>');
                html.push('    </li>');    
            }
            html.push('    <li class="float-right fans-dz-qh">');
            html.push('        <span class="iconfont icon-fanhui font-ms yby-center"></span>');
            html.push('        <span class="iconfont icon-youfanhui font-ms yby-center"></span>');
            html.push('    </li>');
            html.push('</ul>');
    }
    $("#box").html(html.join(''));
}

function goPage(url, param) {
    fun.showPageFull({
        page_url: url || '',
        pageParam: param || {},
    });
}

function bindEvent() {
    // 导航条
    $('body').on('tap', '#nav li', function () {
        $(this).addClass("on").siblings().removeClass("on");
        var type = $(this).data('type');
        showHtml(type);
    });

    // 跳转
    $('body').on('tap', '.page', function () {
        var type = $(this).data('page');
        switch (type) {
            case 'sz':
                goPage(page_arr['shop_fans_xq_sz'], {
                    return_page: html_name
                })
                break;

            case 'lt':
                goPage(page_arr['shop_chat'], {
                    return_page: html_name
                })
                break;

            case 'xq':
                goPage(page_arr['shop_zl_khyl'], {
                    return_page: html_name
                })
                break;
        }
    });
}