var html_name = page_arr.shop_xq_fx; // 兴趣分析
var type1_value, type2_value;  // 获取type
var init_type = ''; //获取type1的值
var init_type2 = ('' || 'cp');//获取type2的值
var last = { // 限制切换同一个tab造成的再次请求
    date: $('.btn-click').length - 1
}
var reset = {}; // 重置按钮传参数据

// 搜索的数据
var search_data = { // 获取本月第一天和最后一天
    begin_time: fun.Date(fun.getMonthArr(1)[0]['begin_date']).Format('yy-mm-dd'),
    end_time: fun.Date(fun.getMonthArr(1)[0]['end_date']).Format('yy-mm-dd'),
    groudType: 'date', // 默认是按天进行查询
    type: 'fw' // "按访问" 还是 "按销售"
};

// 点击头部产品出现弹窗 type2
var cp_data = [
    { id: 1, name: '产品', db_name: 'cp', "is_choose": 1 },
    { id: 2, name: '类别', db_name: 'lb' },
    { id: 3, name: '工艺', db_name: 'gy' },
];

// 点击头部访问出现弹窗 type1
var visitor_data = [
    { id: 1, name: '按访问', db_name: 'fw', "is_choose": 1 },
    { id: 2, name: '按销售', db_name: 'xs' },
];

// 图标需要的color数据,默认不超过6个 
var color_data = [
    {
        'begin_color': '#55b1ec',
        'end_color': '#71cfff',
    }, {
        'begin_color': '#5eaadb',
        'end_color': '#8d81f1',
    }, {
        'begin_color': '#ffae51',
        'end_color': '#ff7760',
    }, {
        'begin_color': '#ff5d3c',
        'end_color': '#ff9858'
    }, {
        'begin_color': '#f3618f',
        'end_color': '#fc4d84'
    }, {
        'begin_color': '#f774b5',
        'end_color': '#de2f81'
    }
]

// 页面初始化
page_init = function () {
    // 头部样式
    $('#header').header({
        back: true,
        filter: true,
        title: '兴趣分析'
    });

    fun.setItem(html_name + 'sideslip', true); // 该页面筛选按钮是否可以打开

    // 监听筛选返回事件
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        // 根据点击筛选返回的状态做处理
        var temp = ret['value'];
        switch (ret['value']['status']) {
            case 'search': // 搜索
            case 'reset': // 重置
                search(temp);
                break;
        }
    })
    init();
}

// 搜索处理
function search(temp) {
    var date = {
        begin_time: temp['data']['begin_date'],
        end_time: temp['data']['end_date']
    }
    fun.setItem(html_name + 'sideslip', true); // 筛选按钮,是否可以打开
    search_data['begin_time'] = temp['data']['begin_date']; // 起始时间
    search_data['end_time'] = temp['data']['end_date']; // 结束时间
    fun.searchRange('.btn_click', date, last);

    $('#begin_date').text(fun.dateFormat('yyyy.MM.dd', search_data['begin_time'])); // 起始时间
    $('#end_date').text(fun.dateFormat('yyyy.MM.dd', search_data['end_time'])); // 结束时间
    getList($('.visitor').attr('gys'), $('.chanpin').attr('gys'), date.begin_time, date.end_time);
}

// 获取数据
function getList(type1_value, type2_value, begin_time, end_time) {
    if (type1_value === 'xs') {  //按销售
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getBpXqfx,
            data: {
                begin_time: begin_time || search_data['begin_time'],
                end_time: end_time || search_data['end_time'],
                type1: 'xs', // 销售
                type2: type2_value || 'cp', // 产品
            },
            success: function (res) {
                if (res['status'] === 0) {
                    $('.message').html('');
                    if ($.nui.isTrue(res['data']) && $.nui.isTrue(res['data'])) {
                        $('.statistical,.stat-visitor').show();
                        echarts_edit(res['data']);
                        showList(res);
                        echarts_edit(res['data']);
                    } else {
                        $('.statistical,.stat-visitor').hide();
                        fun.createDataEmptyTips({ dom: '.message', btnShow: false });
                    }
                }
            }
        });
    } else {  //按访问
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.hobbyAnalyzeResult,
            data: {
                begin_time: begin_time || search_data['begin_time'],
                end_time: end_time || search_data['end_time'],
                type: type2_value || 'cp', // 类型2
            },
            success: function (res) {
                if (res['status'] === 0) {
                    $('.message').html('');
                    if ($.nui.isTrue(res['data']) && $.nui.isTrue(res['data']['type_result'])) {
                        $('.statistical,.stat-visitor').show();
                        echarts_edit(res['data']);
                        showList(res);
                        echarts_edit(res['data']);
                    } else {
                        $('.statistical,.stat-visitor').hide();
                        fun.createDataEmptyTips({ dom: '.message', btnShow: false });
                    }
                }
            }
        });
    }
}

// 渲染详细信息
function showList(res) {
    $('.message').empty();
    var html = [];
    var data = res.data
    //表头
    html.push('<li class="clearfix" style="border: none !important;">')
    html.push('    <p class="color float-left yby-font-ms origin-line-height">数据来源</p>')
    html.push('</li>')
    html.push('<li class="clearfix color-gray clear yby-opacity7 font-ls">')
    html.push('    <p class="color float-left origin-line-height">排名</p>')
    html.push('    <p class="order-stat float-left origin-line-height">产品</p>')
    html.push('    <p class="price-all float-left origin-line-height">访问（次）</p>')
    html.push('</li>')
    //按销售
    if (init_type === 'xs') {
        switch (init_type2) {
            case 'cp':
                $(data).each(function (idx, item) {
                    var index_ph = idx + 1
                    html.push('<li class="clearfix clear yby-opacity8 font-ls">')
                    html.push('     <div class="color float-left origin-line-height">')
                    switch (idx) {
                        case 0:
                            html.push('         <img src="../img/jp.png" class="pai ranking-img">')
                            break;
                        case 1:
                            html.push('         <img src="../img/yp.png" class="pai ranking-img">')
                            break;
                        case 2:
                            html.push('         <img src="../img/tp.png" class="pai ranking-img">')
                            break;
                        default:
                            html.push('         ' + index_ph + '')
                            break;
                    }
                    html.push('     </div>')
                    html.push('     <div class="order float-left">')
                    // html.push('         <p class="picture_cp origin-line-height">')
                    html.push('           <div class="logo-border">')
                    if ($.nui.isTrue(item['cp_tp'])) {
                        if (/http/.test(item['cp_tp'])) {
                            html.push('             <img src="' + item['cp_tp'] + '" class="product"><img src="../img/mask.png" class="mark">')
                        } else {
                            html.push('             <img src="' + fun.getImgPath(item['cp_tp']) + '" class="product"><img src="../img/mask.png" class="mark">')
                        }
                    } else {
                        html.push('             <img src="../img/logo.png" class="product logo">')
                    }
                    html.push('           </div>')
                    html.push('           <span class="limit">' + (item['cp_bh'] || '') + (item['cp_mc'] || '') + '</span>')
                    // html.push('         </p>')
                    html.push('     </div>')
                    html.push('     <div class="price origin-line-height float-left">' + (item['hsje'] || 0) + '</div>')
                    html.push('</li>')
                    return true;
                })
                break;
            case 'lb':
                $(data).each(function (idx, item) {
                    var index_ph = idx + 1
                    html.push('<li class="clearfix clearfix yby-opacity8 font-ls">')
                    html.push('     <div class="color float-left origin-line-height">')
                    switch (idx) {
                        case 0:
                            html.push('         <img src="../img/jp.png" class="pai ranking-img">')
                            break;
                        case 1:
                            html.push('         <img src="../img/yp.png" class="pai ranking-img">')
                            break;
                        case 2:
                            html.push('         <img src="../img/tp.png" class="pai ranking-img">')
                            break;
                        default:
                            html.push('         ' + index_ph + '')
                            break;
                    }
                    html.push('     </div>')
                    html.push('     <div class="order float-left">')
                    html.push('         <p class="picture origin-line-height">')
                    html.push('             <span class="limit">' + (item['lb_mc'] || '') + '</span>')
                    html.push('         </p>')
                    html.push('     </div>')
                    html.push('     <div class="price float-left origin-line-height">' + (item['hsje'] || 0) + '</div>')
                    html.push('</li>')
                    return true;
                })
                break;
            case 'gy':
                $(data).each(function (idx, item) {
                    var index_ph = idx + 1
                    html.push('<li class="clearfix clearfix yby-opacity8 font-ls">')
                    html.push('     <div class="color float-left origin-line-height">')
                    switch (idx) {
                        case 0:
                            html.push('         <img src="../img/jp.png" class="pai ranking-img">')
                            break;
                        case 1:
                            html.push('         <img src="../img/yp.png" class="pai ranking-img">')
                            break;
                        case 2:
                            html.push('         <img src="../img/tp.png" class="pai ranking-img">')
                            break;
                        default:
                            html.push('         ' + index_ph + '')
                            break;
                    }
                    html.push('     </div>')
                    html.push('     <div class="order float-left">')
                    html.push('         <p class="picture origin-line-height">')
                    html.push('             <span class="limit">' + (item['gy_mc'] || '') + '</span>')
                    html.push('         </p>')
                    html.push('     </div>')
                    html.push('     <div class="price float-left origin-line-height">' + (item['hsje'] || 0) + '</div>')
                    html.push('</li>')
                    return true;
                })
                break;
        }
    }
    //按访问
    else {
        switch (init_type2) {
            case 'cp':
                $(data['type_result']).each(function (idx, item) {
                    var index_ph = idx + 1
                    html.push('<li class="clearfix clear yby-opacity8 font-ls">')
                    html.push('     <div class="color float-left origin-line-height">')
                    switch (idx) {
                        case 0:
                            html.push('         <img src="../img/jp.png" class="pai ranking-img">')
                            break;
                        case 1:
                            html.push('         <img src="../img/yp.png" class="pai ranking-img">')
                            break;
                        case 2:
                            html.push('         <img src="../img/tp.png" class="pai ranking-img">')
                            break;
                        default:
                            html.push('         ' + index_ph + '')
                            break;
                    }
                    html.push('     </div>')
                    html.push('     <div class="order float-left">')
                    // html.push('         <p class="picture_cp origin-line-height">')
                    html.push('           <div class="logo-border">')
                    if ($.nui.isTrue(item['cp_ztp'])) {
                        if (/http/.test(item['cp_ztp'])) {
                            html.push('             <img src="' + item['cp_ztp'] + '" class="product"><img src="../img/mask.png" class="mark">')
                        } else {
                            html.push('             <img src="' + fun.getImgPath(item['cp_ztp']) + '" class="product"><img src="../img/mask.png" class="mark">')
                        }
                    } else {
                        html.push('             <img src="../img/logo.png" class="product logo">')
                    }
                    html.push('           </div>')
                    html.push('           <span class="limit">' + (item['cp_bh'] || '') + (item['cp_mc'] || '') + '</span>')
                    // html.push('         </p>')
                    html.push('     </div>')
                    html.push('     <div class="price origin-line-height float-left">' + (item['count'] || 0) + '</div>')
                    html.push('</li>')
                    return true;
                })
                break;
            case 'lb':
                $(data['type_result']).each(function (idx, item) {
                    var index_ph = idx + 1
                    html.push('<li class="clearfix clearfix yby-opacity8 font-ls">')
                    html.push('     <div class="color float-left origin-line-height">')
                    switch (idx) {
                        case 0:
                            html.push('         <img src="../img/jp.png" class="pai ranking-img">')
                            break;
                        case 1:
                            html.push('         <img src="../img/yp.png" class="pai ranking-img">')
                            break;
                        case 2:
                            html.push('         <img src="../img/tp.png" class="pai ranking-img">')
                            break;
                        default:
                            html.push('         ' + index_ph + '')
                            break;
                    }
                    html.push('     </div>')
                    html.push('     <div class="order float-left">')
                    html.push('         <p class="picture origin-line-height">')
                    html.push('             <span class="limit">' + (item['cp_lb_mc'] || '') + '</span>')
                    html.push('         </p>')
                    html.push('     </div>')
                    html.push('     <div class="price float-left origin-line-height">' + (item['count'] || 0) + '</div>')
                    html.push('</li>')
                    return true;
                })
                break;
            case 'gy':
                $(data['type_result']).each(function (idx, item) {
                    var index_ph = idx + 1
                    html.push('<li class="clearfix clearfix yby-opacity8 font-ls">')
                    html.push('     <div class="color float-left origin-line-height">')
                    switch (idx) {
                        case 0:
                            html.push('         <img src="../img/jp.png" class="pai ranking-img">')
                            break;
                        case 1:
                            html.push('         <img src="../img/yp.png" class="pai ranking-img">')
                            break;
                        case 2:
                            html.push('         <img src="../img/tp.png" class="pai ranking-img">')
                            break;
                        default:
                            html.push('         ' + index_ph + '')
                            break;
                    }
                    html.push('     </div>')
                    html.push('     <div class="order float-left">')
                    html.push('         <p class="picture origin-line-height">')
                    html.push('             <span class="limit">' + (item['gy_mc'] || '') + '</span>')
                    html.push('         </p>')
                    html.push('     </div>')
                    html.push('     <div class="price float-left origin-line-height">' + (item['count'] || 0) + '</div>')
                    html.push('</li>')
                    return true;
                })
                break;
        }
    }
    // console.log($('.message').html());

    $('.message').html(html.join(''));
    type1_value = $('.visitor').attr('gys');
    type2_value = $('.chanpin').attr('gys');

    // 文字对齐
    if (type2_value === 'lb' || type2_value === 'gy') {
        $('.order').css('text-align', 'center');
    } else {
        $('.order').css('text-align', 'left');
    }

    $('.order-stat').text($('.chanpin').text());
    if (type1_value === 'xs') {
        $('.number_all').text(res['hj'] || 0);
        $('.price-all').text('金额');
    } else {
        if ($.nui.isTrue(data['visitor_total'])) {
            $('.number_all').text(data['visitor_total'][0]['count'] || 0);
        } else {
            $('.number_all').text(0);
        }
    }
}

// 把数据拼成echarts需要的格式
function echarts_data(echarts_data, color_data) {
    var select_data = [];
    var data = []
    if (init_type === 'xs') {
        select_data = echarts_data;
        for (var i = 0; i < select_data.length; i++) {
            if (i < 6) {
                switch (init_type2) {
                    case 'cp':
                        data[i] = {
                            'value': select_data[i]['hsje'],
                            'name': select_data[i]['cp_mc'],
                            'itemStyle': {
                                'color': {
                                    'type': 'linear',
                                    'x': 0,
                                    'y': 0,
                                    'x2': 1,
                                    'y2': 0,
                                    'colorStops': [
                                        { 'offset': 0, 'color': color_data[i]['begin_color'] },
                                        { 'offset': 1, 'color': color_data[i]['end_color'] }
                                    ],
                                    'globalCoord': false
                                }
                            }
                        }
                        break;
                    case 'lb':
                        data[i] = {
                            'value': select_data[i]['hsje'],
                            'name': select_data[i]['lb_mc'],
                            'itemStyle': {
                                'color': {
                                    'type': 'linear',
                                    'x': 0,
                                    'y': 0,
                                    'x2': 1,
                                    'y2': 0,
                                    'colorStops': [
                                        { 'offset': 0, 'color': color_data[i]['begin_color'] },
                                        { 'offset': 1, 'color': color_data[i]['end_color'] }
                                    ],
                                    'globalCoord': false
                                }
                            }
                        }
                        break;
                    case 'gy':
                        data[i] = {
                            'value': select_data[i]['hsje'],
                            'name': select_data[i]['gy_mc'],
                            'itemStyle': {
                                'color': {
                                    'type': 'linear',
                                    'x': 0,
                                    'y': 0,
                                    'x2': 1,
                                    'y2': 0,
                                    'colorStops': [
                                        { 'offset': 0, 'color': color_data[i]['begin_color'] },
                                        { 'offset': 1, 'color': color_data[i]['end_color'] }
                                    ],
                                    'globalCoord': false
                                }
                            }
                        }
                        break;
                }
            }
        }
        return data
    } else {
        
        select_data = echarts_data['type_result'];
        for (var i = 0; i < select_data.length; i++) {
            if (i < 6) {
                switch (init_type2) {
                    case 'cp':
                        data[i] = {
                            'value': select_data[i]['count'],
                            'name': select_data[i]['cp_mc'],
                            'itemStyle': {
                                'color': {
                                    'type': 'linear',
                                    'x': 0,
                                    'y': 0,
                                    'x2': 1,
                                    'y2': 0,
                                    'colorStops': [
                                        { 'offset': 0, 'color': color_data[i]['begin_color'] },
                                        { 'offset': 1, 'color': color_data[i]['end_color'] }
                                    ],
                                    'globalCoord': false
                                }
                            }
                        }
                        break;
                    case 'lb':
                        data[i] = {
                            'value': select_data[i]['count'],
                            'name': select_data[i]['cp_lb_mc'],
                            'itemStyle': {
                                'color': {
                                    'type': 'linear',
                                    'x': 0,
                                    'y': 0,
                                    'x2': 1,
                                    'y2': 0,
                                    'colorStops': [
                                        { 'offset': 0, 'color': color_data[i]['begin_color'] },
                                        { 'offset': 1, 'color': color_data[i]['end_color'] }
                                    ],
                                    'globalCoord': false
                                }
                            }
                        }
                        break;
                    case 'gy':
                        data[i] = {
                            'value': select_data[i]['count'],
                            'name': select_data[i]['gy_mc'],
                            'itemStyle': {
                                'color': {
                                    'type': 'linear',
                                    'x': 0,
                                    'y': 0,
                                    'x2': 1,
                                    'y2': 0,
                                    'colorStops': [
                                        { 'offset': 0, 'color': color_data[i]['begin_color'] },
                                        { 'offset': 1, 'color': color_data[i]['end_color'] }
                                    ],
                                    'globalCoord': false
                                }
                            }
                        }
                        break;
                }
            }
        }
        return data
    }
}

// echats图形编辑
function echarts_edit(data) {
    /**获取数据中的值，赋给echarts */
    var xingqu = document.getElementById("container");
    var myChart = echarts.init(xingqu);
    option = null;
    option = {
        backgroundColor: '#fff',
        tooltip: {
            trigger: 'item',
            formatter: "{b} : {c} ({d}%)"
        },
        series: [
            {
                type: 'pie',
                startAngle: 240,
                radius: ['40%', '80%'],
                center: ['50%', '55%'],
                roseType: 'radius',
                label: {
                    normal: {
                        textStyle: {
                            color: 'rgba(255, 255, 255, 0.3)'
                        }
                    }
                },
                labelLine: {
                    normal: {
                        lineStyle: {
                            color: 'rgba(255, 255, 255, 0.3)'
                        },
                        smooth: 0.2,
                        length: 10,
                        length2: 20
                    }
                },
                /**引入数据 */
                data: echarts_data(data, color_data)
            }
        ]
    };
    myChart.setOption(option, true);
    myChart.on('click', function (param) {//不监听会报错
        return;
    })
}

// 根据类型切换改变类型
function switchType(type) {
    switch (type) {
        case 'fw':
            search_data['type'] = 'fw';
            break;
        case 'xs':
            search_data['type'] = 'xs';
            break;
        // 没有default
    }
}

// 根据类型切换显示对应文本
function changeTotalTxt(type) {
    switch (type) {
        case 'fw':
            $('.type-title').text('总访问');
            $('.type-unit').text('次');
            break;
        case 'xs':
            $('.type-title').text('总金额');
            $('.type-unit').text('');
            break;
        // 没有default
    }
}

// 事件公用执行方法
function bindEvent() {
    $('#visitor').on('click', function () {
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: visitor_data,
            choose: function (res) {
                $(visitor_data).each(function (i, obj) {
                    if (obj['id'] == res['id']) {
                        visitor_data[i]['is_choose'] = 1;
                    } else {
                        visitor_data[i]['is_choose'] = 0;
                    }
                })
                $('.visitor').text(res['name'] || "").attr('gys', (res['db_name'] || ""));
                init_type = $('.visitor').attr('gys');
                switchType(res['db_name']);  // 根据类型切换改变类型
                changeTotalTxt(search_data['type']); // 根据类型切换显示对应文本
                getList(res['db_name'], $('.chanpin').attr('gys') || 'cp');
            }
        });
    });

    $('#chanpin').on('click', function () {
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: cp_data,
            choose: function (res) {
                $(cp_data).each(function (i, obj) {
                    if (obj['id'] == res['id']) {
                        cp_data[i]['is_choose'] = 1;
                    } else {
                        cp_data[i]['is_choose'] = 0;
                    }
                })
                $('.chanpin').text(res['name'] || "").attr('gys', (res['db_name'] || ""));
                init_type2 = $('.chanpin').attr('gys');
                getList($('.visitor').attr('gys') || 'fw', res['db_name'])
            }
        });
    });

    // 打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        axisX = [];
        var sideslip = fun.getItem(html_name + 'sideslip'); // 搜索页是否可以打开
        var options = {
            time: {
                begin_date: search_data['begin_time'], // 起始时间
                end_date: search_data['end_time'], // 结束时间
                text: {
                    begin_text: '开始日期',
                    end_text: '结束日期'
                }
            },
        };
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    return_page: html_name,
                    search_data: options,
                    reset: reset,
                    is_restbutton: true,
                    type: 'shop_xq_fx'
                },
            });
        }
    })

    // 日期切换
    $('body').on('tap', '.btn_click', fun.debounce(function () {
        if (last['date'] === $(this).index()) return;
        last['date'] = $(this).index();
        axisX = [];
        echartShowData = [];
        $(this).addClass('main-color').siblings().removeClass('main-color');
        var selTime = $(this).data('time');
        var tempObj = null;
        switch (selTime) {
            case 'this_year': // 本年
                tempObj = fun.getYearArr(1)[0];
                break;
            case 'last_month': // 上月
                tempObj = fun.getLastMonth();
                break;
            case 'this_month': // 本月
                tempObj = fun.getMonthArr(1)[0];
                break;
            case 'lately_seven': // 近7天
                tempObj = fun.getLatelyTime(7, false);
                break;
            case 'lately_fifteen': // 近15天
                tempObj = fun.getLatelyTime(15, false);
                break;
            case 'lately_thirty': // 近30天
                tempObj = fun.getLatelyTime(30, false);
                break;
        }

        $('#begin_date').text(tempObj['begin_date']);
        $('#end_date').text(tempObj['end_date']);

        search_data['begin_time'] = fun.Date(tempObj['begin_date']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(tempObj['end_date']).Format('yy-mm-dd');
        search_data['id'] = search_data['id'];
        getList($('.visitor').attr('gys'), $('.chanpin').attr('gys'));
    }, 300))
}

function init() {
    reset = { // 重置日期
        begin_date: fun.getLatelyTime(30, true)['begin_date'],
        end_date: fun.getLatelyTime(30, true)['end_date']
    }
    $('#begin_date').text(fun.getLatelyTime(30, false)['begin_date']); // 起始时间
    $('#end_date').text(fun.getLatelyTime(30, false)['end_date']); // 结束时间
    search_data['begin_time'] = fun.getLatelyTime(30, true)['begin_date'];
    search_data['end_time'] = fun.getLatelyTime(30, true)['end_date'];
    bindEvent();
    getList();
}