let imgData, // 页面参数
	imgEdit, // 裁剪图片方法
	pinch, // 图片缩放方法
	imgTailor, // 裁剪后图片返回的数据
	listTimeRoll,
	aggregateRoll,
	coordinate_arr = [], //识别出来的坐标数组
	r = 10, //绘图圆的半径
	power = {
		// 记录计算出来的匹数
		isPower: true, // 是否第一次上传
		listTimeAq: 0, // 上次识别匹
		thisTimeAq: 0, // 本次识别匹
		aggregateAq: 0, // 累计识别匹
	};

// 页面初始化
apiready = function () {
	imgData = api.pageParam;

	// 根据类型显示重拍或重选
	if (imgData.type === 'downbeat') {
		$('.downbeat').show();
		$('.reselect').hide();
	} else {
		$('.downbeat').hide();
		$('.reselect').show();
	}

	// 打开页面隐藏上次匹和累计匹
	if (power.isPower) {
		$('.list-time-aq').hide();
		$('.aggregate-aq').hide();
	}

	// 实例化裁剪方法
	imgEditMethod(imgData.base64);
};

/******头部显示******/
$('#header').header({
	back: true,
	title: '智能计数',
	appendBackBtnEvt: function () {
		// api.sendEvent({
		// 	name: page_data['return_page'] || '',
		// 	extra: {
		// 		status: 'personalCard',
		// 	},
		// });
		api.closeWin();
	},
});

// 重拍
$('.downbeat').click(function () {
	openCamera();
});

// 重选
$('.reselect').click(function () {
	openAlbum();
});

// 开始计算
$('.start-to').click(function () {
	base64Size(imgData.base64, '大小');
	imgTailor = imgEdit.crop(); // 获取裁剪后的数据
	imgTailor = {
		...imgTailor,
		x: imgTailor.x * imgTailor.rate,
		y: imgTailor.y * imgTailor.rate,
		w: imgTailor.w * imgTailor.rate,
		h: imgTailor.h * imgTailor.rate,
	};
	r = 10 * imgTailor.rate;
	if (!imgTailor.base64Data) return;
	// 判断长宽比
	proportionJudge(imgTailor.base64Data).then((is) => {
		console.log(is);
		if (is) {
			imgTailor.removeBase64Head = imgTailor.base64Data.replace(/^data:image\/\w+;base64,/, ''); // 去掉base64位头部
			// 计算
			physicalDetection(imgTailor.removeBase64Head);
		} else {
			api.alert({ msg: '识别区域的长宽比应在3:1以内' });
		}
	});
});

// 点击图片生成圆点
$('.new-canavs-box').on('click', '#new_image', function (e) {
	d1 = new Date().getTime();
	let x = e.offsetX * imgTailor.rate,
		y = e.offsetY * imgTailor.rate,
		is_exist = false; //判断点击的坐标是否已经存在了，没有的话就添加一个
	let i;
	coordinate_arr.forEach((item, index) => {
		if (item.x - r < x && x < item.x + r && item.y - r < y && y < item.y + r) {
			i = index;
			is_exist = true;
		}
	});
	if (!is_exist) {
		coordinate_arr.push({ x: x, y: y, is_click: 0 });
	} else {
		coordinate_arr.splice(i, 1); // 存在的话就删除了
	}
	// 绘图
	plot();
});

// 打开相机
function openCamera (type) {
	api.getPicture(
		{
			sourceType: 'camera', // 图片源类型，从相册、图片库或相机获取图片
			encodingType: 'jpg', // 返回图片类型，jpg或png
			mediaValue: 'pic', // 媒体类型，图片或视频
			destinationType: 'base64', // 返回数据类型，指定返回图片地址或图片经过base64编码后的字符串
			quality: 70, // 图片质量，只针对jpg格式图片（0-100整数）
			targetWidth: 1080, // 压缩后的图片宽度，图片会按比例适配此宽度
			// targetHeight: 500, // 压缩后的图片高度，图片会按比例适配此高度
			saveToPhotoAlbum: false, // 拍照或录制视频后是否保存到系统相册目录。注意此处仅是文件系统层面的操作，使用诸如“图库”App仍然有可能查看到。
		},
		function (ret, err) {
			if (ret && ret.base64Data) {
				if (type === 'reset') {
					// 清零识别匹
					$('.count-after').hide();
					$('.count-before').show();
					power.listTimeAq = 0;
					power.thisTimeAq = 0;
					reckonIdentifyAq();
				} else if (type === 'aggregate') {
					// 累加识别匹
					$('.count-after').hide();
					$('.count-before').show();
					power.listTimeAq = power.aggregateAq;
					reckonIdentifyAq();
				}
				// 生成裁剪框
				imgEditMethod(ret.base64Data);
			} else {
				console.log(err);
			}
		}
	);
}

// 打开相册
function openAlbum (type) {
	api.getPicture(
		{
			sourceType: 'library', // 图片源类型，从相册、图片库或相机获取图片
			encodingType: 'jpg', // 返回图片类型，jpg或png
			mediaValue: 'pic', // 媒体类型，图片或视频
			destinationType: 'base64', // 返回数据类型，指定返回图片地址或图片经过base64编码后的字符串
			quality: 80, // 图片质量，只针对jpg格式图片（0-100整数）
			targetWidth: 1080, // 压缩后的图片宽度，图片会按比例适配此宽度
			// targetHeight: 400, // 压缩后的图片高度，图片会按比例适配此高度
			saveToPhotoAlbum: false, // 拍照或录制视频后是否保存到系统相册目录。注意此处仅是文件系统层面的操作，使用诸如“图库”App仍然有可能查看到。
		},
		function (ret, err) {
			if (ret && ret.base64Data) {
				if (type === 'reset') {
					// 清零识别匹
					$('.count-after').hide();
					$('.count-before').show();
					power.listTimeAq = 0;
					power.thisTimeAq = 0;
					reckonIdentifyAq();
				} else if (type === 'aggregate') {
					// 累加识别匹
					$('.count-after').hide();
					$('.count-before').show();
					power.listTimeAq = power.aggregateAq;
					reckonIdentifyAq();
				}
				// 生成裁剪框
				imgEditMethod(ret.base64Data);
			} else {
				console.log(err);
			}
		}
	);
}

// 重算
$('.rollback').on('click', function () {
	physicalDetection(imgTailor.removeBase64Head);
});

// 清零
$('.reset').on('click', function () {
	if (imgData.type === 'downbeat') {
		isBool = openCamera('reset');
	} else if (imgData.type === 'reselect') {
		isBool = openAlbum('reset');
	}
});

// 累加
$('.aggregate').on('click', function () {
	if (imgData.type === 'downbeat') {
		isBool = openCamera('aggregate');
	} else if (imgData.type === 'reselect') {
		isBool = openAlbum('aggregate');
	}
});

// 物理检测token调用
function physicalDetection (base64) {
	if (!base64) return;
	fun.showLoad('计算中...'); // 加载状态
	// 计算截取图片坐标
	var __app_id="fsYDonlOUcALwSTINJE0F7w";
	var __app_key="VSczQDM5p5GjI3wPMhohaUSsnRg3BI4mJ";
	var timestamps1 = $.nui.getRandomNum();
	$.ajax({
        type: 'POST',
        url: AJAX_URL.smartCount,
		dataType: 'json',
        data: {
			sign: $.nui.md5(`${__app_id}|${__app_key}|${timestamps1}`),
			timestamps: timestamps1,
			app_id: __app_id,
			data:{
				image: base64
			}
		},
        success: function (res) {
			console.log('计算状态', res);
			if (res && (res.status == 0 || res.status == 200) && res.data) {
				api.hideProgress();
				// 隐藏计算前的图片,显示计算后的图片
				$('.count-before').hide();
				$('.count-after').show();

				// 展示对应的字体图标
				if (imgData.type === 'downbeat') {
					$('.count-operate .icon-paizhao').show();
					$('.count-operate .icon-zhaopian').hide();
				} else if (imgData.type === 'reselect') {
					$('.count-operate .icon-paizhao').hide();
					$('.count-operate .icon-zhaopian').show();
				}

				// 重置元素
				$('.count-after .new-image').remove();
				$('.count-after .new-canavs-box').prepend('<img id="new_image" class="new-image" />');
				// 给当前的图片和容器设置宽高
				$('.new-canavs-box').css({ width: imgTailor.cw, height: imgTailor.ch });
				$('#new_image').css({ width: imgTailor.cw, height: imgTailor.ch });
				pinch = null;
				// 实例化图片缩放
				pinch = new RTP.PinchZoom($('#new_image'), {
					maxZoom: 8,
					minZoom: 0.8,
					onZoomStart: function (object, event) { },
					onZoomUpdate: function (object, event) { },
				});

				// 计算坐标
				computed(res.data);
				// 绘图
				plot();
			} else {
				fun.toast(res && res.msg ? res.msg : '计算失败');
			}
			fun.hideLoad();
        },
		complete:function(){
			fun.hideLoad();
		}
    });
	
}

// 实例化裁剪方法
function imgEditMethod (base64) {
	// 删除子元素
	$('.count-before .canvas-container').empty();
	// 重新生成结构
	$('.count-before .canvas-container').html('<canvas id="mycanvas" class="car-canvas"></canvas>');

	// 重置 实例化
	imgEdit = null;
	imgEdit = new veImage({
		canvas: $('#mycanvas').get(0), // 画布
		image: base64, // 图片地址路径或base64编码
		container: $('.count-before .canvas-container').get(0),
	});

	// 更新图片
	imgData.base64 = base64;
}

//计算坐标数据
function computed (data) {
	// 重置计算坐标列表
	coordinate_arr = [];
	data.forEach((item, index) => {
		// let x = imgTailor.x + item.location.left + item.location.width / 2,
		//     y = imgTailor.y + item.location.top + item.location.height / 2;
		let x = imgTailor.x + item.location.left * imgTailor.rate + (item.location.width / 2) * imgTailor.rate,
			y = imgTailor.y + item.location.top * imgTailor.rate + (item.location.height / 2) * imgTailor.rate;
		let obj = { x: x, y: y, is_click: 1 };
		coordinate_arr.push(obj);
	});
}

// 绘图
function plot () {
	// console.log(coordinate_arr);
	let canvas = document.getElementById('new_canvas'),
		cvsCtx = canvas.getContext('2d'),
		img = new Image();
	img.src = imgData.base64;
	img.onload = function () {
		canvas.width = img.width;
		canvas.height = img.height;
		cvsCtx.drawImage(img, 0, 0, img.width, img.height);
		//画圆点
		coordinate_arr.forEach((item) => {
			let color = item.is_click == 0 ? '#ff0033' : '#0097f5';
			cvsCtx.beginPath(); //注意此处
			cvsCtx.fillStyle = color;
			cvsCtx.arc(item.x, item.y, r, 0, 2 * Math.PI);
			cvsCtx.fill();
			cvsCtx.closePath(); //注意此处
		});

		// 获取画布中的图片
		let cvsBase64 = canvas.toDataURL();
		$('#new_image').attr('src', cvsBase64);
		// 计算识别匹
		reckonIdentifyAq();
	};
}

// 计算识别匹
function reckonIdentifyAq () {
	power.thisTimeAq = coordinate_arr.length; // 本次
	power.aggregateAq = power.listTimeAq + power.thisTimeAq; // 累计

	// 重置匹数
	if (power.isPower) {
		power.isPower = false;
		// 初始化滚动方法
		thisTimeRoll = $('.this-time-aq .amount').numberAnimate({ num: power.thisTimeAq, speed: 1000 }); // 本次滚动
		aggregateRoll = $('.aggregate-aq .amount').numberAnimate({ num: power.aggregateAq, speed: 1000 }); // 累计滚动
	} else {
		thisTimeRoll.resetData(power.thisTimeAq);
		aggregateRoll.resetData(power.aggregateAq);
	}

	// 隐藏和渲染匹
	if (power.listTimeAq === 0 || power.isPower) {
		// 若上次匹数量为 0 就不显示上次匹和累计匹
		$('.list-time-aq').hide();
		$('.aggregate-aq').hide();
	} else {
		$('.list-time-aq .amount').text(power.listTimeAq); // 上次匹
		$('.list-time-aq').show();
		$('.aggregate-aq').show();
	}
}

// 计算 base64 编码大小
function base64Size (base64, txt = '编码大小 ') {
	let stringLength = base64.replace(/^data:image\/\w+;base64,/, '').length;
	let sizeInBytes = 4 * Math.ceil(stringLength / 3) * 0.5624896334383812;
	let sizeInKb = sizeInBytes / 1024;
	console.log(txt, sizeInKb + 'kb');
	return sizeInKb;
}

// 判断图片比例 不能超过3:1
function proportionJudge (base64) {
	return new Promise(function (reslove, reject) {
		let image = new Image();
		image.src = base64;
		image.onload = function () {
			let imageRate = image.width / image.height;
			if (imageRate >= 3 || imageRate <= 0.34) {
				reslove(false);
			} else {
				reslove(true);
			}
		};
	});
}
