var html_name = page_arr.xs_cpfx_xq;
var topVal = "TOP 10";
var titles;
var type_arr = [
    { 'name': 'TOP 10', 'id': '10', "is_choose": 1 },
    { 'name': 'TOP 20', 'id': '20' },
    { 'name': 'TOP 30', 'id': '30' }];
var search_data = {
    'type': 'getXqInfo',
    'limit': 10,
};
// var param_data = [];

page_init = function () {
    titles = $.nui.isTrue(page_data['cp_mc']) ? page_data['cp_bh'] + page_data['cp_mc'] : page_data['cp_bh'];
    $('#header').header({
        back: true, //返回
        title: titles, //标题
        text_btn: true, //文字按钮
        text_val: topVal, //文字按钮值
    });
    $('.theme-date').text(page_data.begin_time.replace(/-/g, '.') + '-' + page_data.end_time.replace(/-/g, '.'));
    getList();
}

//点击切换类型
$('body').on('touchend', '#complete_btn', function (e) {
    e.preventDefault();
    var val = $(this).text();
    $(type_arr).each(function (i, arr) {
        if ('TOP ' + type_arr[i]['id'] == val) {
            type_arr[i]['is_choose'] = 1;
        } else {
            type_arr[i]['is_choose'] = 0;
        }
    });
    fun.showBookList({
        width: '280px',
        shadeClose: true,
        list: type_arr,
        choose: function (res) {
            $('#complete_btn').text(res.name);
            search_data['limit'] = res.id;
            getList();
        }
    });
    return false;
});

function getList() {
    var param = $.extend({
        "cp_mc": page_data.cp_mc || '',
        "cp_id": page_data.cp_id || 0,
        "ck_id": 0,
        "cp_bh": page_data.cp_bh || '',
        "begin_time": page_data.begin_time,
        "end_time": page_data.end_time,
    }, search_data);
    console.log(JSON.stringify(param))
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileCpfx,
        data: param,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    // return $('.theme-content').html('<p class="empty_text cpfx_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '.theme-content', btnShow: false });
                }
                var datas = res['data'];
                console.log('---请求');
                console.log(res);
                console.log('---请求');
                // console.log(JSON.stringify(datas))

                //拼接图表数据
                if ($.nui.isTrue(datas.chart)) {
                    var hsje_arr = [],
                        fuje_arr = [];
                    $.each(datas.chart, function (i, arr) {
                        if (arr['je'] < 0 || arr['je'] === 0) {
                            fuje_arr.push({ 'value': arr['je'], 'name': arr['kh_mc'] });
                        } else {
                            hsje_arr.push({ 'value': arr['je'], 'name': arr['kh_mc'] });
                        }
                    });
                    hsje_arr = (datas.chart.length === fuje_arr.length) ? fuje_arr : hsje_arr;
                    showChart(hsje_arr, datas.hj);
                } else {
                    $('.pie_chart').hide();
                }

                // showList(limitData(datas.chart, search_data['limit']));
                showList(datas['chart']);
                ranking(datas['pm_list']);
                monthlySales(datas.list);
            }
        }
    })
}

// 渲染环形图
function showChart(arr, sum) {
    var myChart = echarts.init(document.getElementById('chart'));
    var option = {
        title: [{
            text: '总销售额',
            x: 'center',
            top: '45%',
            textStyle: {
                color: '#a5a5a5',
                fontStyle: 'normal',
                fontWeight: '600',
                fontFamily: 'sans-serif',
                fontSize: 12
            }
        }, {
            text: sum,//"1232552.32"
            x: 'center',
            top: '50%',
            textStyle: {
                color: '#000',
                width: '50%',
                fontStyle: 'normal',
                fontWeight: '400',
                fontFamily: 'sans-serif',
                fontSize: 16
            }
        }],
        tooltip: {
            trigger: 'item',
            formatter: "{b} ({d}%)<br/>{a}: {c} "
        },
        series: [{
            name: '含税金额',
            type: 'pie',
            color: order_color,
            radius: ['60%', '80%'],
            avoidLabelOverlap: true,
            label: {
                normal: {
                    show: false,
                    position: 'center'
                }
            },
            labelLine: {
                normal: {
                    show: false
                }
            },
            data: arr,
        }]
    };
    myChart.setOption(option);
    myChart.on('click', function (param) {//不监听会报错
        return;
    });
}

//渲染客户列表
function showList(data) {
    var html = [];
    $.each(data, function (i, list) {
        // console.log(JSON.stringify(list))
        var chart_color = order_color[i % order_color.length];
        var serial = i > 2 ? (i + 1) + '.' : '';
        html.push('<li class="list-item lower-border-line khfx clearfix" data-kh="' + (list['kh_mc'] || '') + '" data-id="' + (list['kh_id'] || 0) + '">');
        html.push('		<div class="customer clearfix">');
        html.push('			<div class="ranking">' + serial + '</div>');
        html.push('			<div class="circular" style="background-color:' + chart_color + '"></div>');
        html.push('			<span class="list-name">' + (list['kh_mc'] || '') + '</span>');
        html.push('			<i class="iconfont icon-youfanhui youfanhui"></i>');
        html.push('		</div>');
        html.push('		<div class="lower clearfix">');
        html.push('			<span class="total-sales">总销售</span>');
        html.push('			<span class="piece">' + (list['ps'] || 0) + '匹</span>');
        html.push('			<span class="weight">' + (list['sl'] || 0) + (list['dw_mc'] || '') + '</span>');
        html.push('			<span class="price">￥' + (list['je'] || 0) + '</span>');
        html.push('		</div>');
        html.push('</li>');
    });
    $('.list-group').html(html.join(''));
}

//赋值排名对应数据
function ranking(data) {
    // console.log(JSON.stringify(data))
    var thl = data.thl || 0;
    var mll = data.mllv || 0;

    $('#fhjs_sl').text(data.xss || 0); //销售数-销售
    $('#thjs_sl').text(data.ths || 0); //销售数-退货

    $('#fhjs_hsje').text(data.xse || 0); //销售额-销售
    $('#thjs_hsje').text(data.the || 0); //销售额-退货

    $('#thl').text((Number(thl || 0).fixed(2) + '%')); //退货率

    $('#kc_zps').text(data.kcp || 0); //库存-匹数
    $('#kc_zsl').text(data.kcs || 0); //库存-总数量

    $('#pjcb').text(data.pjcb || 0); //价格分析-成本
    $('#pjsj').text(data.pjsj || 0); //价格分析-售价

    $('#ml').text(data.ml || 0); //销售额-退货
    $('#mll').text((Number(mll || 0).fixed(2) + '%')); //毛利率
}

//每月销售情况
function monthlySales(data) {
    if (data.length === 0) {
        $('.finance-heading').hide();
    }
    var html = [];
    $.each(data, function (i, sales) {
        var sl_str = (sales['sl'] + sales['dw_mc']) || '';
        html.push('<li class="finance-term2 lower-border-line msale" data-rq = "' + (sales['rq'] || '') + '">');
        html.push('<span class="finance-date finance-high">' + (sales['rq'] || '') + '</span>');
        html.push('<div class="finance-sales-number">');
        html.push('<span class="finance-kilo">' + sl_str + '</span>');
        html.push('<span class="finance-piece">' + (sales['ps'] || '') + '匹</span></div>');
        html.push('<div class="finance-sales-volume finance-high">');
        html.push('<span class="finance-achievement">' + (sales['je'] || '') + '</span>');
        html.push('<i class="iconfont icon-youfanhui finance-youfanhui"></i></div></li>');
    });
    $('#monthSales').html(html.join(''));
}

//客户分析-详情
$('body').on('tap', '.khfx', function () {
    // var value = $(this);
    fun.showPageFull({
        page_url: page_arr.xs_khfx_xq,
        pageParam: {
            wldw_mc: $(this).data('kh'),
            wldw_id: $(this).data('id'),
        }
    });
});

//发退货结算统计
// $('body').on('tap', '.msale', function () {
//     var rq = getDate($(this).data('rq'));
//     var cp_id = $(this).data('cp');
//     //如果当前用户有：发退货结算统计 页面 的浏览权限
//     if (Auth.checkArr(['bp_xsfhjs', 'bp_xsthjs'], 'view', 'in')) {
//         fun.showPageFull({
//             page_url: page_arr.xs_fthjs_tj,
//             pageParam: {
//                 cp_id: cp_id,
//                 begin_time: rq.begin_time,
//                 end_time: rq.end_time
//             }
//         });
//     }
// });

//点击每月销售记录，跳转到发退货结算统计
$('body').on('tap', '.msale', function () {
    if (Auth.checkArr(['bp_xsfhjs', 'bp_xsthjs'], 'view', 'in')) {
        var date = $(this).data('rq');
        var begin_date = $.nui.dayjs(date).startOf('month').format('YYYY-MM-DD');
        var end_date = $.nui.dayjs(date).endOf('month').format('YYYY-MM-DD');
        fun.showPageFull({
            page_url: page_arr.xs_fthjs_tj,
            pageParam: {
                "type": 'cp_fx',
                "cp_id": page_data['cp_id'] || 0,
                "cp_mc": titles,
                "begin_date": begin_date,
                "end_date": end_date,
                // "details": details
            }
        });
    }
});
//判断金额是否全为正负数
// function judgeData(str, limit) {
//     var ss = [], qt = 0, negative = 0, plus = 0;
//     for (var i in str) {
//         if (i < limit) {
//             if (str[i] < 0) negative++;
//             else plus++;
//         }
//     }
//     if (!!negative && !!plus) {
//         earnD(str, 'alien');
//     } else {
//         earnD(str, '');
//     }

//     function earnD(arr, type) {
//         for (var i in arr) {
//             if (i < limit) {
//                 if (arr[i] < 0 && type == 'alien') ss.push(0);
//                 else ss.push(arr[i]);
//             } else {
//                 qt = parseInt(qt) + parseInt(arr[i]);
//             }
//         }
//     }

//     if (!!qt) ss.push(qt);
//     return ss;
// }

//获取开始日期和结束日期
// function getDate(str) {
//     var m, d, begin_time = '', end_time = '';
//     var year = parseInt(str.split('-')[0]);
//     var month = parseInt(str.split('-')[1]);
//     if (month == 2) {
//         if ((year % 4 == 0 && year % 100 != 0) || (year % 400 == 0)) d = 29;
//         else d = 28;
//     } else if ([4, 6, 9, 11].indexOf(month) != -1) {
//         d = 30;
//     } else {
//         d = 31;
//     }

//     m = (month < 10) ? ('0' + month) : month;
//     begin_time = year + '-' + m + '-' + '01';
//     end_time = year + '-' + m + '-' + d;
//     return {
//         'begin_time': begin_time,
//         'end_time': end_time
//     }
// }


// function limitData(arr, limit) {
//     var rs = [];
//     for (i in arr) {
//         if (i < limit) {
//             rs.push(arr[i]);
//         }
//     }
//     return rs;
// }
