var html_name = page_arr.xs_djcx;

//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [], ztj_data = [];

//发送api查询参数
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "type": "dj_zb"    //订金查询API固定需要的
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

var USER_INFO = {};
var _hz = html_name + '_hz_';
var _html_name = html_name + '_';

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = fun.getItem(_html_name + 'group') || "";

    // 页面加载，要先读取有记忆的搜索条件
    search_storage = $.extend(true, {
        'xswdy': fun.getItem(html_name + 'xswdy', 0),
        'hldj': fun.getItem(html_name + '_hldj', 0),
        "hz": {
            "choose": {
                "kh": fun.getItem(_hz + 'kh', 0),
                "md": fun.getItem(_hz + 'md', 0)
            },
            "text": fun.getItem(_hz + 'text', ""),
        }
    }, search_storage);
    search_data = $.extend({}, search_data, search_storage);

    // 初始页面默认请求的数据
    getList(search_data);


    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {

        var param = ret.value.data;
        //api查询所需参数
        search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间
        search_data['wldw_id'] = param.kh['id'] || 0;                 //供应商
        search_data['md_id'] = param.md['id'] || 0;                    //门店
        search_data['xswdy'] = param['xswdy'];
        search_data['hldj']=param['hldj']

        //搜索菜单需要缓存的数据
        search_storage['keyword'] = search_data['keyword'];
        search_storage['begin_date'] = search_data['begin_time'];
        search_storage['end_date'] = search_data['end_time'];
        search_storage['xswdy'] = param['xswdy'];                //显示为抵用
        search_storage['kh'] = param.kh;
        search_storage['md'] = param.md;
        search_storage['hldj'] = search_data['hldj'];

        fun.setItem(html_name + 'xswdy', search_storage['xswdy']);
        fun.setItem(html_name + '_hldj', search_storage['hldj']);

        //设置时间控件时间
        date_bar.setDate(search_storage);

        fun.setItem(html_name + 'xswdy', search_storage['xswdy']);

        //汇总功能
        search_data['group'] = param.hz['group'] || '';
        search_storage['hz'] = param.hz;
        var hc = param['hz']['choose'];
        fun.setItem(_html_name + 'group', search_data['group']);
        fun.setItem(_hz + 'kh', hc['kh']);
        fun.setItem(_hz + 'md', hc['md']);
        fun.setItem(_hz + 'text', param.hz['text']);
        fun.setItem(html_name + 'sideslip', true);

        // $('#order_list').empty();
        // page_list = [];
        fun.clearPage($('#order_list'));
        getList(search_data);

    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}

$('#header').header({
    back: true,
    filter: true,
    title: '订金查询'
});

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'],
            "placeholder": "单号"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [
            {
                key: "kh",
                "text": "客户",
                "value": (search_storage['kh'] && search_storage['kh']['text']) || '',
                "id": (search_storage['kh'] && search_storage['kh']['id']) || '',
            }, {
                key: "md",
                "text": "门店",
                "value": (search_storage['md'] && search_storage['md']['text']) || '',
                "id": (search_storage['md'] && search_storage['md']['id']) || '',
            },
            {
                key: "hz",
                "text": "汇总",
                "group": [
                    { name: '客户', key: "kh", columns: 'wldw_id,wldw_mc', choose: getHz('kh') },
                    // { name: '单号', key: "dh", columns: 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc', choose: getHz('dh') },
                    // { name: '门店', key: "md", columns: 'md_id,md_mc', choose: getHz('md') }
                ],
                "value": getVal('hz', 'text'),
            }
        ],

        "switch": [
            {
                "text": "显示未抵用",
                "max_width": true,
                "key": "xswdy",
                "value": search_storage['xswdy']
            },
            {"text": "合拢单据", "max_width": true, "key": "hldj", "value": search_storage['hldj']},
        ],
    }
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

// 订单编辑
// $('body').on('tap', '#order_list', function () {
//     fun.showPageFull({
//         page_url: page_arr.xs_khdd_kd,
//         pageParam: {}
//     });
// });

var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            // $('#order_list').empty();
            fun.clearPage($('#order_list'));
            getList(search_data);
        }
    });

var order_data = [
    {
        wldw_mc: '客户名称',
        md_mc: '门店',
        zdr_mc: '制单人',
        kdsj: '2018-05-28 15:30',
        dh: 'CDD1812270006',
        dj: 10,
        ydy: 2,
        wdy: 8,
    }, {
        wldw_mc: '客户名称',
        md_mc: '门店',
        zdr_mc: '制单人',
        kdsj: '2018-05-28 15:30',
        dh: 'CDD1812270006',
        dj: 10,
        ydy: 2,
        wdy: 8,
    },
];

// showList(order_data);

function showList(data) {
    $('#tj1').text(ztj_data[0]['dj'] || 0);//总订货
    $('#tj2').text(ztj_data[0]['ydyje'] || 0);//已抵用
    $('#tj3').text(ztj_data[0]['wdyje'] || 0);//未抵用
    function getFloat(value) {
        value = parseFloat(value);
        var noVirtualValue = (value == 0 || isNaN(value))
        if (noVirtualValue) return 0;
        return value;
    }
    var hldj = fun.getItem(html_name + '_hldj', 0);

    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !hldj,
        render: {
            titlebar: function (res) {
                var html = [];
                var wldw = !!fun.is_value(res['wldw_mc']), // 往来单位名称
                    hmd = !!fun.is_value(res['md_mc']) || !!fun.is_value(res['zdr_mc']); // 门店名称 | 制单人名称
                if (!!res['md_id'] || res['md_id'] == 0) hmd = true; // 门店id
                var kdrq = !!fun.is_value(res['kdsj']); // 时间
                dh = !!fun.is_value(res['dh']); // 单号
                var is_sh = !!res['is_sh']; // 是否审核

                // 判断是否审核
                var is_shClass = is_sh ? 'button-blue' : 'button-gray';
                var is_shText = is_sh ? '已审核' : '未审核';
                var showName = !res['kdsj'] && !res['zdr_mc'] && !res['is_sh'] ? 'show-name' : '';

                 // if (wldw || hmd) {
                html.push('     <div class="item-top border-bottom">');
                wldw && html.push('  <p class="kh-name font-ls font-bold ' + showName + '">' + res['wldw_mc'] + '</p>');
                kdrq && html.push('  <div class="list-right">');
                kdrq && html.push('     <span class="time font-ss margin-right-s">' + fun.formatTime(res['kdsj']) + '</span>');
                hmd && html.push('      <span class="zdr font-ss margin-right-s zdr-text-width">' + res['zdr_mc'] + '</span>');

                // 有开启汇总不显示审核状态
                if (!search_data['group']) {
                    // 判断当前是否审核
                    html.push('             <span class="' + is_shClass + ' ' + 'border-radius-s  font-ss' + '">' + is_shText + '</span>');
                }

                html.push('          </div>');
                html.push('     </div>');

                // }
                // if (kdrq || dh) {
                // html.push('<div class="title-bar-row">');
                // kdrq && html.push('<div><span>' + fun.is_value(res['kdsj']) + '</span></div>');
                // dh && html.push('<div class="align-right" ><a>' + fun.is_value(res['dh']) + '</a></div>');
                // html.push('</div>');
                // }
                return html.join('');
            },
            subdata: function (res) { // 这一块不用管它
                return [
                    '<div class="item-bottom">',
                    '    <div class="font-ms">',
                    '        <span class="item-row-name">订金</span>',
                    '        <span class="item-row-money">' + getFloat(res['dj']) + '</span>',
                    '    </div>',
                    '    <div class="font-ms">',
                    '        <span class="item-row-name">已抵用</span>',
                    '        <span class="item-row-money">' + getFloat(res['ydyje']) + '</span>',
                    '    </div>',
                    '    <div class="font-ms">',
                    '        <span class="item-row-name">未抵用</span>',
                    '        <span class="item-row-money color-not">' + getFloat(res['wdyje']) + '</span>',
                    '    </div>',
                    '</div>'
                ].join('');
            }
        },
    });
}

// 获取汇总选中值
function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}
// 获取汇总文本
function getVal(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

/** 获取订金查询api
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL['getDjcxtj'],
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    $('#tj3').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                ztj_data = res['info'];
                page_list = res.data;
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        },
    })
}

// $('body').on('tap', '.item-top', function () {
//     $(this).next().slideToggle(100);
// })
