var html_name = page_arr.xs_khfx_cp;
var search_data = {};

$('#header').header({
    back: true,
    title: '客户名称',
    text_btn: true,
    text_val: 'TOP 10'
});

// 页面样式调整
function pageInit() {
    $('.top').css('top', api.safeArea.top + $('#header').outerHeight() - parseFloat($('html').css('fontSize')));
    $('.content').css('paddingTop', (parseFloat($('.top').css('top')) + $('.top').outerHeight()));
}

page_init = function () {
    pageInit();
    $('#header_title').text((page_data['wldw_mc'] || ""));
    $('#date').text((page_data['begin_time'] || "") + ' ~ ' + (page_data['end_time'] || ""));
    search_data = {
        begin_time: (page_data['begin_time'] || ""),
        end_time: (page_data['end_time'] || ""),
        wldw_id: (page_data['wldw_id'] || 0)
    }
    $('#complete_btn').text((fun.getItem(html_name + '_top') && fun.getItem(html_name + '_top')['name']) ? fun.getItem(html_name + '_top')['name'] : "TOP 10");
    getData();
}

function getData() {
    // console.log(JSON.stringify(search_data))
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getKhfxList,
        data: $.extend({}, {
            "type": "kh_cp",
            "wldw_id": 0,
            "begin_time": "",
            "end_time": "",
            "limit": (fun.getItem(html_name + '_top') && fun.getItem(html_name + '_top')['id']) ? fun.getItem(html_name + '_top')['id'] : 10
        }, search_data),
        success: function (res) {
            if (res['status'] == 0) {
                showList(res);
            }
        }
    })
}

function showList(params) {
    var style = [], money_arr = [], money_data = [];
    $(params['data']).each(function (i, obj) {
        // console.log(JSON.stringify(obj))
        var colour = order_color[i % order_color.length];
        var xh = i >= 3 ? (i + 1 + ".") : '';
        var cp = (fun.is_value(obj['cp_bh']) + ' ' + fun.is_value(obj['cp_mc'])) || '';
        style.push('<li class="list-item lower-border-line">');
        style.push('   <div class="customer">');
        style.push('       <div class="ranking">' + xh + '</div>');
        style.push('       <div style="background-color:' + colour + ';" class="circular"></div>');
        style.push('       <span class="name">' + cp + '</span>');
        style.push('   </div>');
        style.push('   <div class="lower">');
        style.push('       <span class="total-sales">总销售</span>');
        style.push('       <span class="piece">' + (obj['xsp'] || 0) + '匹</span>');
        style.push('       <span class="weight">' + (obj['xss'] || 0) + (obj['dw_mc'] || "") + '</span>');
        style.push('       <span class="price">￥' + (obj['xse'] || 0) + '</span>');
        style.push('   </div>');
        style.push('</li>');
        var value = obj['xse'] || 0;
        if (value < 0 || value === 0) {
            // console.log(value,'--')
            money_data.push({ value: value, name: cp });
        } else if (value > 0) {
            // console.log(value,'++')
            money_arr.push({ value: value, name: cp });
        }
    });
    money_arr = (params['data'].length === money_data.length) ? money_data : money_arr;
    // console.log(JSON.stringify(money_arr))

    $('#product_list').html(style.join(''));
    SetCharts({
        sum: (params && params['hj']),
        money_arr: money_arr
    });
}

// 环形图
function SetCharts(opt) {
    // console.log(JSON.stringify(opt))
    var myChart = echarts.init(document.getElementById('chart'));
    var option = {
        title: [{
            text: '总销售额',
            x: 'center',
            top: '38%',
            textStyle: {
                color: '#a5a5a5',
                fontStyle: 'normal',
                fontWeight: '600',
                fontFamily: 'sans-serif',
                // fontSize: 12
                fontSize: 16
            }
        }, {
            text: (opt && opt['sum'] || 0),
            x: 'center',
            top: '50%',
            textStyle: {
                color: '#000',
                width: '50%',
                fontStyle: 'normal',
                fontWeight: '400',
                fontFamily: 'sans-serif',
                // fontSize: 16
                fontSize: 20
            }
        }],
        // legend: {

        //     orient: 'horizontal',
        //     icon: 'circle',
        //     bottom: 20,
        //     x: 'center',
        //     data: opt['money_arr'] || [],
        // },
        tooltip: {
            trigger: 'item',
            formatter: "{b} <br/>{a}: {c} ({d}%)"
        },
        series: [{
            name: '销售额',
            type: 'pie',
            color: order_color,
            radius: ['60%', '75%'],
            avoidLabelOverlap: true,
            label: {
                normal: {
                    show: false,
                    position: 'center'
                }
            },
            labelLine: {
                normal: {
                    show: false
                }
            },
            data: opt['money_arr'] || []
        }]
    };
    myChart.setOption(option);
    myChart.on('click', function (param) {//不监听会报错
        return;
    });
}

$('body').on('touchend', '#complete_btn', function (e) {
    e.preventDefault();
    var dialog_opt = [
        {
            "id": 10,
            "name": "TOP 10",
            "is_choose": 1
        },
        {
            "id": 20,
            "name": "TOP 20"
        },
        {
            "id": 30,
            "name": "TOP 30"
        }
    ];

    if (fun.getItem(html_name + '_top')) {
        $(dialog_opt).each(function (k, val) {
            if (val['id'] == fun.getItem(html_name + '_top')['id']) {
                val['is_choose'] = 1;
            } else {
                val['is_choose'] = 0;
            }
        })
    }
    fun.showBookList({
        width: '280px',
        shadeClose: true,
        list: dialog_opt,
        choose: function (res) {
            search_data['limit'] = res['id'];
            fun.setItem(html_name + '_top', { 'id': res['id'], 'name': res['name'] });
            $('#complete_btn').text(res['name']);
            getData();
        }
    })
    return true;
})

// 跳转客户分析-明细客户
$('body').on('click','#analysis',function(){
    fun.showPageFull({
        page_url: page_arr.xs_khfx_xq,
        pageParam: {
            wldw_mc: page_data['wldw_mc'],
            wldw_id: page_data['wldw_id']
        }
    });
})