var html_name = page_arr.xs_nyfx, temps, cp_list = [];
var date_arr = fun.getMonthArr(6);
var to_month = fun.getMonthArr(1)[0]; // 获取本月第一天和最后一天

var search_data = {
    'begin_time': fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    'end_time': fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    'type': 'fx_cp',
    'cx_type': '',
    'md_id': 0,
    'md_mc': "",
    'keyword': "",
    'reset': {
        begin_date: fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        end_date: fun.Date(to_month['end_date']).Format('yy-mm-dd')
    }
};

var page_list = [];

var date_bar = $('#date_bar').dateBar({
    'data': date_arr,
    'tap': function (ret) { // ret 为对应月份的数据
        // {
        // 	'text': (myDate.getMonth() + 1) + "月",
        // 	'begin_date': myDate.Format('yy.mm.01'),
        // 	'end_date': myDate.Format('yy.mm.dd')
        search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
        $('.list-group').empty();
        getData();
    }
});

// 头部
$('#header').header({
    back: true, //返回
    title: '拿样分析', //标题
    filter: true,     //筛选
    foot_input: {	  //头部下面文本框
        show: true,
        scan_icon: true,
        plader: '产品编号 产品名称'
    },
});

page_init = function () {
    $("#foot_search").select();
    getData();

    function search(temp) {
        if (temp['status'] === 'search') {
            search_data['md_id'] = temp['data']['md']['id'] || 0; // 门店id
            search_data['md_mc'] = temp['data']['md']['text'] || ''; // 门店名称
        } else if (temp['status'] === 'reset') {
            search_data['md_id'] = 0; // 门店id
            search_data['md_mc'] = ''; // 门店名称
        }

        search_data['begin_time'] = temp['data']['begin_date']; // 起始时间
        search_data['end_time'] = temp['data']['end_date']; // 结束时间
        date_bar.setDate({
            begin_date: search_data['begin_time'],
            end_date: search_data['end_time']
        });

        fun.setItem(html_name + 'sideslip', true); // 筛选按钮,是否可以打开
        $('.list-group').empty();
        getData();
    }

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        console.log('---');
        console.log(temp);
        console.log('---');
        switch (temp['status']) {
            case 'search': // 监听搜索页
            case 'reset': // 重置
                search(temp);
                break;
        }
    });

    // 分页加载
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showData(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('list-group', ".list-item");
        }
    });

    bindEvent();
}

function getData() {
    temps = $.extend({
        keyword: "",
        begin_time: "",
        end_time: "",
        md_id: 0,
        md_mc: "",
    }, search_data);

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNyfxList,
        data: temps,
        success: function (res) {
            if (res.status != 0) return fun.toast('获取信息失败！');
            if (!res['data'] || res['data'].length == 0) {
                $('.content').css('height', '75%');
                return fun.createDataEmptyTips({ dom: '#list-group', btnShow: false });
            }
            $('.content').css('height', 'auto');
            var info_list = fun.createApiDataIndex(res.data);
            showData(fun.PagingData(info_list));
        }
    });
}

// 比例值取整
function valueRound(value) {
    switch (typeof value) {
        case 'number':
            value += ''; // eg: 100.00 => 100
            break;
        case 'string':  // eg: '100.00'  => 100
            if (/^\d{1,3}\.00$/.test(value)) {
                var dotIdx = value.indexOf('.');
                if (dotIdx > -1) {
                    value = value.slice(0, dotIdx);
                }
            }
            break;
        // 没有default
    }

    return value;
}

function showData(data) {
    var html_list = [];
    cp_list = data;
    for (var i = 0; i < data.length; i++) {
        var goods_text = fun.is_value(data[i]['cp_bh']) + ' ' + fun.is_value(data[i]['cp_mc'])
        // var img = []
        // if ($.nui.isEmpty(data[i]['cp_tp'])) {
        //     img = []
        // } else {
        //     if ($.isArray(data[i]['cp_tp'])) {
        //         img = data[i]['cp_tp']
        //     } else {
        //         if (data[i]['cp_tp'].indexOf(',') > -1) {
        //             img = data[i]['cp_tp'].split(',')
        //         } else {
        //             img.push(data[i]['cp_tp'])
        //         }
        //     }
        // }
        var img_url = ((!!data[i]['cp_tp']) ? fun.getImgPath(data[i]['cp_tp']) : "../img/logo.png");

        html_list.push('<li class="list-item lower-border-line" id="' + fun.is_value(data[i]['id']) + '" data-list=\'' + JSON.stringify(data[i]) + '\'>');
        html_list.push('	<div class="pack">');

        if (img_url === "../img/logo.png") {
            html_list.push('		<span class="cp_img mr-box">');
            html_list.push('            <img src="' + img_url + '" alt="" class="mr-img">');
            html_list.push('        </span>');
        } else {
            html_list.push('		<span class="cp_img">');
            html_list.push('            <img src="' + img_url + '" alt="">');
            html_list.push('            <img src="../img/mask.png" alt="" class="mask-img">')
            html_list.push('        </span>');
        }

        html_list.push('		<span class="name over-flow hidden-width">' + fun.redFont(goods_text, (temps['keyword'] || '')) + '</span>');
        html_list.push('	</div>');
        html_list.push('	<div class="pack3 clearfix">');
        html_list.push('		<div class="text-pack">');
        html_list.push('			<span class="text">拿样/人</span>');
        html_list.push('			<span class="number2">' + fun.is_value(data[i]['nys']) + '</span>');
        html_list.push('	</div>');
        html_list.push('	<div class="text-pack">');
        html_list.push('			<span class="text">下货/人</span>');
        html_list.push('			<span class="number2">' + fun.is_value(data[i]['xhs']) + '</span>');
        html_list.push('	</div>');
        html_list.push('	<div class="text-pack2">');
        html_list.push('			<span class="text2">比例</span>');
        html_list.push('			<span class="number2">' + fun.is_value(valueRound(data[i]['xhbl'])) + '%</span>');
        html_list.push('	</div>');
        html_list.push('	<div class="pack2">');
        html_list.push('		<span class="stock-number">下货数</span>');
        html_list.push('		<span class="number">' + fun.is_value(data[i]['xhzsl']) + '</span>');
        html_list.push('	</div>');
        html_list.push('        <i class="iconfont icon-youfanhui youfanhui"></i>')
        // html_list.push('	<div class="pack2 clearfix">');
        // html_list.push('		<div class="text-pack clearfix">');
        // html_list.push('			<span class="text" style="color: #000;text-align:left">' + fun.is_value(data[i]['nys']) + '</span>');
        // // html_list.push('			<span class="number2"></span>');
        // html_list.push('	    </div>');
        // html_list.push('	    <div class="text-pack clearfix">');
        // html_list.push('			&nbsp;<span class="text"> </span>');
        // html_list.push('			<span class="number2"> </span>');
        // html_list.push('	    </div>');
        // html_list.push('	    <div class="text-pack2 clearfix">');
        // html_list.push('			<span class="text2">下货数</span>');
        // html_list.push('			<span class="number2" style="color: #ff2e2e;">' + fun.is_value(data[i]['xhzsl']) + '</span>');
        // html_list.push('	    </div>');
        // html_list.push('        <i class="iconfont icon-youfanhui youfanhui"></i>')
        // html_list.push('	</div>');
        // html_list.push('	<div class="pack2 clearfix">');
        // html_list.push('		<div class="text-pack clearfix">');
        // html_list.push('			<span class="text">拿样/人</span>');
        // html_list.push('			<span class="number2">' + fun.is_value(data[i]['nys']) + '</span>');
        // html_list.push('	    </div>');
        // html_list.push('	    <div class="text-pack clearfix">');
        // html_list.push('			<span class="text">下货/人</span>');
        // html_list.push('			<span class="number2">' + fun.is_value(data[i]['xhs']) + '</span>');
        // html_list.push('	    </div>');
        // html_list.push('	    <div class="text-pack2">');
        // html_list.push('			<span class="text2">比例</span>');
        // html_list.push('			<span class="number2" >' + fun.is_value(valueRound(data[i]['xhbl'])) + '%</span>');
        // html_list.push('	    </div>');
        // html_list.push('	</div>');
        // html_list.push('		');
        html_list.push('</li>');
    }
    $("#list-group").html(html_list.join(''));
}

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });
}

// 该页面筛选按钮是否可以打开
fun.setItem(html_name + 'sideslip', true);

// 初始化事件
function bindEvent() {
    //点击键盘搜索
    $('body').on('search', "#foot_search", function (e) {
        search_data["keyword"] = $(this).val().trim();
        // if (e.keyCode === 13){
        // $(this).select();
        $('#list-group').empty();
        getData();
        // }
    });

    //点击记录行
    $('body').on('tap', '.list-item', function () {
        var data = $(this).data('list');
        fun.showPageFull({
            page_url: page_arr.xs_nyfx_cpxq, // 产品类别编辑页面(需要完善)
            pageParam: {
                return_page: html_name,
                cp_id: data['cp_id'],
                begin_time: search_data['begin_time'],
                end_time: search_data['end_time'],
                list: data,
            }
        });
    });

    //扫码
    $('.foot-input-box').on('click', ".icon-saoma", function () {
        QuestPermission.requestPermission('camera', null,function () {
            openScanner({
                callback: function (value) {
                    $("#foot_search").val(value);
                    $("#foot_search").select();
                    if (!!$("#foot_search").val()) {
                        search_data["keyword"] = $("#foot_search").val();
                        getData();
                        return true;
                    } else {
                        fun.toast('扫码失败！');
                        return true;
                    }
                }
            });
        });
       
    });

    //打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        var sideslip = fun.getItem(html_name + 'sideslip'); // 搜索页是否可以打开
        var options = {
            time: {
                begin_date: search_data['begin_time'], // 起始时间
                end_date: search_data['end_time'] // 结束时间
            },
            choose_merchants: [{
                key: "md", // key值
                text: "门店",
                value: (temps && temps['md_mc'] ? temps['md_mc'] : ''), // 门店名称
                id: (temps && temps['md_id'] ? temps['md_id'] : '') // 门店id
            }],
        };
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "search_data": options,
                    "type": 'xs_nyfx',
                    "reset": search_data['reset']
                },
                // y: fun.fontUnit(header)
            });
        }
    })
}

