html_name = page_arr.xsbj;

Bills['AJAX_URL'] = { 'getDj': AJAX_URL.getBpXsDjAndScdj };
Bills['wldw_type'] = 'kh';
Bills['djlx'] = 'bp_xsbj';
Bills['auth'] = 'bp_xsbj';
Bills['config'] = {
    dwgshsbl: 'dwgshsbl_bp', // 单位公式换算保留位数
    jesswr: 'jesswr_bpxs',   // 金额四舍五入
    bdjesswr: 'bdjesswr_bpxs', // 本单金额四舍五入
};

var xsbj = {}, PAGE_EDIT, img_arr = [], photoBrowser;
var __ROW_DATA, __DJ_DATA, return_page, __JL_DATA = [], __IS_NEW = true, __IS_EDIT = true;
// 页面必传参数
// __ROW_DATA  编辑的数据  return_page 返回的上一页  __DJ_DATA 单据信息

var jjdw_list = [];
var SYS_CONFIG = {};

var jjdw_select_flag = false; // 变更单位（计价单位）

page_init = function () {
    jjdw_list = fun.getItem('jjdw_list') || [];
    SYS_CONFIG = fun.getItem('sys_config') || {};

    // 更新本地存储数据
    fun.load_DATA_LIST(['sys_config', 'jjdw'], function () {
        SYS_CONFIG = fun.getItem('sys_config') || {};
        jjdw_list = fun.getItem('jjdw_list') || [];
    });

    __ROW_DATA = page_data.__ROW_DATA || {};
    __DJ_DATA = page_data.__DJ_DATA;
    __JL_DATA = page_data.__JL_DATA || [];
    PAGE_EDIT = Auth.check(Bills['auth'], 'edit') && $.nui.isEmpty(__DJ_DATA.is_sh);
    return_page = page_data.return_page;
    __IS_NEW = page_data.__IS_NEW;
    __IS_EDIT = page_data.__IS_EDIT;
    back_ori_data = JSON.parse(JSON.stringify(__ROW_DATA)); // 最原始数据

    __ROW_DATA.dj = __ROW_DATA.dj || '';
    __ROW_DATA.zdj = __ROW_DATA.zdj || '';

    console.log('page_data', page_data);
    // 图片浏览工具
    photoBrowser = api.require('photoBrowser');

    xsbj.initHeader();
    xsbj.initData();
    xsbj.initDomEvent();
    // 事件监听
    api.addEventListener({ name: html_name }, xsbj.addEventListener)
};


xsbj.initShowData = function () {
    // console.log('这是数据');
    // console.log(__ROW_DATA);
    $('#dj').val(__ROW_DATA.hsdj || 0).attr('readonly', !__IS_EDIT);
    $('#jjsl').val(__ROW_DATA.jjsl || 0).attr('readonly', !__IS_EDIT);

    $('#unit').text(fun.is_value(__ROW_DATA.jjdw_mc)).attr('readonly', !__IS_EDIT);
    $('#add_unit').text(fun.is_value(__ROW_DATA.dw_mc)).attr('readonly', !__IS_EDIT);
    $('#qdl').val(__ROW_DATA.qdl || 0).attr('readonly', !__IS_EDIT);
    $('#fk').val(fun.is_value(__ROW_DATA.fk)).attr('readonly', !__IS_EDIT);
    $('#kz').val(fun.is_value(__ROW_DATA.kz)).attr('readonly', !__IS_EDIT);

    $('#scdj').val(__ROW_DATA.scdj || 0);
    $('#bzj').val(__ROW_DATA.bzj || 0);

    $('#kcps').val(__ROW_DATA.kcps || 0);
    $('#kczsl').val(__ROW_DATA.kczsl || 0);

    __ROW_DATA.lx = __ROW_DATA.lx || '';
    $('#lx').val(fun.is_value(__ROW_DATA.lx)).attr('readonly', !__IS_EDIT);
    $('#dzts').val(__ROW_DATA.dzts || '').attr('readonly', !__IS_EDIT);
    if (__ROW_DATA.lx !== '定做') {
        $('.dzts-block').hide();
    }

    $('#cf').val(fun.is_value(__ROW_DATA.cf)).attr('readonly', !__IS_EDIT);
    $('#bz').val(fun.is_value(__ROW_DATA.bz)).attr('readonly', !__IS_EDIT);
};

// 初始化显示数据
xsbj.initData = function () {
    xsbj.initShowData();

    // 产品图片处理
    var cp_info = fun.getListInfoByKey(fun.getItem('cp_list'), __ROW_DATA.cp_id);
    var cp_imgs = (cp_info.imgs || '').split(',');

    if ($.isArray(cp_imgs)) {
        for (var i = 0; i < cp_imgs.length; i++) {
            var imgPath = fun.getImgPath(cp_imgs[i], true);
            if (imgPath) {
                img_arr.push(imgPath);
            }
        }
    } else if (cp_imgs) {
        var imgPath = fun.getImgPath(cp_imgs, true);
        if (imgPath) {
            img_arr.push(imgPath);
        }
    }

    if (img_arr.length) {
        $('#preview').attr('src', img_arr[0]);
    } else {
        //产品图片默认图
        $('.mask').hide();
        $('#preview').attr('src', '../img/logo.png').css({
            'width': '70%',
            'height': '70%',
            'margin-top': '15%',
            'opacity': '0.3'
        });
        $('.picture').css({
            'border-radius': '0.25rem',
            'background-color': '#f5f5f5',
        });
    }

    // 新增记录，需要查询上次价、标准价、库存批、库存数
    if (__IS_NEW) {
        xsbj.loadDjData();
        $('#color_search').attr('placeholder', __ROW_DATA.cp_ys_bh + __ROW_DATA.cp_ys_mc);
    }
    xsbj.loadPsAndSl();
};

// 初始化导航栏
xsbj.initHeader = function () {
    if (!__IS_NEW) {
        (function () {
            var tempName = '';
            if ($.nui.isTrue(__ROW_DATA['cp_ys_id'])) { // 非色系报价
                tempName = (__ROW_DATA['cp_ys_bh'] || '') + (__ROW_DATA['cp_ys_mc'] || '');
            } else { // 色系报价
                tempName = __ROW_DATA.color_type;
            }
            $('.header-bar').html('<span class="shys-color">' + tempName + '</span>');
        })();
    }
    $('.header-bar').show();

    $('#header').header({
        title: (__ROW_DATA['cp_bh'] || '') + ' ' + (__ROW_DATA['cp_mc'] || ''),
        text_btn: PAGE_EDIT,
        text_val: '完成',
        appendBackBtnEvt: function () {
            xsbj.sendUpdateEvent('back');
        }
    });

    page_data.keyback = function () {
        xsbj.sendUpdateEvent('back');//  监听返回键
    }
};

// 初始化为事件监听
xsbj.initDomEvent = function () {
    // 完成按钮点击
    $('#complete_btn').on('tap', function () {
        xsbj.sendUpdateEvent('complete');
    });

    // 类型
    // 点击后，弹出以下窗口：
    // 显示的内容：空、现货、定制
    // 默认选中：空
    $('body').on('click', '.lx-block', function (e) {
        e.stopPropagation();

        $('input').blur();

        if (!__IS_EDIT) {
            return false;
        }

        var list = [{ name: '' }, { name: '现货' }, { name: '定做' }];

        var val = $('#lx').val().trim() || '';
        $(list).each(function (i, arr) {
            if (arr['name'] === val) {
                list[i]['is_choose'] = 1;
            } else {
                list[i]['is_choose'] = 0;
            }
        });
        fun.showBookList({
            list: list,
            choose: function (res) {
                $('#lx').val(res['name']);
                __ROW_DATA.lx = res.name;
                // 当 类型 = 定制 时，才显示这一项。反之，则不显示。
                if (res.name === '定做') {
                    $('.dzts-block').show();
                } else {
                    $('.dzts-block').hide();
                    $('#dzts').val('');
                }
            }
        });
    });

    // 点击选择计价单位
    $('#unit').on('tap', function () {
        if (!__IS_EDIT) {
            return false;
        }
        fun.showPageFull({
            page_url: page_arr.select_list,
            pageParam: {
                return_page: html_name,
                page_type: 'jjdw',
            }
        });
    });

    // 点击选择单位
    $('#add_unit').on('tap', function () {
        if (!__IS_EDIT) {
            return false;
        }
        fun.showPageFull({
            page_url: page_arr.select_list,
            pageParam: {
                return_page: html_name,
                page_type: 'dw',
            }
        });
    });

    // 下个色
    $('#color').on('tap', function () {
        // 当前页面处于添加状态下，才显示该按钮。反之，则不显示。
        // 点击后，将数据生成到 当前单据。清空当前页面的数据，跳转到：颜色搜索 页面。
        if (xsbj.sendUpdateEvent('color')) {
            xsbj.clearData();
            xsbj.selectYs();
        }
    });

    // 当前产品 对应产品资料 第1张图 点击后，弹出大图浏览模式。
    $('.picture').on('tap', function () {
        if (img_arr.length > 0) {
            photoBrowser.open({
                images: img_arr,
                placeholderImg: '../img/logo.png',
                bgColor: '#000'
            }, function (ret, err) {
                if (ret) {
                    if (ret['eventType'] === 'click') {
                        photoBrowser.close();
                    }
                } else {
                    console.log(JSON.stringify(err));
                }
            });
        }
    });

    // 监听幅宽变化
    $('body').on('change', '#fk', function () {
        __ROW_DATA.fk = $(this).val().trim();
        xsbj.loadPsAndSl();
    });

    // 监听克重变化
    $('body').on('change', '#kz', function () {
        __ROW_DATA.kz = $(this).val().trim();
        xsbj.loadPsAndSl();
    });

    $('body').on('change', '#cf', function () {
        __ROW_DATA.cf = $(this).val().trim();
    })

    if (__IS_NEW) {
        // 点击跳转选择颜色
        $('#color_search').on('tap', xsbj.selectYs);
    }
};

// 选择产品颜色跳转
xsbj.selectYs = function () {
    xsbj.getRowData();
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            djlx: page_data.djlx,
            return_page: html_name,
            cp_id: __ROW_DATA.cp_id,
            page_type: 'cp_ys',
        }
    });
};

// 事件监听
xsbj.addEventListener = function (ret, err) {
    var value = ret.value;
    if (value.status === 'select_list') {
        if (value.data.page_type === 'dw') { //  选择单位后事件通知

            // 进入选择单位页面，单位和计价单位值一样，计价单位不修改，直接修改单位，计价单位需跟着更变
            if (__ROW_DATA['dw_mc'] === __ROW_DATA['jjdw_mc']) {
                jjdw_select_flag = true;
            }

            // 计价单位变化时
            // 上次价 —— 当颜色发生变更时，自动读取对应的上次价
            // 标准价 —— 当颜色发生变更时，自动读取：产品报价 对应的价格
            if (__ROW_DATA.dw_id !== value.data.list_data.id) {
                __ROW_DATA.dw_id = value.data.list_data.id;
                __ROW_DATA.dw_mc = value.data.list_data.name;

                if (jjdw_select_flag) { // 单位更改值需跟着改变
                    $('#unit').text(__ROW_DATA.dw_mc);
                    __ROW_DATA.jjdw_id = __ROW_DATA.dw_id;
                }
                $('#add_unit').text(__ROW_DATA.dw_mc);
                xsbj.loadDjData();
                xsbj.loadPsAndSl();
            }
        } else if (value.data.page_type === 'jjdw') { // 选择计价单位后事件通知
            // 计价单位变化时
            // 上次价 —— 当颜色发生变更时，自动读取对应的上次价
            // 标准价 —— 当颜色发生变更时，自动读取：产品报价 对应的价格
            var jjdwText = $('#unit').text(); // 没重新选择计价单位之前的计价单位

            if (__ROW_DATA.jjdw_id !== value.data.list_data.id) {
                __ROW_DATA.jjdw_id = value.data.list_data.id;
                __ROW_DATA.jjdw_mc = value.data.list_data.name;

                // 初始计价单位和单位值相同，先手动修改了计价单位，单位变动计价单位不需要变动
                if (jjdwText !== __ROW_DATA.jjdw_mc) {
                    jjdw_select_flag = false;
                }

                $('#unit').text(__ROW_DATA.jjdw_mc);

                // 获取价格、库存匹、库存数
                xsbj.loadDjData();
                xsbj.loadPsAndSl();
            }
        } else if (value.data.page_type === 'cp_ys') { // // 选择颜色后事件通知
            // 颜色变化时,选择下个色回调
            // 起订量 —— 当颜色发生变更时，自动读取：产品资料-颜色记录表 对应的起订量
            // 上次价 —— 当颜色发生变更时，自动读取对应的上次价
            // 标准价 —— 当颜色发生变更时，自动读取：产品报价 对应的价格
            __ROW_DATA.cp_ys_id = value.data.list_data.id;
            __ROW_DATA.cp_ys_bh = value.data.list_data.number;
            __ROW_DATA.cp_ys_mc = value.data.list_data.name;
            __ROW_DATA.qdl = value.data.list_data.order_amount;

            xsbj.initShowData();
            $('#color_search').attr('placeholder', __ROW_DATA.cp_ys_bh + __ROW_DATA.cp_ys_mc);  // header提示更新
            // 获取价格、库存匹、库存数
            xsbj.loadDjData();
            xsbj.loadPsAndSl();
        }
    }
};

// 加载新数据
xsbj.loadDjData = function () {
    __getDj({
        data: {
            "djlx": Bills['djlx'],
            "wldw_id": __DJ_DATA.wldw_id || 0,
            "cp_id": __ROW_DATA.cp_id,
            "cp_ys_id": __ROW_DATA.cp_ys_id || 0,
            "jjdw_id": __ROW_DATA.jjdw_id,
            "kdsj": __DJ_DATA.kdsj || fun.formatDate(new Date(), 'YYYY-MM-DD HH:mm'),
            "dj_info": __ROW_DATA.dj_info || {},
            "dd_dj_id": __ROW_DATA.dd_dj_id || 0,
            "dd_jl_id": __ROW_DATA.dd_jl_id || 0,
            "gx_id": __ROW_DATA.gx_id || 0,
            // 获取成本价 需要用到 仓库、单位
            "ck_id": __ROW_DATA.ck_id || 0,
            "dw_id": __ROW_DATA.dw_id || 0,
            // 标准价 最低价 需要用到类型
            "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], __ROW_DATA['jg_lx_mc'], 'simple', 'name') || 'dh'
        },
        callback: function (res) {
            if (res.status === 0) {
                __ROW_DATA.hsdj = res.data.dj;
                __ROW_DATA.bzj = res.data.bzj;
                __ROW_DATA.scdj = res.data.scdj;
                __ROW_DATA.zdj = res.zdj;

                console.log('我是数据');
                console.log(__ROW_DATA);

                $('#dj').val(__ROW_DATA.hsdj || 0);
                $('#scdj').val(__ROW_DATA.scdj || 0);
                $('#bzj').val(__ROW_DATA.bzj || 0);
            }
        }
    });
};

// 获取产品起订量
xsbj.loadQdl = function () {
    fun.ajax({
        showLoad: true,
        url: AJAX_URL.getGoodsColourList,
        data: {
            goods_id: __ROW_DATA.cp_id,
            goods_title: __ROW_DATA.cp_mc,
            is_stop: 0
        },
        success: function (res) {
            if (res.status === 0) {
                for (var i = 0; i < res.data.length; i++) {
                    if (res.data[i].id === __ROW_DATA.cp_ys_id) {
                        __ROW_DATA.qdl = res.data[i].order_amount;
                        $("#qdl").val(res.data[i].order_amount || 0);
                    }
                }
            }
        }
    });
};

// 获取库存匹数和数量
xsbj.loadPsAndSl = function () {
    // 如果当前用户在【用户权限】的门店不为空，则读取相同门店 且 没开启 次品仓 的所有仓库库存。
    // 反之，则读取所有门店 且 没开启 次品仓 的所有仓库库存。
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getKcsl,
        data: {
            'ck_id': __ROW_DATA.ck_id,
            'md_id': fun.getItem('user_info')['store_id'] || 0,
            'cp_ys_id': __ROW_DATA.cp_ys_id,
            'cp_id': __ROW_DATA.cp_id,
            'fk': __ROW_DATA.fk || '',
            'kz': __ROW_DATA.kz || '',
            'gg': __ROW_DATA.gg || '',
            'dw_id': __ROW_DATA.dw_id
        },
        success: function (res) {
            console.log('----');
            console.log(res);
            console.log('----');
            if (res.status === 0) {
                if (res.data) {
                    __ROW_DATA.kcps = res.data.ps ? res.data.ps : 0;
                    __ROW_DATA.kczsl = res.data.zsl ? res.data.zsl : 0;
                } else {
                    __ROW_DATA.kcps = 0;
                    __ROW_DATA.kczsl = 0;
                }
                $('#kcps').val(__ROW_DATA.kcps || 0);
                $('#kczsl').val(__ROW_DATA.kczsl || 0);
            }
        }
    });
};

// 获取可编辑的字段数据
xsbj.getRowData = function () {
    __ROW_DATA.jjsl = Number($('#jjsl').val() || 0);
    __ROW_DATA.qdl = Number($('#qdl').val() || 0);
    __ROW_DATA.fk = $('#fk').val();
    __ROW_DATA.kz = $('#kz').val();
    __ROW_DATA.scdj = Number($('#scdj').val() || 0);
    __ROW_DATA.bzj = Number($('#bzj').val() || 0);
    __ROW_DATA.dzts = Number($('#dzts').val() || 0);
    __ROW_DATA.bz = $('#bz').val();

    // 含税单价 = 单价
    __ROW_DATA.dj = Number($('#dj').val() || 0);
    __ROW_DATA.hsdj = __ROW_DATA.dj;

    // 计算汇总金额hsje
    if (__ROW_DATA.jjsl && __ROW_DATA.hsdj) {
        __ROW_DATA.hsje = __ROW_DATA.jjsl * __ROW_DATA.hsdj;
    } else {
        __ROW_DATA.hsje = 0;
    }
    // 含税率%、税额 赋值为0
    __ROW_DATA.shuie = 0;
    __ROW_DATA.shuilv = 0;
    // 金额、总金额、含税总金额
    __ROW_DATA.je = __ROW_DATA.hsje;
    __ROW_DATA.zje = __ROW_DATA.hsje;
    __ROW_DATA.hszje = __ROW_DATA.hsje;
};

// 三种情况
// 1. 返回，选择产品页面       back
// 2. 完成，跳转销售报价页面   complete
// 3. 下个色，停留当前页面     color
xsbj.sendUpdateEvent = function (type) {
    xsbj.getRowData();

    if (type === 'back') {
        xsbj.pageBack();
    } else if (type === 'complete') {
        xsbj.nextPage();
    } else if (type === 'color') {
        return xsbj.nextColor();
    }
    return true;
};

// 关闭页面时发送数据
xsbj.closeAndSendEvent = function () {
    api.sendEvent({
        name: return_page,
        extra: {
            'status': 'close_win',
        }
    });

    setTimeout(function () {
        api.closeWin();
    }, 300);
};

// 导航栏点击返回
xsbj.pageBack = function () {
    // 数据一样时直接关闭
    if ($.nui.isObjEquals(back_ori_data, __ROW_DATA)) {
        xsbj.closeAndSendEvent();
        return false;
    }

    // 新增时
    // 1. 单价为0, 有颜色      返回选择颜色页面
    // 2. 单价为0, 没颜色      返回选择产品页面
    // 3. 单价不为0, 没颜色    提示选择颜色，不返回
    // 4. 单价不为0, 有颜色    返回选择产品页面

    // 编辑时，单价不能为0  提示输入单价
    if (__IS_NEW) {
        if ($.nui.isEmpty(__ROW_DATA.dj)) {
            if ($.nui.isEmpty(__ROW_DATA.cp_ys_id)) {
                api.closeToWin({ name: return_page });
            } else {
                api.closeWin();
            }
            return false;
        } else {
            // 非色系报价，那么 cp_ys_id 不为 0，色系报价，cp_ys_id 为 0，并且 color_type 有值
            var notSeries = (!('color_type' in __ROW_DATA) && $.nui.isEmpty(__ROW_DATA.color_type)); // 不是色系报价
            if ($.nui.isEmpty(__ROW_DATA.cp_ys_id) && notSeries) {
                fun.toast('请选择颜色');
                return false;
            }
        }
    } else {
        // if ($.nui.isEmpty(__ROW_DATA.dj)) {
        //     fun.toast('请输入单价');
        //     return false;
        // }
    }

    var extra = {
        'status': 'update',
        row: __ROW_DATA
    };

    if (return_page === page_arr.choice_product) {
        __JL_DATA.push(__ROW_DATA);
        extra = {
            status: 'update_rows',
            data: {
                __JL_DATA: __JL_DATA
            }
        }
    }

    api.sendEvent({
        name: return_page,
        extra: extra
    });

    setTimeout(function () {
        api.closeToWin({ name: return_page });
    }, 200);
};

// 完成
xsbj.nextPage = function () {
    // 非色系报价，那么 cp_ys_id 不为 0，色系报价，cp_ys_id 为 0，并且 color_type 有值
    // 检查颜色和单价
    var notSeries = (!('color_type' in __ROW_DATA) && $.nui.isEmpty(__ROW_DATA.color_type)); // 不是色系报价
    if ($.nui.isEmpty(__ROW_DATA.cp_ys_id) && notSeries) {
        fun.toast('请选择颜色');
        return false;
    }

    // if ($.nui.isEmpty(__ROW_DATA.dj)) {
    //     fun.toast('请输入单价');
    //     return false;
    // }

    // 销售报价开单处理
    if (page_data.djlx === 'bp_xsbj') {
        if ($.nui.isTrue(page_data.__route)) {                  // 新增
            __JL_DATA.push(__ROW_DATA);
            if (page_data.from_page !== page_arr.xs_xsbj_kd) {  // 销售报价查询页面进入，跳转开单编辑页面
                PageShow.gotoNextPage({
                    html_name: html_name,
                    page_data: $.extend(page_data, {
                        data: {
                            list: __JL_DATA
                        }
                    })
                });
            } else {                                            // 销售报价开单编辑页面进入，发送事件通知
                api.sendEvent({
                    name: page_arr.xs_xsbj_kd,
                    extra: {
                        status: 'update_rows',
                        data: {
                            __JL_DATA: __JL_DATA
                        }
                    }
                });

                setTimeout(function () {
                    api.closeToWin({ name: page_arr.xs_xsbj_kd });
                }, 200);
            }
        } else {                                                // 编辑
            // 如果记录没有修改
            if ($.nui.isObjEquals(back_ori_data, __ROW_DATA)) {
                xsbj.closeAndSendEvent();
                return false;
            }

            api.sendEvent({
                name: page_arr.xs_xsbj_kd,
                extra: {
                    status: 'update',
                    row: __ROW_DATA
                }
            });

            setTimeout(function () {
                api.closeWin();
            }, 300);
        }
    }
};

// 下个色
xsbj.nextColor = function () {
    // 非色系报价，那么 cp_ys_id 不为 0，色系报价，cp_ys_id 为 0，并且 color_type 有值
    // 检查颜色和单价
    var notSeries = (!('color_type' in __ROW_DATA) && $.nui.isEmpty(__ROW_DATA.color_type)); // 不是色系报价
    if ($.nui.isEmpty(__ROW_DATA.cp_ys_id) && notSeries) {
        fun.toast('请选择颜色');
        return false;
    }

    if ($.nui.isEmpty(__ROW_DATA.dj)) {
        fun.toast('请输入单价');
        return false;
    }

    // 拷贝，防止修改时影响__JL_DATA里的数据
    __JL_DATA.push(JSON.parse(JSON.stringify(__ROW_DATA)));

    var extra = {
        status: 'update',
        data: {
            __JL_DATA: __JL_DATA
        }
    };

    if (return_page === page_arr.choice_product) {
        extra = {
            status: 'update_rows',
            data: {
                __JL_DATA: __JL_DATA
            }
        }
    }

    api.sendEvent({
        name: return_page,
        extra: extra
    });
    return true;
};

// 数据格式化
xsbj.clearData = function () {
    __ROW_DATA.jjsl = '';
    __ROW_DATA.qdl = '';
    // __ROW_DATA.fk = '';
    // __ROW_DATA.kz = '';
    __ROW_DATA.scdj = 0;
    __ROW_DATA.bzj = 0;
    // __ROW_DATA.dzts = '';
    __ROW_DATA.bz = '';

    // 含税单价 = 单价
    __ROW_DATA.dj = '';
    __ROW_DATA.hsdj = __ROW_DATA.dj;
    __ROW_DATA.zdj = 0;

    __ROW_DATA.cp_ys_id = 0;
    __ROW_DATA.cp_ys_bh = '';
    __ROW_DATA.cp_ys_mc = '';

    $('#dj,#qdl,#jjsl,#bz').val('');

    if (__IS_NEW) {
        $('#color_search').attr('placeholder', '搜索颜色');
    }
};
