var html_name = page_arr.yarn; // 页面名称
var search_data = {
    "keyword": "",
    "is_stop": 0,
    "class_id": 0,
    "order": {},
    "keyword_key": ['name', 'simple'],
    "label_id": []
};
var list_data = {},
    search_storage = {},
    photoBrowser = {},
    page_list = [];
var last_lb_id = 0,
    last_dw_id = 0, last_dw_mc = '';

var yarn = {};

$('#header').header({
    back: true,
    add: Auth.check('sx', 'edit'),
    filter: true,
    title: '纱线',
    foot_input: {
        show: true,
        scan_icon: true,
        plader: '搜索'
    },
});

// 获取类别展示标签个数
yarn.getLabelLen = (function () {
    var labelArr = ['class_name', 'brand', 'area', 'nature'];
    return function (item) {
        var count = 0;
        for (var i = 0; i < labelArr.length; i++) {
            if ($.nui.isTrue(item[labelArr[i]])) {
                count++;
            }
        };
        // console.log(status);
        return count;
    }
})();

// 展示列表标签
yarn.getLabelStr = (function () {
    return function (item) {
        var labelLen = yarn.getLabelLen(item);
        var str = '';
        if (labelLen === 2 || labelLen === 1) {
            str = 'center-text space-around';
        } else if (labelLen === 0) {
            str = 'center-text content-center';
        } else {
            str = 'center-text';
        }
        return '<div class="' + str + '">';
    }
})();

// 初始化事件绑定
yarn.bindEvent = function () {
    // 编辑产品
    $('body').on('click', '.prices', function (e) {
        e.preventDefault();
        var index = $('.prices').index(this)
        var goods_id = $('.prices').eq(index).attr('goods_id')
        var search_val = $('#foot_search').val().trim();
        var jvals = fun.judgeLastStr(search_val);
        fun.showPageFull({
            "page_url": page_arr.yarn_edit,
            "pageParam": {
                "return_page": html_name,
                "opt": "edit",
                'id': goods_id
            }
        });
        return false;
    });

    //浏览大图
    $('body').on('click', '.picture', function (e) {
        e.preventDefault();
        e.stopPropagation();
        var img_arr = [];
        var __imgs = $(this).find('.product').data('img_url');
        if ($.nui.isEmpty(__imgs)) return;
        if ($.isArray(__imgs)) {
            for (var i = 0; i < __imgs.length; i++) {
                img_arr.push(fun.getImgPath(__imgs[i], true));
            }
        } else {
            img_arr.push(fun.getImgPath(__imgs, true));
        }
        if (img_arr.length === 0) return;
        photoBrowser.open({
            images: img_arr,
            placeholderImg: '../img/logo.png',
            bgColor: '#000'
        }, function (ret, err) {
            if (ret) {
                if (ret['eventType'] == 'click') {
                    photoBrowser.close();
                }
            } else {
                // console.log(JSON.stringify(err));
            }
        });
        return false;
    });

    // 添加产品
    $('body').delay('tap', '#add_btn', function () {
        var search_val = $('#foot_search').val().trim();

        if (search_val == '') {
            openPage(search_val);
        } else {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.getInfoByKeyword,
                data: {
                    "type": 'sx',
                    "keyword": search_val
                },
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            openPage(search_val);
                            break;
                        case 104:
                            layer.closeAll();
                            fun.dialog({
                                content: '【' + search_val + '】已存在，是否继续添加？',
                                btn: ['确定', '取消'],
                                shadeClose: false,
                                className: 'data-change-skin',
                                yes: function () {
                                    openPage('');
                                },
                                no: function () {
                                    search_data['keyword'] = search_val;
                                    getList();
                                }
                            });
                            break;
                        default:
                            fun.toast(res['msg']);
                            break;
                    }
                }
            })
        }

        function openPage(jvals) {
            fun.showPageFull({
                "page_url": page_arr.yarn_edit,
                "pageParam": {
                    "return_page": html_name,
                    "last_lb_id": last_lb_id,
                    'last_dw_id': last_dw_id,
                    'last_dw_mc': last_dw_mc,
                    "opt": "append",
                    'cp_bh': jvals
                }
            });
        }
    });

    // 删除产品
    $('body').on('click', '.delete-cp', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var list = $(this).parents('.center-list').data('list');
        deleteCp(list);
    })

    // 跳转 产品详情页
    $('body').on('click', '.pro-add', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if ($(this).find('.check-box:visible').length) {
            if ($(this).find('.check-box').hasClass('check-choice')) {
                $(this).find('.check-box').removeClass('check-choice');
            } else {
                $(this).find('.check-box').addClass('check-choice');
            }
        } else {
            var list = $(this).closest('li').data('list');
            fun.showPageFull({
                "page_url": page_arr.yarn_view,
                "pageParam": {
                    "goods_info": list,
                    "goods_id": list['id'],
                    "return_page": html_name
                }
            });
        }
    });

    // 更多
    $('body').on('click', '.more-btn', function (e) {
        e.stopPropagation();
        var $this = $(this);
        var list = $this.closest('li').data('list');
        var merchants_list = [
            { "name": "库存", "column": "kc", },
            { "name": "分析", "column": "fx", },
        ];
        if (Auth.check('cp', 'edit')) {
            merchants_list.push({ "name": "删除", "column": "sc", })
        }
        fun.showBookList({
            list: merchants_list,
            open_init: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            choose: function (res) {
                // document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                // console.log(res);
                switch (res['column']) {
                    case 'kc'://库存
                        fun.showPageFull({
                            "page_url": page_arr.kc_kcxq,
                            "pageParam": {
                                "data": list,
                                "cp_id": list['id'],
                                "info": list['number'] + "" + list['name'],
                                "return_page": html_name
                            }
                        })
                        break;
                    case 'fx'://分析
                        var to_month = fun.getMonthArr(1)[0];
                        fun.showPageFull({
                            "page_url": page_arr.xs_cpfx_xq,
                            "pageParam": {
                                "type": 'rxfx',
                                "cp_mc": list['name'],
                                "cp_id": list['id'],
                                "cp_bh": list['number'],
                                "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
                                "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
                            }
                        })
                        break;
                    case 'sc'://删除
                        deleteCp(list);
                        break;
                }
            },
            end: function () {
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        })
        return false;
    });

    // 点击键盘搜索
    $("#foot_search").bind('search', fun.throttle(function () {
        $("#goods_list").html('');
        page_list = [];
        search_data['keyword'] = $(this).val().trim();
        getList();
    }, 300));

    // 扫描
    $('body').on('tap', ".icon-saoma", function () {
        openScanner({
            callback: function (value) {
                $("#foot_search").val(value);
                if (!!$("#foot_search").val()) {
                    search_data['keyword'] = $('#foot_search').val().trim();
                    $('#product_list').empty();
                    getList();
                    return true;
                } else {
                    fun.toast('扫码失败！');
                    return true;
                }
            }
        });
    });

    // 搜索条码
    $('body').on('keypress', '#foot_input', function (e) {
        var value = $('#foot_input').val().trim();
        if (e.keyCode === 13 && !!code) {
            $(this).select();
            page_data['page_num'] = 1;
            getList();
        }
    });

    $('body').on('tap', '#filter_btn', function () {
        var sideslip = fun.getItem(html_name + 'sideslip');
        var options = {
            "choose_merchants": [{
                key: "sx_lb",
                "text": "类别",
                "id": (search_data['class_id'] || 0),
                "value": (search_data['class_name'] || "")
            }, {
                key: "sx_pp",
                "text": "品牌",
                "id": (search_data['pp_id'] || 0),
                "value": (search_data['sx_pp'] || "")
            }, {
                key: "sx_dq",
                "text": "地区",
                "id": (search_data['dq_id'] || 0),
                "value": (search_data['sx_dq'] || "")
            }, {
                key: "sx_xz",
                "text": "性质",
                "id": (search_data['xz_id'] || 0),
                "value": (search_data['sx_xz'] || "")
            },],
            "sort": [{
                "text": "日期",
                "key": "RQ_SORT",
                "value": (search_data['order']['rq'] || '')
            },],
            "switch": [{
                "text": "显示停用",
                "max_width": true,
                "key": "is_stop",
                "value": (search_data['is_stop'] || 0)
            }],
        }
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "search_data": options
                },
            });
        }
    })
}

page_init = function () {
    photoBrowser = api.require('photoBrowser');
    getList();
    api.addEventListener({
        name: html_name,
    }, function (res) {
        // console.log(res);
        $("foot_input").select();
        //is_edit是否有修改权限
        var temp = res['value']['data'];
        if (!!res) {
            switch (res.value.status) {
                case "search":
                    $('#goods_list').addClass('switch-tab');
                    if (!!res.value.data.view) {
                        fun.setItem('cp_view', 1);
                    } else {
                        fun.setItem('cp_view', 0);
                    }
                    // console.log(JSON.stringify(temp))
                    search_data['class_id'] = temp['sx_lb']['id'];
                    search_data['class_name'] = temp['sx_lb']['text'];
                    search_data['sx_pp'] = temp.sx_pp && temp['sx_pp']['text'];
                    search_data['sx_dq'] = temp.sx_dq && temp['sx_dq']['text'];
                    search_data['sx_xz'] = temp.sx_xz && temp['sx_xz']['text'];

                    search_data['order']['rq'] = temp['RQ_SORT'];
                    search_data['is_stop'] = temp['is_stop'];
                    //搜索菜单需要缓存的数据
                    search_storage['is_stop'] = temp['is_stop'];

                    fun.setItem(html_name + '_' + 'is_stop', search_storage['is_stop']);
                    fun.setItem(html_name + 'sideslip', true);
                    getList();
                    break;
                case "refresh":
                    $('#goods_list').addClass('switch-tab');
                    getList(false);
                    break;
                case "empty":
                    prices_arr = [];
                    break;
                default:
                    break;
            }
        }
    });
    // 解决由于ios造成的滚动事件失效，模拟滚动到底部
    fun.iosScrollToBottom()({
        up: {
            ele: '.content', // 需要传递的选择器，用于获取滚动高度
            viewListHeight: function () { // 视口列表高度
                return $(window).height() - parseFloat($('.goods-wrap').css('top'))
            },
            getListHeight: getListHeight, // 容器真实高度，分页叠加的过程，高度逐渐增加
            callback: function () {
                if (page_list.length > 0) {
                    showData(fun.PagingData(page_list, 5) || []);
                } else {
                    if ($.nui.isTrue($('.empty_bottom').length)) return;
                    var minus = $(window).height() - fun.getCssVal('.goods-wrap', 'top');
                    if (getListHeight() >= minus) {
                        fun.createBottomLine('goods_list', ".content");
                        $('.empty_bottom').show();
                    }
                }
            }
        },
    })
    $('.header .foot-input-box').css({
        height: '3rem'
    })
    $('.goods-wrap').css({
        top: api.safeArea.top + $('#header').outerHeight() - fun.computedHtmlFontSize()
    })
    yarn.bindEvent();
}

/* 方法 */
// 清空页面操作
yarn.resetPage = function () {
    list_data = {};
    page_list = [];
    $("#goods_list").html('');
    $('#goods_list').empty();
}

// 计算滑动容器列表高度。由于父级都是定位
function getListHeight() {
    var height = 0;
    if ($.nui.isTrue($('#goods_list li').length)) {
        $('#goods_list li').each(function (idx, item) {
            height += $(this).outerHeight();
        })
    }
    return height;
}

// 获取请求的数据
function getList(initFirst) {
    yarn.resetPage();
    fun.ajax({
        showLoad: true,
        hideLoad: false,
        url: AJAX_URL.getYarnList,
        data: $.extend({}, {
            "keyword": "",
            "is_stop": 0
        }, search_data),
        success: function (res) {
            // if (initFirst) {
            //     fun.load_DATA_LIST(['jjdw'], null, { showLoad: false, hideLoad: true, close: true });
            //     fun.load_DATA_LIST(['cp_lb'], null, { showLoad: false, hideLoad: true, close: true });
            // }
            if (res['status'] == 0) {
                if ($.nui.isEmpty(res['data'])) {
                    // $('.empty_bottom').hide();
                    // $('.font-lls').css('pointer-events', 'auto');
                    // $('#goods_list').css({
                    //     height: $(window).height() - fun.getCssVal('.goods-wrap', 'top')
                    // })
                    fun.createDataEmptyTips({ dom: '#goods_list', btnShow: false });
                    fun.load_DATA_LIST(['sx'], null, { showLoad: false, hideLoad: true, close: true });
                    return fun.hideLoad();
                }
                // $('#goods_list').css({
                //     height: 'auto'
                // })

                page_list = res.data;

                // initJgVal(res.data); // 处理旧数据保存报价
                // printDataList = res.data.slice(0);

                var tmp_rows = (res.data || []).slice(0).sort(function (a, b) {
                    $('.font-lls').css('pointer-events', 'auto');
                    return new Date(fun.compateIEDate(a['date'])).getTime() - new Date(fun.compateIEDate(b['date'])).getTime();
                });

                last_dw_id = tmp_rows[tmp_rows.length - 1]['unit_id'];
                last_dw_mc = tmp_rows[tmp_rows.length - 1]['unit_name'];
                last_lb_id = tmp_rows[tmp_rows.length - 1]['class_id'] || 0;

                showData(fun.PagingData(page_list) || []);
                // showData(page_list || []);
            } else {
                fun.alert({ msg: '网络异常！' });
                fun.hideLoad();
            }
            // $('.font-lls').css('pointer-events', 'auto');
            // fun.load_DATA_LIST(['cp'], null, { showLoad: false, hideLoad: false, close: false });
        }
    })
}

//显示数据
function showData(data) {
    // console.log(JSON.stringify(data))
    var listHtml = [];
    for (var i = 0; i < data.length; i++) {
        var item = data[i];
        var goods_text = item['name'] || '',
            goods_id = item['id'],
            img_url = (item['imgs']) ? fun.getImgPath(item['imgs']) : "../img/logo.png",
            large_url = (item['imgs']) ? fun.getImgPath(item['imgs'], true) : "../img/logo.png";
        list_data[goods_id] = item;
        listHtml.push('<li class="center-list lower-border-line pro-add clearfix wrap-style" goods_id="' + goods_id + '" data-list=\'' + fun.formatString(JSON.stringify(item)) + '\'>');
        listHtml.push('    <div class="le wrap-style">');
        // listHtml.push('    <div class="check"></div>');
        if (img_url === "../img/logo.png") {
            listHtml.push('<div class="picture mr-bj">');
            listHtml.push('       <img src="' + img_url + '" class="product cp-img imgs" large_url="' + large_url + '"  data-img_url=\'' + (item['imgs'] ? JSON.stringify(item['imgs'].split(',')) : '') + '\' >');
        } else {
            listHtml.push('<div class="picture">');
            listHtml.push('       <img src="' + img_url + '" onerror="imgError1(this);" large_url="' + large_url + '" data-img_url=\'' + (item['imgs'] ? JSON.stringify(item['imgs'].split(',')) : '') + '\'  class="product large imgs">');
        }
        listHtml.push('       </div>');
        listHtml.push(yarn.getLabelStr(item));
        listHtml.push('           <div class="text">' + (fun.redFont((item['name'] || ''), search_data['keyword']) || '') + '</div>');

        if ($.nui.isTrue(item['class_name'])) {
            listHtml.push('<span class="val-text">' + fun.is_value(item['class_name']) + '</span>');
        }
        if ($.nui.isTrue(item['brand'])) {
            listHtml.push('<span class="val-text">' + fun.is_value(item['brand']) + '</span>');
        }
        if ($.nui.isTrue(item['area'])) {
            listHtml.push('<span class="val-text">' + fun.is_value(item['area']) + '</span>');
        }
        if ($.nui.isTrue(item['nature'])) {
            listHtml.push('<span class="val-text">' + fun.is_value(item['nature']) + '</span>');
        }

        listHtml.push('       </div>');
        Auth.check('sx', 'edit') ? listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 more delete-cp btn-style">删除</div>') : '';
        Auth.check('sx', 'edit') ? listHtml.push('<div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 prices prices-btn btn-style">编辑</div>') : '';

        listHtml.push('    </div>');
        listHtml.push('</li>');
    }
    $("#goods_list").append(listHtml.join(''));
    resetSwiperSlide(); // 左滑根据权限滑动对应距离
    setTimeout(function () {
        fun.hideLoad();
    }, 200);
}

// 删除产品
function deleteCp(list) {
    fun.dialog({
        content: '您确定要删除【' + list['name'] + '】吗？',
        btn: ['删除', '取消'],
        success: function () {
            setTimeout(function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
            }, 200);
        },
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveYarn,
                data: {
                    "save_type": "delete",
                    "id": typeof list['id'] === 'object' ? list['id'] : [list['id']]
                },
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            fun.toast('删除成功。');
                            getList();
                            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                            break;
                        case 103:
                            fun.dialog({
                                content: '【' + list['name'] + '】已被调用，不允许删除。如果该产品没有在经营，您可以使用：停用功能。',
                                btn: ['转为停用状态', '我知道了'],
                                yes: function () {
                                    fun.ajax({
                                        showLoad: true,
                                        hideLoad: true,
                                        url: AJAX_URL.saveYarn,
                                        data: {
                                            "save_type": "delete",
                                            "is_has": true,
                                            "id": typeof list['id'] === 'object' ? list['id'] : [list['id']],
                                        },
                                        success: function (res) {
                                            if (res['status'] == 0) {
                                                fun.toast('修改成功。');
                                                getList();
                                            }
                                        }
                                    })
                                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                                },
                                no: function () {
                                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                                }
                            });
                            break;
                        default:
                            fun.toast('删除失败。');
                            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    }
                }
            })
        },
        no: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        },
    })
}

// 左滑根据权限滑动对应距离
function resetSwiperSlide() {
    for (var i = 0; i < $('.le').length; i++) { // 每一个记录行的
        var slidesLen = $('.le').eq(i).find('.slids').length;
        for (var j = 0; j < slidesLen; j++) { // 每一记录行的左滑出现子项
            $('.le').eq(i).find('.slids').eq(j).css({
                right: -(slidesLen - j) * 20 + '%'
            })
        }
    }
}

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}

function imgError1(_this) {
    _this.src = '../../img/logo.png';
    _this.parentNode.classList.add('mr-bj');
    _this.classList.remove('large');
    _this.classList.add('cp-img');
    var nextEle = _this.nextElementSibling;

    if ($.nui.isTrue(nextEle)) {
        _this.parentNode.removeChild(nextEle);
    }

    _this.onerror = null;
}

/* 事件 */
// 打开搜索页
fun.setItem(html_name + 'sideslip', true);