var html_name = page_arr.ywy_shop;
var request = [];
$('#header').header({
    back: true,
    title: '业务员小店',
    appendBackBtnEvt: isDataChange
});

page_init = function () {
    $('.box').css({
        marginTop: api.safeArea.top + $('#header').height()
    })

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        var colour = color[$('.people').length % color.length];
        var html = [];
        html.push('<div class="people">');
        html.push('    <div class="fork"><i id="icon_new" class="iconfont icon-fork"></i></div>');
        if (!!temp.imgs) {
            html.push('    <div class="portrait"><img class="tuan" style="background-color:' + colour + '" src="../img/cp.png"></div>');
        } else {
            html.push('    <div class="portrait"><span class="tuan" style="background-color:' + colour + '">' + fun.getLastName(temp.name || '') + '</span></div>');
        }
        html.push('    <span id="name" class="name">' + (temp.name || '') + '</span>');
        html.push('</div>');
        $('#add').before(html.join(''))
    })

    getUserList();
};

// 删除
$('body').on('click', '.fork', function () {
    var _this = $(this);
    fun.dialog({
        content: '你确定要关闭【' + _this.siblings("#name").text() + '】的小店吗？',
        btn: ['删除', '取消'],
        shadeClose: false,
        className: 'data-change-skin',
        yes: function () {  //TODO 删除时需要提交数据
            var __id = _this.parent().data('list').account_id;
            var __data = {
                "had_small_shop": 0,
                "user_id": _this.parent().data('list').id
            }
            setSalesman(__id,__data,_this)
        }
    });
})

// 添加
$('body').on('click', '#add', function () {
    fun.showPageFull({
        page_url: page_arr.account_service,
        pageParam: {
            return_page: html_name,
            status: 'ywy_shop',
            request: request
        }
    });
})

//获取全部账号列表的数据
function getUserList() {
    fun.ajax({
        showLoad:true,
        hideLoad:true,
        url:AJAX_URL.getUserList,
        data:{
            "is_all": 1,
            "account_id":(fun.getItem('account_info')['account_id'] || 0)
        },
        success:function(res){
            if(res['status'] === 0 && res['data'].length !== 0){
                getList(res['data'])
            }
        }
    })
}

//获取数据(已经开通了小店的业务员列表)
function getList(data) {
    $.ajax({
        type: "GET",
        url: AJAX_URL.Accounts + '/?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        success: function (res) {
            if (res.length != 0) {
                $(data).each(function (idx, item) {  //遍历账号列表
                    $(res).each(function (i, obj) {
                        if (item.account_id === obj.id) {
                            request.push(item)
                        }
                    })
                })
            }
            showList(request)
        }
    })
}

// 渲染列表
function showList(data) {
    var html = [];
    $(data).each(function (idx, Obj) {
        var colour = color[idx % color.length];
        html.push('<div class="people" data-list=\'' + JSON.stringify(Obj) + '\'>');
        html.push('    <div class="fork"><i id="icon_new" class="iconfont icon-fork"></i></div>');
        if ($.nui.isTrue(Obj.imgs)) {
            html.push('    <div class="portrait"><img class="tuan" style="background-color:' + colour + '" src="../img/cp.png"></div>');
        } else {
            html.push('    <div class="portrait"><span class="tuan" style="background-color:' + colour + '">' + fun.getLastName(Obj.name || '') + '</span></div>');
        }
        html.push('    <span id="name" class="name">' + (Obj.name || '') + '</span>');
        html.push('</div>');
    })
    $('#add').before(html.join(''))
}

//设置是否开通业务员小店 (主要用于取消开通，开通功能在账号搜索那边已经实现)
function setSalesman(id, data,_this) {
    $.ajax({
        type: "PUT",
        url: AJAX_URL.Accounts + '/' + id + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        data: data,
        success: function (res) {
            _this.parent().remove();
        },
        error: function () {
            fun.toast('设置失败')
        }
    })
}

//返回
function isDataChange() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            status: 'ywy_shop',
            num: $('.people').length
        }
    })
    setTimeout(function () {
        api.closeWin();
    }, 100);
}