
; (function ($) {

    $.fn.calendar = function (option) {
        var _this = this,
            curdate = new Date(),
            curyear = curdate.getFullYear(),
            curmonth = curdate.getMonth() + 1,
            curday = curdate.getDate(),
            week = ['日', '一', '二', '三', '四', '五', '六'];

        var _opt = $.extend({
            year: curyear,
            month: curmonth,
            undoneProArr: [
                '20181023'
            ],
            doneProArr: [
                '20181022', '20181123'
            ],
            clickDay: function (selectday) {

            },
            slideEvt: function (slideDate) {

            }
        }, option);
        _this.init = function () {
            _this.createHtml();
            _this.setEvt();
        }

        /** 时间格式 */
        Date.prototype.format = function (fmt) {
            fmt = fmt || 'yyyy-MM-dd hh:mm:ss';
            var o = {
                "M+": this.getMonth() + 1,                 //月份 
                "d+": this.getDate(),                    //日 
                "h+": this.getHours(),                   //小时 
                "m+": this.getMinutes(),                 //分 
                "s+": this.getSeconds(),                 //秒 
                "q+": Math.floor((this.getMonth() + 3) / 3), //季度 
                "S": this.getMilliseconds()             //毫秒 
            };
            if (/(y+)/.test(fmt)) {
                fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
            }
            for (var k in o) {
                if (new RegExp("(" + k + ")").test(fmt)) {
                    fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
                }
            }
            return fmt;
        }

        /**工具 */
        _this.tools = {
            /**
             * 根据年份，返回该年 每个月的 所有天数
             * @param {*} y 指定年份
             */
            monthDates: function (y) {
                var isLeapYear = function (year) {
                    var flag;
                    year % 4 === 0 ? (year % 100 !== 0 ? flag = 1 : (year % 400 === 0 ? flag = 1 : flag = 0)) : flag = 0;//闰年处理
                    return flag;
                };
                return [31, 28 + isLeapYear(y), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
            },

            /**
             * 根据 指定时间 返回农历相应的 数据对象
             * @param {*} datestr 
             */
            getLunarDateObj: function (datestr) {

                var lunar = {
                    tg: '甲乙丙丁戊己庚辛壬癸',
                    dz: '子丑寅卯辰巳午未申酉戌亥',
                    number: '一二三四五六七八九十',
                    year: '鼠牛虎兔龙蛇马羊猴鸡狗猪',
                    month: '正二三四五六七八九十冬腊',
                    monthadd: [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334],
                    calendar: [0xA4B, 0x5164B, 0x6A5, 0x6D4, 0x415B5, 0x2B6, 0x957, 0x2092F, 0x497, 0x60C96, 0xD4A, 0xEA5, 0x50DA9, 0x5AD, 0x2B6, 0x3126E, 0x92E, 0x7192D, 0xC95, 0xD4A, 0x61B4A, 0xB55, 0x56A, 0x4155B, 0x25D, 0x92D, 0x2192B, 0xA95, 0x71695, 0x6CA, 0xB55, 0x50AB5, 0x4DA, 0xA5B, 0x30A57, 0x52B, 0x8152A, 0xE95, 0x6AA, 0x615AA, 0xAB5, 0x4B6, 0x414AE, 0xA57, 0x526, 0x31D26, 0xD95, 0x70B55, 0x56A, 0x96D, 0x5095D, 0x4AD, 0xA4D, 0x41A4D, 0xD25, 0x81AA5, 0xB54, 0xB6A, 0x612DA, 0x95B, 0x49B, 0x41497, 0xA4B, 0xA164B, 0x6A5, 0x6D4, 0x615B4, 0xAB6, 0x957, 0x5092F, 0x497, 0x64B, 0x30D4A, 0xEA5, 0x80D65, 0x5AC, 0xAB6, 0x5126D, 0x92E, 0xC96, 0x41A95, 0xD4A, 0xDA5, 0x20B55, 0x56A, 0x7155B, 0x25D, 0x92D, 0x5192B, 0xA95, 0xB4A, 0x416AA, 0xAD5, 0x90AB5, 0x4BA, 0xA5B, 0x60A57, 0x52B, 0xA93, 0x40E95]
                }

                function getLunarDate(date) {

                    var year, month, day;
                    if (!date) {
                        date = new Date(), year = date.getFullYear(), month = date.getMonth(), day = date.getDate();
                    } else {
                        // date = date.split('-'), year = parseInt(date[0]), month = date[1] - 1, day = parseInt(date[2]);
                        var curdate = new Date(date);
                        year = curdate.getFullYear();
                        month = curdate.getMonth();
                        day = curdate.getDate();
                    }

                    if (year < 1921 || year > 2020) {
                        return {}
                    }

                    var total, m, n, k, bit, lunarYear, lunarMonth, lunarDay;
                    var isEnd = false;
                    var tmp = year;
                    if (tmp < 1900) {
                        tmp += 1900;
                    }
                    total = (tmp - 1921) * 365 + Math.floor((tmp - 1921) / 4) + lunar.monthadd[month] + day - 38;
                    if (year % 4 == 0 && month > 1) {
                        total++;
                    }
                    for (m = 0; ; m++) {
                        k = (lunar.calendar[m] < 0xfff) ? 11 : 12;
                        for (n = k; n >= 0; n--) {
                            bit = (lunar.calendar[m] >> n) & 1;
                            if (total <= 29 + bit) {
                                isEnd = true;
                                break;
                            }
                            total = total - 29 - bit;
                        }
                        if (isEnd) break;
                    }
                    lunarYear = 1921 + m;
                    lunarMonth = k - n + 1;
                    lunarDay = total;
                    if (k == 12) {
                        if (lunarMonth == Math.floor(lunar.calendar[m] / 0x10000) + 1) {
                            lunarMonth = 1 - lunarMonth;
                        }
                        if (lunarMonth > Math.floor(lunar.calendar[m] / 0x10000) + 1) {
                            lunarMonth--;
                        }
                    }

                    return {
                        lunarYear: lunarYear,
                        lunarMonth: lunarMonth,
                        lunarDay: lunarDay,
                    };
                }

                function getLunarDateString(lunarDate) {
                    if (!lunarDate.lunarDay) return;
                    var data = {},
                        lunarYear = lunarDate.lunarYear,
                        lunarMonth = lunarDate.lunarMonth,
                        lunarDay = lunarDate.lunarDay;

                    data.tg = lunar.tg.charAt((lunarYear - 4) % 10);
                    data.dz = lunar.dz.charAt((lunarYear - 4) % 12);
                    data.year = lunar.year.charAt((lunarYear - 4) % 12);
                    data.month = lunarMonth < 1 ? '(闰)' + lunar.month.charAt(-lunarMonth - 1) : lunar.month.charAt(lunarMonth - 1);

                    data.day = (lunarDay < 11) ? "初" : ((lunarDay < 20) ? "十" : ((lunarDay < 30) ? "廿" : "三十"));
                    if (lunarDay % 10 != 0 || lunarDay == 10) {
                        data.day += lunar.number.charAt((lunarDay - 1) % 10);
                    }

                    return data;
                }

                var lunarDate = getLunarDate(datestr)
                var day = getLunarDateString(lunarDate);
                return day;
            },

            /**
             * 根据 传入的日期，获取相应的节日
             * @param {*} day 
             */
            getCurDayFestival: function (day) {
                var _optmonth = _opt.month;
                if (!!!day) {
                    return false;
                }
                var festivalObj = {
                    "0101": "元旦",

                    "0214": "情人节",

                    "0308": "妇女节",
                    "0312": "植树节",

                    "0401": "愚人节",
                    "0405": "清明节",

                    "0504": "青年节",


                    "0601": "儿童节",

                    "0801": "建军节",

                    "0910": "教师节",

                    "1001": "国庆节",

                    "1225": "圣诞节",

                }
                var key = "";
                if (_optmonth < 10) {
                    key = '0' + _optmonth;
                } else {
                    key = _optmonth;
                }
                key += day;

                return festivalObj[key] ? festivalObj[key] : false;
            },

            /**
             * 获取节日区间数组
             * @param {*} num 放假多少天 基于 节日当天 左右偏移量
             * @param {*} dateparam 节日当天
             * @param {*} fmt 时间格式
             */
            getFestivalSection: function (num, dateparam, fmt) {
                var nowdate = new Date(dateparam);
                var isadd = true;
                if (num < 0) {
                    isadd = false;
                }
                var sectionArr = [];
                if (isadd) {
                    for (var i = 0; i < num; i++) {
                        var _curdate = nowdate.setDate(i ? nowdate.getDate() + 1 : nowdate.getDate());
                        var curfmt = new Date(_curdate).format(fmt);
                        sectionArr.push(curfmt);
                    }
                } else {
                    var abs = Math.abs(num);
                    for (var i = 0; i < abs; i++) {
                        var _curdate = nowdate.setDate(i ? nowdate.getDate() - 1 : nowdate.getDate());
                        var curfmt = new Date(_curdate).format(fmt);
                        sectionArr.push(curfmt);
                    }
                }
                return sectionArr;
            },

            /**
             * 获取指定年份的 所有节假日休息时间
             * @param {*} $year 指定年份
             */
            getYearFestivalDate: function ($year) {
                var allyear = {
                    "1": {
                        yuandan: _this.tools.getFestivalSection(-3, '2000-1-1', 'MMdd'),
                        chunjie: _this.tools.getFestivalSection(7, '2000-2-15', 'MMdd'),
                        qinqming: _this.tools.getFestivalSection(3, '2000-4-5', 'MMdd'),
                        laodong: _this.tools.getFestivalSection(-3, '2000-5-1', 'MMdd'),
                        duanwu: _this.tools.getFestivalSection(-3, '2000-6-18', 'MMdd'),
                        zhongqiu: _this.tools.getFestivalSection(-3, '2000-9-24', 'MMdd'),
                        guoqin: _this.tools.getFestivalSection(7, '2000-10-1', 'MMdd')
                    },
                    "2019": {
                        yuandan: _this.tools.getFestivalSection(-3, '2019-1-1', 'MMdd'),
                        chunjie: _this.tools.getFestivalSection(7, '2019-2-15', 'MMdd'),
                        qinqming: _this.tools.getFestivalSection(3, '2019-4-5', 'MMdd'),
                        laodong: _this.tools.getFestivalSection(-3, '2019-5-1', 'MMdd'),
                        duanwu: _this.tools.getFestivalSection(-3, '2019-6-18', 'MMdd'),
                        zhongqiu: _this.tools.getFestivalSection(-3, '2019-9-24', 'MMdd'),
                        guoqin: _this.tools.getFestivalSection(7, '2019-10-1', 'MMdd')
                    }
                }
                return allyear[$year] ? allyear[$year] : allyear["1"];

            },

            /**
             * 获取 当前日期是否是 节日休息日
             * @param {string} day 
             */
            getXiuxiByFestival: function (day) {
                var _optmonth = _opt.month;
                _optmonth = _optmonth < 10 ? '0' + _optmonth : _optmonth;
                var fes = _this.tools.getYearFestivalDate(_opt.year);
                day = day ? day : '01';
                var mmdd = _optmonth + '' + day;

                var finded = false;

                for (const k in fes) {
                    if (fes.hasOwnProperty(k)) {
                        const v = fes[k];
                        var indexof = v.indexOf(mmdd);
                        if (indexof != -1) {
                            finded = true;
                        }
                    }
                }
                return finded;
            },

            /**
            * 根据 传入的日期，获取相应的农历
            * @param {*} day 
            */
            getCurDayLunarDate: function (day) {
                var _optmonth = _opt.month;
                if (!!!day) return false;
                var _date = new Date(_opt.year, _optmonth - 1, day);
                return _this.tools.getLunarDateObj(_date).day;
            },

            //判断是否是双休日
            isShuangxiu: function (day) {
                var _optmonth = _opt.month;
                var _day = new Date(_opt.year, _optmonth - 1, day).getDay();
                if (_day == 0 || _day == 6) {
                    return true;
                }
                return false;
            },

            /**
             * 左右滑动事件
             * @param {*} jqSelector 选择器
             * @param {*} leftFunc 左滑动事件
             * @param {*} rightFunc 右滑动事件
             */
            slideEvt: function (jqSelector, leftFunc, rightFunc) {
                $(jqSelector).on("touchstart", function (e) {
                    // 判断默认行为是否可以被禁用
                    if (e.cancelable) {
                        // 判断默认行为是否已经被禁用
                        if (!e.defaultPrevented) {
                            e.preventDefault();
                        }
                    }
                    startX = e.originalEvent.changedTouches[0].pageX,
                        startY = e.originalEvent.changedTouches[0].pageY;
                });
                $(jqSelector).on("touchend", function (e) {
                    var _this = this;
                    // 判断默认行为是否可以被禁用
                    if (e.cancelable) {
                        // 判断默认行为是否已经被禁用
                        if (!e.defaultPrevented) {
                            e.preventDefault();
                        }
                    }
                    moveEndX = e.originalEvent.changedTouches[0].pageX,
                        moveEndY = e.originalEvent.changedTouches[0].pageY,
                        X = moveEndX - startX,
                        Y = moveEndY - startY;
                    var offset = 20;
                    //左滑
                    if (X < -offset) {
                        if (typeof leftFunc == "function")
                            leftFunc(_this);
                    }
                    //右滑
                    else if (X > offset) {
                        if (typeof rightFunc == "function")
                            rightFunc(_this);
                    }
                    // //下滑
                    // else if ( Y > 0) {
                    // }
                    // //上滑
                    // else if ( Y < 0 ) {
                    // }
                    // //单击
                    // else{
                    // }
                });
            }
        };

        //创建HTML
        _this.createHtml = function () {
            var _optmonth = _opt.month;

            //获取日历数据
            var calendarData = function () {
                var allday = [];
                var montharr = _this.tools.monthDates(_opt.year);
                var curMonthDay = montharr[_optmonth - 1];

                var addcount = new Date(_opt.year, _optmonth - 1, 1).getDay(); //用于移位
                var br = 7;
                var brindex = 0;
                var rowday = [];
                var startfor = (1 - addcount);  //开始循环数
                var maxfor = curMonthDay + addcount;  //结束循环数
                for (var i = startfor; i <= maxfor; i++) {
                    brindex++;
                    //追加一系列的天数
                    if (i <= 0) {
                        rowday.push('');
                    }
                    else if (i > 0 && i < 10) {
                        rowday.push('0' + i);
                    } else if (i <= curMonthDay) {
                        rowday.push(i + '');
                    } else {
                        rowday.push('');
                    }
                    if (brindex == br) {
                        allday.push(rowday);
                        rowday = [];
                        brindex = 0;
                    }
                    if (i == maxfor) {
                        //验证下一行是否是空的，空的话就不追加了
                        var youxiao = false;
                        if (rowday.length > 0) {
                            rowday.forEach(function (obj) {
                                if (!!obj) {
                                    youxiao = true;
                                }
                            });
                        }
                        if (youxiao) {
                            //凑够一行 7 个数
                            for (var i = 0; i <= br - rowday.length; i++) {
                                rowday.push('');
                            }
                        }
                        youxiao ? allday.push(rowday) : null;
                    }
                }
                return allday;
            }
            var cd = calendarData();

            //组装HTML
            var htmlstr = [];
            htmlstr.push(" <div class=\"calender\" >");
            htmlstr.push("        <div class=\"calender-week\">");
            week.forEach(function (obj) {
                htmlstr.push("            <div class=\"week-item\">" + obj + "</div>");
            });
            htmlstr.push("        </div>");
            htmlstr.push("        <div class=\"calender-days\">");
            cd.forEach(function ($row) {
                htmlstr.push("            <div class=\"day-row\">");

                $row.forEach(function ($day) {
                    //获取当前日是什么节、什么农历
                    var festival = _this.tools.getCurDayFestival($day);
                    var lunar = _this.tools.getCurDayLunarDate($day);
                    var chinese = festival ? festival : lunar ? lunar : '';

                    //样式
                    var issx = '', today = '', xiu = '', pro = '', cpro = '', _optdatestr = '', curdatestr = '', prodatestr = '';

                    if (!!$day) {
                        _optdatestr = _opt.year + '-' + _opt.month + '-' + $day;
                        curdatestr = curyear + '-' + curmonth + '-' + curday;
                        prodatestr = _opt.year + '' + _opt.month + $day;
                        //双休、今天、法定休息日
                        issx = _this.tools.isShuangxiu($day) ? "shuangxiu" : "";
                        today = _optdatestr == curdatestr ? "active" : "";
                        xiu = _this.tools.getXiuxiByFestival($day) ? "xiuxi" : "";

                        //计划
                        pro = _opt.undoneProArr.indexOf(prodatestr) != -1 ? "hongdian" : "";
                        cpro = _opt.doneProArr.indexOf(prodatestr) != -1 ? "huidian" : "";

                    }
                    var stylestr = issx + " " + today + ' ' + xiu + ' ' + pro + ' ' + cpro;

                    htmlstr.push("                <div class='day-item " + stylestr + "' data-datetime='" + _optdatestr + "'>");
                    htmlstr.push("                    <div class=\"day-item-txt\">");
                    htmlstr.push("                        <div class=\"day-item-num\">" + $day + "</div>");
                    htmlstr.push("                        <div class=\"day-item-chinese\">" + chinese + "</div>");
                    htmlstr.push("                    </div>");
                    htmlstr.push("                </div>");
                });

                htmlstr.push("        </div>");
            });
            htmlstr.push("    </div>");

            $(_this).html(htmlstr.join(''));
        }
        _this.setEvt = function () {
            var _optmonth = _opt.month;
            _opt.year = parseInt(_opt.year);
            _this.tools.slideEvt('.calender', function () {

                _optmonth++;
                if (_optmonth > 12) {
                    _opt.month = 1;
                    _opt.year = _opt.year + 1;
                    _optmonth = 1;
                } else {
                    _opt.month = _optmonth;
                }
                _this.init();
                var dateobj = {
                    year: _opt.year,
                    month: _opt.month
                }
                _opt.slideEvt(dateobj);

            }, function () {
                _optmonth--;
                // _opt.month =  ? 11 : _optmonth;
                if (_optmonth < 1) {
                    _opt.month = 12;
                    _opt.year = _opt.year - 1;
                    _optmonth = 12;
                } else {
                    _opt.month = _optmonth
                }
                _this.init();
                var dateobj = {
                    year: _opt.year,
                    month: _opt.month
                }
                _opt.slideEvt(dateobj);
            });

            $('.day-item').off('tap').on('tap', function () {
                var _this = this;
                setTimeout(function () {
                    var selectdate = $(_this).attr('data-datetime');
                    $('.day-item').removeClass('select');
                    $(_this).addClass('select');
                    _opt.clickDay(selectdate);
                }, 50);
            })

        }
        _this.init();
    }

})(jQuery)
